      SUBROUTINE AITGS(AITG,E,O,IT2,IT3)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      COMMON/INTEGRAL/A,B,C,D,IT1
      dimension O(2)
C     int(o1,o2)sqrt(E-V(q))dq,V=Aq^2/2+Bq+Cq^3/6+Dq^4/24
      CM=219470.0d0
      O(1)=0.0d0
      O(2)=0.0d0
      OLIMIT=0.000001d0
      ELIMIT=0.001d0/CM
      SLIMIT=0.000001d0
      IT2=0
      DO 1 I=1,2
      DEL=0.025d0*DBLE(I*2-3)
      ON=0.0d0
2     ON=ON+DEL
      IT2=IT2+1
      IF(IT2.GT.1000)THEN
       WRITE(6,*)I,' Cross-section of energy surface not found '
       WRITE(3,*)I,' Cross-section of energy surface not found '
       VN=ON*(B+ON*(0.5d0*A+ON*(C/6.0d0+D*ON/24.0d0)))
       WRITE(3,3000)A*CM,B*CM,C*CM,D*CM,ON,DEL,E*CM,VN*CM
3000  FORMAT(' A = ',F10.1,' B = ',F10.1,' C = ',F10.1,' D = ',F10.1,/,
     1       ' ON, DEL, E, VN: ',4F15.6)
       AITG=1.0d7
       RETURN
      ENDIF
      VN=ON*(B+ON*(0.5d0*A+ON*(C/6.0d0+D*ON/24.0d0)))
      IF(VN.GE.E)THEN
       DEL=0.5d0*DEL
       ON=ON-DEL-DEL
       IF(ABS(DEL+DEL).LT.OLIMIT.AND.ABS(VN-E).LT.ELIMIT)GOTO 1
       GOTO 2
      ENDIF
      GOTO 2
1     O(I)=ON
      IF(O(1).LT.-100.OR.O(2).GT.100)THEN
       WRITE(6,*)' No solution for this energy'
       WRITE(3,*)' No solution for this energy'
       AITG=10000000.0d0
       RETURN
      ENDIF
      NS=1000
      SUMO=0.0d0
      IT3=0
4     NS=NS+100
      IT3=IT3+1
      IF(IT3.GT.100)THEN
       WRITE(3,*)'Impossible to do numerical integration.'
       WRITE(6,*)'Impossible to do numerical integration.'
       AITG=10000000.0d0
       RETURN
      ENDIF
      H=(O(2)-O(1))/DBLE(NS)
      SUM=0.0d0
      X=O(1)
      DO 3 I=1,NS-1
      X=X+H
      COEF=2.0d0+2.0d0*MOD(I+1,2)
3     SUM=SUM+COEF*DSQRT(E-X*(B+X*(A/2.0d0+X*(C/6.0d0+X*D/24.0d0))))
      SUM=SUM*H/3.0d0
      IF(ABS(SUM-SUMO).GT.SLIMIT)THEN
       SUMO=SUM
       GOTO 4
      ENDIF
      AITG=SUM
      RETURN
      END
