c The actions of this unit are controlled by enviroment variables.
c Run `grep GVIB_ *f' to get a list of the variables and `gvib -h'
c for explanation. 
c
c 
c Calculate kinetic energy <a|T|a> of the given VSCF product function.
c The VSCF function is expanded in the basis of LHOs.
c
      subroutine calc_vscf_Tenergy(nnmodes,vscf_nbase,func,qff2,energy)
      include 'common.h'
c In:
      integer nnmodes,vscf_nbase
      real*8 func(vscf_nbase,nnmodes), qff2(nnmodes)
c Out:
      real*8 energy
      
      real*8 freqi
      integer i,ibase,mu

      energy = 0d0

      do i=1,nnmodes
	    freqi = qff2(i)
	    
	    do ibase=1,vscf_nbase
		  mu = ibase-1
      
	  energy = energy + freqi*(mu+0.5d0)*0.5d0*(func(ibase,i)**2)

		  if ((ibase+2).le.vscf_nbase) then
		energy = energy - freqi*sqrt(dble((mu+1)*(mu+2)))*0.5d0
     &		      *func(ibase,i)*func(ibase+2,i)	  !  2*0.25=0.5
		  end if
	    end do
      end do

      end


