      program convg
c     extracts Gaussian normal mode cubic and quartic constants into
c     CQQ.TXT.SCR and DQQ,TXT,SCR
      IMPLICIT none
      real*8,allocatable:: e(:),C(:),D(:)
      real*8 CM,a,cqau,cqcm,dqau,dqcm
      character*80 s80
      logical l2
      integer*4 i,M,N,j,k,l,i1,j1,k1,n3,n4,n7
c
      CM=219470.0d0
      l2=.false.
      M=0
      n3=0
      n4=0
4     open(9,file='G.OUT',status='old')
1     read(9,900,end=999,err=999)s80
900   format(a80)
      if(s80(9:49).eq.'QUADRATIC FORCE CONSTANTS IN NORMAL MODES')then
       call s8
       if(.not.l2)then
        l2=.true.
3       read(9,*,end=88,err=88)a,a,a
        M=M+1
        goto 3
88      close(9)
        write(6,*)M,' modes '
        if(M.gt.0)then
         allocate(e(M),C(M**3),D(M**3))
         do 5 i=1,M
5        e(i)=0.0d0
         do 6 i=1,M**3
         C(i)=0.0d0
6        D(i)=0.0d0
         goto 4
        endif
        stop
       else
        do 7 i=1,M
        read(9,*)e(i),e(i),e(i)
7       e(i)=e(i)/CM
       endif
      endif
      if(s80(11:41).eq.'CUBIC FORCE CONSTANTS IN NORMAL'.and.l2)then
       call s8
9      read(9,*,end=77,err=77)i,j,k,a
       c(i+M*(j-1)+M**2*(k-1))=a
       c(i+M*(k-1)+M**2*(j-1))=a
       c(j+M*(k-1)+M**2*(i-1))=a
       c(j+M*(i-1)+M**2*(k-1))=a
       c(k+M*(i-1)+M**2*(j-1))=a
       c(k+M*(j-1)+M**2*(i-1))=a
       n3=n3+1
       goto 9
77     write(6,*)n3,' cubic constants '
      endif
      if(s80(10:42).eq.'QUARTIC FORCE CONSTANTS IN NORMAL'.and.l2)then
       call s8
11     read(9,*,end=66,err=66)i,j,k,l,a
       if(i.eq.j)then
        i1=i
        j1=k
        k1=l
       else
        if(i.eq.k)then
         i1=i
         j1=j
         k1=l
        else
         if(i.eq.l)then
          i1=i
          j1=j
          k1=k
         else
          if(j.eq.k)then
           i1=j
           j1=i
           k1=l
          else
           if(j.eq.l)then
            i1=j
            j1=i
            k1=k
           else
            if(k.eq.l)then
             i1=k
             j1=i
             k1=j
            else
             write(6,*)i,j,k,l,' general quartic not implemented'
             stop
            endif
           endif
          endif
         endif
        endif
       endif
       d(i1+M*(j1-1)+M**2*(k1-1))=a
       d(i1+M*(k1-1)+M**2*(j1-1))=a
       n4=n4+1
       goto 11
66     write(6,*)n4,' quartic constants'
       goto 999
      endif
      goto 1
999   close(9)
c
      N=M+6
      N7=7

      if(n3.gt.0)then
       open(23,file='CQQ.SCR.TXT')
       do 64 i=N7,N
       i1=M-i+7
       do 64 j=i,N
       j1=M-j+7
       do 64 k=j,N
       k1=M-k+7
       cqcm=c(i1+M*(j1-1)+M**2*(k1-1))
       if(abs(cqcm).eq.0.0d0)goto 64
       write(23,2423)I,J,K,cqcm/CM,cqcm
2423   format(3I5,G16.8,' ',F9.1)
64     continue
       close(23)
      endif

      if(n4.gt.0)then
       open(23,file='DQQ.SCR.TXT')
       do 621 i=n7,n
       i1=M-i+7
       do 621 j=n7,n
       j1=M-j+7
       do 621 k=j,n
       k1=M-k+7
       dqcm=d(i1+M*(j1-1)+M**2*(k1-1))
       if(abs(dqcm).eq.0.0d0)goto 621
       write(23,5333)I,J,K,dqcm/CM,dqcm
5333   format(3I6,G16.8,' ',f9.1)
621    continue
       close(23)
      endif

      END

      subroutine s8
      do 2 i=1,8
2     read(9,*)
      return
      end
