      SUBROUTINE CORRECT(ASL,ASK)
      IMPLICIT none
      integer*4 NGE0,ib0,nl0
      include 'dimensions.h'
      PARAMETER (NGE0=24,ib0=100,nl0=100)
      real*8 ASK,ASL,EAH(MG0),E,A,CM,EOLD(NT3),EK1(MG0),EK2(MG0),
     1EK0(MG0),VMM
      real*8,allocatable:: a33(:),H2(:,:),t(:,:),c(:,:),CFI(:)
      integer*4,allocatable:: j33(:)
c     integer*8,allocatable:: j33(:)
      integer*4 IYX(2,NGE0),si(ME0),iex,ib,nqa,
     1STATE1(NT3),STATE2(NT3),ISI(NGE0,4),NSBIGU,
     1N7,N,NHBIG,IT,IS,IBIGSYM,ICC,IN,I,K,LEXCL,J,MV,I0,I1,I2,J1,J2,L,
     2i33,IBR,ICAN,NZF,IERM,ii,ISB,JHH,JJ,KG,NCAN,NDIM,NG0,
     3NSBIG,Nexc,kk,iopt,NQ1,mclock,it0,NMM,NHAND
c
c     state batches:
      integer*4 SUBTYPE(ib0),TYPE(ib0),STATE2B(ib0,NT3),IC(ib0,ME0),
     1NC(ib0,ME0),inm(ib0)
      real*8 EJ(ib0)
c
      COMMON/MMM/VMM,NMM,NHAND
      COMMON/CEM/E(NT3)
      LOGICAL L4,LENAS
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent
      logical lopt,ldc2,lex
      COMMON/lop/lopt(300)
      equivalence (lopt(41),ldc2),(lopt(34),LENAS)
      COMMON/DIA1/NHBIG,IT(NM0),IS(NM0),IBIGSYM(NM0),
     1ICC(NM0,ME0),IN(NM0,ME0)
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      CHARACTER*1 s1
      integer*4 ielist
      common/qxcc/ielist(NT3)
      common/iop/iopt(300)
      equivalence (NQ1,iopt(1))
c
c     largest d-coefficients:
      real*8 dco
      integer*4 kco,jco
      common/dlc/dco(nl0),kco(nl0),jco(nl0)
C
      call w36(' ')
      call w36('Corrrect')
      call w36('^^^^^^^^')
      call w36('***************************************************')
      call w36('Correct VCI energies by remaining force field terms')
      call w36('***************************************************')
      call w36(' ')
      CM=219470.0d0
      it0=mclock()

      inquire(FILE='EAHC.SCR',exist=lex)
      if(lex)then
       call w36('EAHC.SCR exists, calculation skipped')
       return
      endif

c     read states used for diagonalization:
      call readstates(NHBIG,N7,N,NM0,IS,IBIGSYM,IT,ICC,IN,ISB,IYX,ME0,
     1NGE0)

c     read anharmonic energies and states again:
      OPEN(4,FILE='EIGEN.SCR',FORM='UNFORMATTED')
      read(4)N7,N,LEXCL,NHBIG,MV,KG,ISB
      read(4)(IT(I),I=1,NHBIG) ,(IS(I),I=1,NHBIG),
     1((ICC(I,J),I=1,NHBIG),J=1,LEXCL),((IN(I,J),I=1,NHBIG),J=1,LEXCL),
     2(EAH(I),I=1,MV),(E(I),I=N7,N),(EOLD(I),I=N7,N),
     3((IYX(K,J),K=1,2),J=1,ISB),((ISI(J,K),K=1,4),J=1,KG)
      CLOSE(4)
      call w36('Eigenvectors read from EIGEN.SCR')
c
      do 1 I0=1,KG
      I1=ISI(I0,1)
      I2=ISI(I0,2)
      J1=ISI(I0,3)
      J2=ISI(I0,4)
      write(3,300)I0,J1,J2,I1,I2
      write(6,300)I0,J1,J2,I1,I2
300   format(' Symmetry ',i6,' eigenstates ',i5,'-',i5,/,
     1       '                 basis states',i5,'-',i5)
      NDIM=I2-I1+1

      allocate(c(1:NDIM,1:NDIM))

      allocate(CFI(1:NDIM))
      do 4 j=J1,J2
      call loadc(j,CFI,NDIM)
      do 4 i=1,NDIM
4     c(i,j)=CFI(i)
      deallocate(CFI)

      do 100 k=J1,J2
      EK0(k)=EAH(k)
      EK1(k)=0.0d0
100   EK2(k)=0.0d0
c
      if(LENAS)then
       call w36(' ')
       call w36('       H = H0 + H1 + H2')
       call w36(' ')
c
c      First order correction  Ek(1) = <psik|H2|psik>
c      for anharmonic constants between ASL and ASK
c      load these constants:
       call LOADCDS2(N7,N,E,QUARTIC,LSPARSE,ASL,ASK,L4,LH40,HW)
       call w36('Force field for H2 loaded')
c
c      do <i|H2|j> in HO basis
       call dohim2(I1,I2,ISB,I0)
       allocate(a33(1:NDIM),j33(1:NDIM))
       allocate(H2(1:NDIM,1:NDIM))
       write(s1,4000)KG
4000   format(i1)
       OPEN(4,FILE=s1//'A2.SCR',FORM='UNFORMATTED',STATUS='OLD')
       READ(4)NG0
       if(NG0.ne.NDIM)call report('NDIM<>NG0')
       DO 921 I=1,NDIM
       DO 921 L=1,NDIM
921    H2(I,L)=0.0d0
       DO 92 I=1,NDIM
       READ(4)i33,(j33(JHH),JHH=1,i33),(a33(JHH),JHH=1,i33)
       DO 92 JHH=1,i33
       L=j33(JHH)
       H2(L,I)=a33(JHH)
       if(L.eq.I)H2(L,I)=H2(L,I)*2.0d0
92     H2(I,L)=H2(L,I)
       CLOSE(4)
       deallocate(a33,j33)
       call w36('H2 read from '//s1//'A2.SCR')
c
       allocate(t(1:NDIM,1:NDIM))
c      transforming first index
       do 2 I=1,NDIM
       do 2 j=1,NDIM
       t(I,j)=0.0d0
       do 2 ii=1,NDIM
2      t(I,j)=t(I,j)+H2(ii,J)*c(ii,I)
c
c      transforming second index
       do 6 I=1,NDIM
       do 6 J=1,NDIM
       H2(I,J)=0.0d0
       do 6 jj=1,NDIM
6      H2(I,J)=H2(I,J)+t(I,jj)*c(jj,J)
c
c      E(1)k=<K|H2|K>:
       do 102 k=J1,J2
102    EK1(k)=H2(k,k)/CM
      else
       call w36(' ')
       call w36('       rest of vibrational states added')
       call w36(' ')
      endif
c
      if(ldc2)then
c
       call w36('Second-order correction')
       do 15 i=1,nl0
15     dco(i)=0.0d0
       write(6,6009)LEXCL,NQ1
       write(3,6009)LEXCL,NQ1
6009   format(' LEXCL:',I4,', NQ1:',I4)

       if(LENAS)then
        call LOADCDS2(N7,N,E,QUARTIC,LSPARSE,ASL,ASK,L4,LH40,HW)
       else
        call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
       endif
c
c      number of added states:
       NSBIG=0
c      number of unique states not among 1..NHBIG:
       NSBIGU=0
c      ib ... add to k by batches
       ib=0
c      generate basis states
c      ================================================================
       do 3 Nexc=0,LEXCL
       do 203 iex=1,Nexc
203    si(iex)=N7
5      DO 204 I=N7,N
204    STATE2(I)=0
       do 206 iex=1,Nexc
206    STATE2(si(iex))=STATE2(si(iex))+1
c
c      check that the state is allowed:
       do 207 I=N7,N
       if(LBLOCK)then
        do 2071 II=1,NCAN
2071    if(ICAN(II).eq.I.and.STATE2(I).ne.0)goto 12
       endif
207    if(STATE2(I).gt.ielist(I))goto 12
c
c      limit number of excitation centers
       nqa=0
       do 2072 I=N7,N
2072   if(STATE2(I).ne.0)nqa=nqa+1
       if(nqa.gt.NQ1)goto 12
c
       NSBIG=NSBIG+1
       ib=ib+1
c
c      state energy:
       EJ(ib)=0.0d0
       DO 210 II=N7,N
       STATE2B(ib,II)=STATE2(II)
210    EJ(ib)=EJ(ib)+dble(STATE2(II))*E(II)

c      state short representation:
       TYPE(ib)=0
       SUBTYPE(ib)=0
       DO 214 I=1,ME0
       IC(ib,I)=0
214    NC(ib,I)=0
       do 211 I=N7,N
       if(STATE2(I).gt.0)then
        SUBTYPE(ib)=SUBTYPE(ib)+1
        TYPE(ib)=TYPE(ib)+STATE2(I)
        IC(ib,SUBTYPE(ib))=I
        NC(ib,SUBTYPE(ib))=STATE2(I)
       endif
211    continue
c
c      find if state NSBIG is among the smaller set
c      inm=0 ... NSBIG was not included within I1...I2
c      inm>0 ... NSBIG was included as number inm
       inm(ib)=0
       do 212 II=I1,I2
       if(IS(II).ne.SUBTYPE(ib))goto 212
       if(IT(II).ne.TYPE(ib))goto 212
       do 213 KK=1,SUBTYPE(ib)
       if(NC(ib,KK).NE.IN(II,KK))goto 212
213    if(IC(ib,KK).NE.ICC(II,KK))goto 212
       inm(ib)=II
       goto 209
212    continue
209    continue
       if(inm(ib).eq.0)NSBIGU=NSBIGU+1
c
c      add to each VCI state k:
c      ................................................................
       IF(ib.eq.ib0)call addk(ISI,ib,EJ,EK0,NDIM,I1,I2,J1,J2,
     1inm,c,EK1,EK2,TYPE,LSPARSE,LQD,NZF,LH40,STATE2B,NSBIG,LENAS)
c      ................................................................
c
c      find index to be changed
12     do 8 II=Nexc,1,-1
8      if(si(II).lt.N)goto 9
       goto 3
9      do 10 i=II+1,Nexc
10     si(i)=si(II)+1
       si(II)=si(II)+1
c
       goto 5
3      continue
c      ================================================================
c      "j"-state sum
c
c      add rest of states:
       call addk(ISI,ib,EJ,EK0,NDIM,I1,I2,J1,J2,
     1inm,c,EK1,EK2,TYPE,LSPARSE,LQD,NZF,LH40,STATE2B,NSBIG,LENAS)
c
       write(6,6080)NSBIG,NHBIG,NSBIGU,VMM
       write(3,6080)NSBIG,NHBIG,NSBIGU,VMM
6080   format(I10,' states added',/,
     1        I10,' original states',/,
     2        I10,' unique states',
     3        F10.2,' maximum corrected frequency')

       if(NSBIG.NE.NSBIGU+NHBIG)then
        call w36(' ')
        call w36('*****************************')
        call w36('Warning - NSBIG<>NSBIGU+NHBIG')
        call w36('*****************************')
        call w36(' ')
       endif

       call w36('Largest dkj coefficients:')
       do 14 i=1,nl0
       write(3,607)i,dco(i),kco(i),jco(i)
14     write(6,607)i,dco(i),kco(i),jco(i)
607    format(i4,f10.5,2i10)

       call w36('Second order finished')
      else
       call w36('Second order skipped')
      endif
c     second order
c
      call w36(' K   E0K   E(1)      E(2)        TOTAL')
      do 1 k=J1,J2
      EK0(k)=EAH(k)
      EAH(k)=EK0(k)+EK1(k)+EK2(k)
      write(3,6029)k,CM*EK0(k),CM*EK1(k),CM*EK2(k),CM*EAH(k)
1     write(6,6029)k,CM*EK0(k),CM*EK1(k),CM*EK2(k),CM*EAH(k)
6029  format(i4,4f10.2)
c     I0 symmetry block

      if(LENAS)deallocate(H2,t)
      deallocate(c)
c
      OPEN(4,FILE='EAHC.SCR',FORM='UNFORMATTED')
      write(4)NHBIG,(EAH(I),I=1,NHBIG)
      CLOSE(4)
      call w36('Repaired eigenvalues written to EAHC.SCR')
      write(3,36009)dble(mclock()-it0)/100.0d0
      write(6,36009)dble(mclock()-it0)/100.0d0
36009 format(' Time: ',f15.2,' sec')
      return
C
      END

      subroutine addk(ISI,ib,EJ,EK0,NDIM,I1,I2,J1,J2,
     1inm,c,EK1,EK2,TYPE,LSPARSE,LQD,NZF,LH40,STATE2B,NSBIG,LENAS)
      implicit none
      integer*4 NGE0,NDIM,ib0,nl0
      include 'dimensions.h'
      PARAMETER (NGE0=24,nl0=100,ib0=100)
      integer*4 N7,N,ISI(NGE0,4),I1,I2,J1,J2,k,ii,
     1ib,i,j,TYPE(*),NZF,state1(NT3),state2(NT3),NHBIG,NSBIG,
     2IT,IS,IBIGSYM,ICC,IN,KK,STATE2B(ib0,NT3),inm(*)
      logical LSPARSE,LQD,LH40,L4,LENAS
      real*8 EK1(*),EK2(*),tkj,c(NDIM,NDIM),cjk,v,
     1dkj,AAf,hij,EJ(ib0),EK0(*),A
      real*8,allocatable::fih2fj(:,:)
      common/sum/A,state1,state2,N7,N,L4
      COMMON/DIA1/NHBIG,IT(NM0),IS(NM0),IBIGSYM(NM0),
     1ICC(NM0,ME0),IN(NM0,ME0)
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent
c     largest d-coefficients:
      real*8 dco
      integer*4 kco,jco
      common/dlc/dco(nl0),kco(nl0),jco(nl0)
c
      allocate(fih2fj(ib,I2-I1+1))
c     precalculate <fi(1..N)|H2|fj j=1..NSBIG>:
      do 1 j=1,ib

      S2_Ncent=0
      S2_Nexc=0
      do 11 ii=N7,N
      if(STATE2B(j,ii).ne.0)then
       S2_Ncent=S2_Ncent+1
       S2_Lcent(S2_Ncent)=ii
       S2_Lexc(S2_Ncent)=STATE2B(j,ii)
       S2_Nexc=S2_Nexc+STATE2B(j,ii)
      endif
11    state2(ii)=STATE2B(j,ii)

      do 1 i=I1,I2

      DO 217 II=N7,N
217   STATE1(II)=0
      S1_Ncent=IS(i)
      S1_Nexc=IT(i)
      do 218 KK=1,IS(i)
      S1_Lcent(KK)=ICC(i,KK)
      S1_Lexc(KK)=IN(i,KK)
218   STATE1(ICC(i,KK))=IN(i,KK)

1     fih2fj(j,i-I1+1)=hij(IT(i),TYPE(j),LSPARSE,LQD,NZF,LH40)
c
c     add this batch to the k-states
      do 2 j=1,ib
      do 2 k=J1,J2
c
c     tkj=<psi_k|H2|fj>=sum(i)cki*<fi(1..N)|H2|fj>:
      tkj=0.0d0
      do 216 i=I1,I2
216   tkj=tkj+c(i,k)*fih2fj(j,i-I1+1)
      if(LENAS)then
c
       if(inm(j).ne.0)then
        cjk=c(inm(j),k)
       else
        cjk=0.0d0
       endif

c      coefficients (E(1)k c(k,j) - tkj)/(ej-epsk):
       v=EK1(k)*cjk-tkj
       if(dabs(v).gt.0.0d0)then
        if(v.gt.0.0d0)then
         dkj= AAf(EJ(j),EK0(k),v)/dabs(v)
        else
         dkj=-AAf(EJ(j),EK0(k),v)/dabs(v)
        endif
        do 13 i=1,nl0
        if(dabs(dkj).gt.dabs(dco(i)))then
         do 131 ii=nl0,i+1,-1
         dco(ii)=dco(ii-1)
         kco(ii)=kco(ii-1)
131      jco(ii)=jco(ii-1)
         dco(i)=dkj
         kco(i)=k
         jco(i)=NSBIG-ib+j
         goto 16
        endif
13      continue
16      continue
       else
        dkj=0.0d0
       endif
c
c      e(2)k=sum(dkj*tkj-E(1)k dkj ckj):
       EK2(k)=EK2(k)+dkj*(tkj-EK1(k)*cjk)
      else
c      only new states considered
       if(inm(j).eq.0)then
c       e(2)k=sum tkj^2/(epsk-ej):
        EK2(k)=EK2(k)+AAf(EK0(k),EJ(j),tkj)
       endif
      endif
2     continue

      ib=0

      return

      end
