      SUBROUTINE DOCQ(S,N,LP3,HW,N7,LXS,YLIM,NCAN,ICAN,tol3)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      LOGICAL LP3,HW,LXS
      include 'dimensions.h'
      DIMENSION S(NT3,N),A(NT3,NT3),ICAN(*)
      real*8,allocatable:: CQ(:),CX(:,:,:),CNEW(:,:,:)
c     CQ(NT3**3),CX(NT3,NT3,NT3),CNEW(NT3,NT3,NT3)
      COMMON/CEM/E(NT3)
c
      allocate(CQ(1:N*((N*(N+1))/2)),stat=is)
      if(is.ne.0)call report('cannot allocate CQ in docq')
      allocate(CX(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX in docq')
      allocate(CNEW(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CNEW in docq')
      CM=219470.0d0
      DO 40 IC=1,N
      DO 40 JC=1,N
      DO 40 KC=1,N
40    CX(JC,KC,IC)=0.0d0
      IF(LXS)THEN
       IF(.NOT.LP3)THEN
        WRITE(6,*)' Transforming sparse CX -> CQ'
        N33=0
        DO 111 ICIND=1,NT3**3
111     CQ(ICIND)=0.0d0
        OPEN(4,FILE='SCR.33')
62      READ(4,*,END=53)IC,JC,KC,CON
        INDC=0
        IF(IC.EQ.JC)THEN
         IF(JC.EQ.KC)THEN
          GOTO 10
         ELSE
          JC=KC
          GOTO 20
         ENDIF
        ELSE
         IF(IC.EQ.KC)THEN
          GOTO 20
         ELSE
          IF(JC.EQ.KC)THEN
           JC=IC
           IC=KC
           GOTO 20
          ELSE
           GOTO 30
          ENDIF
         ENDIF
        ENDIF
C
C       iii
10      DO 11 I=N7,N
        AII=S(IC,I)*CON
        DO 11 J=I,N
        AJI=S(IC,J)*AII
        DO 11 K=J,N
        INDC=INDC+1
11      CQ(INDC)=CQ(INDC)+S(IC,K)*AJI
        GOTO 99
C
C       iij
20      DO 22 I=N7,N
        AII=S(IC,I)*CON
        AIJ=S(JC,I)*CON
        DO 22 J=I,N
        AIIAJI=AII*S(IC,J)
        AIIAJJ=AII*S(JC,J)
        AIJAJI=AIJ*S(IC,J)
        DO 22 K=J,N
        INDC=INDC+1
22      CQ(INDC)=CQ(INDC)+AIIAJI*S(JC,K)+(AIIAJJ+AIJAJI)*S(IC,K)
        GOTO 99
C
C       ijk
30      DO 33 I=N7,N
        AII=S(IC,I)*CON
        AIJ=S(JC,I)*CON
        AIK=S(KC,I)*CON
        DO 33 J=I,N
        AIIAJJ=AII*S(JC,J)
        AIIAJK=AII*S(KC,J)
        AIJAJK=AIJ*S(KC,J)
        AIJAJI=AIJ*S(IC,J)
        AIKAJI=AIK*S(IC,J)
        AIKAJJ=AIK*S(JC,J)
        DO 33 K=J,N
        INDC=INDC+1
33      CQ(INDC)=CQ(INDC)+S(IC,K)*(AIJAJK+AIKAJJ)+
     1                    S(JC,K)*(AIKAJI+AIIAJK)+
     2                    S(KC,K)*(AIIAJJ+AIJAJI)
C
99      N33=N33+1
        GOTO 62
53      CLOSE(4)
        WRITE(3,*)N33,' Cartesian cubics loaded'
        WRITE(6,*)N33,' Cartesian cubics loaded'
        GOTO 999
       ENDIF
       N33=0
       OPEN(4,FILE='SCR.33')
82     READ(4,*,END=83)I,J,K,CX(I,J,K)
       CX(J,I,K)=CX(I,J,K)
       CX(K,J,I)=CX(I,J,K)
       CX(I,K,J)=CX(I,J,K)
       CX(K,I,J)=CX(I,J,K)
       CX(J,K,I)=CX(I,J,K)
       N33=N33+1
       GOTO 82
83     CLOSE(4)
       WRITE(3,*)N33,' sparse cartesian cubics loaded, CX reconstructed'
       GOTO 84
      ENDIF
      INDC=0
      DO 41 IC=1,N
      DO 41 JC=IC,N
      DO 41 KC=JC,N
      INDC=INDC+1
      AC=CQ(INDC)
      CX(IC,JC,KC)=AC
      CX(JC,IC,KC)=AC
      CX(KC,JC,IC)=AC
      CX(IC,KC,JC)=AC
      CX(KC,IC,JC)=AC
41    CX(JC,KC,IC)=AC
C
84    C111=0.0d0
      C211=0.0d0
      C311=0.0d0
      DO 43 L=2,N/3
      C111=C111-CX(3*L-2,1,1)
      C211=C211-CX(3*L-1,1,1)
43    C311=C311-CX(3*L  ,1,1)
      WRITE(3,333)C111,C211,C311,CX(1,1,1),CX(2,1,1),CX(3,1,1)
      WRITE(6,333)C111,C211,C311,CX(1,1,1),CX(2,1,1),CX(3,1,1)
333   FORMAT(1X,'Sum rule for cubics',/,1X,3F15.10,/,1X,3F15.10,/,/)
      write(6,*)INDC,' cartesians'
      write(3,*)INDC,' cartesians'
C
      IF(LP3)THEN
       WRITE(6,*)'Projecting zero-vibrations from cubics...'
       CALL DOMA(A,NT3,N,HW)
       DO 52 I=1,N
       WRITE(6,*)I,' of ',N
       DO 52 J=I,N
       DO 52 K=J,N
       S1=0.0d0
       S2=0.0d0
       S3=0.0d0
       DO 552 II=1,N
       AIII=A(I,II)
       AJII=A(J,II)
       AKII=A(K,II)
C      iiii:
       S1=S1+AIII*AJII*AKII*CX(II,II,II)
       DO 552 JJ=II+1,N
       AIJJ=A(I,JJ)
       AJJJ=A(J,JJ)
       AKJJ=A(K,JJ)
C      iij=iji=jii (and i>j):
       S2=S2+CX(II,II,JJ)*
     1 (AIII*AJII*AKJJ+AIJJ*AJII*AKII+AIII*AJJJ*AKII)+
     2       CX(JJ,JJ,II)*
     2 (AIJJ*AJJJ*AKII+AIII*AJJJ*AKJJ+AIJJ*AJII*AKJJ)
       SKKK=AIII*AJJJ+AIJJ*AJII
       SJKK=AIII*AKJJ+AIJJ*AKII
       SIKK=AJII*AKJJ+AJJJ*AKII
       DO 552 KK=JJ+1,N
C      ijk=ikj=jik=jki=kij=kji
552    S3=S3+CX(KK,II,JJ)*(
     1 A(K,KK)*SKKK+A(J,KK)*SJKK+A(I,KK)*SIKK)
52     CNEW(I,J,K)=S1+S2+S3
       DO 55 I=1,N
       DO 55 J=I,N
       DO 55 K=J,N
       CX(I,J,K)=CNEW(I,J,K)
       CX(J,I,K)=CNEW(I,J,K)
       CX(K,J,I)=CNEW(I,J,K)
       CX(I,K,J)=CNEW(I,J,K)
       CX(J,K,I)=CNEW(I,J,K)
55     CX(K,I,J)=CNEW(I,J,K)
      ENDIF
c
c     write projected cubics on the disk
      OPEN(40,FILE='XX3P.SCR.TXT',FORM='UNFORMATTED')
      DO 56 I=1,N
      DO 56 J=1,N
      DO 56 K=1,N
56    if(dabs(CX(I,J,K)).gt.YLIM)write(40,4000)I,J,K,CX(I,J,K)
4000  format(3i6,G16.8)
      close(40)
C
      WRITE(3,*)
      INDC=0
      WRITE(6,*)' Transforming cubics ... '
      DO 44 I=N7,N
      WRITE(6,*)I,' of ',N
      DO 44 J=I,N
      DO 44 K=J,N
      INDC=INDC+1
      S1=0.0d0
      S2=0.0d0
      S3=0.0d0
      DO 42 IC=1,N
      AII=S(IC,I)
      AJI=S(IC,J)
      AKI=S(IC,K)
C     iii
      S1=S1+AII*AJI*AKI*CX(IC,IC,IC)
      DO 42 JC=IC+1,N
      AIJ=S(JC,I)
      AJJ=S(JC,J)
      AKJ=S(JC,K)
C     iij=iji=jii=jji=jij=ijj
      S2=S2+(AII*(AJI*AKJ+AJJ*AKI)+AIJ*AJI*AKI)*CX(IC,IC,JC)+
     1      (AIJ*AJJ*AKI+(AIJ*AJI+AII*AJJ)*AKJ)*CX(JC,JC,IC)
      SKCK=AII*AJJ+AIJ*AJI
      SKCJ=AII*AKJ+AIJ*AKI
      SKCI=AJI*AKJ+AJJ*AKI
      DO 42 KC=JC+1,N
C     ijk=ikj=jki=jik=kij=kji
42    S3=S3+CX(IC,JC,KC)*
     1(S(KC,K)*SKCK+S(KC,J)*SKCJ+S(KC,I)*SKCI)
44    CQ(INDC)=S1+S2+S3
999   continue
c
      open(23,file='CQQ.SCR.TXT')
      INDC=0
      nq=0
      do 64 i=N7,N
      do 64 j=i,N
      do 64 k=j,N
      INDC=INDC+1

c     skip if mode blocked:
      do 4001 l=1,NCAN
4001  if(I-N7+1.eq.ICAN(l).or.J-N7+1.eq.ICAN(l).or.K-N7+1.eq.ICAN(l))
     1goto 64
c
c     skip for negative frequencies:
      if(e(i).le.0.0d0.or.e(j).le.0.0d0.or.e(k).le.0.0d0)goto 64

      cqau=CQ(INDC)
      cqcn=cqau/dsqrt(abs(e(i)*e(j)*e(k)))
      cqcm=cqcn*cm
c
c     skip small constants:
      if(abs(cqcm).lt.tol3)goto 64
c
      write(23,2423)I,J,K,cqcn,cqcm
2423  format(3I5,G16.8,' ',F9.1)
      nq=nq+1
64    continue
      close(23)
      write(6,6000)INDC,nq,tol3
      write(3,6000)INDC,nq,tol3
6000  format('Number of normal cubics ',I10,/,
     1       'Selected                ',I10,/,
     1       'Limit                   ',F10.7,/,
     1       'Writen in CQQ.SCR.TXT',/)
      deallocate(CQ)
      deallocate(CX)
      deallocate(CNEW)
      RETURN
      END
