      SUBROUTINE DOHBIG(IRQR,ASL,IDC,EOLD)
      IMPLICIT none
      include 'dimensions.h'
      integer*4 NGE0
      PARAMETER (NGE0=24)
      integer*4 IRQR,IDC,I,J,K,J1,MVTOT,ISTARTBLK,I1,I2,Kb,NDIM,
     1IYX(2,NGE0),ISI(NGE0,4),IK,MOT,KK,JK,KKK,JJ,NE,IERR,IAH,IJ,
     1NEE,L,i33,JHH,jmax,mclock,INI,IMOD,ISA,ISB,IT0
      real*8 ASL,EOLD(*),EAH(MG0),amax,CM,etlim,etal,det

      real*8 A
      integer*4 STATE1(NT3),STATE2(NT3),N7,N
      LOGICAL L4
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4

      real*8 E
      COMMON/CEM/E(NT3)

      integer*4 NHBIG,IT,IS,IBIGSYM,ICC,IN
      COMMON/DIA1/NHBIG,IT(NM0),IS(NM0),IBIGSYM(NM0),
     1ICC(NM0,ME0),IN(NM0,ME0)

      LOGICAL SMITIN,lft,lftg,lopt,lto,lfft,ldh3,lcoef
      real*8 ropt,clim,OH,DOH,wmin,wmax,dw,acoef,dele
      common/lop/lopt(300)
      common/opt/ropt(100)
      equivalence (lft,lopt(27)),(lftg,lopt(28)),(lto,lopt(40)),
     1(wmin,ropt(8)),(wmax,ropt(9)),(dw,ropt(10)),(OH,ropt(15)),
     1(DOH,ropt(16)),(etlim,ropt(17)),(etal,ropt(18)),(det,ropt(19)),
     1(lfft,lopt(45)),(ldh3,lopt(46)),(SMITIN,lopt(49)),(clim,ropt(24)),
     1(lcoef,lopt(50)),(acoef,ropt(25)),(dele,ropt(26))

      logical LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,HW,DC,QUARTIC
      integer*4 NCAN,ICAN,NZF,IBR,IERM
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,HW,DC,QUARTIC,NCAN,
     1ICAN(NT3),NZF,IBR,IERM

      integer*4 MV,LEXCL
      COMMON/RUNCON/LEXCL
      COMMON/EIGEN/MV
      real*8 AMACH
      COMMON/MACHINE/AMACH
      real*8 VMM
      integer*4 NMM,NHAND
      COMMON/MMM/VMM,NMM,NHAND
      real*8 GRADCONV,OLIMIT
      COMMON/PPP/GRADCONV,OLIMIT
      CHARACTER*1 s1
      CHARACTER*3 SSTR
      INTEGER*4 IY,CHT,IG,IGG,KG,ID,iopt,nproc,NG0,MAXIT
      COMMON/SYMCOM/IY(NT3),CHT(NGE0,NGE0),IG,IGG,KG,ID(NGE0),SSTR
      common/iop/iopt(300)
      equivalence (iopt(18),NG0)

      real*8,allocatable:: HBIG(:,:),SMALLC(:,:),EE(:),a33(:),SMALLE(:),
     1CFJ(:)
      integer*4 ,allocatable::j33(:)

c     NQQ=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6
c     HBIG(NG0,NG0),SMALLC(NG0,NG0),CQ(NQQ)
c
      call w36(' ')
      call w36('Dohbig')
      call w36('^^^^^^')
      CM=219470.0d0
      nproc=iopt(14)
      MAXIT=iopt(19)
C     1 a.u.= 2.1947E5 cm^-1
C
      allocate(CFJ(NM0))
      write(6,*)NHBIG,N7,N
      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
      call w36('CD loaded')
      write(6,*)NHBIG,N7,N
c
      call readstates(NHBIG,N7,N,NM0,IS,IBIGSYM,IT,ICC,IN,ISB,IYX,ME0,
     1NGE0)
c
      IF(IDC.EQ.1)THEN
       OPEN(4,FILE='EIGEN.SCR',FORM='UNFORMATTED')
       READ(4)N7,N,LEXCL,NHBIG,MV,KG,ISB
       READ(4)(IT(I),I=1,NHBIG) ,(IS(I),I=1,NHBIG),
     1 ((ICC(I,J),I=1,NHBIG),J=1,LEXCL),((IN(I,J),I=1,NHBIG),J=1,LEXCL),
     2 (EAH(I),I=1,MV),(E(I),I=N7,N),(EOLD(I),I=N7,N),
     3 ((IYX(K,J),K=1,2),J=1,ISB),((ISI(J,K),K=1,4),J=1,KG)
       CLOSE(4)
       GOTO 9898
      ENDIF
C
      J1=1
      MVTOT=0
      ISTARTBLK=MAX(1,IBR)
C
C     Start from block IBR, frequency IERM
C
      DO 94 J=ISTARTBLK,ISB
      WRITE(3,*)' Block  ',J
      WRITE(6,*)' Block  ',J
      I1=IYX(1,J)
      I2=IYX(2,J)
c
c     determine symmetry
      Kb=1
      DO 1003 IK=1,KG
1003  IF(IBIGSYM(I1).EQ.IK)Kb=IK
      NDIM=I2-I1+1
      WRITE(3,*)' Symmetry',Kb
      WRITE(6,*)' Symmetry',Kb
      write(s1,4000)Kb
4000  format(i1)

      IF(J.GT.1)THEN
       OPEN(45,FILE='EEO.SCR',FORM='UNFORMATTED',STATUS='OLD')
       READ(45)MOT,(EAH(KK),KK=1,MOT)
       READ(45)JK,((ISI(KK,KKK),KKK=1,4),KK=1,JK)
       CLOSE(45)
       WRITE(3,*)MOT,' energies read in'
       WRITE(6,*)MOT,' energies read in'
C      Find how many states done
       J1=0
       DO 101 I=1,KG
       IF(ISI(I,4).GT.J1)THEN
        DO 102 JJ=1,J-1
        IF(IBIGSYM(IYX(1,JJ)).EQ.I) J1=ISI(I,4)
102     CONTINUE
       ENDIF
101    CONTINUE
       WRITE(3,*)J1,' states of this block finished'
       WRITE(6,*)J1,' states of this block finished'
       J1=J1+1
      ENDIF
C
      IF(.not.LMITIN.AND.NDIM.GT.NG0)then
       if(.not.lft)CALL REPORT('Block too big')
      endif
      IF(IERM.EQ.0)then
c
c      parallelizable path:
       if(.not.LSPARSE.and.NZF.eq.0.and..not.LH40)then
        CALL dohim4(I1,I2,ISB,Kb,nproc)
       else
        if(ldh3)then
c        "fast H" - obsolete option:
         CALL dohim3(I1,I2,ISB,Kb)
        else
         CALL dohim(I1,I2,ISB,Kb)
        endif
       endif
      endif
      WRITE(6,*)' HAMILTONIAN DONE',I1,I2,NDIM
      ISI(Kb,1)=I1
      ISI(Kb,2)=I2
C
C     Number of eigenvalues to be found: NE; IF IRQR=0, use STurm seq.
      NE=MIN(nint((dble(IRQR)*dble(I2-I1+1)) / dble(NHBIG)),NDIM)
      NEE=NE
      write(6,6001)IRQR,I2,I1,NHBIG,NDIM,NE
6001  format(' IRQR ,   I2, I1:',3I9,/,
     1       ' NHBIG, NDIM, NE:',3I9)
      IF(NEE.EQ.0)NEE=NDIM
      allocate(SMALLE(NDIM))
c
c     Fourier transform spectral generation routines:
      if(lft)then
       if(lfft)then
        call sgfourier(NDIM,NMM,NEE,VMM,SMALLE,IERR,MV,J1,s1,MVTOT,
     1  lftg)
       else
        call sgfourierslow(NDIM,NMM,NEE,VMM,SMALLE,IERR,MV,J1,s1,MVTOT,
     1  lftg)
       endif
      endif
      it0=mclock()
C
C     The diagonalization routine called:
      IF(LMITIN)then
       if(SMITIN)then
        write(6,*)'mitin called-all in memory'
        I=NDIM
        CALL MITINS(NDIM,NMM,NEE,VMM,SMALLE,IERR,MV,J1,s1,MVTOT,I,
     1  nproc,clim,MAXIT,HW,OLIMIT,GRADCONV,AMACH,acoef,lcoef,dele)
       else
        write(6,*)'mitin called-classical'
        I=NDIM
        CALL MITINX(NDIM,NMM,NEE,VMM,SMALLE,IERR,MV,J1,s1,MVTOT,I)
       endif
      else
       allocate(EE(NDIM),a33(NDIM),j33(NDIM))
       allocate(HBIG(1:NDIM,1:NDIM))
       allocate(SMALLC(1:NDIM,1:NDIM))
       OPEN(4,FILE=s1//'A2.SCR',FORM='UNFORMATTED',STATUS='OLD')
       READ(4)NDIM
       if(NG0.lt.NDIM)call report('NDIM>NG0')
       DO 921 I=1,NDIM
       DO 921 L=1,NDIM
921    HBIG(I,L)=0.0d0
       DO 92 I=1,NDIM
       READ(4)i33,(j33(JHH),JHH=1,i33),(a33(JHH),JHH=1,i33)
       DO 92 JHH=1,i33
       L=j33(JHH)
92     HBIG(L,I)=a33(JHH)
       CLOSE(4)
       deallocate(a33,j33)
       call w36('Direct method - Hamiltonian read from '//s1//'A2.SCR')
       if(lto)then
        call w36('Empirical Hamiltonian scaling')
        write(3,2966)etlim,det,etal
        write(6,2966)etlim,det,etal
2966    format(' Elim = ',f8.1,' cm-1',/,
     1         ' dE   = ',f8.1,' cm-1',/,
     2         ' sf   = ',f8.1)
        do 922 I=1,NDIM
922     if(HBIG(I,I).gt.etlim)HBIG(I,I)=HBIG(I,I)*
     1  (etal+(1.0d0-etal)*exp(-(HBIG(I,I)-etlim)**2/det**2))
       endif
       IF(HW)THEN
        WRITE(3,*)' THE HAMILTONIAN:'
        WRITE(6,*)' HAMILTONIAN: diagonal and largest interaction:'
        DO 1206 I=1,NDIM
        WRITE(3,1209)I
1209    FORMAT(I10,':')
        jmax=0
        amax=0.0d0
        do 2 JJ=1,NDIM
        if(JJ.ne.I.and.dabs(HBIG(I,JJ)).gt.amax)then
         amax=dabs(HBIG(I,JJ))
         jmax=JJ
        endif
2       continue
        WRITE(6,1208)I,HBIG(I,I),amax,jmax
1208    FORMAT(I5,2F9.1,' to ',I5)
1206    WRITE(3,1207)(HBIG(I,JJ),JJ=1,NDIM)
1207    FORMAT(10F8.1)
       ENDIF
       IMOD=2
       IERR=0
       I=NDIM
       CALL TRED12(NDIM,I,HBIG,SMALLC,SMALLE,IMOD,IERR,EE)
       deallocate(EE)
       if(IERR.ne.0)call report('Diagonalization error')
       call w36('diagonalization ok')
       NE=NDIM
       MV=0
       do 1  i=1,NDIM
1      if(SMALLE(i).lt.VMM)MV=MV+1
       WRITE(3,301)MV,VMM
       WRITE(6,301)MV,VMM
301    format(i5,' eigenvalues smaller than ',f10.2)
       deallocate(HBIG)
      endif
      write(3,6009)dble(mclock()-it0)/100.0d0
      write(6,6009)dble(mclock()-it0)/100.0d0
6009  format(' Time: ',f15.2,' sec')
C
C     The Hamiltonian is diagonalized in CM-1, because of numerical stability
      DO 105 ISA=1,MV
105   SMALLE(ISA)=SMALLE(ISA)/CM
C
      IF(IERR.NE.0.AND.IERR.NE.8888)CALL REPORT(' DIAG. ERROR ')
      WRITE(3,*)'From ',MV,' eigenvalues ',MIN(MV,MG0-MVTOT),' kept'
      WRITE(6,*)'From ',MV,' eigenvalues ',MIN(MV,MG0-MVTOT),' kept'
      MV=MIN(MV,MG0-MVTOT)
      ISI(Kb,3)=MVTOT+1
      ISI(Kb,4)=MVTOT+MV
      DO 97 ISA=1,MV
      MVTOT=MVTOT+1
      EAH(MVTOT)=SMALLE(ISA)
      WRITE(3,*)ISA,MVTOT,SMALLE(ISA)*CM
      WRITE(6,*)ISA,MVTOT,SMALLE(ISA)*CM
      IF(LMITIN)GOTO 97
C     MVTOT - eigenvector:
      DO 977 INI=1,NDIM
977   CFJ(INI)=SMALLC(INI,ISA)
      WRITE(3,*)' Eigenvector ',ISA,MVTOT,NDIM,MV
      IF(HW)THEN
       WRITE(3,3333)(CFJ(IJ),IJ=1,NDIM)
3333   FORMAT(10F7.4)
      ENDIF
      CALL SAVEC(MVTOT,CFJ,NDIM)
97    CONTINUE
      if(.not.LMITIN) deallocate(SMALLC)
      deallocate(SMALLE)
C
      IERM=0
      OPEN(45,FILE='EEO.SCR',FORM='UNFORMATTED')
      WRITE(45)MVTOT,(EAH(KK),KK=1,MVTOT)
      WRITE(45)KG,((ISI(KK,KKK),KKK=1,4),KK=1,KG)
      CLOSE(45)
      WRITE(3,*)MVTOT,' energies saved into EEO.SCR'
94    WRITE(6,*)MVTOT,' energies saved into EEO.SCR'
c     end of block calculations
      write(6,*)((ISI(k,i),i=1,4),k=1,KG)
C
      IF(MVTOT.EQ.0)CALL REPORT('No eigenvalues found')
      OPEN(45,FILE='EEO.SCR',FORM='UNFORMATTED',STATUS='OLD')
      READ(45)MV,(EAH(KK),KK=1,MV)
      READ(45)KG,((ISI(KK,KKK),KKK=1,4),KK=1,KG)
      CLOSE(45)
      WRITE(6,*)MV,' energies read from EEO.SCR:'
      WRITE(3,*)MV,' energies read from EEO.SCR:'
      DO 24 I=1,MV
      WRITE(3,6000)I,EAH(I)*CM
24    WRITE(6,6000)I,EAH(I)*CM
6000  FORMAT(I6,F12.2)
C
      OPEN(4,FILE='EIGEN.SCR',FORM='UNFORMATTED')
      WRITE(4)N7,N,LEXCL,NHBIG,MV,KG,ISB
      WRITE(4)(IT(I),I=1,NHBIG) ,(IS(I),I=1,NHBIG),
     1((ICC(I,J),I=1,NHBIG),J=1,LEXCL),((IN(I,J),I=1,NHBIG),J=1,LEXCL),
     2(EAH(I),I=1,MV),(E(I),I=N7,N),(EOLD(I),I=N7,N),
     3((IYX(K,J),K=1,2),J=1,ISB),((ISI(J,K),K=1,4),J=1,KG)
      CLOSE(4)
      WRITE(6,*)' EIGEN.SCR written'
      WRITE(3,*)' EIGEN.SCR written'
C
      IAH=1
      CALL TERMO(EAH,IAH,MV,IAH)
C
9898  CONTINUE
C
      call w36('Dohbig-ok')
      RETURN
      END
