      SUBROUTINE DOHIM(ISTART,IEND,ISB,Kb)
      IMPLICIT none
      include 'dimensions.h'
      INTEGER*4 ISTART,IEND,ISB,Kb,NDIM,ild,it0,IISTART,I,i33,IHH,
     1II,K,maxj,J,JHH,MCLOCK
      LOGICAL LASCR,la1scr
      real*8 E
      COMMON/CEM/E(NT3)
      integer*4 NBG,IT,IS,IBIGSYM,ICC,IN
      COMMON/DIA1/NBG,IT(NM0),IS(NM0),IBIGSYM(NM0),
     1ICC(NM0,ME0),IN(NM0,ME0)
      LOGICAL LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC
      integer*4 NCAN,ICAN,NZF,IBR,IERM
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      real*8 ropt
      common/opt/ropt(100)
      real*8 A
      INTEGER*4 STATE1(NT3),STATE2(NT3),N7,N
      LOGICAL L4
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      real*8 HSLIM
      equivalence (HSLIM,ropt(7))
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent
      real*8 nel,aveo,aved,CM,EI,hmaxj,EJ,HII,hij,HOFF
      character*1 s1
      integer*4,allocatable::j33(:)
      real*8,allocatable::a33(:)
c
      call w36(' ')
      call w36('Dohim')
      call w36('^^^^^')
      allocate(a33(NM0),j33(NM0))
      NDIM=IEND-ISTART+1
      ild=0
      write(6,6001)ISTART,IEND,ISB,Kb,N7,LSPARSE
      write(3,6001)ISTART,IEND,ISB,Kb,N7,LSPARSE
6001  format('dohim called',
     1/,' ISTART:',I8,' IEND:',I8,' ISB:',I5,' Kb:',I5,' N7:',I5,
     2/,' SPARSE:',L5)
      write(s1,4000)Kb
4000  format(i1)
      inquire(FILE=s1//'A2.SCR',exist=LASCR)
      inquire(FILE=s1//'A.SCR',exist=la1scr)
      if(LASCR.or.la1scr)then
       if(lASCR)then
        write(6,*)s1//'A2.SCR found on disk'
        OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
       else
        write(6,*)s1//'A.SCR found on disk'
        OPEN(2,FILE=s1//'A.SCR',FORM='UNFORMATTED')
       endif
       read(2,end=2999,err=2999)i
       ild=ild+1
       do 200 i=1,NDIM
       read(2,end=2999,err=2999)
200    ild=ild+1
2999   close(2)
       write(6,*)ild,' lines'
       write(3,*)ild,' lines'
       if(ISB.eq.1.and.ild.eq.NDIM+1)then
        write(6,*)'calculation skipped'
        return
       endif
      endif

      it0=mclock()
      nel=0.0d0
      aveo=0.0d0
      aved=0.0d0
      CM=219470.0d0
      WRITE(3,3000)
      WRITE(6,3000)
3000  FORMAT(' Diagonal Hamiltonian:',/,
     1       ' line        hii  harmonic  jmax    hijmax ',/,
     280(1H-))

      OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
      if(ild.gt.0)then
       do 2001 i=1,ild
2001   read(2)
       IISTART=ISTART+ild-1
       IHH=ild-1
       write(6,2006)ISTART,ild,IISTART,NDIM
2006   format(' ISTART:',I6,' ild:', I6,' IISTART:',I6,' NDIM:',I6)
      else
       WRITE(2)NDIM
       IISTART=ISTART
       IHH=0
      endif
c
      DO 29 I=IISTART,IEND
      IHH=IHH+1
      i33=0

C     Define state i:
      EI=0.0d0
      DO 1 II=N7,N
1     STATE1(II)=0
      S1_Ncent=IS(I)
      S1_Nexc=IT(I)
      DO 4 K=1,IS(I)
      EI=EI+DBLE(IN(I,K))*E(ICC(I,K))
      S1_Lcent(K)=ICC(I,K)
      S1_Lexc(K)=IN(I,K)
4     STATE1(ICC(I,K))=IN(I,K)
c
c     maximal off-diagonal component
      maxj=0
      hmaxj=0.0d0
c
      JHH=0
      DO 2 J=ISTART,IEND
c     DO 2 J=I,I
      JHH=JHH+1
c
C     Define state j:
      EJ=0.0d0
      DO 5 II=N7,N
5     STATE2(II)=0
      S2_Ncent=IS(J)
      S2_Nexc=IT(J)
      DO 6 K=1,IS(J)
      EJ=EJ+DBLE(IN(J,K))*E(ICC(J,K))
      S2_Lcent(K)=ICC(J,K)
      S2_Lexc(K)=IN(J,K)
6     STATE2(ICC(J,K))=IN(J,K)

C     i=j:
      IF(I.EQ.J)THEN
C      Diagonal harmonic term:
c      QUARTIC ... calculate diagonal quartic terms
c      LQD     ... calculate off-diagonal quartic terms
c      LH40    ... kinetic energy correction
       HII=EI+hij(IT(I),IT(J),LSPARSE,QUARTIC,NZF,LH40)
       nel=nel+1.0d0
       i33=i33+1
       a33(i33)=HII*CM
       j33(i33)=IHH
       aved=aved+dabs(a33(i33))
       write(3,3030)I,a33(i33),EI*CM,maxj,hmaxj
       write(6,3030)I,a33(i33),EI*CM,maxj,hmaxj
3030   format(I6,2F10.2,i6,F10.2)
      else
       HOFF=hij(IT(I),IT(J),LSPARSE,LQD,NZF,LH40)
       if(dabs(HOFF*CM).ge.hmaxj)then
        maxj=J
        hmaxj=dabs(HOFF*CM)
       endif
       if(dabs(HOFF/(EI-EJ)).gt.HSLIM)then
        i33=i33+1
        j33(i33)=JHH
        a33(i33)=HOFF*CM
        aveo=aveo+dabs(a33(i33))
        nel=nel+1.0d0
       endif
      endif
2     CONTINUE
c     J
c
      WRITE(2)i33,(j33(JHH),JHH=1,i33),(a33(JHH),JHH=1,i33)
29    CONTINUE
c     I
c
      CLOSE(2)
      WRITE(3,6000)s1,HSLIM,nel,nel/dble(NDIM)/dble(NDIM+1)*50.0d0,
     1dble(NDIM)*dble(NDIM+1)/2.0d0,nel*(4.0d0+8.0d0)/1000.0d0,
     1aved/dble(NDIM),aveo/nel
      WRITE(6,6000)s1,HSLIM,nel,nel/dble(NDIM)/dble(NDIM+1)*50.0d0,
     1dble(NDIM)*dble(NDIM+1)/2.0d0,nel*(4.0d0+8.0d0)/1000.0d0,
     1aved/dble(NDIM),aveo/nel
6000  format(' Hamiltonian written into ',a1,'A2.SCR',/,
     1' Cut of limit |Hij/Eij|:',f10.5,/,
     2' Number of elements bigger then cutoff:',f20.0,' (',f5.1,'%)',/,
     3' Total number of elements :',f20.0,/,
     3' Memory required :',f10.0,' kbytes',/,
     3' Average diagonal element:',f10.2,/,
     3' Average off diagonal element:',f10.2)
      write(6,6009)(mclock()-it0)/100
      write(3,6009)(mclock()-it0)/100
6009  format(' H done in ',i10,' sec')
      call w36('Dohim-ok')
      RETURN
      END
c
      function hij(ti,tj,LSPARSE,LQD,NZF,LH40)
c     <i|H|j> off-diagonal only
      implicit none
      include 'dimensions.h'
      integer*4 ti,tj,NZF,STATE1(NT3),STATE2(NT3),N7,N
      logical LSPARSE,LQD,LH40,L4
      real*8 A,hij,um
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      A=0.0d0
c
C     Cubic term
      IF(LSPARSE)THEN
       IF( ((ti-tj+1)/2)*2.EQ.ti-tj+1 )CALL SUMSGHOST
      ELSE
       IF( ((ti-tj+1)/2)*2.EQ.ti-tj+1 )CALL SUMS
      ENDIF
      um=A
c
C     Quartic
      IF(LQD)THEN
       A=0.0d0
       IF(LSPARSE)THEN
        IF( ((ti-tj)/2)*2.EQ.ti-tj )CALL SUMSQGHOST
       ELSE
        IF( ((ti-tj)/2)*2.EQ.ti-tj )CALL SUMSQ
       ENDIF
       um=um+A
      ENDIF
c
C     Substituted frequencies
      IF(NZF.NE.0)THEN
       CALL SUMSE
       um=um+A
      ENDIF
c
C     Kinetic term
      IF(LH40)THEN
       CALL SUM4
       um=um+A
c      AKIN=A*CM
      ENDIF

      hij=um
      return
      end
