      SUBROUTINE DOHIM2(ISTART,IEND,ISB,Kb)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      DIMENSION a33(NM0),j33(NM0)
      INTEGER*4 STATE1(NT3),STATE2(NT3)
      LOGICAL L4,LASCR
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      COMMON/CEM/E(NT3)
      COMMON/DIA1/NBG,IT(NM0),IS(NM0),IBIGSYM(NM0),
     1ICC(NM0,ME0),IN(NM0,ME0)
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      character*1 s1
      common/opt/ropt(100)
      equivalence (HSLIM,ropt(7))
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent
c
      call w36(' ')
      call w36('Dohim2')
      call w36('^^^^^^')
      NDIM=IEND-ISTART+1
      ild=0
      write(6,6001)ISTART,IEND,ISB,Kb,N7,LSPARSE
      write(3,6001)ISTART,IEND,ISB,Kb,N7,LSPARSE
6001  format('dohim called',
     1/,' ISTART:',I6,' IEND:',I6,' ISB:',I5,' Kb:',I5,' N7:',I5,
     2/,' SPARSE:',L5)
      write(s1,4000)Kb
4000  format(i1)
      inquire(FILE=s1//'A2.SCR',exist=LASCR)
      if(LASCR)then
       write(6,*)s1//'A2.SCR found on disk'
       OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
       read(2,end=2999,err=2999)i
       ild=ild+1
       do 200 i=1,NDIM
       read(2,end=2999,err=2999)
200    ild=ild+1
2999   close(2)
       write(6,*)ild,' lines in '//s1//'A2.SCR'
       write(3,*)ild,' lines in '//s1//'A2.SCR'
       if(ISB.eq.1.and.ild.eq.NDIM+1)then
        write(6,*)'calculation skipped'
        return
       endif
      endif

      it0=mclock()
      S1_Nexc=0
      S1_Ncent=0
      S2_Nexc=0
      S2_Ncent=0
      S1_Lexc(1)=0
      S1_Lcent(1)=0
      S2_Lexc(1)=0
      S2_Lcent(1)=0
      nel=0
      aveo=0.0d0
      aved=0.0d0
      CM=219470.0d0
      C4D=0.0d0
      WRITE(3,3000)
      WRITE(6,3000)
3000  FORMAT(' Diagonal Hamiltonian:',/,
     1       ' line        hii  harmonic   quartic    subst.   kinetic',
     2' max. hij (i<>j), j',/,80(1H-))

      OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
      if(ild.gt.0)then
       do 2001 i=1,ild
2001   read(2)
       IISTART=ISTART+ild-1
       IHH=ild-1
       write(6,2006)ISTART,ild,IISTART,NDIM
2006   format(' ISTART:',I6,' ild:', I6,' IISTART:',I6,' NDIM:',I6)
      else
       WRITE(2)NDIM
       IISTART=ISTART
       IHH=0
      endif
c
      DO 29 I=IISTART,IEND
      IHH=IHH+1
      i33=0

C     Define state i:
      EI=0.0d0
      DO 1 II=N7,N
1     STATE1(II)=0
      S1_Ncent=IS(I)
      S1_Nexc=IT(I)
      DO 4 K=1,IS(I)
      EI=EI+DBLE(IN(I,K))*E(ICC(I,K))
      S1_Lcent(K)=ICC(I,K)
      S1_Lexc(K)=IN(I,K)
4     STATE1(ICC(I,K))=IN(I,K)

c
      JHH=0
      DO 2 J=ISTART,I
      JHH=JHH+1
c
C     Define state j:
      DO 5 II=N7,N
5     STATE2(II)=0
      S2_Ncent=IS(J)
      S2_Nexc=IT(J)
      DO 6 K=1,IS(J)
      S2_Lcent(K)=ICC(J,K)
      S2_Lexc(K)=IN(J,K)
6     STATE2(ICC(J,K))=IN(J,K)

C     i=j:
      IF(I.EQ.J)THEN
       HII=0.0d0
       CQD=0.0d0
       CED=0.0d0
C      Diagonal quartic:
       IF(QUARTIC)THEN
        IF(LSPARSE)THEN
         CALL SUMSQGHOST
        ELSE
         CALL SUMSQ
        ENDIF
        HII=HII+A
        CQD=A
       ENDIF
       nel=nel+1
       i33=i33+1
       a33(i33)=HII*CM*0.5d0
       j33(i33)=IHH
       aved=aved+dabs(2.0d0*a33(i33))
       write(3,3030)I,2.0d0*a33(i33),EI*CM,CQD*CM,CED*CM,C4D*CM
       write(6,3030)I,2.0d0*a33(i33),EI*CM,CQD*CM,CED*CM,C4D*CM
3030   format(I6,5F10.2)
       GOTO 2
      ENDIF
c
C     j<i :
      A=0.0d0
      IF(LSPARSE)THEN
       IF( ((IT(I)-IT(J)+1)/2)*2.EQ.IT(I)-IT(J)+1 )CALL SUMSGHOST
      ELSE
       IF( ((IT(I)-IT(J)+1)/2)*2.EQ.IT(I)-IT(J)+1 )CALL SUMS
      ENDIF
c     ACUBIC=A*CM
C     Cubic term
      HOFF=A
      IF(LQD)THEN
       A=0.0d0
       IF(LSPARSE)THEN
        IF( ((IT(I)-IT(J))/2)*2.EQ.IT(I)-IT(J) )CALL SUMSQGHOST
       ELSE
        IF( ((IT(I)-IT(J))/2)*2.EQ.IT(I)-IT(J) )CALL SUMSQ
       ENDIF
C     Off-diagonal quartic
       HOFF=HOFF+A
c      AQUARTIC=A*CM
      ENDIF
      if(dabs(HOFF*CM).gt.HSLIM)then
       i33=i33+1
       j33(i33)=JHH
       a33(i33)=HOFF*CM
       aveo=aveo+dabs(a33(i33))
       nel=nel+1
      endif
c
2     CONTINUE
c     J
c
      WRITE(2)i33,(j33(JHH),JHH=1,i33),(a33(JHH),JHH=1,i33)
29    CONTINUE
c     I
c
      CLOSE(2)
      WRITE(6,6000)s1,HSLIM,nel,dble(nel)/dble(NDIM*(NDIM+1)/2)*100,
     1NDIM*(NDIM+1)/2,nel*(4+8)/1000,aved/dble(NDIM),
     2aveo/dble(nel+1)
      WRITE(3,6000)s1,HSLIM,nel,dble(nel)/dble(NDIM*(NDIM+1)/2)*100,
     1NDIM*(NDIM+1)/2,nel*(4+8)/1000,aved/dble(NDIM),
     2aveo/dble(nel+1)
6000  format(' Hamiltonian written into ',a1,'A2.SCR',/,
     1' Cut of limit:',f10.5,' cm-1',/,
     2' Number of elements bigger then cutoff:',i10,' (',f5.1,'%)',/,
     3' Total number of elements :',i10,/,
     3' Memory required :',i10,' kbytes',/,
     3' Average diagonal element:',f10.2,/,
     3' Average off diagonal element:',f10.2)
      write(6,6009)(mclock()-it0)/100
      write(3,6009)(mclock()-it0)/100
6009  format(' H done in ',i10,' sec')
      call w36('Dohim2-ok')
      RETURN
      END
