      SUBROUTINE DOHIMX(N,NDIM)
      implicit none
      integer*4 I,N33,N44,PR,NXX,NDIM,i33
      include 'dimensions.h'
      parameter (NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6)
      logical LASCR,live,lopt,lcb3,lcb4,lcb2
      real*8 CM,S11,S22,S33,E,S44,SUMA,SUMB,SUMC,SUMD,a33(NM0),hrec
      integer*4 NHBIG,IT(NM0),IS(NM0),ICC(NM0,ME0),IBIGSYM(NM0),
     1IN(NM0,ME0),icx,idx,STATE1(NT3),STATE2(NT3),S1,S2,n1,n2,
     1i1,i2,ic,ii,iq,j,jj,JW,k,N,IW,j33(NM0),itot,it0,
     1NCAN,ICAN,NZF,IBR,IERM
      COMMON/DIA1/NHBIG,IT,IS,IBIGSYM,ICC,IN
      real*8 FCAR,cx,dx
      common/dia3/FCAR(NT3,NT3),cx(NXX),dx(NXX),icx(3,NXX),idx(4,NXX),
     1N33,N44
      common/lcbe/E(NT3),live(NT3)
      common/lop/lopt(300)
      equivalence (lopt(20),lcb3),(lopt(21),lcb4),(lopt(22),lcb2)
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM

      inquire(FILE='1A2.SCR',exist=LASCR)
      if(LASCR)then
       call w36('1A2.SCR found on disk')
       return
      endif

      write(6,6003)lcb2,lcb3,lcb4,NHBIG
      write(3,6003)lcb2,lcb3,lcb4,NHBIG
6003  format('Quadratics, cubics, quartics: ',3(1x,L1),' NHBIG ',i10)


      CM=219470.0d0
      hrec=0.0d0
      if(HW)then
       WRITE(3,3000)
       WRITE(6,3000)
      endif
3000  FORMAT(' Diagonal Hamiltonian:',/,
     1       ' line        hii   harm.-0   harm.-1     cubic   quartic',
     2/,80(1H-))

      OPEN(22,FILE='1A2.SCR',FORM='UNFORMATTED')
      write(22)NHBIG
c
      itot=0
      DO 29 IW=1,NHBIG

C     Define state IW:
      DO 1 II=1,N
1     STATE1(II)=0
      DO 4 K=1,IS(IW)
4     STATE1(ICC(IW,K))=IN(IW,K)
c
      i33=0
      DO 2 JW=1,NHBIG
c
C     Define state JJ:
      DO 51 II=1,N
51    STATE2(II)=0
      DO 61 K=1,IS(JW)
61    STATE2(ICC(JW,K))=IN(JW,K)

      SUMA=0.0d0
      SUMB=0.0d0
      SUMC=0.0d0
      SUMD=0.0d0
c     ***********************************************************
c     <n|0.5(p^2+q^2)|n> = (n+0.5)*hw
      if(IW.EQ.JW)THEN
       do 71 II=1,N
71     if(live(II))SUMA=SUMA+E(II)*(dble(STATE1(II))+0.5d0)
      ENDIF
c     <n|0.5(fii-w)qiqi|m> (correction to any frequency)
      do 83 i1=1,N
      if(live(i1))then
      PR=0
      DO 84 II=1,N
      n1=STATE1(II)
      n2=STATE2(II)
      IF(II.NE.i1)THEN
       IF(n1.NE.n2)GOTO 83
      ELSE
       IF(n1.eq.n2)THEN
        PR=(2*n1+1)*(2*n2+1)
       ELSE
        IF(n1.eq.n2+2)THEN
         PR=n1*(n1-1)
        ELSE
         IF(n1.eq.n2-2)THEN
          PR=n2*(n2-1)
         else
          goto 83
         ENDIF
        ENDIF
       ENDIF
      ENDIF
84    CONTINUE
      SUMA=SUMA+0.25d0*dsqrt(dble(PR))*(FCAR(i1,i1)-E(i1)**2)/E(i1)
c     0.5(from matrix element)x0.5(from Taylor expansion)=0.25
      endif
83    continue
c     ***********************************************************
c     sum 0.5fij xi xj  i<> j = sum fij xi xj i<j
c     <n|x|n+1>=sqrt((n+1)/2), etc
      if(lcb2)then
      do 82 i1=1,N
      do 82 i2=i1+1,N
      if(live(i1).and.live(i2))then
      do 81 II=1,N
      n1=STATE1(II)
      n2=STATE2(II)
81    if(II.ne.i1.and.II.ne.i2.and.n1.ne.n2)goto 82
      n1=STATE1(i1)
      n2=STATE2(i1)
      PR=1
      if(n1.eq.n2+1)then
       PR=PR*n1
      else
       if(n1.eq.n2-1)then
        PR=PR*n2
       else
        goto 82
       endif
      endif
      n1=STATE1(i2)
      n2=STATE2(i2)
      if(n1.eq.n2+1)then
       PR=PR*n1
      else
       if(n1.eq.n2-1)then
        PR=PR*n2
       else
        goto 82
       endif
      endif
      SUMB=SUMB+FCAR(i1,i2)*dsqrt(dble(PR))/2.0d0/dsqrt(e(i1)*e(i2))
      endif
82    continue
      endif
c     ***********************************************************
c     sum 1/6cijk xi xj xk
      S11=0.0d0
      S22=0.0d0
      S33=0.0d0
      if(lcb3)then
      DO 1000 IC=1,N33
      I=icx(1,IC)
      J=icx(2,IC)
      K=icx(3,IC)
      if(live(I).and.live(J).and.live(K))then
C     i=<j=<k
C
C     Term ijk, i<j<k
      IF(I.LT.J.AND.J.LT.K)THEN
      PR=1
      DO 8 IQ=1,N
      IF(IQ.NE.K.AND.IQ.NE.J.AND.IQ.NE.I)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 8
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(S1.EQ.S2+1)THEN
       PR=PR*S1
       GOTO 8
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=PR*S2
       GOTO 8
      ENDIF
      GOTO 1000
8     CONTINUE
      S33=S33+DSQRT(DBLE(PR))*cx(IC)
      GOTO 1000
      ENDIF
C
C     TERM   ijk, i=j<k
      IF(I.EQ.J.AND.J.LT.K)THEN
       II=I
       JJ=K
       GOTO 1001
      ENDIF
C
C     TERM   ijk, i<j=k
      IF(I.LT.J.AND.J.EQ.K)THEN
       II=J
       JJ=I
       GOTO 1001
      ENDIF
C
C     TERM   iii
      DO 52 IQ=1,N
      IF(IQ.NE.I)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 52
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(S1.EQ.S2-3)THEN
       PR=S2*(S2-1)*(S2-2)
       GOTO 52
      ENDIF
      IF(S1.EQ.S2+3)THEN
       PR=S1*(S1-1)*(S1-2)
       GOTO 52
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=9*S2*S2*S2
       GOTO 52
      ENDIF
      IF(S1.EQ.S2+1)THEN
       PR=9*S1*S1*S1
       GOTO 52
      ENDIF
      GOTO 1000
52    CONTINUE
      S11=S11+DSQRT(DBLE(PR))*cx(IC)
      GOTO 1000
C
C     Calculate <S1|Qii^2 Qjj|+S2>:
1001  PR=1
      DO 31 IQ=1,N
      IF(IQ.NE.II.AND.IQ.NE.JJ)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 31
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(IQ.EQ.JJ)THEN
       IF(S1.EQ.S2+1)THEN
	PR=PR*S1
	GOTO 31
       ENDIF
       IF(S1.EQ.S2-1)THEN
	PR=PR*S2
	GOTO 31
       ENDIF
       GOTO 1000
      ENDIF
      IF(S1.EQ.S2)THEN
       PR=PR*(2*S1+1)*(2*S1+1)
       GOTO 31
      ENDIF
      IF(S1.EQ.S2+2)THEN
       PR=PR*S1*(S1-1)
       GOTO 31
      ENDIF
      IF(S1.EQ.S2-2)THEN
       PR=PR*S2*(S2-1)
       GOTO 31
      ENDIF
      GOTO 1000
31    CONTINUE
      S22=S22+DSQRT(DBLE(PR))*cx(IC)
      endif
1000  CONTINUE
      endif
c     if(IW.ne.JW)write(6,60000)S11,S22,S33,IW,JW
c0000 format(3f10.4,3i4)
      SUMC=(S11+3.0d0*S22+6.0d0*S33)*0.058925565101d0
C     0.0589=1/(6*sqrt(8))
c     ***********************************************************
c     sum (1/24) dijkl xi xj xk xl
      S11=0.0d0
      S22=0.0d0
      S33=0.0d0
      S44=0.0d0
      if(lcb4)then
      DO 4000 IC=1,N44
      I=idx(1,IC)
      J=idx(3,IC)
      K=idx(4,IC)
      if(live(I).and.live(J).and.live(K))then
C     iijk, j<k, for terms iijj ii=<jj
C
C     Term iijk, i<>j,k>j,k<>i
C     iijk=iikj=ijki=ikji=ijik=ikij=jkii=kjii=jiki=kiji=jiik=kiij
      IF((I.NE.J.AND.K.NE.J).AND.K.NE.I)THEN
      PR=1
      DO 7 IQ=1,N
      IF(IQ.NE.I.AND.IQ.NE.J.AND.IQ.NE.K)THEN
C      <S1|S2>(IQ)
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 7
       GOTO 4000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(IQ.EQ.I)THEN
C      <S1|Q^2|S2>(IQ),IQ I
       IF(S1.EQ.S2+2)THEN
        PR=PR*S1*(S1-1)
        GOTO 7
       ENDIF
       IF(S1.EQ.S2-2)THEN
        PR=PR*S2*(S2-1)
        GOTO 7
       ENDIF
       IF(S1.EQ.S2)THEN
        PR=PR*(2*S1+1)*(2*S1+1)
        GOTO 7
       ENDIF
       GOTO 4000
      ENDIF
C     IQ is ether J or K
C     <S1|Q|S2>(IQ),IQ=J,K
      IF(S1.EQ.S2+1)THEN
       PR=PR*S1
       GOTO 7
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=PR*S2
       GOTO 7
      ENDIF
      GOTO 4000
7     CONTINUE
      S44=S44+DSQRT(DBLE(PR))*dx(IC)
      GOTO 4000
      ENDIF
c
c     TERMS  iiij=iiji=ijii=jiii and iiij=iiji=ijii=jiii
      IF(I.EQ.J.AND.K.GT.J)THEN
       II=I
       JJ=K
       GOTO 2000
      ENDIF
      IF(I.EQ.K.AND.K.GT.J)THEN
       II=I
       JJ=J
       GOTO 2000
      ENDIF
c
C     Term  iijj=jjii=ijij=jiji=jiij=ijji, j>i, omit j<i
      IF(J.EQ.K.AND.J.GT.I)THEN
      PR=1
      DO 3 IQ=1,N
      IF(IQ.NE.I.AND.IQ.NE.J)THEN
C     <S1|S2>(IQ)
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 3
       GOTO 4000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
C     <S1|Q^2|S2>(IQ),IQ is either I or J
      IF(S1.EQ.S2+2)THEN
       PR=PR*S1*(S1-1)
       GOTO 3
      ENDIF
      IF(S1.EQ.S2-2)THEN
       PR=PR*S2*(S2-1)
       GOTO 3
      ENDIF
      IF(S1.EQ.S2)THEN
       PR=PR*(2*S1+1)*(2*S1+1)
       GOTO 3
      ENDIF
      GOTO 4000
3     CONTINUE
      S22=S22+DSQRT(DBLE(PR))*dx(IC)
c
      GOTO 4000
      ENDIF
C
C     Term iiii
      IF(I.EQ.J.AND.J.EQ.K)THEN
      DO 5 IQ=1,N
      IF(IQ.NE.I)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ)) GOTO 5
       GOTO 4000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(S1.EQ.S2-4)THEN
       PR=S2*(S2-1)*(S2-2)*(S2-3)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2+4)THEN
       PR=S1*(S1-1)*(S1-2)*(S1-3)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2-2)THEN
       PR=(4*S2-2)*(4*S2-2)*S2*(S2-1)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2+2)THEN
       PR=(4*S1-2)*(4*S1-2)*S1*(S1-1)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2)THEN
       PR=(6*S1*S1+6*S1+3)*(6*S1*S1+6*S1+3)
       GOTO 5
      ENDIF
      GOTO 4000
5     CONTINUE
C     <S1|Diiii|S2>
      S11=S11+DSQRT(DBLE(PR))*dx(IC)
c
      GOTO 4000
      ENDIF
C
2000  PR=1
C     TERM <S1|Qii^3Qj|S2>
      DO 6 IQ=1,N
      IF(IQ.NE.II.AND.IQ.NE.JJ)THEN
C     <S1|S2>(IQ)
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 6
       GOTO 4000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(IQ.EQ.II)THEN
C      <S1|Q^3|S2>(IQ),IQ II
       IF(S1.EQ.S2+3)THEN
        PR=PR*S1*(S1-1)*(S1-2)
        GOTO 6
       ENDIF
       IF(S1.EQ.S2-3)THEN
        PR=PR*S2*(S2-1)*(S2-2)
        GOTO 6
       ENDIF
       IF(S1.EQ.S2+1)THEN
        PR=PR*9*S1*S1*S1
        GOTO 6
       ENDIF
       IF(S1.EQ.S2-1)THEN
        PR=PR*9*S2*S2*S2
        GOTO 6
       ENDIF
       GOTO 4000
      ENDIF
C     <S1|Q|S2>(IQ),IQ=JJ
      IF(S1.EQ.S2+1)THEN
       PR=PR*S1
       GOTO 6
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=PR*S2
       GOTO 6
      ENDIF
      GOTO 4000
6     CONTINUE
      S33=S33+DSQRT(DBLE(PR))*dx(IC)
      endif
4000  CONTINUE
      endif
      SUMD=0.01041666666d0*(S11+6.0d0*S22+4.0d0*S33+12.0d0*S44)
C     0.0104167=(1/4)*(1/24)
c     ***********************************************************
      if(dabs(SUMB).gt.hrec)then
c      write(6,*)IW,JW,SUMB*CM
       hrec=dabs(SUMB)
      endif
      if((dabs((SUMA+SUMB+SUMC+SUMD)*CM)).gt.1.0d-1.or.JW.EQ.IW)then
       i33=i33+1
       if(i33.gt.NM0)call report('i33.gt.NM0')
       j33(i33)=JW
       a33(i33)=(SUMA+SUMB+SUMC+SUMD)*CM
       IF(IW.EQ.JW)THEN
        a33(i33)=a33(i33)
        if(HW)then
         write(3,3030)IW,a33(i33),SUMA*CM,SUMB*CM,SUMC*CM,SUMD*CM
         write(6,3030)IW,a33(i33),SUMA*CM,SUMB*CM,SUMC*CM,SUMD*CM
3030     format(I6,5F10.2)
        endif
       ENDIF
       itot=itot+1
      endif
c
2     CONTINUE
c     JW
c
29    WRITE(22)i33,(j33(JW),JW=1,i33),(a33(JW),JW=1,i33)
      CLOSE(22)
c     IW
c
      it0=int(dble(NHBIG)*dble(NHBIG+1)/2.0d0)
      write(3,6000)itot,it0,
     1dble(itot)/dble(it0)*100.0d0
      write(6,6000)itot,it0,
     1dble(itot)/dble(it0)*100.0d0
6000  format(i10,' of ',i12,' (',f4.1,' %) non zero elements')
c
      call w36(' Hamiltonian written into 1A2.SCR')
      NDIM=NHBIG
      RETURN
      END
