      SUBROUTINE ENA2(ASL,EOLD)
c     perturbation calculation with possible degenerate levels
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      PARAMETER (NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6 )
      INTEGER*4 STATE1(NT3),STATE2(NT3)
      DIMENSION AW(NT3),EM3(NT3),EM5(NT3),EC0(NT3),EC2(NT3),
     1EC4(NT3),EQD(NT3),EEF(NT3),EEO(NT3),EM1(NT3),EOLD(NT3),
     2EK1(NT3),EK3(NT3),EK5(NT3)
      COMMON/CEM/E(NT3)
      LOGICAL L4,LSPARSE
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      real*8 ropt,OH,DOH
      COMMON/opt/ropt(100)
      equivalence (OH,ropt(15)),(DOH,ropt(16))
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      COMMON/RUNCON/LEXCL
      COMMON/DIA2B/CS(NXX),ICS(3,NXX),NCSP
      Z0=0.0d0
      CM=219470.0d0
C     1 a.u.= 2.1947E5 cm^-1
      call w36('PERTURBATIONAL CALCULATION ENA2')
      write(3,*)'quartic ',QUARTIC
      write(3,*)'sparse  ',LSPARSE


      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)

      DO 33 I=N7,N
      STATE1(I)=0
33    STATE2(I)=0

      EGQ=0.0d0
      EGQK=0.0d0
      EG1=0.0d0
      EG2=0.0d0
      EG2K=0.0d0
      EG3=0.0d0
      EG4=0.0d0
      EG4K=0.0d0
      EGE=0.0d0
      EGO=0.0d0
      ISY1=0
      ISY2=0
      DO 65 I=N7,N
      EEF(I)=0.0d0
      EEO(I)=0.0d0
      EQD(I)=0.0d0
      EM1(I)=0.0d0
      EM3(I)=0.0d0
      EK1(I)=0.0d0
      EK3(I)=0.0d0
      EK5(I)=0.0d0
      EC0(I)=0.0d0
      EC2(I)=0.0d0
      EC4(I)=0.0d0
65    EM5(I)=0.0d0
      ISY1=IFINDSYM1(N,STATE1,N7)
      ISYGR=ISY1
C
C     GROUND STATE
C
C     <ground|ground>-interactions:
C     ***************
C
C     Quartic <ground|V4|ground>:
      IF(QUARTIC)THEN
       IF(LSPARSE)THEN
        CALL SUMSQGHOST
       ELSE
        CALL SUMSQ
       ENDIF
       EGQ=EGQ+A
      ENDIF
C
C     <ground|Kinetic|ground>:
      IF(LH40)THEN
       CALL SUM4
       EGQK=EGQK+A
      ENDIF
C
C     <ground|VE|ground>:
      IF(NZF.NE.0)THEN
       CALL SUMSE
       EGE=EGE+A
      ENDIF
C
C     MONO-EXCITED STATES:
C
      DO 66 I1=N7,N
      STATE2(I1)=STATE2(I1)+1
      E1=E(I1)
      WRITE(6,7009)I1-N7+1,N-N7+1,E(I1)*219470.0d0
7009  format(i4,' of ',i4,f10.2)
      ISY2=IFINDSYM1(N,STATE2,N7)
C
C
C     <ground|mono>-interactions:
C     ***************************
C
C     <ground|V3|mono>, to mono:
      IF(ISY2.EQ.ISY1)THEN
      IF(LSPARSE)THEN
       CALL SUMSGHOST
      ELSE
       CALL SUMS
      ENDIF
      AA=AAf(E1,Z0,A)
      EC0(I1)=EC0(I1)+AA
      EG1=EG1-AA
      ENDIF
C
c     IF(LBLOCK)THEN
c      DO 90 I=1,NCAN
c      IF(I1.EQ.N7-1+ICAN(I))GOTO 72
c0     CONTINUE
c     ENDIF
C
C     <ground|V3|mono>, to ground:
C
C     <mono|mono> DIAGONAL interactions:
C     **********************************
C
      STATE1(I1)=1
C
C     <mono|V4|mono>:
      IF(QUARTIC)THEN
       IF(LSPARSE)THEN
        CALL SUMSQGHOST
       ELSE
        CALL SUMSQ
       ENDIF
       EQD(I1)=EQD(I1)+A
      ENDIF
C
C     <mono|VE|mono>:
      IF(NZF.NE.0)THEN
       CALL SUMSE
       EEF(I1)=EEF(I1)+A
      ENDIF
C
C     <mono|Kinetic|mono>:
      IF(LH40)THEN
       CALL SUM4
       EK1(I1)=EK1(I1)+A
      ENDIF
C
      STATE1(I1)=0
C
C     <mono|mono> OFF-DIAGONAL interactions:
C     **************************************
C
      DO 1 IQ=N7,N
      STATE1(IQ)=STATE1(IQ)+1
      IF(IQ.EQ.I1)GOTO 1
      ISY1=IFINDSYM1(N,STATE1,N7)
C
      IF(ISY1.EQ.ISY2)THEN
C
C     <mono|Kinetic|mono>:
      IF(LH40)THEN
       CALL SUM4
       EK1(I1)=EK1(I1)-AAf(E(IQ),E1,A)
      ENDIF
C
C     <mono|V4|mono>:
      IF(QUARTIC.AND.L4)THEN
       IF(LSPARSE)THEN
        CALL SUMSQGHOST
       ELSE
        CALL SUMSQ
       ENDIF
       EM1(I1)=EM1(I1)-AAf(E(IQ),E1,A)
      ENDIF
C
      ENDIF
C
1     STATE1(IQ)=STATE1(IQ)-1
      ISY1=ISYGR
C
      IF(LEXCL.LT.2)GOTO 72
C
C     DOUBLE EXCITED STATES:
C
      DO 67 I2=I1,N
      STATE2(I2)=STATE2(I2)+1
      ISY2=IFINDSYM1(N,STATE2,N7)
      E2=E1+E(I2)
c     IF(LBLOCK)THEN
c      DO 91 I=1,NCAN
c      IF(I2.EQ.N7-1+ICAN(I))GOTO 74
c1     CONTINUE
c     ENDIF
C
C     <ground|double>:
C     ****************
C
      IF(ISY1.EQ.ISY2)THEN
C
C     <ground|Kinetic|double>:
      IF(LH40)THEN
       CALL SUM4
       EG2K=EG2K-AAf(E2,Z0,A)
      ENDIF
C
C     <ground|V4|double>:
      IF(LQD)THEN
       IF(LSPARSE)THEN
        CALL SUMSQGHOST
       ELSE
        CALL SUMSQ
       ENDIF
       EG2=EG2-AAf(E2,Z0,A)
      ENDIF
C
C     <ground|VE|double>
      IF(NZF.NE.0)THEN
       CALL SUMSE
       EGO=EGO-AAf(E2,Z0,A)
      ENDIF
      ENDIF
C
      DO 30 IQ=N7,N
      STATE1(IQ)=1
      ISY1=IFINDSYM1(N,STATE1,N7)
C
C     <mono|double>:
C     **************
C
      IF(ISY1.EQ.ISY2)THEN
C
C     <mono|V3|double>:
      IF(LSPARSE)THEN
       CALL SUMSGHOST
      ELSE
       CALL SUMS
      ENDIF
      EC2(IQ)=EC2(IQ)+AAf(E(IQ),E2,A)
      ENDIF
C
30    STATE1(IQ)=0
      ISY1=ISYGR
      IF(LEXCL.LT.3)GOTO 74
C
C     TRIPLE-EXCITED STATES:
C
      DO 68 I3=I2,N
      STATE2(I3)=STATE2(I3)+1
      ISY2=IFINDSYM1(N,STATE2,N7)
      E3=E2+E(I3)
c     IF(LBLOCK)THEN
c      DO 92 I=1,NCAN
c      IF(I3.EQ.N7-1+ICAN(I))GOTO 76
c2     CONTINUE
c     ENDIF
C
C     <ground|triple>:
C     ****************
C
      IF(ISY1.EQ.ISY2)THEN
      IF(LSPARSE)THEN
       CALL SUMSGHOST
      ELSE
       CALL SUMS
      ENDIF
C
C     <ground|V3|triple>
      EG3=EG3-AAf(E3,Z0,A)
      ENDIF
C
C     <mono|triple>:
C     **************
C
C     Kinetic term:
      IF(LH40)THEN
       DO 105 IQ=N7,N
       STATE1(IQ)=1
       ISY1=IFINDSYM1(N,STATE1,N7)
C
       IF(ISY1.EQ.ISY2)THEN
       CALL SUM4
       EK3(IQ)=EK3(IQ)+AAf(E(IQ),E3,A)
       ENDIF
C
105    STATE1(IQ)=0
       ISY1=ISYGR
      ENDIF
C
C     Quartic term:
C     <mono|V4|triple>
      IF(LQD)THEN
       DO 82 IQ=N7,N
       STATE1(IQ)=1
       ISY1=IFINDSYM1(N,STATE1,N7)
C
       IF(ISY1.EQ.ISY2)THEN
       IF(LSPARSE)THEN
        CALL SUMSQGHOST
       ELSE
        CALL SUMSQ
       ENDIF
       EM3(IQ)=EM3(IQ)+AAf(E(IQ),E3,A)
       ENDIF
C
82     STATE1(IQ)=0
       ISY1=ISYGR
      ENDIF
C
C     Energy substitution:<mono|VE|triple>
      IF(NZF.NE.0)THEN
       DO 829 IQ=N7,N
       STATE1(IQ)=1
       ISY1=IFINDSYM1(N,STATE1,N7)
C
       IF(ISY1.EQ.ISY2)THEN
       CALL SUMSE
       EEO(IQ)=EEO(IQ)+AAf(E(IQ),E3,A)
       ENDIF
C
829    STATE1(IQ)=0
       ISY1=ISYGR
      ENDIF
      IF(LEXCL.LT.4)GOTO 76
C
C     QUADRUPLE-EXCITED STATES:
C
      DO 69 I4=I3,N
      STATE2(I4)=STATE2(I4)+1
      ISY2=IFINDSYM1(N,STATE2,N7)
      E4=E3+E(I4)
c     IF(LBLOCK)THEN
c      DO 93 I=1,NCAN
c      IF(I4.EQ.N7-1+ICAN(I))GOTO 78
c3     CONTINUE
c     ENDIF
C
C     <ground|quadruple>:
C     *******************
C
      IF(ISY1.EQ.ISY2)THEN
C
C     <ground|V4|quadruple>
      IF(LQD)THEN
       IF(LSPARSE)THEN
        CALL SUMSQGHOST
       ELSE
        CALL SUMSQ
       ENDIF
       EG4=EG4-AAf(E4,Z0,A)
      ENDIF
C
C     Kinetic:
      IF(LH40)THEN
       CALL SUM4
       EG4=EG4-AAf(E4,Z0,A)
      ENDIF
      ENDIF
C
C     <mono|quadruple>:
C     *****************
C
      DO 32 IQ=N7,N
      STATE1(IQ)=1
      ISY1=IFINDSYM1(N,STATE1,N7)
C
      IF(ISY1.EQ.ISY2)THEN
      IF(LSPARSE)THEN
       CALL SUMSGHOST
      ELSE
       CALL SUMS
      ENDIF
C     <mono|V3|quadruple>
      EC4(IQ)=EC4(IQ)+AAf(E(IQ),E4,A)
      ENDIF
C
32    STATE1(IQ)=0
      ISY1=ISYGR
      IF(LEXCL.LT.5.OR.(.NOT.LQD))GOTO 78
C
C     PENTA-EXCITED STATES:
C
      DO 70 I5=I4,N
      STATE2(I5)=STATE2(I5)+1
      ISY2=IFINDSYM1(N,STATE2,N7)
      E5=E4+E(I5)
c     IF(LBLOCK)THEN
c      DO 94 I=1,NCAN
c      IF(I5.EQ.N7-1+ICAN(I))GOTO 80
c4     CONTINUE
c     ENDIF
C
C     <mono|penta>:
C     *************
      DO 83 IQ=N7,N
      STATE1(IQ)=1
      ISY1=IFINDSYM1(N,STATE1,N7)
C
      IF(ISY1.EQ.ISY2)THEN
C
C     <mono|V4|5-times>:
      IF(LSPARSE)THEN
       CALL SUMSQGHOST
      ELSE
       CALL SUMSQ
      ENDIF
      EM5(IQ)=EM5(IQ)+AAf(E(IQ),E5,A)
C
C     <mono|Kinetic|penta>:
      IF(LH40)THEN
       CALL SUM4
       EK5(IQ)=EK5(IQ)+AAf(E(IQ),E5,A)
      ENDIF
C
      ENDIF
C
83    STATE1(IQ)=0
      ISY1=ISYGR
C
70    STATE2(I5)=STATE2(I5)-1
78    CONTINUE
69    STATE2(I4)=STATE2(I4)-1
76    CONTINUE
68    STATE2(I3)=STATE2(I3)-1
74    CONTINUE
67    STATE2(I2)=STATE2(I2)-1
72    CONTINUE
66    STATE2(I1)=STATE2(I1)-1
C
C
      EG1=EG1*CM
      EG3=EG3*CM
      EAG=EG1+EG3
      WRITE(3,*)
      WRITE(6,*)
      DO 2 I=N7,N
      EO=EOLD(I)*CM
      EE=E(I)*CM
      EC0(I)=EC0(I)*CM
      EC2(I)=EC2(I)*CM
      EC4(I)=EC4(I)*CM
      A=EC0(I)+EC2(I)+EC4(I)
      AW(I)=EE+A
      WA=AW(I)-EAG
      ENEW=AW(I)
      WA=ENEW-EAG
2     CALL WRTCOR(EAG,EAG,' Cubic corrections',
     1I,EO,EE,A,A-EAG,WA,WA-EE,N7,N)
C
      IF(QUARTIC)THEN
      EGQ=EGQ*CM
      EAG=EAG+EGQ
      DO 5 I=N7,N
      EO=EOLD(I)*CM
      EE=E(I)*CM
      A=EQD(I)*CM
      AW(I)=AW(I)+A
      WA=AW(I)-EAG
5     CALL WRTCOR(EAG,EAG,' Quartic corrections',
     1I,EO,EE,A,A-EGQ,WA,WA-EE,N7,N)
C
      IF(LQD)THEN
C      ground-2, ground-4, mono-1, mono-3, mono-5
       EG2=EG2*CM
       EG4=EG4*CM
       EAG=EAG+EG2+EG4
       DO 64 I=N7,N
       EE=E(I)*CM
       EO=EOLD(I)*CM
       DE1=EM1(I)*CM
       DE3=EM3(I)*CM
       DE5=EM5(I)*CM
       A=DE3+DE5+DE1
       AW(I)=AW(I)+A
       WA=AW(I)-EAG
64     CALL WRTCOR(EG2+EG4,EAG,' Quartic off-diagonal corrections',
     1 I,EO,EE,A,A-EG2-EG4,WA,WA-EE,N7,N)
      ENDIF
      ENDIF
C
      IF(LH40)THEN
C      ground-2, ground-4, mono-1, mono-3, mono-5
       EG2K=EG2K*CM
       EG4K=EG4K*CM
       EGQK=EGQK*CM
       A=EG2K+EG4K+EGQK
       EAG=EAG+A
       DO 106 I=N7,N
       EO=EOLD(I)*CM
       EE=E(I)*CM
       DE1=EK1(I)*CM
       DE3=EK3(I)*CM
       DE5=EK5(I)*CM
       A=DE3+DE5+DE1
       AW(I)=AW(I)+A
       WA=AW(I)-EAG
106    CALL WRTCOR(A,EAG,' Kinetic quartic corrections',
     1 I,EO,EE,A,A-EGQK-EG2K-EG4K,WA,WA-EE,N7,N)
      ENDIF
C
      IF(NZF.NE.0)THEN
       EGE=EGE*CM
       EGO=EGO*CM
       EAG=EAG+EGE+EGO
       DO 649 I=N7,N
       EE=E(I)*CM
       EO=EOLD(I)*CM
       DED=EEF(I)*CM
       DEO=EEO(I)*CM
       A=DED+DEO
       AW(I)=AW(I)+A
       WA=AW(I)-EAG
649    CALL WRTCOR(EGE+EGO,EAG,' The frequency substitution',
     1  I,EO,EE,A,A-EGE-EGO,WA,WA-EE,N7,N)
      ENDIF
      call replacedog(N,E,AW,EAG,N7)
      RETURN
      END

      function AAf(enp,en,v)
c     for non-deg case goes to v^2/(enp-en)
      implicit none
      real*8 AAf,en,enp,v
      if(en.gt.enp)then
       AAf=-0.5d0*(enp-en+dsqrt((en-enp)**2+4.0d0*v**2))
      else
       AAf=-0.5d0*(enp-en-dsqrt((en-enp)**2+4.0d0*v**2))
      endif
      return
      end
