      SUBROUTINE ENA2S(ASL,EOLD,SSP)
c     perturbation calculation with possible degenerate levels
c     sparse version
      IMPLICIT none
      INTEGER*4 NX4,NQQ,NXX,N7,N,N40,NGE0,ME00,NMX,NDSS
      include 'dimensions.h'
      PARAMETER (N40=6200000,ME00=5,
     1NX4=NT3*((NT3*(NT3+1))/2),NMX=1000000,NGE0=24,
     1NQQ=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6,
     1NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6 )
      INTEGER*4 STATE1(NT3),STATE2(NT3),ICS,NCSP,NCAN,ICAN,NZF,IBR,
     1IERM,IDS,NDSP,K4,L44,KP4,LPP4,NCO,NDSP2,IDS2,c5(ME00),n5(ME00),
     1i,i1,ic,ifindsym1,ii,iq,isy1,isy2,j,jj,k,l,n4,nold,LEXCL
      real*8 ASL,AW(NT3),EM35(NT3),EC0(NT3),EC24(NT3),z0,EAG,EO,EE,
     1EQD(NT3),EEF(NT3),EEO(NT3),EM1(NT3),EOLD(NT3),CM,AAf,
     2EK1(NT3),EK35(NT3),E,A,CIJK,CS,CQ4,DS,CH,EI,EJ,AA,ENEW,
     1AH4L,DS2,EGQ,EGQK,EGE,EGO,EG1,EG3,EG24,EG2K,DE1,DE35,WA,
     1DED,DEO
      COMMON/RUNCON/LEXCL
      COMMON/CEM/E(NT3)
      LOGICAL L4,LSPARSE
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      COMMON/DIA2A/CIJK(NT3,NT3,NT3)
      COMMON/DIA2B/CS(NXX),ICS(3,NXX),NCSP
      integer*4 NHBIGs,ITs,ISs,IBIGSYM,ICCs,INs
      COMMON/DIA1/NHBIGs,ITs(NM0),ISs(NM0),IBIGSYM(NM0),
     1ICCs(NM0,ME0),INs(NM0,ME0)
      INTEGER*4 GAMA(NGE0),GI(NGE0),IYX(2,NGE0),ISB
      integer*4 iopt
      common/iop/iopt(300)
      character*3 SSTR,SSP(NGE0)
      INTEGER*4 CHT,IY,IG,IGG,KG,ID
      COMMON/SYMCOM/IY(NT3),CHT(NGE0,NGE0),IG,IGG,KG,ID(NGE0),SSTR
      real*8 ropt,OH,DOH
      COMMON/opt/ropt(100)
      equivalence (OH,ropt(15)),(DOH,ropt(16))
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      COMMON/VQA/CQ4(NT3,NT3,NT3)
      COMMON/VQB/DS(NX4),IDS(3,NX4),NDSP
      COMMON/VQ2/DS2(N40),IDS2(4,N40),NDSS
      COMMON/VQ2N/NDSP2
      COMMON/V4/CH(NX4),K4(NX4),L44(NX4),KP4(NX4),LPP4(NX4),
     1AH4L,NCO
      integer*4 NHBIG,IT,IS,ICC,IN
      COMMON/DD1/NHBIG,IT(NMX),IS(NMX),ICC(NMX,ME00),
     1IN(NMX,ME00)
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent

      call w36(' ')
      call w36('Ena2s')
      call w36('^^^^')
      do 1001 II=1,2
      do 1001 I=1,NGE0
1001  IYX(II,I)=0
      z0=0.0d0
      CM=219470.0d0
C     1 a.u.= 2.1947E5 cm^-1
      call w36('PERTURBATIONAL CALCULATION ENA2-sparse version')
      write(3,*)'quartic ',QUARTIC
      write(3,*)'sparse  ',LSPARSE
      if(LH40)call report('Kinetic not implemented')
      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
c     now cubic cijk, i<=j<=k and quartic diijk j<=k should be loaded


      EGQ=z0
      EGQK=z0
      EGE=z0
      EGO=z0
      EG1=z0
      EG3=z0
      EG24=z0
      EG2K=z0
      DO 33 I=N7,N
      EM1(I)=z0
      EM35(I)=z0
      EC0(I)=z0
      EEF(I)=z0
      EEO(I)=z0
      EK1(I)=z0
      EK35(I)=z0
      EC24(I)=z0
      EQD(I)=z0
      STATE1(I)=0
33    STATE2(I)=0
      S1_Ncent=0
      S1_Nexc=0
      S2_Ncent=0
      S2_Nexc=0

c
c     <ground|V|ground>: -------------------------------------------
C     Quartic <ground|V4|ground>:
      IF(QUARTIC)THEN
       if(LSPARSE)then
        CALL SUMSQGHOST
       else
        CALL SUMSQ
       endif
       EGQ=EGQ+A
      ENDIF
c
c     kinetic energy
C     <ground|Kinetic|ground>:
      IF(LH40)THEN
       CALL SUM4
       EGQK=EGQK+A
      ENDIF
c
C     <ground|VE|ground>:
      IF(NZF.NE.0)THEN
       CALL SUMSE
       EGE=EGE+A
      ENDIF
c     <ground|V|ground>: -------------------------------------------
C
C     <mono|mono> DIAGONAL interactions:-------------------

      DO 66 I1=N7,N
      STATE1(I1)=1
      STATE2(I1)=1
      call addexcitation(I1,S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,ME0)
      call addexcitation(I1,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent,ME0)
C
C     <mono|V4|mono>:
      IF(QUARTIC)THEN
       if(LSPARSE)then
        CALL SUMSQGHOST
       else
        CALL SUMSQ
       endif
       EQD(I1)=EQD(I1)+A
      ENDIF
C
C     <mono|VE|mono>:
      IF(NZF.NE.0)THEN
       CALL SUMSE
       EEF(I1)=EEF(I1)+A
      ENDIF
C
C     <mono|Kinetic|mono>:
      IF(LH40)THEN
       CALL SUM4
       EK1(I1)=EK1(I1)+A
      ENDIF
C
      S1_Ncent=0
      S1_Nexc=0
      S2_Ncent=0
      S2_Nexc=0
      STATE1(I1)=0
66    STATE2(I1)=0
C     <mono|mono> DIAGONAL interactions:-------------------

c
c     make list of states for off-diagonal interactions

c
c     add ground and monoexcited automatically
      NHBIG=0
      call addst(0,0,0,0,0,0,0,0,0,0)
      do 1 IQ=N7,N
1     call addst(IQ,1,0,0,0,0,0,0,0,0)

      write(6,6003)NHBIG
      write(3,6003)NHBIG
6003  format(I9,' ground and first excited states')
      nold=NHBIG


      IF(QUARTIC)THEN
       if(NDSP2.ne.0)then
c       all ijkl included
        N4=NDSP2
       else
c       semidiagonal iijk only
        N4=NDSP
       endif
c
c/////////////////////////////////////////////////////////////
       do 1000 IC=1,N4
       if(NDSP2.ne.0)then
        i=IDS2(1,IC)
        j=IDS2(2,IC)
        k=IDS2(3,IC)
        l=IDS2(4,IC)
       else
        i=IDS(1,IC)
        j=i
        k=IDS(2,IC)
        l=IDS(3,IC)
       endif
c     sort out the constant type-start
      if(j.eq.i)then
c      ii
       if(k.eq.i)then
c       iii
        if(l.eq.i)then
c        iiii
         goto 2001
        else
c        iiij
         ii=i
         jj=l
         goto 2002
        endif
       else
c       iij
        if(l.eq.i)then
c        iiji
         ii=i
         jj=k
         goto 2002
        else
         if(l.eq.k)then
c         iijj
          j=k
          goto 2003
         else
c         iijk
          j=k
          k=l
          goto 2004
         endif
        endif
       endif
      else
c      ij
       if(k.eq.i)then
c       iji
        if(l.eq.i)then
c        ijii
         ii=i
         jj=j
         goto 2002
        else
         if(l.eq.j)then
c         ijij
          goto 2003
         else
c         ijik
          k=l
          goto 2004
         endif
        endif
       else
        if(k.eq.j)then
c        ijj
         if(l.eq.i)then
c         ijji
          goto 2003
         else
          if(l.eq.j)then
c          ijjj
           ii=j
           jj=i
           goto 2002
          else
c          ijjk
           k=i
           i=j
           j=l
           goto 2004
          endif
         endif
        else
c        ijk
         if(l.eq.i)then
c         ijki
          goto 2004
         else
          if(l.eq.j)then
c          ijkj
           j=i
           i=l
           goto 2004
          else
           if(l.eq.k)then
c           ijkk
            k=i
            i=l
            goto 2004
           else
c           ijkl
            goto 2005
           endif
          endif
         endif
        endif
       endif
      endif
C
C     ijkl
2005  continue

c     i j k l     dijkl qi qj qk ql        i+1  j+1  k+1  l+1
c                                          i+1  j+1  k+1  l-1
c                                          i+1  j+1  k-1  l+1
c                                          i+1  j+1  k-1  l-1
c                                          i+1  j-1  k+1  l+1
c                                          i+1  j-1  k+1  l-1
c                                          i+1  j-1  k-1  l+1
c                                          i+1  j-1  k-1  l-1
c                                          i-1  j+1  k+1  l+1
c                                          i-1  j+1  k+1  l-1
c                                          i-1  j+1  k-1  l+1
c                                          i-1  j+1  k-1  l-1
c                                          i-1  j-1  k+1  l+1
c                                          i-1  j-1  k+1  l-1
c                                          i-1  j-1  k-1  l+1
c                                          i-1  j-1  k-1  l-1
c
c     interaction with the ground state
      call addst(i,1,j,1,k,1,l,1,0,0)
c
c     interactions with monoexcited
      do 2 IQ=N7,N
      if(i.eq.IQ)then
       call addst(0,0,i,2,j,1,k,1,l,1)
       call addst(0,0,i,0,j,1,k,1,l,1)
      else
       if(j.eq.IQ)then
        call addst(0,0,i,1,j,0,k,1,l,1)
        call addst(0,0,i,1,j,2,k,1,l,1)
       else
        if(k.eq.IQ)then
         call addst(0,0,i,1,j,1,k,0,l,1)
         call addst(0,0,i,1,j,1,k,2,l,1)
        else
         if(l.eq.IQ)then
          call addst(0,0,i,1,j,1,k,1,l,0)
          call addst(0,0,i,1,j,1,k,1,l,2)
         else
          call addst(IQ,1,i,1,j,1,k,1,l,1)
         endif
        endif
       endif
      endif
2     continue

      GOTO 1000
C
C     iijk
2004  continue
c     <i j k | diijk qi^2 qj qk |  i    j+1  k+1 >
c                               |  i    j+1  k-1 >
c                               |  i    j-1  k+1 >
c                               |  i    j-1  k-1 >
c                               |  i+2  j+1  k+1 >
c                               |  i+2  j+1  k-1 >
c                               |  i+2  j-1  k+1 >
c                               |  i+2  j-1  k-1 >
c                               |  i-2  j+1  k+1 >
c                               |  i-2  j+1  k-1 >
c                               |  i-2  j-1  k+1 >
c                               |  i-2  j-1  k-1 >
c
c     interaction with the ground state
      call addst(0,0,0,0,0,0,j,1,k,1)
      call addst(0,0,0,0,i,2,j,1,k,1)
c
c     interactions with monoexcited
      do 3 IQ=N7,N
      if(i.eq.IQ)then
       call addst(0,0,0,0,i,1,j,1,k,1)
       call addst(0,0,0,0,i,3,j,1,k,1)
      else
       if(j.eq.IQ)then
        call addst(0,0,0,0,0,0,j,2,k,1)
        call addst(0,0,0,0,0,0,0,0,k,1)
        call addst(0,0,0,0,i,2,j,2,k,1)
        call addst(0,0,0,0,i,2,0,0,k,1)
       else
        if(k.eq.IQ)then
         call addst(0,0,0,0,0,0,j,1,k,2)
         call addst(0,0,0,0,0,0,j,1,0,0)
         call addst(0,0,0,0,i,2,j,1,k,2)
         call addst(0,0,0,0,i,2,j,1,0,0)
        else
         call addst(0,0,IQ,1,0,0,j,1,k,1)
         call addst(0,0,IQ,1,i,2,j,1,k,1)
        endif
       endif
      endif
3     continue

      GOTO 1000
c
C     iijj
2003  continue
c     < i j | diijj qi^2 qj^2 |  i    j    >
c                             |  i    j+2  >
c                             |  i    j-2  >
c                             |  i+2  j    >
c                             |  i+2  j+2  >
c                             |  i+2  j-2  >
c                             |  i-2  j    >
c                             |  i-2  j+2  >
c                             |  i-2  j-2  >
c
c     interaction with the ground state
c     call addst(0,0,0,0,0,0,0,0,0,0)
      call addst(0,0,0,0,0,0,0,0,j,2)
      call addst(0,0,0,0,0,0,i,2,0,0)
      call addst(0,0,0,0,0,0,i,2,j,2)
c
c     interactions with monoexcited
      do 4 IQ=N7,N
      if(i.eq.IQ)then
c      call addst(0,0,0,0,i,1,0,0,0,0)
       call addst(0,0,0,0,i,1,j,2,0,0)
       call addst(0,0,0,0,i,3,0,0,0,0)
       call addst(0,0,0,0,i,3,j,2,0,0)
      else
       if(j.eq.IQ)then
c       call addst(0,0,0,0,0,0,j,1,0,0)
        call addst(0,0,0,0,i,2,j,1,0,0)
        call addst(0,0,0,0,0,0,j,3,0,0)
        call addst(0,0,0,0,i,2,j,3,0,0)
       else
c       call addst(0,0,IQ,1,0,0,0,0,0,0)
        call addst(0,0,IQ,1,0,0,j,2,0,0)
        call addst(0,0,IQ,1,i,2,0,0,0,0)
        call addst(0,0,IQ,1,i,2,j,2,0,0)
       endif
      endif
4     continue

      GOTO 1000
C
C     Term iiii
2001  continue
c     < i  | diiii qi^4 |  i+4 >
c                       |  i+2 >
c                       |  i   >
c                       |  i-2 >
c                       |  i-4 >
c
c     interaction with the ground state
c     call addst(0,0,0,0,0,0,0,0,0,0)
      call addst(0,0,0,0,0,0,0,0,i,2)
      call addst(0,0,0,0,0,0,0,0,i,4)
c
c     interactions with monoexcited
      do 5 IQ=N7,N
      if(i.eq.IQ)then
       call addst(i,5,0,0,0,0,0,0,0,0)
       call addst(i,3,0,0,0,0,0,0,0,0)
c      call addst(i,1,0,0,0,0,0,0,0,0)
      else
c      call addst(IQ,1,0,0,0,0,0,0,0)
       call addst(IQ,1,i,2,0,0,0,0,0,0)
       call addst(IQ,1,i,4,0,0,0,0,0,0)
      endif
5     continue

      GOTO 1000
C
2002  continue
C     iiij
c     < i j  | diiij qi^3 qj |  i+3 j+1 >
c                            |  i+3 j-1 >
c                            |  i+1 j+1 >
c                            |  i+1 j-1 >
c                            |  i-1 j+1 >
c                            |  i-1 j-1 >
c                            |  i-3 j+1 >
c                            |  i-3 j-1 >
c
c     interaction with the ground state
      call addst(ii,1,jj,1,0,0,0,0,0,0)
      call addst(ii,3,jj,1,0,0,0,0,0,0)
c
c     interactions with monoexcited
      do 6 IQ=N7,N
      if(ii.eq.IQ)then
       call addst(ii,4,jj,1,0,0,0,0,0,0)
       call addst(ii,2,jj,1,0,0,0,0,0,0)
c      call addst(j,1,0,0,0,0,0,0,0,0)
      else
       if(jj.eq.IQ)then
        call addst(ii,1,jj,2,0,0,0,0,0,0)
c       call addst(ii,1, 0,0,0,0,0,0,0,0)
        call addst(ii,3,jj,2,0,0,0,0,0,0)
        call addst(ii,3, 0,0,0,0,0,0,0,0)
       else
        call addst(IQ,1,ii,1,jj,1,0,0,0,0)
        call addst(IQ,1,ii,3,jj,1,0,0,0,0)
       endif
      endif
6     continue

1000  CONTINUE
c/////////////////////////////////////////////////////////////
      ENDIF

      write(6,6001)N4,NHBIG-nold
      write(3,6001)N4,NHBIG-nold
6001  format(I9,' quartic constants generated ',I8,' states')
      nold=NHBIG
      if(HW)then
       do 19 I=1,nold
       if(HW)write(3,30011)I,IS(I)
30011  format(I9,i4,5x,$)
       do K=1,IS(I)
        write(3,30021)ICC(I,K),IN(I,K)
30021   format(I9,i4,5x,10(i9,'_',i1))
       enddo
c      if(HW)write(3,30011)I,IS(I),((ICC(I,K),IN(I,K)),K=1,IS(I))
19     continue
      endif
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c     cubic constants:
      DO 2000 IC=1,NCSP
      I=ICS(1,IC)
      J=ICS(2,IC)
      K=ICS(3,IC)
C     i=<j=<k
C
C     Term ijk, i<j<k
      IF(I.LT.J.AND.J.LT.K)goto 3002
C
C     TERM   ijk, i=j<k
      IF(I.EQ.J.AND.J.LT.K)THEN
       II=I
       JJ=K
       GOTO 3001
      ENDIF
C
C     TERM   ijk, i<j=k
      IF(I.LT.J.AND.J.EQ.K)THEN
       II=J
       JJ=I
       GOTO 3001
      ENDIF
C
C     TERM   iii
      goto 3003
c
C     iij
3001  continue
c     < i j | ciij qi^2 qj |  i-2 j-1 >
c                          |  i-2 j+1 >
c                          |  i   j+1 >
c                          |  i   j-1 >
c                          |  i+2 j+1 >
c                          |  i+2 j-1 >
c
c     interaction with the ground state
c     call addst(jj,1,0,0,0,0,0,0,0,0)
      call addst(ii,2,jj,1,0,0,0,0,0,0)
c
c     interactions with monoexcited
      do 7 IQ=N7,N
      if(ii.eq.IQ)then
       call addst(ii,1,jj,1,0,0,0,0,0,0)
       call addst(ii,3,jj,1,0,0,0,0,0,0)
      else
       if(jj.eq.IQ)then
c       call addst(0,0,0,0,0,0,0,0,0,0)
        call addst(jj,2,0,0,0,0,0,0,0,0)
        call addst(ii,2, 0,0,0,0,0,0,0,0)
        call addst(ii,2,jj,2,0,0,0,0,0,0)
       else
        call addst(IQ,1,jj,1,0,0,0,0,0,0)
        call addst(IQ,1,ii,2,jj,1,0,0,0,0)
       endif
      endif
7     continue
      GOTO 2000
c
c     ijk
3002  continue
c     < i j k | cijk qi qj qk |  i+1 j+1 k+1 >
c                             |  i+1 j+1 k-1 >
c                             |  i+1 j-1 k+1 >
c                             |  i+1 j-1 k-1 >
c                             |  i-1 j+1 k+1 >
c                             |  i-1 j+1 k+1 >
c                             |  i-1 j-1 k-1 >
c                             |  i-1 j-1 k-1 >
c
c     interaction with the ground state
      call addst(i,1,j,1,k,1,0,0,0,0)
c
c     interactions with monoexcited
      do 8 IQ=N7,N
      if(i.eq.IQ)then
       call addst(i,2,j,1,k,1,0,0,0,0)
       call addst(0,0,j,1,k,1,0,0,0,0)
      else
       if(j.eq.IQ)then
        call addst(i,1,j,2,k,1,0,0,0,0)
        call addst(i,1,0,0,k,1,0,0,0,0)
       else
        if(k.eq.IQ)then
         call addst(i,1,j,1,0,0,0,0,0,0)
         call addst(i,1,j,1,k,2,0,0,0,0)
        else
         call addst(IQ,1,i,1,j,1,k,1,0,0)
         call addst(IQ,1,i,1,j,1,k,1,0,0)
        endif
       endif
      endif
8     continue
      GOTO 2000
c
c     iii
3003  continue
c     < i  | ciii qi^3 |  i-3 >
c                      |  i-1 >
c                      |  i+1 >
c                      |  i+3 >
c
c     interaction with the ground state
c     call addst(i,1,0,0,0,0,0,0,0,0)
      call addst(i,3,0,0,0,0,0,0,0,0)
c
c     interactions with monoexcited
      do 9 IQ=N7,N
      if(i.eq.IQ)then
c      call addst(0,0,0,0,0,0,0,0,0,0)
       call addst(i,2,0,0,0,0,0,0,0,0)
       call addst(i,4,0,0,0,0,0,0,0,0)
      else
       call addst(IQ,1,i,1,0,0,0,0,0,0)
       call addst(IQ,1,i,3,0,0,0,0,0,0)
      endif
9     continue
c
      GOTO 2000
2000  CONTINUE
C
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      write(6,6002)NCSP,NHBIG-nold,NHBIG
      write(3,6002)NCSP,NHBIG-nold,NHBIG
6002  format(I9,' cubic constants generated ',I8,' states,',
     1I8,' total')
      if(HW)then
       do 20 I=nold,NHBIG
       write(3,30011)I,IS(I)
       do K=1,IS(I)
        write(3,30021)ICC(I,K),IN(I,K)
       enddo
c0     if(HW)write(3,30011)I,IS(I),((ICC(I,K),IN(I,K)),K=1,IS(I))
20     continue
      endif


      DO 15 I=N7,N
      STATE1(I)=0
15    STATE2(I)=0
      S1_Ncent=0
      S1_Nexc=0

      do 10 i=1,NHBIG
c
C     Define state i:
      EI=0.0d0
      do 13 II=1,ME00
      n5(II)=0
13    c5(II)=0
      DO 11 II=N7,N
11    STATE2(II)=0
      S2_Ncent=IS(I)
      S2_Nexc=IT(I)
      DO 12 K=1,IS(I)
      S2_Lcent(K)=ICC(I,K)
      S2_Lexc(K)=IN(I,K)
      EI=EI+DBLE(IN(I,K))*E(ICC(I,K))
      c5(k)=ICC(I,K)
      n5(k)=IN(I,K)
12    STATE2(ICC(I,K))=IN(I,K)
      ISY2=IFINDSYM1(N,STATE2,N7)
c
c     loop over ground and monoexcited states:
      do 14 j=N7-1,N
      EJ=0.0d0
      if(j.ge.N7)then
       call addexcitation(j,S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,ME0)
       STATE1(j)=1
       EJ=E(j)
      endif
      ISY1=IFINDSYM1(N,STATE1,N7)
      ic=0
      do 16 ii=N7,N
16    if(STATE1(ii).ne.STATE2(ii))ic=ic+1
c                                            "J<>I:"
      if(ic.ne.0)then
       if(ISY1.eq.ISY2)then

c       <i1 |V3 |i2<>i1>
        if(LSPARSE)THEN
         call SUMSGHOST
        ELSE
         call SUMS
        ENDIF
        AA=AAf(EI,EJ,A)
        if(j.GE.N7)then
         if(i.eq.1)then
c         <ground|V3|mono> to mono
          EC0(j)=EC0(j)-AA
         else
c         <mono|V3|double and quadruple>
          EC24(j)=EC24(j)-AA
         endif
        else
         if(i.gt.N-N7+2)then
c         <ground|V3|triple>
          EG3=EG3-AA
         else
c         <ground|V3|mono>
          EG1=EG1-AA
         endif
        endif

c       <i1 |kinetic |i2<>i1>
        if(LH40)then
        call SUM4
        AA=AAf(EI,EJ,A)
        if(j.GE.N7)then
c        <mono|kinetic|triple penta>
         EK35(j)=EK35(j)-AA
        else
c        <ground|kinetic|double>
         EG2K=EG2K-AA
        endif
        endif

c       <i1 |V4 |i2<>i1>
        if(QUARTIC)then
        if(LSPARSE)THEN
        call SUMSQGHOST
        ELSE
        call SUMSQ
        ENDIF
        AA=AAf(EI,EJ,A)
        if(j.GE.N7)then
         if(i.gt.1.and.i.le.N-N7+2)then
c         <mono|V4|mono>
          EM1(j)=EM1(j)-AA
c         write(6,6009)(STATE1(K),K=N7,N)
c         write(6,6009)(STATE2(K),K=N7,N)
c009      format(80i1)
c         if(i.eq.2)write(6,*)i,j,AA
         else
c         <mono|V4|triple + penta + ground>
          EM35(j)=EM35(j)-AA
         endif
        else
c        <ground|V4|double and quadruple>
         EG24=EG24-AA
        endif
        endif

c       <i1 |VE |i2<>i1>
        if(NZF.NE.0)THEN
        call SUMSE
        AA=AAf(EI,EJ,A)
        if(j.GE.N7)then
c        <mono|VE|triple>
         EEO(j)=EEO(j)-AA
        else
c        <ground|VE|double>
         EGO=EGO-AA
        endif
        endif

       endif
      endif
      if(j.ge.N7)then
       STATE1(j)=0
       call removeexcitation(j,S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent)
      endif
14    continue

      DO 10 K=1,IS(I)
10    STATE2(ICC(I,K))=0

      EG1=EG1*CM
      EG3=EG3*CM
      EAG=EG1+EG3
      WRITE(3,*)
      WRITE(6,*)
      DO 17 I=N7,N
      EO=EOLD(I)*CM
      EE=E(I)*CM
      EC0(I)=EC0(I)*CM
      EC24(I)=EC24(I)*CM
      A=EC0(I)+EC24(I)
      AW(I)=EE+A
      WA=AW(I)-EAG
      ENEW=AW(I)
      WA=ENEW-EAG
17    CALL WRTCOR(EAG,EAG,' Cubic corrections',
     1I,EO,EE,A,A-EAG,WA,WA-EE,N7,N)
C
      IF(QUARTIC)THEN
      EGQ=EGQ*CM
      EAG=EAG+EGQ
      DO 18 I=N7,N
      EO=EOLD(I)*CM
      EE=E(I)*CM
      A=EQD(I)*CM
      AW(I)=AW(I)+A
      WA=AW(I)-EAG
18    CALL WRTCOR(EAG,EAG,' Quartic corrections',
     1I,EO,EE,A,A-EGQ,WA,WA-EE,N7,N)
C
      IF(LQD)THEN
C      ground-2, ground-4, mono-1, mono-3, mono-5
       EG24=EG24*CM
       EAG=EAG+EG24
       DO 64 I=N7,N
       EE=E(I)*CM
       EO=EOLD(I)*CM
       DE1=EM1(I)*CM
       DE35=EM35(I)*CM
       A=DE35+DE1
       AW(I)=AW(I)+A
       WA=AW(I)-EAG
64     CALL WRTCOR(EG24,EAG,' Quartic off-diagonal corrections',
     1 I,EO,EE,A,A-EG24,WA,WA-EE,N7,N)
      ENDIF
      ENDIF
C
      IF(LH40)THEN
C      ground-2, ground-4, mono-1, mono-3, mono-5
       EG2K=EG2K*CM
       EGQK=EGQK*CM
       A=EG2K+EGQK
       EAG=EAG+A
       DO 106 I=N7,N
       EO=EOLD(I)*CM
       EE=E(I)*CM
       DE1=EK1(I)*CM
       DE35=EK35(I)*CM
       A=DE35+DE1
       AW(I)=AW(I)+A
       WA=AW(I)-EAG
106    CALL WRTCOR(A,EAG,' Kinetic quartic corrections',
     1 I,EO,EE,A,A-EGQK-EG2K,WA,WA-EE,N7,N)
      ENDIF
C
      IF(NZF.NE.0)THEN
       EGE=EGE*CM
       EGO=EGO*CM
       EAG=EAG+EGE+EGO
       DO 649 I=N7,N
       EE=E(I)*CM
       EO=EOLD(I)*CM
       DED=EEF(I)*CM
       DEO=EEO(I)*CM
       A=DED+DEO
       AW(I)=AW(I)+A
       WA=AW(I)-EAG
649    CALL WRTCOR(EGE+EGO,EAG,' The frequency substitution',
     1  I,EO,EE,A,A-EGE-EGO,WA,WA-EE,N7,N)
      ENDIF
      call replacedog(N,E,AW,EAG,N7)
c
c     writing states for usage in diagonalization:
c     -----------------------------------------------------
      write(6,*)NHBIG,NM0
      if(NHBIG.le.NM0)THEN
       NHBIGs=NHBIG
       do 21 I=1,NHBIG
       ISs(I)=IS(I)
       ITs(I)=IT(I)
       do 21 J=1,IS(I)
       INs(i,J)=IN(i,J)
21     ICCs(i,J)=ICC(i,J)

       if(iopt(2).lt.2)then
        CALL  FINDSYM(NHBIG,ISs,ICCs,INs,IBIGSYM,IY,N,KG,
     1  CHT,N7,NGE0,NT3,GAMA,GI,NM0,LEXCL)
        call w36(' States to be ordered according to the symmetry')
        CALL SYMORDER(IYX,ISB,KG,SSP,LEXCL)
       else
        ISB=1
        IYX(1,1)=1
        IYX(2,1)=NHBIG
       endif
c
       WRITE(3,*)ISB,' symmetry blocks found'
       DO 93 J=1,ISB
93     WRITE(3,*)J,' : ',IYX(1,J),' - ',IYX(2,J)
C
       WRITE(3,3005)N-N7+1,NHBIG
       WRITE(6,3005)N-N7+1,NHBIG
3005   FORMAT(I20,' FUNDAMENTALS',/,
     1        I20,' STATES IN THE HAMILTONIAN')
       CALL WS(ISB,IYX)
      ELSE
       call w36('NHBIG>NM0, states not kept')
      ENDIF
c     --------------------------------------------------------

      call w36('Ena2s-ok')
      RETURN
      END

      subroutine iu8(SUBTYPE,TYPE,C,NCI,i,e)
      implicit none
      integer*4 SUBTYPE,TYPE,C(*),NCI(*),i,e
      if(i.gt.0)then
       SUBTYPE=SUBTYPE+1
       TYPE=TYPE+e
       C(SUBTYPE)=i
       NCI(SUBTYPE)=e
      endif
      return
      end

      subroutine addst(i1,e1,i2,e2,i3,e3,i4,e4,i5,e5)
      implicit none
      integer*4 i1,e1,i2,e2,i3,e3,i4,e4,i5,e5,SUBTYPE,TYPE,ME00,NHBIG,
     1NMX
      parameter (ME00=5,NMX=1000000)
      integer*4 IT,IS,ICC,IN,C(ME00),NCI(ME00),i,ic,j,ee(2,ME00),ii
      COMMON/DD1/NHBIG,IT(NMX),IS(NMX),ICC(NMX,ME00),
     1IN(NMX,ME00)
c
      ee(1,1)=i1
      ee(2,1)=e1
      ee(1,2)=i2
      ee(2,2)=e2
      ee(1,3)=i3
      ee(2,3)=e3
      ee(1,4)=i4
      ee(2,4)=e4
      ee(1,5)=i5
      ee(2,5)=e5
      do i=1,ME00
       do j=i+1,ME00
        if(ee(1,j).lt.ee(1,i))then
         ii=ee(1,j)
         ee(1,j)=ee(1,i)
         ee(1,i)=ii
         ii=ee(2,j)
         ee(2,j)=ee(2,i)
         ee(2,i)=ii
        endif
       enddo
      enddo

c     number of excited modes
      SUBTYPE=0
c     number of excitations
      TYPE=0
      do 1 i=1,ME00
      NCI(i)=0
1     C(i)=0
      do 4 i=1,ME00
4     call iu8(SUBTYPE,TYPE,C,NCI,ee(1,i),ee(2,i))
c
c     find if it already exists:
      do 3 i=1,NHBIG
      if(IT(i).eq.TYPE.and.IS(i).eq.SUBTYPE)then
       ic=0
       do 31 j=1,ME00
31     if(ICC(i,j).ne.C(j).or.IN(i,j).ne.NCI(j))ic=ic+1
       if(ic.eq.0)return
      endif
3     continue

      NHBIG=NHBIG+1
      if(NHBIG.gt.NMX)then
       write(6,*)NMX
       write(3,*)NMX
       call report('too many states in addst/ena2s')
      endif
      IT(NHBIG)=TYPE
      IS(NHBIG)=SUBTYPE
      DO 2 I=1,ME00
      ICC(NHBIG,I)=C(I)
2     IN(NHBIG,I)=NCI(I)
      return
      end
