      SUBROUTINE FINDSYM(NHBIG,IS,ICC,IN,IBIGSYM,IY,N,KG,                       
     1CHT,N7,NGE0,NT3,GAMA,GI,NM0,LEXCL)                                        
      IMPLICIT REAL*8 (A-H,O-Z)                                                 
      IMPLICIT INTEGER*4 (I-N)                                                  
      DIMENSION IS(NHBIG),ICC(NM0,LEXCL),IN(NM0,LEXCL),                         
     1IBIGSYM(NM0),IY(NT3),CHT(NGE0,NGE0)                                       
      INTEGER*4 GAMA(NGE0),CHT,GI(NGE0)                                         
                                                                                
C     Loop over all states:                                                     
      DO 1 I=1,NHBIG                                                            
                                                                                
      DO 2 J=1,KG                                                               
2     GAMA(J)=1                                                                 
                                                                                
C     Look at all modes:                                                        
      DO 3 JJ=N7,N                                                              
                                                                                
      DO 4 II=1,KG                                                              
4     GI(II)=1                                                                  
                                                                                
      DO 5 IE=1,IS(I)                                                           
C     Check if mode JJ is excited:                                              
      IF(ICC(I,IE).EQ.JJ)THEN                                                   
C      Check if the excitation is odd- then symmetry is same as mode symmetry   
       IF((IN(I,IE)/2)*2.NE.IN(I,IE))THEN                                       
        DO 6 II=1,KG                                                            
6       GI(II)=CHT(IY(JJ),II)                                                   
       ENDIF                                                                    
      ENDIF                                                                     
5     CONTINUE                                                                  
                                                                                
C     Construct characters of the state                                         
      DO 3 J=1,KG                                                               
3     GAMA(J)=GAMA(J)*GI(J)                                                     
                                                                                
      DO 7 K=1,KG                                                               
C     Look at all symmetry elements K                                           
      DO 8 J=1,KG                                                               
      IF(GAMA(J).NE.CHT(K,J))GOTO 7                                             
8     CONTINUE                                                                  
      IBIGSYM(I)=K                                                              
      GOTO 1                                                                    
7     CONTINUE                                                                  
                                                                                
      CALL REPORT('Symmetry of states not found')                               
1     CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
