


c Same as above, but the function can be excited
c
      subroutine init_evscf_func(vscf_nbase,nnmodes,func_exc,vscf_func)
      include 'common.h'
c In:
      integer nnmodes,vscf_nbase,func_exc(nnmodes)
c Out:
c     The first index goes over the base of the LHOs, the second over the modes.
      real*8 vscf_func(vscf_nbase,nnmodes)
      
      integer ilho,imode,exci
      
      do imode=1,nnmodes
	    exci = 1+func_exc(imode)
	    if ( exci.lt.1 .or. exci.gt.vscf_nbase ) then
		  write(0,*)'FIXME: exci ',exci,vscf_nbase
		  call exit_nicely()
	    end if
            do ilho=1,vscf_nbase
		  if (ilho.eq.exci) then
			vscf_func(ilho,imode)=1d0
		  else
			vscf_func(ilho,imode)=0d0
		  end if
	    end do
      end do
      end 


