      SUBROUTINE LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
      implicit none
      INTEGER*4 N40,N,N7,NINDC,is,INDC,I,J,K,NCSP,IT,IDS,
     1K4,L44,KP4,LPP4,idss,L,M,NCO,NDSS,NXX,NX4,NDSP,ICS,ntem
      include 'dimensions.h'
      parameter (N40=6200000,
     1NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6,
     3NX4=NT3*((NT3*(NT3+1))/2))
      real*8,allocatable::CQ(:),CQ4t(:,:,:)
      real*8 E(*),CM,ACO,ASL,CIJK,CS,CQ4,DS,AC,AH4L,
     1CH,dss
      LOGICAL QUARTIC,LSPARSE,L4,LH40,lex,ldqq,HW,l44e
      COMMON/DIA2A/CIJK(NT3,NT3,NT3)
      COMMON/DIA2B/CS(NXX),ICS(3,NXX),NCSP
      COMMON/VQA/CQ4(NT3,NT3,NT3)
      COMMON/VQB/DS(NX4),IDS(3,NX4),NDSP
      COMMON/VQ2/dss(N40),idss(4,N40),ndss
      COMMON/V4/CH(NX4),K4(NX4),L44(NX4),KP4(NX4),LPP4(NX4),
     1AH4L,NCO
      integer*4 iopt,modcpl,ndif
      common/iop/iopt(300)
      equivalence (modcpl,iopt(17))
      logical lopt,LENAS
      common/lop/lopt(300)
      equivalence (LENAS,lopt(34))
c
      call w36(' ')
      call w36('Loadcds')
      call w36('^^^^^^^')
      CM=219470.0d0
      ACO=ASL/CM
      call w36('allocation ok')
      if(modcpl.ne.0)then
       write(3,3002)modcpl
       write(6,3002)modcpl
3002   format(' Maximum number of coupled modes: ',i2)
      endif
c
c     CIJK cubic constants:
c     use temporary CQ, rewrite complete into CIJK only
c     if sparse option not used
      allocate(CQ(1:N**3),stat=is)
      if(is.ne.0)call report('cannot allocate CQ in loadcd')
      call load3(CQ,N)
c
      IT=0
      ntem=0
      IF(LSPARSE)THEN
       DO 1 I=N7,N
       DO 1 J=I,N
       DO 1 K=J,N
       IT=IT+1
       IF(ABS(CQ(I+(J-1)*N+(K-1)*N**2)).GT.ACO)THEN
        IF(modcpl.ne.0)then
         ndif=1
         if(J.ne.I)ndif=2
         if(K.ne.J)ndif=ndif+1
        endif
        if(modcpl.eq.0.or.ndif.le.modcpl)then
         ntem=ntem+1
         if(ntem.gt.NXX)call report('ntem too big')
         CS(ntem)=CQ(I+(J-1)*N+(K-1)*N**2)
         ICS(1,ntem)=I
         ICS(2,ntem)=J
         ICS(3,ntem)=K
        endif
       ENDIF
1      CONTINUE
       NCSP=ntem
      else
       DO 4 I=N7,N
       DO 4 J=N7,N
       DO 4 K=N7,N
       IT=IT+1
       if(ABS(CQ(I+(J-1)*N+(K-1)*N**2)).gt.ACO)then
        CIJK(I,J,K)=CQ(I+(J-1)*N+(K-1)*N**2)
        ntem=ntem+1
        if(LENAS)then
         NCSP=ntem
         ICS(1,ntem)=I
         ICS(2,ntem)=J
         ICS(3,ntem)=K
        endif
       else
        CIJK(I,J,K)=0.0d0
       endif
4      continue
       call w36('all cubics retained')
       write(6,6009)N7,N7,N7,CIJK(N7,N7,N7)
       write(6,6009)N ,N ,N ,CIJK(N ,N ,N )
       write(3,6009)N7,N7,N7,CIJK(N7,N7,N7)
       write(3,6009)N ,N ,N ,CIJK(N ,N ,N )
6009   format(3i5,' : ',g12.4)
      endif
      WRITE(3,3000)ntem,ASL,IT
      WRITE(6,3000)ntem,ASL,IT
3000  FORMAT(I10,' cubics greater than  ',F10.4,'; total ',I9)
      deallocate(CQ)

      IF(QUARTIC)THEN
       if(.not.LSPARSE)then
        do 8 I=N7,N
        do 8 J=N7,N
        do 8 K=N7,N
8       CQ4(I,J,K)=0.0d0
       else
        NDSP=0
       endif
       IT=0
       ntem=0
       open(23,file='DQQ.SCR.TXT')
7      read(23,*,err=7000,end=7000)I,J,K,AC
       IT=IT+1
       if(LSPARSE)then
        if(dabs(AC).lt.ACO)goto 7
        IF(K.EQ.J.AND.K.LT.I)GOTO 7
        IF(.NOT.L4)THEN
         IF(K.NE.I.AND.K.NE.J.AND.I.NE.J)GOTO 7
         IF(K.NE.I.AND.I.EQ.J)GOTO 7
         IF(J.NE.I.AND.K.EQ.I)GOTO 7
        ENDIF
        IF(modcpl.ne.0)then
         if(J.eq.I)then
          if(K.eq.I)then
           ndif=1
          else
           ndif=2
          endif
         else
          if(K.eq.I.or.K.eq.J)then
           ndif=2
          else
           ndif=3
          endif
         endif
        endif
        if(modcpl.ne.0.and.ndif.gt.modcpl)GOTO 7
        ntem=ntem+1
        DS(ntem)=AC
        IDS(1,ntem)=I
        IDS(2,ntem)=J
        IDS(3,ntem)=K
       else
        if(dabs(AC).ge.ACO)then
         ntem=ntem+1
         if(LENAS)then
          NDSP=ntem
          IDS(1,ntem)=I
          IDS(2,ntem)=J
          IDS(3,ntem)=K
         endif
         CQ4(I,J,K)=AC
         CQ4(I,K,J)=AC
        endif
       endif
       goto 7
7000   close(23)
       if(LSPARSE)NDSP=ntem
       WRITE(3,7004)ntem,ASL,IT
       WRITE(6,7004)ntem,ASL,IT
7004  FORMAT(I10,' quartics greater than',F10.4,'; total ',I9)
      ENDIF

c     kinetic quartic constants:
      IF(LH40)THEN
       OPEN(4,FILE='H40.SCR',FORM='UNFORMATTED')
       NCO=0
5      READ(4,END=6)K,L,M,N,AC
       NCO=NCO+1
       IF(NCO.GT.NX4)CALL REPORT('Too many kinetic quartics')
       K4(NCO)=K
       L44(NCO)=L
       KP4(NCO)=M
       LPP4(NCO)=N
       CH(NCO)=AC
       GOTO 5
6      CLOSE(4)
       WRITE(3,3400)NCO,AH4L
       WRITE(6,3400)NCO,AH4L
3400   FORMAT(I7,' of kinetic quartics were loaded, ',
     1 'cut off limit',F10.4,' cm-1')
      ENDIF

c     all DIJKL quartic constants:
      inquire(file='D42Q.SCR',exist=lex)
      ndss=0
      if(lex)then
c      how many constants
       open(4,file='D42Q.SCR',form='unformatted')
30011  read(4,end=33331,err=33331)i,j,k,l,AC
       ndss=ndss+1
       goto 30011
33331  close(4)
       write(6,*)ndss,' constants from D42Q.SCR'
       write(3,*)ndss,' constants from D42Q.SCR'
       if(ndss.gt.N40)call report('to many constants in D42Q.SCR')
       ndss=0
       open(4,file='D42Q.SCR',form='unformatted')
3001   read(4,end=3333,err=3333)i,j,k,l,AC
       ndss=ndss+1
       dss(ndss)=AC
       idss(1,ndss)=i
       idss(2,ndss)=j
       idss(3,ndss)=k
       idss(4,ndss)=l
       goto 3001
3333   close(4)
       if(HW)then
        open(4,file='D42.SCR.TXT')
        do i=1,ndss
         write(4,4001)i,(idss(j,i),j=1,4),dss(i)
4001     format(5i4,f15.5)
        enddo
        close(4)
        call w36('Control D42.SCR.TXT written')
       endif
      endif
      call w36('Loadcds-ok')
      RETURN
      END
