      subroutine m4
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NGEO=24,NGR0=100,NA0=10,NTEM0=10)
      REAL*8 MGD(3),MED(3),MND(3),partQ(NTEM0),bf(NTEM0),u(3)
      INTEGER*4 A,B,C,D,IHA(NA0),IGROUND(NGR0),ISI(NGEO,4)
      real*8,allocatable:: ELD(:,:),bmax(:),u54(:,:),MDT(:,:),
     1AAEL(:,:,:,:),AEL(:,:,:),GEL(:,:,:),CFIG(:),CFI(:),E(:),
     2S(:,:),EAH(:),W(:),EH0(:),R(:,:),AM(:),PP(:,:,:),II(:,:,:),
     3JJ(:,:,:),GTENQ(:,:,:),PV(:,:,:),X(:,:),QM(:,:),QJ(:,:),
     4PPQ(:,:,:,:),IIQ(:,:,:,:),JJQ(:,:,:,:),PPT(:,:,:),PVT(:,:,:),
     5QP(:,:),QI(:,:),QMQ(:,:,:),QPQ(:,:,:),ALPHA(:,:,:),
     6ALPHAQ(:,:,:),EAHt(:),PPV(:,:,:,:),avq(:),aptn(:,:),
     7avq2(:,:),avqt(:,:),avq2t(:,:,:),alphaaq(:,:),GTEN(:,:,:),
     8ATEN(:,:,:,:),ATENQ(:,:,:,:),aptaq(:,:),aataq(:,:),gaq(:,:),
     9aaq(:,:),bmaxw(:),bmaxws(:)
      integer*4,allocatable:: ICC(:,:),IN(:,:),IS(:),ibmax(:),IDN(:),
     1SI(:),SJ(:),SK(:),item(:)
      LOGICAL GEO,AD,WRQ,WRONLY,RAMAN,lex,LHAND,lreq,
     1LVCD,LTEN,LTTT,LRESTART,LINS
      COMMON/BLANKC/N7,N
      COMMON/WP/NAT
      COMMON/OPTW/WRQ
      COMMON/ANTI/EPS(3,3,3)
      character*2 symbol
      logical lfu
      common/opt/ropt(100)
      equivalence (ropt(21),EXCNM)
      common/tlist/tems(NTEM0),NTEM
      common/iop/iopt(300)
      equivalence (nproc,iopt(14))
      integer*4 omp_get_num_procs,omp_get_max_threads
c
      Z0=0.0d0
      DEBYE=2.541732d0
      OPEN(3,FILE='M4.OUT')
      WRITE(6,666)
      WRITE(3,666)
666   FORMAT(/,6X,47H* * * * * * * * * * * * * * * * * * * * * * * *,/,
     1         6X,47H*                                             *,/,
     2         6X,47H*     ANHARMONIC VCD AND IR SPECTRA           *,/,
     3         6X,47H*                                             *,/,
     4         6X,47H*          M4 SUBROUTINE                      *,/,
     6         6X,47H* * * * * * * * * * * * * * * * * * * * * * * *,/,
     7/,       6X,47H  INPUT  :      SMAT.SCR   S - MATRIX          ,/,
     8         6X,47H               C5.OUT   CADPAC OUTPUT          ,/,
     8         6X,47H               M4.OPT   OPTIONS                ,/,
     8         6X,47H               G.OUT    Gaussian output        ,/,
     9         6X,47H             FILE.X  COORDINATES               ,/,
     A         6X,47H            EIGEN.CUB   ANHARMONIC WF          ,/,
     A         6X,47H              CFI.SCR   ANHARMONIC WF          ,/,
     A         6X,47H             FILE.TTT   ALTERNATIVE FOR POLDER ,/,
     A         6X,47H             FILE.TEN   ALT. FOR DIPDER (to C5),/,
     B/,       6X,47H  OUTPUT :     M4.TAB                          ,/,
     C         6X,47H               M4.OUT                          ,/,
     D/)
C
      CALL SPAR(AD,GEO,WRQ,RAMAN,WRONLY,FGEO,IGROUND,NGROUND,NGR0,
     1N1,N2,ELIMIT,IZERO,CM,AUD,CLIGHT,BOHR,LVCD,LTEN,
     2LTTT,ACUT,LRESTART,LINS,TEMP)

c
c     set up parallel parameters:
      if(nproc.gt.omp_get_num_procs())
     1call report('not enough processors')
      if(nproc.gt.omp_get_max_threads())
     1write(6,*)'Number of threads will increase'
      call omp_set_num_threads(nproc)
      call omp_set_dynamic(0)
      call omp_set_nested(0)
C
c     energies and S-matrix in atomic units:
      OPEN(2,FILE='SMAT.SCR',FORM='UNFORMATTED')
      READ(2)NAT
      N=3*NAT
      allocate (E(N),S(N,N),W(N),R(3,NAT),AM(NAT),IDN(NAT),SJ(N),
     1SI(N),SK(N),PP(NAT,3,3),II(NAT,3,3),JJ(NAT,3,3),GTENQ(3,3,N),
     1PV(NAT,3,3),X(3,NAT),QM(3,N),QJ(3,N),PPQ(NAT,3,3,N),
     2IIQ(NAT,3,3,N),JJQ(NAT,3,3,N),PPT(NAT,3,3),PVT(NAT,3,3),QP(3,N),
     3QI(3,N),QMQ(3,N,N),QPQ(3,N,N),ALPHA(N,3,3),ALPHAQ(3,3,N),
     4PPV(NAT,3,3,N),avq(N),aptn(2*N,3),avq2(N,N),avqt(NTEM0,N),
     5avq2t(NTEM0,N,N),alphaaq(N**2,9),GTEN(N,3,3),ATEN(N,3,3,3),
     6ATENQ(3,3,3,N),aptaq(2*N**2,3),aataq(N**2,3),gaq(N**2,9),
     7aaq(N**2,27))
      call vz(PPQ,0.0d0,NAT*3*3*N)
      call vz(PPV,0.0d0,NAT*3*3*N)
      call vz(IIQ,0.0d0,NAT*3*3*N)
      call vz(JJQ,0.0d0,NAT*3*3*N)
      rewind 2
      READ(2)NAT,(E(I),I=1,3*NAT),((S(I,J),J=1,3*NAT),I=1,3*NAT)
      CLOSE(2)
      NOAT=NAT
      call w36('Molecular properties allocated, S-matrix from SMAT.SCR')

      CALL INIP(II,JJ,PV,NAT)
C
      OPEN(4,FILE='EIGEN.SCR',FORM='UNFORMATTED')
      READ(4)N7,N,LEXCL,NHBIG,MV,KG,ISB
      write(6,*)NHBIG
      allocate(item(2*LEXCL))
      if(ISB.GT.NGEO)call report('ISB>NGEO')
      if(KG.GT.NGEO)call report('KG>NGEO')
      allocate(ICC(1:NHBIG,1:LEXCL),IN(1:NHBIG,1:LEXCL),IS(1:NHBIG),
     1CFI(1:NHBIG),CFIG(1:NHBIG),EAH(MV),EH0(MV),EAHt(MV))
      READ(4)(IDUM,I=1,NHBIG) ,(IS(I),I=1,NHBIG),
     1((ICC(I,J),I=1,NHBIG),J=1,LEXCL) ,((IN(I,J),I=1,NHBIG),J=1,LEXCL),
     2(EAH(I),I=1,MV),(W(I),I=N7,N),(WDUMM,I=N7,N),
     3((IDUM,K=1,2),J=1,ISB),((ISI(J,K),K=1,4),J=1,KG)
      DO 12 I=1,MV
12    EH0(I)=EAH(I)
      CLOSE(4)
      call w36('WF allocated, read from EIGEN.SCR')
c

      inquire(file='EAHC.SCR',exist=lex)
      if(lex)then
       open(4,file='EAHC.SCR',form='unformatted')
       read(4)NHBIG,(EAH(I),I=1,NHBIG)
       close(4)
       call w36('Corrected AH energies in EAHC.SCR')
      endif

      allocate(ibmax(NHBIG),bmax(NHBIG),bmaxw(NHBIG),bmaxws(NHBIG))
      do 5411 I=1,NHBIG
      ibmax(I)=0
      bmaxw(I)=0.0d0
      bmaxws(I)=0.0d0
5411  bmax(I)=0.0d0

      WRITE(3,7009)NAT,N7,N,NHBIG,MV,KG,ISB,LEXCL
      WRITE(6,7009)NAT,N7,N,NHBIG,MV,KG,ISB,LEXCL
7009  format(/,' NAT             ',i7,', modes           ',i7,' -',i7,/,
     1         ' total dimension ',i7,', number of states',i7,/,
     2         ' number of syms  ',i7,', number of blocks',i7,/,
     3         ' max excitation  ',i7,/)
C
      OPEN(2,FILE='FILE.X')
      READ(2,*)
      READ(2,*)NOAT
      DO 35 K=1,NOAT
      READ(2,*)IDN(K),(R(I,K),I=1,3)
      DO 34 I=1,3
34    R(I,K)=R(I,K)/BOHR
C     Charges, masses and coh and incoh ins cross-sections
c     Z(K)=DBLE(IDN(K))
      symbol='  '
35    AM(K)=amave(IDN(K),symbol)
      CLOSE(2)
      call w36('Coordinates from FILE.X')
C

      if(LTTT)THEN
       call READTENTTT(N,NAT,ALPHA,GTEN,ATEN)
       call w36('Polarizability derivatives from FILE.TTT')
      endif

      IF(LTEN)THEN
       WRITE(3,*)' From FILE.TEN'
       WRITE(6,*)' From FILE.TEN'
       CALL READFD(PP,II,JJ,PV,NAT)
       call w36('Dipole derivatives from FILE.TEN')
      ENDIF
C
      CALL TT(N,N7,QP,QJ,QI,QM,NOAT,S,RAMAN,ALPHAQ,ALPHA,WRQ,
     1E,W,QPQ,QMQ ,AD,MGD,MND,MED,II,JJ,PP,IIQ,PPQ,N1,N2,
     2CLIGHT,AUD,PPV,R,JJQ,PVT,PPT,GTENQ,ATENQ,GTEN,ATEN)

      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       if(.not.LTEN)then
        call rdten1q(QP,QM,N,N)
       endif
      endif
      inquire(file='TTTQ.TXT.SCR',exist=lex)
      if(lex)then
       if(.not.LTTT)then
        call readtttq(N,ALPHAQ,GTENQ,ATENQ,N,N7)
       endif
      endif

c     read second dipole derivatives if available:
      call rdtenq(aptaq,aataq,N,N)
      do 903 i=N7,n
      do 903 j=N7,n
      do 903 ix=1,3
      QPQ(ix,i,j)=aptaq(i+(j-1)*n,ix)
903   QMQ(ix,i,j)=aataq(i+(j-1)*n,ix)
      
c     second polarizability derivatives:
      call rdttqaq(N,N,alphaaq,gaq,aaq)
C
C     Start of anharmonic calculations:
C     List biggest expansion coefficients for all states:
c     first all, then fundamental only
      DO 54 ih=1,2
      if(ih.eq.1)then
       call w36('All states')
      else
       call w36('Fundamental only')
      endif
      DO 54 I0=1,KG
      I1=ISI(I0,1)
      I2=ISI(I0,2)
      J1=ISI(I0,3)
      J2=ISI(I0,4)
      NDIM=I2-I1+1
      WRITE(3,300)I0,J1,J2,I1,I2
      WRITE(6,300)I0,J1,J2,I1,I2
300   format('Symmetry ',i6,' eigenstates  ',i7,'-',i7,/,
     1       '                basis states ',i7,'-',i7)

      if(I1.NE.0)THEN
       write(3,301)
301    format('state  energy',
     1 ' three most present bases and coefs [%]:')

       DO 541 I=J1,J2
       CALL LOADC(I,CFI,NDIM)
       IN1=0
       IN2=0
       IN3=0
       C1=Z0
       C2=Z0
       C3=Z0
       DO 70 J=1,NDIM
c      if(J.eq.22)write(6,*)I,CFI(J)**2*100.0d0
       if(abs(CFI(J)).gt.bmax(J))then
        bmax(J)=abs(CFI(J))
        bmaxws(J)=(EAH(I)-EAH(1))*CM
        ibmax(J)=I
c       harmonic energy for state J:
        EHJ=0.0d0
        DO 5412 K=1,IS(J-I1+1)
5412    EHJ=EHJ+dble(IN(J-I1+1,K))*E(ICC(J-I1+1,K))
        bmaxw(J)=EHJ*CM
       endif
       IF(ABS(CFI(J)).GT.C1)THEN
        C1=ABS(CFI(J))
        IN1=J
       ENDIF
70     CONTINUE
       DO 71 J=1,NDIM
       IF(J.EQ.IN1)GOTO 71
       IF(ABS(CFI(J)).GT.C2)THEN
        C2=ABS(CFI(J))
        IN2=J
       ENDIF
71     CONTINUE
       DO 72 J=1,NDIM
       IF(J.EQ.IN1.OR.J.EQ.IN2)GOTO 72
       IF(ABS(CFI(J)).GT.C3)THEN
        IN3=J
        C3=ABS(CFI(J))
       ENDIF
72     CONTINUE
       C1=C1*C1*100.0d0
       C2=C2*C2*100.0d0
       C3=C3*C3*100.0d0
c      determine, if fundamental state:
       lfu=IS(IN1+I1-1).eq.1.and.IN(IN1+I1-1,1).eq.1

       do 74 J=1,       IS(IN1+I1-1)
       item(2*(J-1)+1)=ICC(IN1+I1-1,J)
74     item(2*J)=       IN(IN1+I1-1,J)

       if(ih.eq.1.or.lfu)then
        if(ih.eq.2)then
         WRITE(6,6666)I,EAH(I)*CM,IN1+I1-1,C1,IN2+I1-1,C2,IN3+I1-1,C3
6666     FORMAT(I4,F9.1,2x,3(I7,F8.1),$)
         do 80 J=1,2*IS(IN1+I1-1)-1,2
80       write(6,6661)item(J),item(J+1)
6661     FORMAT(i3,'_',i1,' ',$)
         write(6,*)
        endif
        WRITE(3,6666)I,EAH(I)*CM,IN1+I1-1,C1,IN2+I1-1,C2,IN3+I1-1,C3
        do 82 J=1,2*IS(IN1+I1-1)-1,2
82      write(3,6661)item(J),item(J+1)
        write(3,*)
       endif
541    continue

       if(WRQ.or.ih.eq.2)write(3,3009)
3009   format(/,' basis state / most occurs in eigenstate / %:')
       do 542 i=1,NDIM
542    if(WRQ.or.(i.le.N-N7+2.and.ih.eq.2))
     1 write(3,3010)i,bmaxw(i),ibmax(i),bmaxws(i),100*bmax(i)**2
3010   format(3(i8,f9.2,2h /,i7,f9.2,2h /,f9.5),/)
       write(3,*)

      ENDIF


54    continue

      IF(WRONLY)call report(' PROGRAM TERMINATED')
C
      write(6,3001)NGROUND
      write(3,3001)NGROUND
3001  format(/,/,' Transitions from ',I5,' ground states:')
c
c     by default lowest energy:
      if(IGROUND(1).eq.0)then
       IGROUND(1)=1
       DO 3 I=2,MV
3      IF(EAH(I).LT.EAH(IGROUND(1)))IGROUND(1)=I
       call w36('Lowest-energy state taken as ground')
      endif

      write(6,3002)(IGROUND(i),i=1,NGROUND)
      write(3,3002)(IGROUND(i),i=1,NGROUND)
3002  format(8I10)

c     calculate partition function:
      Q=0.0d0
      do 1002 IGG=1,NGROUND
      earg=(EAH(IGROUND(IGG))-EAH(IGROUND(1)))*CM/TEMP/0.69502d0
1002  if(earg.le.20.0d0)Q=Q+exp(-earg)

      ALIM=ACUT*0.000001d0/DSQRT(DBLE(NHBIG))
      OPEN(51,FILE='M4.TAB')
      if(RAMAN)OPEN(55,FILE='M4ROA.TAB')
      WRITE (6,5019)
      WRITE (51,5019)
5019  FORMAT (/,
     110X,'FREQ.      D [10-4D^2]   R [10-8D^2]DO      RAM       POL',
     2/,80(1H-))
      if(RAMAN)WRITE (55,50191)
50191 FORMAT(
     1'MODE   FREQ    IDX    IDY    RAMAN     ROA-Z',
     2'     ROA-X   ROA-180  DEP   raw180 RamanDCPI',/,
     3'       cm-1                            x10^4',
     4'     x10^4     x10^4       au.10^4',/,80(1H-))

      WRITE (3,5244)ALIM,NHBIG,nproc
5244  FORMAT(/,' Cut-off expansion limit: ',G10.3,' NHBIG = ',I5,/,
     1         ' Number of processors   : ',i10)
c     ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
      im0=mclock()
      do 4 IGG=1,NGROUND
      IG=IGROUND(IGG)
      EG=EAH(IG)
      p=exp(-(EAH(IGROUND(IGG))-EAH(IGROUND(1)))*CM/TEMP/0.69502d0)/Q
c
c     find symmetry:
      KK=0
      DO 1001 IK=1,KG
1001  IF(IG.GE.ISI(IK,3).AND.IG.LE.ISI(IK,4))KK=IK
c
      IG1=ISI(KK,1)
      IG2=ISI(KK,2)
      call w36(' ')
      WRITE(3,302)IG,KK,EG*CM,TEMP,p*100.0d0
      WRITE(6,302)IG,KK,EG*CM,TEMP,p*100.0d0
302   format(' Ground state ',i5,', symmetry ',i2,/,
     1       '       energy ',f10.2,' cm-1',/,
     1       '  Temperature ',f10.2,' K',/,
     1       '       weight ',f10.2,' %',/)
      DO 121 I=1,MV
121   EAHt(I)=EAH(I)
      EAHt(IG)=Z0
C
c     use CFIG as buffer in INS:
      IF(LINS)CALL INS(NAT,AM,ISI,KG,EAH,S,MV,IS,ICC,IN,EG,IG,
     1NHBIG,LEXCL,CFI,CFIG)
C
c     SQ2=1.0d0/SQRT(2.0d0)
C     Load ground:
      CALL LOADC(IG,CFIG,IG2-IG1+1)
c
c     make moments  <   G   |X  |  j  > =  C_Gi <i|X|j>
c                    ground       HOi
c     x=u(3) m(3) al(9) G'(9) A(27)
      allocate(u54(1:54,1:NHBIG),stat=i)
      if(i.ne.0)call report('u54 not allocated')

      do 2003 J=1,NHBIG

      do 2001 i=1,54
2001  u54(i,J)=0.0d0
c
c     retrieve state J:
      DO 2006 KK=N7,N
2006  SJ(KK)=0
      ITJ=0
      DO 2007 KK=1,IS(J)
      ITJ=ITJ+IN(J,KK)
2007  SJ(ICC(J,KK))=IN(J,KK)
      
      do 20031 I=IG1,IG

      CGI=CFIG(I-IG1+1)

c     skip states with low weights:
      IF(ABS(CGI).LT.ALIM)GOTO 20031
c
c     retrieve state I:
      DO 2004 KK=N7,N
2004  SI(KK)=0
      ITI=0
      DO 2005 KK=1,IS(I)
      ITI=ITI+IN(I,KK)
2005  SI(ICC(I,KK))=IN(I,KK)

      if(iabs(ITI-ITJ).gt.2)goto 20031

c     <i|X|j> = <i|X0+XQq Qq +(1/2) XQqQj Qq Qj|j>
c     XQq <i|Qq|j> +(1/2) XQqQj <i|Qq Qj|j>
c
      DO 814 IQ=N7,N
      SFU =S1QIS2(SI,IQ,SJ)
      SFUP=S1PIS2(SI,IQ,SJ)
C
c     u=u0+sum(i) du/dqi qi + (1/2)sum(i) d^2u/dqi^2 qi^2
c         +sum(i) sum(j>i) d^u/dqi/dqj qi qj
c
c     For the magnetic dipole,
c     u=u0+sum(i) du/dpi pi + (1/2)sum(i,j) d^u/dpi/dqj pi qj
c
c     first derivatives:
      if(SFU.ne.0.0d0)then
       SFU =SFU*CGI
       IF(RAMAN)THEN
        ij=0
        ik=0
        do 705 ix=1,3
        do 705 iy=1,3
        ij=ij+1
        u54( 6+ij,J)=u54( 6+ij,J)+SFU*ALPHAQ(ix,iy,IQ)
        u54(15+ij,J)=u54(15+ij,J)+SFU* GTENQ(ix,iy,IQ)
        do 705 iz=1,3
        ik=ik+1
705     u54(24+ik,J)=u54(24+ik,J)+SFU*ATENQ(ix,iy,iz,IQ)
       ENDIF
       do 810 ix=1,3
810    u54(ix   ,J)=u54(ix    ,J)+SFU*QP(ix,IQ)
      endif
      if(SFUP.ne.0.0d0)then
       SFUP=SFUP*CGI
       do 8101 ix=1,3
8101   u54(ix+3,J)=u54(ix+3,J)+SFUP*QM(ix,IQ)
      endif

      IF(AD)THEN
C
c      second derivatives diagonal, <Qi^2> (JQ=IQ):
c      second derivatives diagonal, <PiQi>
       SFU =S1QIQJS2(SI,IQ,IQ,SJ)
       SFUP=S1PIQJS2(SI,IQ,IQ,SJ)

       if(SFU.ne.0.0d0)then
        SFU =SFU*0.5d0*CGI
c       (1/2) from the taylor expansion
        if(RAMAN)then
         iu=IQ+(IQ-1)*N
         ij=0
         ik=0
         do 706 ix=1,3
         do 706 iy=1,3
         ij=ij+1
         u54( 6+ij,J)=u54( 6+ij,J)+SFU*alphaaq(iu,ix+3*(iy-1))
         u54(15+ij,J)=u54(15+ij,J)+SFU* gaq(iu,ix+3*(iy-1))
         do 706 iz=1,3
         ik=ik+1
706      u54(24+ik,J)=u54(24+ik,J)+SFU*aaq(iu,ix+3*(iy-1)+9*(iz-1))
        endif
        do 818 ix=1,3
818     u54(  ix,J)=u54(  ix,J)+SFU*QPQ(ix,IQ,IQ)
       endif
       if(SFUP.ne.0.0d0)then
        SFUP=SFUP*0.5d0*CGI
        do 8181 ix=1,3
8181    u54(ix+3,J)=u54(ix+3,J)+SFUP*QMQ(ix,IQ,IQ)
       endif

       DO 811 JQ=IQ+1,N
       ELJKQ =S1QIQJS2(SI,IQ,JQ,SJ)
       ELJKQP=S1PIQJS2(SI,IQ,JQ,SJ)
       ELKJQP=S1PIQJS2(SI,JQ,IQ,SJ)
       if(ELJKQ.ne.0.0d0)then
        ELJKQ =ELJKQ*CGI
        if(RAMAN)then
         iu=IQ+(JQ-1)*N
         ij=0
         ik=0
         do 707 ix=1,3
         do 707 iy=1,3
         ij=ij+1
         u54( 6+ij,J)=u54( 6+ij,J)+ELJKQ*alphaaq(iu,ix+3*(iy-1))
         u54(15+ij,J)=u54(15+ij,J)+ELJKQ*    gaq(iu,ix+3*(iy-1))
         do 707 iz=1,3
         ik=ik+1
707      u54(24+ik,J)=u54(24+ik,J)+ELJKQ*aaq(iu,ix+3*(iy-1)+9*(iz-1))
        endif
        do 817 ix=1,3
817     u54(   ix,J)=u54(    ix,J)+ELJKQ*QPQ(ix,IQ,JQ)
c       (1/2) from Taylor x 2 from ij=ji
       endif
       if(ELJKQP.ne.0.0d0)then
        ELJKQP=ELJKQP*CGI*0.5d0
        do 8171 ix=1,3
8171    u54(ix+3,J)=u54(ix+3,J)+ELJKQP*QMQ(ix,JQ,IQ)
c       QMQ first Q-index-coordinate last-momentum
       endif
       if(ELKJQP.ne.0.0d0)then
        ELKJQP=ELKJQP*CGI*0.5d0
        do 8172 ix=1,3
8172    u54(ix+3,J)=u54(ix+3,J)+ELKJQP*QMQ(ix,IQ,JQ)
c       QMQ first Q-index-coordinate last-momentum
       endif
811    CONTINUE

      ENDIF
814   CONTINUE
20031 CONTINUE
2003  CONTINUE
C
C     Loop over all symmetries
      DO 4001 I0=1,KG
      I1=ISI(I0,1)
      I2=ISI(I0,2)
      J1=ISI(I0,3)
      J2=ISI(I0,4)
      NDIM=I2-I1+1
      NST=J2-J1+1
      IF(I1.NE.0)THEN
      write(6,*)'Symmetry ',I0,NST
c     111111111111111111111111111111111111111111111111111111111111
C
c
      mvi=J2-J1+1
      allocate(ELD(mvi,3),MDT(mvi,3),GEL(mvi,3,3),AEL(mvi,3,3),
     1AAEL(mvi,3,3,3),stat=i)
      if(i.ne.0)call report('moments not allocated')
C     Loop over excited states:
c     44444444444444444444444444444444444444444444444444444444444444444
      DO 804 IE=1,mvi
      CALL LOADC(J1-1+IE,CFI,NDIM)
c     <G|u|E> = <G|u|i> Cei:
      do 8043 IX=1,3
      ELD(IE,IX)=0.0d0
      MDT(IE,IX)=0.0d0
      DO 8043 JX=1,3
      GEL(IE,IX,JX)=0.0d0
      AEL(IE,IX,JX)=0.0d0
      DO 8043 KX=1,3
8043  AAEL(IE,IX,JX,KX)=0.0d0
      DO 804 I=I1,I2
      Cei=CFI(I-I1+1)
      ij=0
      ik=0
      DO 804 IX=1,3
      ELD(IE,IX)=ELD(IE,IX)+u54(   IX,I)*Cei
      MDT(IE,IX)=MDT(IE,IX)+u54( 3+IX,I)*Cei
      DO 804 JX=1,3
      ij=ij+1
      AEL(IE,IX,JX)=AEL(IE,IX,JX)+u54( 6+ij,I)*Cei
      GEL(IE,IX,JX)=GEL(IE,IX,JX)+u54(15+ij,I)*Cei
      DO 804 KX=1,3
      ik=ik+1
804   AAEL(IE,IX,JX,KX)=AAEL(IE,IX,JX,KX)+u54(24+ik,I)*Cei
c     44444444444444444444444444444444444444444444444444444444444444444
c
      DO 44 I=J1,J2
C
C     Find lowest one that is not zeroed yet
      EE=1000000.0d0
      IE=0
      DO 5 J=J1,J2
      IF(J.EQ.IG)GOTO 5
      IF(EAHt(J).LT.EE.AND.ABS(CM*EAHt(J)).GT.0.0010d0)THEN
       EE=EAHt(J)
       IE=J-J1+1
      ENDIF
5     CONTINUE
      EE=EE-EG
      IF(IE.EQ.0)GOTO 44
      EAHt(IE)=Z0
      IF(EE*CM.GT.ELIMIT)GOTO 44
      IF(IE.LT.N1.OR.IE.GT.N2)GOTO 44
C     Dipoles to Debyes:
      C1=                AUD
      C2=2.0d0/CLIGHT*AUD
      DO 13 B=1,3
      ELD(IE,B)=ELD(IE,B)*C1
13    MDT(IE,B)=MDT(IE,B)*C2
      SUMD=0.0d0
      RDO=0.0d0

c     Raman for Stokes only (to upper energy levels):
      IF(RAMAN.and.EE*CM.gt.0.1d0)then
       SAL0=0.0d0
       SAL1=0.0d0
       SAG0=0.0d0
       SAG1=0.0d0
       SA1=0.0d0
       SPAL=0.0d0
       DO 81 A=1,3
       SPAL=SPAL+AEL(IE,A,A)
       DO 81 B=1,3
       SAL0=SAL0+AEL(IE,A,A)*AEL(IE,B,B)
       SAG0=SAG0+AEL(IE,A,A)*GEL(IE,B,B)
       SAG1=SAG1+AEL(IE,A,B)*GEL(IE,A,B)
       SAL1=SAL1+AEL(IE,A,B)*AEL(IE,A,B)
       DO 81 C=1,3
       DO 81 D=1,3
c1     SA1=SA1+EPS(A,C,D)*AEL(IE,A,B)*AAEL(IE,C,D,B)/3.0d0
81     SA1=SA1+EPS(A,C,D)*AEL(IE,A,B)*AAEL(IE,B,D,C)/3.0d0
c      the indices in AAEL are different than in new6
c
c      IL+IR, backscattering, DCP_I
       SDCP180=3.0d0*SAL1-SAL0
c
c      IL+IR, backscattering
c      S180=7.0d0*SAL1+SAL0
c
c      IL+IR, 90o, x
       S90X=7.0d0*SAL1+SAL0
c
c      IR-IL, 90o, x
       D90X=2.0d0*(7.0d0*SAG1+SAG0+SA1)
c
c      IL+IR, 90o, z
c      S90Z=2.0d0*(3.0d0*SAL1-SAL0)
c
c      IR-IL, 90o, z
c      D90Z=4.0d0*(3.0d0*SAG1-SAG0-SA1)
c
c      polarized backscattering components (YDY+YDX=S180):
       YDY=3.0d0*SAL1-SAL0
       YDX=4.0d0*SAL1+2.0d0*SAL0
       P1=YDY/YDX
c
       SDCP180=SDCP180*1000.0d0
c
       AMU=1822.0d0
       SpA3=SPAL/3.0d0*dsqrt((AMU*BOHR**4))
       beta2=0.5d0*(3*SAL1-SAL0)*(AMU*BOHR**4)
       YDY=6.0d0*YDY*(AMU*BOHR**4)
       YDX=6.0d0*YDX*(AMU*BOHR**4)
       EXCA=EXCNM*10.0d0
c      gpisvejc=980.0
       gpisvejc=(AMU*BOHR**5)*1.0d4*2.0d0*4.0d0*atan(1.0d0)/EXCA
c      beta(A)^2=Delta2 in Gaussian:
       betaa=SA1*3.0d0/2.0d0*gpisvejc
       betag=(3.0d0*SAG1-SAG0)/2.0d0*gpisvejc
c      DCP 180
       roa3=8.0d0*(12.0d0*betag+4.0d0*betaa)
c      unknown:
       S90X=S90X*(AMU*BOHR**4)
       D90X=D90x*gpisvejc
       DX=D90X
       IF(S90X.gt.1.0d-9)DX=DX/S90X
c      ICP(90)=90Z
       roa2=8.0d0*(3.0d0*betag-betaa)
       ram2=12.0d0*beta2
       CID2=0.0d0
       if(ram2.gt.1.0d-9)CID2=roa2/ram2
c      ICP(180):
c      8/c*(12*beta(G')^2 + 4*beta(A)^2):
       roa1=96.0d0*(betag+betaa/3.0d0)
       ram1=4.0d0*(45.0d0*SpA3**2+7.0d0*beta2)
c      will be multiplied by frequency, because
c      for simulation of spectra it is divided again:
c      factor of 2 is because of the (1/sqrt(2))^2 matrix Q-element
       roa1=roa1*EE*2.0d0
       ram1=ram1*EE*2.0d0
       YDX=YDX*EE*2.0d0
       YDY=YDY*EE*2.0d0

       CID1=0.0d0
       if(ram1.gt.1.0d-9)CID1=roa1/ram1
       WRITE(55,3550)I,EE*CM,YDX*p,YDY*p,ram1*p,CID2,DX*p,CID1,P1,
     1 roa1*p,roa3*p
3550   FORMAT(I4,f9.2,6f12.2,f6.3,f12.2,f12.2)
       BA=0.5d0*(3.0d0*SAL1-SAL0)
       A2=SAL0*(1.0d0/9.0d0)
       P1=0.0d0
       if(dabs(45.0d0*A2+4.0d0*BA).gt.0.0d0)
     1 P1=3.0d0*BA/(45.0d0*A2+4.0d0*BA)
      ELSE
       ram1=0.0d0
       P1=0.0d0
      endif

      DO 17 III=1,3
      SUMD  =SUMD +ELD(IE,III)*ELD(IE,III)
17    RDO   =RDO  +MDT(IE,III)*ELD(IE,III)
C     Intensity [km/mol]=sqrt(2pi)*v[cm-1]*D[Debye^2]
c      WRITE(6,5239) I,EE*CM,SUMD*p,RDO*p,ram1*p,P1
      if(dabs(SUMD*p).gt.1.0d-8.or.dabs(ram1*p).gt.1.0d-8)then
       if(EE.gt.0.0d0)then
        WRITE(51,5239) I,dabs(EE)*CM,SUMD*p,RDO*p,ram1*p,P1,IG,IE
5239    FORMAT(1X,I4,F12.3,3G15.6,F7.3,i5,'->',i7)
       else
c       stimulated emmision=negative absorption for upper to low trans:
        WRITE(51,5239) I,dabs(EE)*CM,-SUMD*p,RDO*p,ram1*p,P1,IG,IE
       endif
      endif
44    CONTINUE
      ELSE
c     1111111111111111111111111111111111111111111111111111111111111111
      write(6,*)'Symmetry ',I0,' skipped'
      ENDIF
c     1111111111111111111111111111111111111111111111111111111111111111
4001  deallocate(ELD,MDT,GEL,AEL,AAEL)
4     deallocate(u54)
c     ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
C
      WRITE(3,819)
      WRITE(51,819)
      if(RAMAN)WRITE(55,819)
819   FORMAT('--------------------------------------------')
      CLOSE(51)
      if(RAMAN)CLOSE(55)
      write(6,3434)mclock()-im0
      write(3,3434)mclock()-im0
3434  format(' Time passed for spectra calculations ',I10)

      IF(GEO)THEN
       call w36(' ')
       call w36('Equilibrium:')
       call w36(' ')
       CALL ROTCONST(NOAT,AM,R)
       call w36(' ')
       call w36('State averages:')
       call w36(' ')
       inquire(file='HAND.LST',exist=LHAND)
       if(LHAND)then
        call w36('HAND.LST - extra states required')
        open(90,file='HAND.LST')
        read(90,*)NHAND
        if(NHAND.gt.NA0)call report('too many extra states')
        backspace 90
        read(90,*)NHAND,(IHA(I),I=1,NHAND)
        close(90)
       endif
c
c      Initialize temperature-dependent coordinate averages and
c      calculate partition function for all temperatures
       do 77 it=1,NTEM
       istt=0
       partQ(it)=0.0d0
       do 77 I0=1,KG
       do 77 I=J1,J2
       ENI=CM*(EH0(I)-EG)
       lreq=.false.
       if(LHAND)then
        do 75 J=1,NHAND
75      if(IHA(J).eq.I)lreq=.true.
       endif
       IF(ENI.LE.FGEO.or.lreq)then
        istt=istt+1
        partQ(it)=partQ(it)+exp(-ENI/tems(it)/0.69502d0)
       endif
77     continue

       do 76 it=1,NTEM
       do 76 I0=1,N
       avqt(it,I0)=0.0d0
       do 76 J=1,N
76     avq2t(it,I0,J)=0.0d0
c
       DO 53 I0=1,KG
       I1=ISI(I0,1)
       I2=ISI(I0,2)
       J1=ISI(I0,3)
       J2=ISI(I0,4)
       WRITE(3,390)I0,I1,I2,J1,J2,FGEO
       WRITE(6,390)I0,I1,I2,J1,J2,FGEO
390    format('Symmetry ',i3,' I1 I2 J1 J2:',4I8,' FGEO:',f10.1)
       NDIM=I2-I1+1
       DO 53 I=J1,J2
       ENI=CM*(EH0(I)-EG)
       lreq=.false.
       if(LHAND)then
        do 715 J=1,NHAND
715     if(IHA(J).eq.I)lreq=.true.
       endif
       IF(ENI.LE.FGEO.or.lreq)then
        CALL LOADC(I,CFI,NDIM)
c
c       determine, if the state is fundamental
        IN1=0
        C1=0.0d0
        DO 73 J=1,NDIM
        IF(ABS(CFI(J)).GT.C1)THEN
         C1=ABS(CFI(J))
         IN1=J
        ENDIF
73      CONTINUE
        lfu=IS(IN1+I1-1).eq.1.and.IN(IN1+I1-1,1).eq.1

        WRITE(3,5245)
        WRITE(6,5245)
5245    format(70(1h*))
        do 78 it=1,NTEM
        bf(it)=exp(-ENI/tems(it)/0.69502d0)/partQ(it)
        if(lfu)then
         WRITE(3,5241)I,'*',ENI,bf(it)*100.0d0,tems(it)
         WRITE(6,5241)I,'*',ENI,bf(it)*100.0d0,tems(it)
5241     FORMAT(1X,I4,' ',a1,' state (',F10.3,' cm-1), bf ',f10.2,'%:',
     1   f10.2,' K')
        else
         WRITE(3,5241)I,' ',ENI,bf(it)*100.0d0,tems(it)
         WRITE(6,5241)I,' ',ENI,bf(it)*100.0d0,tems(it)
        endif
78      continue
c
c       calculate the normal coordinate averages <Qi> and <QiQj>

        do 181 IQ=N7,N
        avq(IQ)=0.0d0
        do 181 JQ=N7,N
181     avq2(IQ,JQ)=0.0d0

        DO 55 K=I1,I2
        CIK=CFI(K-I1+1)
        DO 66 LL=N7,N
66      SK(LL)=0
        DO 57 LL=1,IS(K)
57      SK(ICC(K,LL))=IN(K,LL)
        DO 55 J=I1,I2
        PC=CIK*CFI(J-I1+1)
        DO 58 LL=N7,N
58      SJ(LL)=0
        DO 69 LL=1,IS(J)
69      SJ(ICC(J,LL))=IN(J,LL)
        DO 55 IQ=N7,N
        avq(IQ)=avq(IQ)+PC*S1QIS2(SK,IQ,SJ)
        DO 55 JQ=N7,N
55      avq2(IQ,JQ)=avq2(IQ,JQ)+PC*S1QIQJS2(SK,IQ,JQ,SJ)*0.5d0

        write(6,6005)
        write(3,6005)
6005    format(' Normal mode averages <Qi> <Qii>:')
        DO 551 it=1,NTEM
        DO 551 IQ=N7,N
        avqt(it,IQ)=avqt(it,IQ)+avq(IQ)*bf(it)
        do 5511 JQ=N7,N
5511    avq2t(it,IQ,JQ)=avq2t(it,IQ,JQ)+avq2(IQ,JQ)*bf(it)
        if(it.eq.1)write(3,6008)IQ,avq(IQ),avq2(IQ,IQ)
551     if(it.eq.1)write(6,6008)IQ,avq(IQ),avq2(IQ,IQ)
6008    format(i5,2f10.5)
c
        call w36('Averaged geometry X=X0+s/sqrt(w).<q>:')
        DO 19 L=1,NOAT
        DO 19 ix=1,3
        X(ix,L)=R(ix,L)
        DO 19 IQ=N7,N
19      X(ix,L)=X(ix,L)+S(3*(L-1)+ix,IQ)*avq(IQ)/DSQRT(DABS(E(IQ)))
        DO 56 L=1,NOAT
        WRITE(6,5242)IDN(L),(X(ix,L)*BOHR,ix=1,3)
56      WRITE(3,5242)IDN(L),(X(ix,L)*BOHR,ix=1,3)
5242    FORMAT(I5,3F15.8)
        CALL ROTCONST(NOAT,AM,X)
c
c       dipole moment u=u0+APT.<q>
        inquire(file='TENQ.TXT.SCR',exist=lex)
        if(lex)then
         open(9,file='TENQ.TXT.SCR')
         read(9,*)(u(ix),ix=1,3)
         dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
         write(6,6003)
         write(3,6003)
6003     format(/,' Dipole moments          atomic units     ',
     1   '                           debye')
         write(3,6004)
         write(6,6004)
6004     format(' equilibrium:')
         write(6,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
         write(3,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
6002     format(2('       ux       uy       uz      norm'),/,
     1   2(3f9.5,1x,f9.5),/)
         read(9,*)
         read(9,*)ndif
         do 23 im=1,ndif
         do 23 jx=1,3
23       read(9,*)idum,imo,idum,aptn(imo,jx),aptn(imo+N,jx)
         close(9)
         do 21 jx=1,3
         do 21 IQ=N7,N
21       u(jx)=u(jx)+aptn(IQ,jx)*avq(IQ)
         dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
         write(3,6006)
         write(6,6006)
6006     format(' with first-derivative corrections:')
         write(6,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
         write(3,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
         inquire(file='TENAQ.TXT.SCR',exist=lex)
         if(lex)then
          do 221 jx=1,3
          do 221 IQ=N7,N
          do 221 JQ=N7,N
221       u(jx)=u(jx)+QPQ(jx,IQ,JQ)*avq2(IQ,JQ)
          dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
         else
          do 222 jx=1,3
          do 222 IQ=N7,N
222       u(jx)=u(jx)+aptn(IQ+N,jx)*avq2(IQ,IQ)
          dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
         endif
         write(3,6007)
         write(6,6007)
6007     format(' with first and second-derivative corrections:')
         write(6,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
         write(3,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
        endif
c
c       other properties:
        call proder(avq,avq2,N7)
       endif
53     continue

       write(3,4000)istt
       write(6,4000)istt
4000   format(/,'Temperature averaged properties ',I9,' states:',/,
     2          '**********************************************')

       write(6,6005)
       write(3,6005)
       DO 5512 it=1,NTEM
       write(3,3600)tems(it)
       write(6,3600)tems(it)
3600   format(f10.2,' K:')
       DO 5512 IQ=N7,N
       write(3,6008)IQ,avqt(it,IQ),avq2t(it,IQ,IQ)
5512   write(6,6008)IQ,avqt(it,IQ),avq2t(it,IQ,IQ)
c
       call w36('Averaged geometry X=X0+s/sqrt(w).<q>:')
       DO 191 L=1,NOAT
       DO 191 ix=1,3
       X(ix,L)=R(ix,L)
       DO 191 IQ=N7,N
191    X(ix,L)=X(ix,L)+S(3*(L-1)+ix,IQ)*avq(IQ)/DSQRT(DABS(E(IQ)))
       DO 561 L=1,NOAT
       WRITE(6,5242)IDN(L),(X(ix,L)*BOHR,ix=1,3)
561    WRITE(3,5242)IDN(L),(X(ix,L)*BOHR,ix=1,3)
       CALL ROTCONST(NOAT,AM,X)
c
       inquire(file='TENQ.TXT.SCR',exist=lex)
       if(lex)then
        open(9,file='TENQ.TXT.SCR')
        read(9,*)(u(ix),ix=1,3)
        dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
        write(6,6003)
        write(3,6003)
        write(3,6004)
        write(6,6004)
        write(6,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
        write(3,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
        read(9,*)
        read(9,*)ndif
        do 231 im=1,ndif
        do 231 jx=1,3
231     read(9,*)idum,imo,idum,aptn(imo,jx),aptn(imo+N,jx)
        close(9)
        do 211 jx=1,3
        do 211 IQ=N7,N
211     u(jx)=u(jx)+aptn(IQ,jx)*avq(IQ)
        dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
        write(3,6006)
        write(6,6006)
        write(6,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
        write(3,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
        inquire(file='TENAQ.TXT.SCR',exist=lex)
        if(lex)then
         do 2211 jx=1,3
         do 2211 IQ=N7,N
         do 2211 JQ=N7,N
2211     u(jx)=u(jx)+QPQ(jx,IQ,JQ)*avq2(IQ,JQ)
         dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
        else
         do 2222 jx=1,3
         do 2222 IQ=N7,N
2222     u(jx)=u(jx)+aptn(IQ+N,jx)*avq2(IQ,IQ)
         dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
        endif
        write(3,6007)
        write(6,6007)
        write(6,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
        write(3,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
       endif

       do 79 it=1,NTEM
       call w36(' ')
       write(3,3600)tems(it)
       write(6,3600)tems(it)
       do 791 IQ=N7,N
       avq(IQ)=avqt(it,IQ)
       do 791 JQ=N7,N
791    avq2(IQ,JQ)=avq2t(it,IQ,JQ)
79     call proder(avq,avq2,N7)
        
      ENDIF

c     deallocate(ICC,IN,IS,CFI,CFIG)
      deallocate(ICC,IN,IS,CFIG)
      CLOSE(3)
      WRITE(6,*)' >> PROGRAM TERMINATED <<'
      STOP
      END

      SUBROUTINE INS(NAT,AM,ISI,KG,EAH,S,MV,IS,ICC,IN,EG,IG,
     1NHBIG,LEXCL,CFI,AINS)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (NGEO=24,NHDIM=2005,ALIM0=0.1d0)
      REAL*8 S(3*NAT,3*NAT),EAH(*),
     1AM(NAT),AINS(*)
      DIMENSION CFI(*),IS(MV),ICC(NHBIG,LEXCL),IN(NHBIG,LEXCL),
     1ISI(NGEO,4)
      COMMON/BLANKC/N7,N
      real*8,allocatable::SG(:),SGC(:),SLL(:)
      INTEGER*4,allocatable::SBUFF(:,:)
C
      CM=219470.0d0
C
      WRITE(6,6000)
      WRITE(3,6000)
6000  FORMAT(
     1' Approximate intensities of inelastic neutron scattering')
      allocate(SG(NAT),SGC(NAT),SBUFF(NHBIG,3*NAT),SLL(3*NAT))
C
C     Get cross sections for all atoms
      CALL SETSG(NAT,SG,SGC,AM)
C
C     Looop over symmetry species
      DO 54 I0=1,KG
      I1=ISI(I0,1)
      I2=ISI(I0,2)
      J1=ISI(I0,3)
      J2=ISI(I0,4)
      NDIM=I2-I1+1
      IF(NDIM.GT.NHDIM)call report('Increase the NHDIM')
C
C     record basis set into SBUFF
      DO 60 II=1,NDIM
      DO 61 KK=N7,N
61    SBUFF(II,KK)=0
      DO 60 KK=1,IS(II)
60    SBUFF(II,ICC(II,KK))=IN(II,KK)
      ALIM=ALIM0/DSQRT(DBLE(NDIM))
C
C     Loop over frequencies/states
      DO 54 I=J1,J2
      CALL LOADC(I,CFI,NDIM)
      IF(I.EQ.IG)GOTO 54
      W=EAH(I)-EG
      WRITE(6,6001)I,W*CM
6001  FORMAT(I4,F10.2)
C
C     Load eigenvector
C
C     Spectrometer frequency function
      C=1.0d0/16.132d0
      ALPHA=0.06d0
      PHI=1.0d0/3.0d0*C*W*EXP(-C*ALPHA*W*CM)
C
C     INt.~sum(at) <sigat dR^2> = sum(at) sig_at Sat,ix,i Sat,ix,j <Qi^2>
C
      DO 57 IQ=N7,N
      SLL(IQ)=0.0d0
      DO 57 L=1,NAT
      SIG=SG(L)
      DO 57 LX=1,3
      LL=3*(L-1)+LX
57    SLL(IQ)=SLL(IQ)+SIG*S(LL,IQ)*S(LL,IQ)
C
      EL=0.0d0
      ANORM=0.0d0
      DO 56 II=1,NDIM
      IF(ABS(CFI(II)).LT.ALIM)GOTO 56
      ANORM=CFI(II)*CFI(II)+ANORM
      DO 561 JJ=1,NDIM
      SUM=0.0d0
      IF(ABS(CFI(JJ)).LT.ALIM)GOTO 561
      DO 59 IQ=N7,N
C
      S1QI2S2=0.0d0
       DO 2 IO=N7,N
       IF(IO.NE.IQ)THEN
	IF(SBUFF(II,IO).NE.SBUFF(JJ,IO))THEN
	 GOTO 59
	ENDIF
	GOTO 2
       ENDIF
       IF(SBUFF(II,IO).EQ.SBUFF(JJ,IO))THEN
	PR=(2*SBUFF(II,IO)+1)*(2*SBUFF(II,IO)+1)
	GOTO 2
       ENDIF
       IF(SBUFF(II,IO).EQ.SBUFF(JJ,IO)+2)THEN
	PR=SBUFF(II,IO)*(SBUFF(II,IO)-1)
	GOTO 2
       ENDIF
       IF(SBUFF(II,IO).EQ.SBUFF(JJ,IO)-2)THEN
	PR=SBUFF(JJ,IO)*(SBUFF(JJ,IO)-1)
	GOTO 2
       ENDIF
       GOTO 59
2      CONTINUE
       S1QI2S2=0.5d0*DSQRT(DBLE(PR))
C
      SUM=SUM+S1QI2S2*SLL(IQ)
59    CONTINUE
      EL=EL+SUM*CFI(II)*CFI(JJ)
561   continue
56    CONTINUE
      WRITE(6,*)ANORM
C
      AINS(I)=PHI*EL
54    CONTINUE
      AINS(IG)=0.0d0
      AMAX=0.0d0
      DO 4 I=1,MV
4     IF(AMAX.LT.AINS(I))AMAX=AINS(I)
      SF=0.0d0
      IF(AMAX.GT.0.0000000001d0)SF=1.0d0/AMAX*100.0d0
      OPEN(4,FILE='INSM4.TAB')
      WRITE(4,4001)
      WRITE(3,4001)
4001  FORMAT(' Inelastic neutron scattering',/,
     1       '     freq[cm-1]   INS intensity',/,
     2       '-------------------------------')
      DO 55 I=1,MV
      IF(I.EQ.IG)GOTO 55
      W=EAH(I)-EG
      WRITE(3,3002)I,W*CM,AINS(I)*SF
      WRITE(4,3002)I,W*CM,AINS(I)*SF
55    CONTINUE
3002  FORMAT(I4,F12.3,F12.4)
      WRITE(4,4002)
      WRITE(3,4002)
4002  FORMAT('-------------------------------')
      CLOSE(4)
      RETURN
      END
C
      SUBROUTINE SETSG(NAT,SG,SGC,AM)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      REAL*8 SG(NAT),AM(NAT),SGC(NAT)
      CHARACTER*4 ATID
      WRITE(3,3000)
3000  FORMAT('     Isotope     INS scattering cross-section',/,
     1       '                 coherent      total    ',/,
     2       ' --------------------------------------------')
C     "Protein Crystalography", T.L.Blundel, L.N.Johnson, Academic Press,
C     London, 1993; pp468-469.
C     Given in Barns=10^-24 cm^2)
      TOL=0.3d0
      DO 2 I=1,NAT
      SG(I)=5.00d0
      SGC(I)=5.00d0
      ATID='XXXX'
      IF(ABS(AM(I)-12.0d0).LT.TOL)THEN
       ATID=' C12'
       SG(I)=5.51d0
       SGC(I)=5.5d0
      ENDIF
      IF(ABS(AM(I)-1.0d0).LT.TOL)THEN
       ATID=' H 1'
       SG(I)=81.5d0
       SGC(I)=1.79d0
      ENDIF
      IF(ABS(AM(I)-2.0d0).LT.TOL)THEN
       ATID=' H 2'
       SG(I)=7.6d0
       SGC(I)=5.4d0
      ENDIF
      IF(ABS(AM(I)-13.0d0).LT.TOL)THEN
       ATID=' C13'
       SG(I)=5.5d0
       SGC(I)=4.5d0
      ENDIF
      IF(ABS(AM(I)-14.0d0).LT.TOL)THEN
       ATID=' N14'
       SG(I)=11.4d0
       SGC(I)=11.0d0
      ENDIF
      IF(ABS(AM(I)-16.0d0).LT.TOL)THEN
       ATID=' O16'
       SG(I)=4.24d0
       SGC(I)=4.2d0
C      this was for O15 (?missprint)
      ENDIF
      IF(ABS(AM(I)-31.0d0).LT.TOL)THEN
       ATID=' P31'
       SG(I)=3.6d0
       SGC(I)=3.5d0
      ENDIF
      IF(ABS(AM(I)-32.0d0).LT.TOL)THEN
       ATID=' S32'
       SG(I)=1.2d0
       SGC(I)=1.2d0
      ENDIF
      IF(ABS(AM(I)-35.0d0).LT.TOL)THEN
       ATID='Cl35'
       SG(I)=15.0d0
       SGC(I)=12.2d0
      ENDIF
2     WRITE(3,3001)I,ATID,SGC(I),SG(I)
3001  FORMAT(I4,1X,A4,2F15.2)
      WRITE(3,*)' --------------------------------------------'
C
      RETURN
      END
C     =================================================================
C     =================================================================
      SUBROUTINE VCDII(R,PPQ,PPV,IIQ,N,PP,PV,NAT)
C     origin gauge for second derivatives of magnetic moment
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      REAL*8 IIQ,IIT
      DIMENSION PPQ(NAT,3,3,N),PPV(NAT,3,3,N),IIQ(NAT,3,3,N),R(3,NAT),
     1IIT(NAT,3,3,NAT*3),Y(3),PP(NAT,3,3),PV(NAT,3,3)
      INTEGER*4 A,B,G,D,L,E
      COMMON/ANTI/EPS(3,3,3)
      NAT=N/3
      DO 90 L=1,NAT
      DO 90 E=1,3
      DO 90 M=1,NAT
      DO 91 IX=1,3
91    Y(IX)=0.5d0*(R(IX,L)+R(IX,M))
      DO 90 A=1,3
      MI=3*(M-1)+A
      DO 90 B=1,3
      IIT(L,E,B,MI)=0.0d0
      DO 90 G=1,3
      DO 90 D=1,3
      IF(G.EQ.E)
     1IIT(L,E,B,MI)=IIT(L,E,B,MI)-0.125d0*EPS(B,G,D)*
     2(PV(L,A,D)+PV(M,A,D)-PP(L,A,D)-PP(M,A,D))
90    IIT(L,E,B,MI)=IIT(L,E,B,MI)-0.25d0*EPS(B,G,D)*(PPV(L,E,D,MI)-
     1PPQ(L,E,D,MI))*Y(G)
      DO 92 L=1,NAT
      DO 92 E=1,3
      DO 92 MI=1,N
      DO 92 B=1,3
92    IIQ(L,E,B,MI)=IIQ(L,E,B,MI)+IIT(L,E,B,MI)
      RETURN
      END
C     =====================================================================
      FUNCTION S1QIS2(S1,IQ,S2)
C     <S1|Qi|S2> in dimensionless coordinates
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      INTEGER*4 S1(*),S2(*)
      COMMON/BLANKC/N7,N
      DO 1 I=N7,N
      IF(I.NE.IQ)THEN
       IF(S1(I).NE.S2(I))THEN
        S1QIS2=0.0d0
        RETURN
       ENDIF
       GOTO 1
      ENDIF
      IF(S1(I).EQ.S2(I)+1)THEN
       S1QIS2=DSQRT(DBLE(S1(I)))
       GOTO 1
      ENDIF
      IF(S1(I).EQ.S2(I)-1)THEN
       S1QIS2=DSQRT(DBLE(S2(I)))
       GOTO 1
      ENDIF
      S1QIS2=0.0d0
      RETURN
1     CONTINUE
      S1QIS2=S1QIS2*0.707106781d0
C     1/sqrt(2)=0.707d0
      RETURN
      END
C     =====================================================================
      FUNCTION S1PIS2(S1,IP,S2)
C     <S1|Pi|S2> in dimensionless coordinates leave factor (-i) out
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      INTEGER*4 S1(*),S2(*)
      COMMON/BLANKC/N7,N
      DO 1 I=N7,N
      IF(I.NE.IP)THEN
       IF(S1(I).NE.S2(I))goto 99
      ELSE
       IF(S1(I).EQ.S2(I)+1)THEN
        S1PIS2=-DSQRT(DBLE(S1(I)))
       ELSE
        IF(S1(I).EQ.S2(I)-1)THEN
         S1PIS2=DSQRT(DBLE(S2(I)))
        ELSE
         goto 99
        ENDIF
       ENDIF
      ENDIF
1     CONTINUE
      S1PIS2=S1PIS2*0.707106781d0
C     1/sqrt(2)=0.707d0
      RETURN
99    S1PIS2=0.0d0
      RETURN
      END
C     ================================================================
      FUNCTION S1QIQJS2(S1,IQ,JQ,S2)
C     <S1|Qi Qj |S2> in dimensionless coordinates
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      INTEGER*4 S1(*),S2(*),PR
      COMMON/BLANKC/N7,N
c     write(6,*)N7,N
c     write(6,700)(s1(i),i=N7,N)
c     write(6,700)(s2(i),i=N7,N)
c00   format(120i1)
      IF(IQ.NE.JQ)THEN
       PR=1
       DO 1 I=N7,N
       IF(I.NE.IQ.AND.I.NE.JQ)THEN
	IF(S1(I).NE.S2(I))THEN
	 S1QIQJS2=0.0d0
	 RETURN
	ENDIF
	GOTO 1
       ENDIF
       IF(S1(I).EQ.S2(I)+1)THEN
	PR=PR*S1(I)
	GOTO 1
       ENDIF
       IF(S1(I).EQ.S2(I)-1)THEN
	PR=PR*S2(I)
	GOTO 1
       ENDIF
       S1QIQJS2=0.0d0
       RETURN
1      CONTINUE
       S1QIQJS2=0.5d0*DSQRT(DBLE(PR))
       RETURN
      ELSE
C     <Qi^2>
       DO 2 I=N7,N
       IF(I.NE.IQ)THEN
	IF(S1(I).NE.S2(I))THEN
	 S1QIQJS2=0.0d0
	 RETURN
	ENDIF
	GOTO 2
       ENDIF
       IF(S1(I).EQ.S2(I))THEN
	PR=(2*S1(I)+1)*(2*S1(I)+1)
	GOTO 2
       ENDIF
       IF(S1(I).EQ.S2(I)+2)THEN
	PR=S1(I)*(S1(I)-1)
	GOTO 2
       ENDIF
       IF(S1(I).EQ.S2(I)-2)THEN
	PR=S2(I)*(S2(I)-1)
	GOTO 2
       ENDIF
       S1QIQJS2=0.0d0
       RETURN
2      CONTINUE
       S1QIQJS2=0.5d0*DSQRT(DBLE(PR))
       RETURN
      ENDIF
      END
C     ================================================================
      FUNCTION S1PIQJS2(S1,IP,JQ,S2)
C     <S1|Pi Qj |S2> in dimensionless coordinates, factor (-i) left out
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      INTEGER*4 S1(*),S2(*),PR
      COMMON/BLANKC/N7,N
      IF(IP.NE.JQ)THEN
C      <PiQj i<>j>
       PR=1
       sii=1.0d0
       DO 1 I=N7,N
       IF(I.NE.IP.AND.I.NE.JQ)THEN
        IF(S1(I).NE.S2(I))then
         S1PIQJS2=0.0d0
         return
        ENDIF
       ELSE
        if(I.EQ.JQ)then
         IF(S1(I).EQ.S2(I)+1)THEN
          PR=PR*S1(I)
         ELSE
          IF(S1(I).EQ.S2(I)-1)THEN
           PR=PR*S2(I)
          ELSE
           S1PIQJS2=0.0d0
           return
          ENDIF
         ENDIF
        else
         IF(S1(I).EQ.S2(I)+1)THEN
          PR=PR*S1(I)
          sii=-sii
         ELSE
          IF(S1(I).EQ.S2(I)-1)THEN
           PR=PR*S2(I)
          ELSE
           S1PIQJS2=0.0d0
           return
          ENDIF
         ENDIF
        endif
       ENDIF
1      CONTINUE
       S1PIQJS2=0.5d0*DSQRT(DBLE(PR))*sii
       RETURN
      ELSE
C     <PiQi>
       DO 2 I=N7,N
       IF(I.NE.IP)THEN
        IF(S1(I).NE.S2(I))then
         S1PIQJS2=0.0d0
         return
        endif
       ELSE
        IF(S1(I).EQ.S2(I)+2)THEN
         S1PIQJS2=-0.5d0*DSQRT(DBLE(S1(I)*(S1(I)-1)))
        ELSE
         IF(S1(I).EQ.S2(I)-2)THEN
          S1PIQJS2=0.5d0*DSQRT(DBLE(S2(I)*(S2(I)-1)))
         ELSE
          IF(S1(I).EQ.S2(I))THEN
           S1PIQJS2=0.5d0
          ElSE
           S1PIQJS2=0.0d0
           return
          ENDIF
         ENDIF
        ENDIF
       ENDIF
2      CONTINUE
       RETURN
      ENDIF
      END
C
C
C
C
      BLOCK DATA
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      parameter (z0=0.0d0,EE=1.0d0,UE=-1.0d0)
      COMMON/ANTI/EPS(3,3,3)
      DATA EPS/z0, z0, z0,  z0,z0, UE,   z0,EE,z0,
     1         z0, z0, EE,  z0,z0, z0,   UE,z0,z0,
     2         z0, UE, z0,  EE,z0, z0,   z0,z0,z0/
      END
C     ================================================================

      SUBROUTINE READTENTTT(N30,NAT,ALPHA,G,A)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ALPHA(N30,3,3),G(N30,3,3),A(N30,3,3,3)
      OPEN(2,FILE='FILE.TTT',STATUS='OLD')
      READ(2,*)
      READ(2,*)NAT
      READ(2,*)
      READ(2,*)
      DO 1 I=1,3
      READ(2,*)
      DO 1 L=1,NAT
      DO 1 IX=1,3
      IND=3*(L-1)+IX
1     READ(2,*)LDUM,IXDUM,(ALPHA(IND,I,J),J=1,3)
      READ(2,*)
      READ(2,*)
      DO 2 I=1,3
      READ(2,*)
      DO 2 L=1,NAT
      DO 2 IX=1,3
      IND=3*(L-1)+IX
c     last index magnetic, inner
2     READ(2,*)LDUM,IXDUM,(G(IND,I,J),J=1,3)
      READ(2,*)
      READ(2,*)
      DO 3 I=1,3
      DO 3 J=1,3
      READ(2,*)
      DO 3 L=1,NAT
      DO 3 IX=1,3
      IND=3*(L-1)+IX
c     READ(2,*)LDUM,IXDUM,(A(IND,I,J,K),K=1,3)
3     READ(2,*)LDUM,IXDUM,(A(IND,J,K,I),K=1,3)
c     read in different order then in new6 to produce rigth result
      CLOSE(2)
      call w36('Polarizability derivatives from FILE.TTT')
      RETURN
      END

      SUBROUTINE ROTCONST(NOAT,AM,RW)
      implicit none
      INTEGER*4 NOAT,IA,I,J,L,IERR
      real*8 ACM(3),AM(*),R(3,NOAT),ABC(3,3),AII(3),RW(3,NOAT),
     1BOHR,HBAR,CLIGHT,PI,AMU,CME,ANGSTROM,CONST,AMASS,
     1U(3,3)
      BOHR=0.52917715d0
C     SI units:
      HBAR=1.05457266D-34
      CLIGHT=2.99792458D8
      PI=3.141592653589d0
      AMU=1.6605402D-27
      CME=0.01d0
      ANGSTROM=1.0D-10
      CONST=CME*HBAR/(2.0d0*PI*CLIGHT*AMU*ANGSTROM*ANGSTROM*BOHR**2)
      call w36(' Rotational constants')
      DO 1 IA=1,NOAT
      DO 1 I=1,3
1     R(I,IA)=RW(I,IA)
      DO 101 I=1,3
101   ACM(I)=0.0d0
      AMASS=0.0d0
      DO 103 L=1,NOAT
      AMASS=AMASS+AM(L)
      DO 103 I=1,3
103   ACM(I)=ACM(I)+R(I,L)*AM(L)
      DO 104 I=1,3
104   ACM(I)=ACM(I)/AMASS
      WRITE(3,5246)AMASS,(ACM(I),I=1,3)
      WRITE(6,5246)AMASS,(ACM(I),I=1,3)
5246  FORMAT(/,' Molecular mass: ',F12.4,/,
     1         ' Center of mass: ',3F12.7,/)
      DO 105 I=1,NOAT
      DO 105 J=1,3
105   R(J,I)=R(J,I)-ACM(J)
      DO 102 J=1,3
      ABC(J,J)=0.0d0
      DO 1021 L=1,NOAT
1021  ABC(J,J)=ABC(J,J)+AM(L)*
     1  (R(1,L)*R(1,L)+R(2,L)*R(2,L)+R(3,L)*R(3,L)-R(J,L)*R(J,L))
      DO 102 I=J+1,3
      ABC(I,J)=0.0d0
      DO 102 L=1,NOAT
102   ABC(I,J)=ABC(I,J)-R(J,L)*R(I,L)*AM(L)
      DO 106 J=1,3
      DO 106 I=J+1,3
106   ABC(J,I)=ABC(I,J)
      WRITE(3,5247)((ABC(I,J),I=1,3),J=1,3)
5247  FORMAT(' Inertia tensor (a.u.) : ',3F10.4,/,
     1     25X,3F10.4,/,25X,3F10.4,/)
      CALL TRED123(3,ABC,U,AII,2,IERR)
      IF(AII(1).GT.1.0d-10)AII(1)=CONST*(1.0d0/(2.0d0*AII(1)))
      IF(AII(2).GT.1.0d-10)AII(2)=CONST*(1.0d0/(2.0d0*AII(2)))
      IF(AII(3).GT.1.0d-10)AII(3)=CONST*(1.0d0/(2.0d0*AII(3)))
      WRITE(3,3005)(AII(I),I=1,3),(AII(I)*CLIGHT/CME/1.0d9,I=1,3)
      WRITE(6,3005)(AII(I),I=1,3),(AII(I)*CLIGHT/CME/1.0d9,I=1,3)
3005  FORMAT(/,' ABC = ',3F15.7,' cm-1',/,
     1         '     = ',3F15.7,' GHz ',/)
      RETURN
      END
C

      SUBROUTINE INIP(II,JJ,PV,NTT)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION II(NTT,3,3),JJ(NTT,3,3),PV(NTT,3,3)
      REAL*8 II,JJ
      DO 1 I=1,NTT
      DO 1 J=1,3
      DO 1 K=1,3
      II(I,J,K)=0.0d0
      JJ(I,J,K)=0.0d0
1     PV(I,J,K)=0.0d0
      RETURN
      END
C
      SUBROUTINE SPAR(AD,GEO,WRQ,RAMAN,WRONLY,FGEO,IGROUND,NGROUND,NGR0,
     1N1,N2,ELIMIT,IZERO,CM,AUD,CLIGHT,BOHR,LVCD,LTEN,
     2LTTT,ACUT,LRESTART,LINS,TEMP)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*10 STRING
      DIMENSION IGROUND(NGR0)
      LOGICAL AD,GEO,WRQ,RAMAN,WRONLY,OPTIONS,
     1LVCD,LTEN,LTTT,LRESTART,LINS
      FGEO=100000.0d0
      ELIMIT=999999.9d0
      CM=219470.0d0
C     1 a.u. = 219470 cm-1
      AUD=2.541732d0
C     e.a=atomic units of dipole = 2.541732 Debye
      CLIGHT=137.035d0
C     Velocity of light in atomic units
      BOHR=0.52917715d0
      AD=.TRUE.
      GEO=.FALSE.
      LTEN=.TRUE.
      LTTT=.TRUE.
      LVCD=.TRUE.
      LINS=.FALSE.
      WRQ=.FALSE.
      RAMAN=.TRUE.
      WRONLY=.FALSE.
      LRESTART=.FALSE.
      NGROUND=1
      IGROUND(1)=0
      N1=0
      N2=32000
      IZERO=0
      ACUT=1.0d0
      TEMP=298.15d0
      INQUIRE(FILE='M4.OPT',EXIST=OPTIONS)
      IF(OPTIONS)THEN
       WRITE(3,*)' FILE M4.OPT FOUND:'
       OPEN(2,FILE='M4.OPT')
500    READ(2,1111)STRING
       WRITE(3,1111)STRING
1111  FORMAT(A10)
       IF(STRING(1:3).EQ.'END')GOTO 611
       IF(STRING(1:3).EQ.'REM')GOTO 500
       IF(STRING(1:3).EQ.'LTT')THEN
        READ(2,*)LTTT
        GOTO 500
       ENDIF
       IF(STRING(1:3).EQ.'RES')THEN
        READ(2,*)LRESTART
        GOTO 500
       ENDIF
       IF(STRING(1:3).EQ.'ACU')THEN
        READ(2,*)ACUT
        GOTO 500
       ENDIF
       IF(STRING(1:3).EQ.'LTE')THEN
        READ(2,*)LTEN
        GOTO 500
       ENDIF
       IF(STRING(1:3).EQ.'INS')THEN
        READ(2,*)LINS
        GOTO 500
       ENDIF
       IF(STRING(1:3).EQ.'VCD')THEN
        READ(2,*)LVCD
        GOTO 500
       ENDIF
       IF(STRING(1:4).EQ.'TEMP')THEN
        READ(2,*)TEMP
        GOTO 500
       ENDIF
       IF(STRING(1:6).EQ.'GROUND')THEN
        READ(2,*)NGROUND,(IGROUND(i),i=1,NGROUND)
        if(NGROUND.gt.NGR0)call report('too many ground states')
        GOTO 500
       ENDIF
       IF(STRING(1:2).EQ.'AD')THEN
        READ(2,*)AD
        GOTO 500
       ENDIF
       IF(STRING.EQ.'FGEO      ')THEN
        READ(2,*)FGEO
        WRITE(3,*)' FGEO limit ',FGEO,' cm-1'
        GOTO 500
       ENDIF
       IF(STRING.EQ.'ELIMIT    ')THEN
        READ(2,*)ELIMIT
        WRITE(3,*)' ENERGY LIMIT limit ',ELIMIT,' cm-1'
        GOTO 500
       ENDIF
       IF(STRING.EQ.'GEOMETRIES')THEN
        READ(2,*)GEO
        GOTO 500
       ENDIF
       IF(STRING.EQ.'RAMAN     ')THEN
        READ(2,*)RAMAN
        GOTO 500
       ENDIF
       IF(STRING.EQ.'WRONLY    ')THEN
        READ(2,*)WRONLY
        GOTO 500
       ENDIF
       IF(STRING.EQ.'WRQ       ')THEN
        READ(2,*)WRQ
        GOTO 500
       ENDIF
       IF(STRING.EQ.'N1N2      ')THEN
        READ(2,*)N1,N2
        GOTO 500
       ENDIF
       call w36(STRING)
       call w36(' Unknown option selected !!! ')
       CLOSE(3)
       CLOSE(2)
       STOP
611    CLOSE(2)
      else
       WRITE(3,*)' FILE M4.OPT NOT FOUND:'
      ENDIF
      call w36('M4.OPT read')
      RETURN
      END
C
      SUBROUTINE TT(N,N7,QP,QJ,QI,QM,NOAT,S,RAMAN,ALPHAQ,ALPHA,WRQ,
     1E,W,QPQ,QMQ ,AD,MGD,MND,MED,II,JJ,PP,IIQ,PPQ,N1,N2,
     2CLIGHT,AUD,PPV,R,JJQ,PVT,PPT,GTENQ,ATENQ,GTEN,ATEN)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER*4 A,B,C
      REAL*8 II,JJ,MGD,MND,MED,IIQ,JJQ
      LOGICAL RAMAN,WRQ,AD
      DIMENSION QP(3,N),QJ(3,N),QM(3,N),QI(3,N),
     1ALPHAQ(3,3,N),S(N,N),ALPHA(N,3,3),E(*),W(*),
     2QPQ(3,N,N),QMQ(3,N,N),ELD(3),MGD(3),MND(3),MED(3),
     3II(NOAT,3,3),JJ(NOAT,3,3), PP(NOAT,3,3),IIQ(NOAT,3,3,N),
     4PPQ(NOAT,3,3,N),PPV(NOAT,3,3,N),R(3,NOAT),JJQ(NOAT,3,3,N),
     5PVT(NOAT,3,3),PPT(NOAT,3,3),GTEN(N,3,3),GTENQ(3,3,N),
     6ATEN(N,3,3,3),ATENQ(3,3,3,N)
C
      CM=219470.0d0
      WRITE(3,*)' Original and basis harmonics:'
      DO 1 IQ=N7,N
      IF(E(IQ).LT.0.0d0)WRITE(3,*)'Absolute value will be used:'
      IF(W(IQ).LT.0.0d0)THEN
       WRITE(3,*)IQ,W(IQ),' w(iq) is negative !!'
       WRITE(6,*)IQ,W(IQ),' w(iq) is negative !!'
       CLOSE(3)
       STOP
      ENDIF
1     WRITE(3,3000)IQ,CM*E(IQ),CM*W(IQ)
3000  FORMAT(I3,2F10.2)
      DO 20 I=N7,N
      DO 20 A=1,3
      QP(A,I)=0.0d0
      QJ(A,I)=0.0d0
      QI(A,I)=0.0d0
      DO 200 L=1,NOAT
      DO 200 B=1,3
      QI(A,I)=QI(A,I)+II(L,B,A)*S(3*L-3+B,I)
      QJ(A,I)=QJ(A,I)+JJ(L,B,A)*S(3*L-3+B,I)
200   QP(A,I)=QP(A,I)+PP(L,B,A)*S(3*L-3+B,I)
20    QM(A,I)=QI(A,I)+QJ(A,I)
c     write(6,*)NOAT,PP(NOAT,1,1)
c     write(6,*)N,QM(1,N)
c     write(6,*)S(3*NOAT-3+1,N)
      IF(RAMAN)THEN

       DO 29 I=N7,3*NOAT
       DO 29 A=1,3
       DO 29 B=1,3
       ALPHAQ(A,B,I)=0.0d0
       GTENQ(A,B,I)=0.0d0
       DO 291 IX=1,3*NOAT
       GTENQ(A,B,I)=GTENQ(A,B,I)+S(IX,I)*GTEN(IX,A,B)
291    ALPHAQ(A,B,I)=ALPHAQ(A,B,I)+S(IX,I)*ALPHA(IX,A,B)
       do 29 C=1,3
       ATENQ(A,B,C,I)=0.0d0
       DO 29 IX=1,3*NOAT
29     ATENQ(A,B,C,I)=ATENQ(A,B,C,I)+S(IX,I)*ATEN(IX,A,B,C)

       IF(WRQ)THEN
        WRITE(3,3001)
3001    FORMAT(1X,'INTERNAL ALPHA DERIVATIVES LISTED:')
        DO 30 IQ=N7,NOAT*3
30      WRITE(3,5000)IQ,((ALPHAQ(I,J,IQ),I=1,3),J=1,3)
5000    FORMAT(1X,I4,' MODE',/,3(3F15.8,/),/)
       ENDIF
       DO 36 I=N7,N
       EI=1.0d0/DSQRT(ABS(E(I)))
       DO 36 A=1,3
       DO 36 B=1,3
       ALPHAQ(A,B,I)=ALPHAQ(A,B,I)*EI
       GTENQ(A,B,I)=GTENQ(A,B,I)*EI
       DO 36 C=1,3
36     ATENQ(A,B,C,I)=ATENQ(A,B,C,I)*EI
       WRITE(3,3010)
3010   FORMAT(' Alpha derivatives transformed into dimensionless',
     1 ' normal coordinates.')
       WRITE(3,3002)
3002   FORMAT(' HARMONIC RAMAN    ram1    P')
c      in Gaussian ram1=Raman activity*4
       TOL=0.000001d0
       DO 31 IQ=N7,3*NOAT
       OM=ABS(E(IQ))
       ECM=OM*CM
       A2=0.0d0
       BA=0.0d0
       P1=0.0d0
       SAL0=0.0d0
       SAL1=0.0d0
       SPAL=0.0d0
       DO 32 I=1,3
       SPAL=SPAL+ALPHAQ(I,I,IQ)
       DO 32 J=1,3
       SAL0=SAL0+ALPHAQ(I,I,IQ)*ALPHAQ(J,J,IQ)
32     SAL1=SAL1+ALPHAQ(I,J,IQ)*ALPHAQ(I,J,IQ)
       AMU=1822.0d0
       BOHR=0.529177d0
       SpA3=SPAL/3.0d0*dsqrt((AMU*BOHR**4))
       beta2=0.5d0*(3.0d0*SAL1-SAL0)*(AMU*BOHR**4)
       ram1=4.0d0*(45.0d0*SpA3**2+7.0d0*beta2)

       BA=0.5d0*(3.0d0*SAL1-SAL0)
       A2=SAL0*(1.0d0/9.0d0)
       IF(A2.LT.TOL.AND.BA.LT.TOL)GOTO 33
       P1=3.0d0*BA/(45.0d0*A2+4.0d0*BA)
33     WRITE(3,3003)IQ,ECM,ram1*OM,P1
3003   FORMAT(I4,F10.2,G15.6,F8.4)
31     CONTINUE
       DO 361 I=N7,N
       EI=DSQRT(ABS(E(I)/W(I)))
       DO 361 A=1,3
       DO 361 B=1,3
       GTENQ(A,B,I)=GTENQ(A,B,I)*EI
       ALPHAQ(A,B,I)=ALPHAQ(A,B,I)*EI
       DO 361 C=1,3
361    ATENQ(A,B,C,I)=ATENQ(A,B,C,I)*EI
       WRITE(3,*)' Basis harmonics used for new Raman'
      ENDIF
      IF(AD)THEN
       IF(WRQ)THEN
        WRITE(3,*)' Cartesian dipole moment second derivatives, CO'
        WRITE(3,*)' electronic part of M:'
        CALL WDMSD(PPQ,PPV,IIQ,NOAT,N)
        WRITE(3,*)' nuclear part of M:'
        CALL WDMSD(PPQ,PPV,JJQ,NOAT,N)
       ENDIF
       IC=1
       CALL EQP(PPQ,NOAT,N,IC)
       WRITE(3,*)'PPQ symmetrized'
       CALL EQP(PPV,NOAT,N,IC)
       WRITE(3,*)'PPV symmetrized'
       CALL VCDII(R,PPQ,PPV,IIQ,N,PPT,PVT,NOAT)
       IC=-1
       CALL EQP(IIQ,NOAT,N,IC)
       WRITE(3,*)'IIQ anti- symmetrized'
       IF(WRQ)THEN
        WRITE(3,*)' Cartesian dipole moment second derivatives, DO'
        WRITE(3,*)' electronic part of M:'
        CALL WDMSD(PPQ,PPV,IIQ,NOAT,N)
       ENDIF
       do 211 L=1,NOAT
       do 211 A=1,3
       do 211 B=1,3
       do 211 M=1,NOAT
       do 211 IB=1,3
       Ir=3*(M-1)+IB
211    IIQ(L,B,A,Ir)=IIQ(L,B,A,Ir)+JJQ(L,B,A,Ir)
       DO 21 I=N7,N
       DO 21 K=N7,N
       DO 21 A=1,3
       QPQ(A,I,K)=0.0d0
       QMQ(A,I,K)=0.0d0
       DO 21 L=1,NOAT
       DO 21 B=1,3
       IND1=3*(L-1)+B
       SM1=S(IND1,I)
       DO 21 M=1,NOAT
       DO 21 IB=1,3
       IND2=3*(M-1)+IB
       SM2=S(IND2,K)*SM1
       QMQ(A,I,K)=QMQ(A,I,K)+IIQ(L,B,A,IND2)*SM2
21     QPQ(A,I,K)=QPQ(A,I,K)+PPQ(L,B,A,IND2)*SM2
       IF(WRQ)THEN
        WRITE(3,2222)
2222  FORMAT(/,' Tensors transformed into internal representation.',
     1/,' Dipole moment second derivatives: ',/,
     2 /,80(1H-),/,21X,'d^2M/dQidQj * 1000',15X,'d^2P/dQidQj * 1000')
        DO 22 I=N7,N
        DO 22 J=I,N
22      WRITE(3,2223)J,I,(1000.0d0*QMQ(I1,J,I),I1=1,3),
     1                   (1000.0d0*QPQ(I1,J,I),I1=1,3)
2223  FORMAT(2I2,6F12.4)
       ENDIF
       DO 37 I=N7,N
       DO 37 J=N7,N
       SF=1.0d0/DSQRT(W(I)*W(J))
       DO 37 I1=1,3
       QPQ(I1,J,I)=QPQ(I1,J,I)*SF
37     QMQ(I1,J,I)=QMQ(I1,J,I)*SF
       IF(WRQ)THEN
        WRITE(3,2225)
2225  FORMAT(' Dimensionless coordinate representation, basis harm: ')
        DO 26 I=N7,N
        DO 26 J=I,N
26      WRITE(3,2223)J,I,(1000.0d0*QMQ(I1,J,I),I1=1,3),
     1                   (1000.0d0*QPQ(I1,J,I),I1=1,3)
       ENDIF
      ENDIF
      IF(WRQ)THEN
       WRITE(3,2226)
2226  FORMAT(/,'Dipole first derivatives, old basis: ',/,/,
     1'                   dM/dQ * 1000               dP/dQ * 1000')
       DO 28 I=N7,N
28     WRITE (3,2223)I,I,(1000.0d0*QM(I1,I),I1=1,3),
     1                   (1000.0d0*QP(I1,I),I1=1,3)
      ENDIF
      DO 38 I=N7,N
      EI=1.0d0/DSQRT(ABS(E(I)))
      DO 38 I1=1,3
      QJ(I1,I)=QJ(I1,I)*EI
      QI(I1,I)=QI(I1,I)*EI
      QM(I1,I)=QM(I1,I)*EI
38    QP(I1,I)=QP(I1,I)*EI
      IF(WRQ)THEN
       WRITE(3,*)' dimensionless coordinates:'
       DO 27 I=N7,N
27     WRITE(3,2223)I,I,(1000.0d0*QM(I1,I),I1=1,3),
     1                  (1000.0d0*QP(I1,I),I1=1,3)
      ENDIF
      WRITE (3,501)
  501 FORMAT (/,
     1' ------------  HARMONIC APPROXIMATION ------',/,/,
     2' MODE FREQUENCY D [D^2] R [D^2]    ',/,
     3' -------------------------------------------')
      DO 412 I=N7,N
      IF(I.LT.N1.OR.I.GT.N2)GOTO 412
      WW=ABS(E(I))
C     u=du/dqi qi=QPi qi
C     m=          QIi qi *2wi
C     EL=<0|qi|1>=1/sqrt(2) /in dimensionless repres./
      EL=1.0d0/DSQRT(2.0d0)
      DS=0.0d0
      RS=0.0d0
      DO 51 B=1,3
C     ELECTRIC DIPOLE IN DEBYES:
      ELD(B) =        QP(B,I)*EL*AUD
C     MAGNETIC DIPOLE IN DEBYES:
      MGD(B) = 2.0d0*WW*QM(B,I)*EL*AUD/CLIGHT
C     MAGNETIC NUCLEAR DIPOLE IN DEBYES:
      MND(B) = 2.0d0*WW*QJ(B,I)*EL*AUD/CLIGHT
C     MAGNETIC ELECTRONIC DIPOLE IN DEBYES:
      MED(B) = 2.0d0*WW*QI(B,I)*EL*AUD/CLIGHT
      RS=RS+ELD(B)*MGD(B)
51    DS=DS+ELD(B)*ELD(B)
      IF(WRQ)WRITE(3,3004)(ELD(B),B=1,3),(MGD(B),B=1,3),
     1                    (MND(B),B=1,3),(MED(B),B=1,3)
3004  FORMAT(' ELECTRIC  : ',3G15.5,/,' MAGNETIC  : ',3G15.5,/,
     1       ' Nuclear   : ',3G15.5,/,' Electronic:',3G15.5)
      IMOD=I-N7+1
      AINTE=2.506628275d0*WW*CM*DS
C     Intensity [km/mol]=sqrt(2pi)*v[cm-1]*D[Debye^2]
      WRITE (3,523) I,IMOD,WW*CM,DS,RS,AINTE
523   FORMAT(2I4,F12.2,2G12.5,F12.3,'km/mol')
412   CONTINUE
      WRITE(3,819)
819   FORMAT('--------------------------------------------')
      DO 388 I=N7,N
      EI=DSQRT(ABS(E(I)/W(I)))
      DO 388 I1=1,3
      QJ(I1,I)=QJ(I1,I)*EI
      QI(I1,I)=QI(I1,I)*EI
      QM(I1,I)=QM(I1,I)*EI
388   QP(I1,I)=QP(I1,I)*EI
      WRITE(3,*)' New basis for dipole firsts'
      WRITE(6,*)' Harmonic calculation finished'
      RETURN
      END
C     =====================================================================
      SUBROUTINE EQP(P,NAT,N,IC)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION P(NAT,3,3,N)
      F=1.0d0
      IF(IC.LT.0) F=-F
      DO 2 I=1,N
      NI=(I-1)/3+1
      IX=I-3*(NI-1)
      DO 2 J=I,N
      NJ=(J-1)/3+1
      JX=J-3*(NJ-1)
      DO 2 K=1,3
      P(NI,IX,K,J)=(P(NJ,JX,K,I)+F*P(NI,IX,K,J))*0.5d0
2     P(NJ,JX,K,I)=P(NI,IX,K,J)*F
      RETURN
      END
C     =====================================================================
      SUBROUTINE WDMSD(PPQ,PPV,IIQ,NAT,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      REAL*8 IIQ
      DIMENSION PPQ(NAT,3,3,N),PPV(NAT,3,3,N),IIQ(NAT,3,3,N)
      WRITE(3,1)
1     FORMAT('coord     PVx     PVy     PVz       Px      Py      ',
     1'Pz       Mx      My      Mz',/,
     1       80(1H-))
      DO 2 I=1,N
      NI=(I-1)/3+1
      IX=I-3*(NI-1)
      DO 2 J=I,N
      NJ=(J-1)/3+1
      JX=J-3*(NJ-1)
      WRITE(3,3)I,J,(PPV(NI,IX,K,J),K=1,3),(PPQ(NI,IX,K,J),K=1,3),
     1(IIQ(NI,IX,K,J),K=1,3)
      IF(J.NE.I)
     1WRITE(3,3)J,I,(PPV(NJ,JX,K,I),K=1,3),(PPQ(NJ,JX,K,I),K=1,3),
     2(IIQ(NJ,JX,K,I),K=1,3)
3     FORMAT(I2,1H/,I2,3(1X,3F8.5))
      WRITE(3,*)
2     CONTINUE
      RETURN
      END
C     =====================================================================
      SUBROUTINE READFD(PP,II,JJ,PV,NTT)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      REAL*8 PP(NTT,3,3),II(NTT,3,3),JJ(NTT,3,3),PV(NTT,3,3)
      LOGICAL ISIT
      INQUIRE(FILE='FILE.TEN',EXIST=ISIT)
      IF(.NOT.ISIT)THEN
       WRITE(3,*)'FILE.TEN does not exist'
       WRITE(6,*)'FILE.TEN does not exist'
       CLOSE(3)
       STOP
      ENDIF
      OPEN(15,FILE='FILE.TEN',STATUS='OLD')
      READ(15,*) NOAT
      DO 10 L=1,NOAT
      DO 10 J=1,3
10    READ(15,*)(PP(L,J,I),I=1,3)
      DO 220 L=1,NOAT
      DO 220 J=1,3
 220  READ(15,*)(II(L,J,I),I=1,3)
      DO 230 L=1,NOAT
      DO 230 J=1,3
230   READ(15,*)(JJ(L,J,I),I=1,3)
      DO 100 L=1,NOAT
      DO 100 J=1,3
100   READ(15,*)(PV(L,J,I),I=1,3)
      CLOSE(15)
      RETURN
      END
C     =====================================================================
