      SUBROUTINE READACESI(NAT,LINEAR,N,FCAR0,S,
     1AM,N7,R,HW,step,tol4,tol3,NCAN,ICAN,XLIM)
      IMPLICIT none
      integer*4 NAT,N,N7,i,j,k,l,ix,II,ndif,nml,
     1IDUM,IA,IC,ij,NINDC,imax,jmax,kmax,imx,jmx,kmx,is,
     1NQ,NQT,ltot,NM,ind,ind1,ind2,iq,jx,nstep,INDC,JJ,kx
      include 'dimensions.h'
      CHARACTER*50 S50
      CHARACTER*2 atsym
      integer*4 iz(NT0),NCAN,ICAN(*),ipl
      real*8 FCAR0(NT3,NT3),FCAR(NT3,NT3),
     2AM(NT3),R(NT0,3),APT(NT0,3,3),XLIM,
     1AAT(NT0,3,3),ALPHA(3,3,NT3),APT0(NT0,3,3),aptn(2*NT3,3),
     1AAT0(NT0,3,3),ALPHA0(3,3,NT3),dip(3),dip0(3),polar(3,3),
     1polar0(3,3),alphan(3,3,2*NT3),S(NT3,NT3),FQ(NT3,NT3),
     1ALPHAA(NT3**2,9),GG(3,3,NT3),AA(3,3,3,NT3),APTQ(NT3,3),
     1GGA(NT3**2,9),AAA(NT3**2,27),AATQ(NT3,3),amave,dipn(3),
     1GG0(3,3,NT3),AA0(3,3,3,NT3),A0Q(3,3,3,NT3),rp(NT0,3),
     1AAQ(3,3,3,NT3),ALPHAQ(3,3,NT3),ALPHA0Q(3,3,NT3),
     1rc(NT0,3),APT0Q(NT3,3),AAT0Q(NT3,3),aatn(NT3,3),
     1GQ(3,3,NT3),G0Q(3,3,NT3),gten(3,3),gten0(3,3),dipt(3),
     1aten(3,3,3),aten0(3,3,3),ajm(NT0,NT0),sigma(2*NT0),
     1sigmaq(2*NT3,NT0),A(3,3),T(3),
     1ajm0(NT0,NT0),sigma0(NT0),optrot,optrot0,optrotq(2*NT3),
     1aptaq(2*NT3**2,3),aataq(NT3**2,3),bohr,cm,SFACR,f1,f2,E,tol4,
     1tol3,step,ASS,ff,ei,ej,dd,dm,c0,EIJK,CIJK,cqau,cqcn,cqcm
c     large arrays:
      real*8,allocatable:: CX3(:,:,:),CX4(:,:,:),ajmq(:,:,:)
c     CX3(NT3,NT3,NT3) third energy derivatives
c     CX4(NT3,NT3,NT3) fourth energy derivatives
c     ajmq(2*NT3,NT0,NT0) spin-spin constant derivatives
      LOGICAL HW,lex,lttt,lfc,lx,lff,ldip,
     1LINEAR,OPT,lapt,laat,lten,lfcd,lnmr,ljj,loptrot,lpolar
      COMMON/CEM/E(NT3)
      common/cnmd/ndif,nml(NT3)
      logical lharm,lopt,ltrf
      common/lop/lopt(300)
      equivalence (lharm,lopt(9))
C

      bohr=0.529177d0
      cm=219470.0d0
      SFACR=0.02342179d0
c           =1/sqrt(amu), to transfer S into atomic units
c
c     Unit explanation:
c     -----------------
c     dX ... Cartesian coordinate displacement
c     dQ ... normal mode coordinate
c     dX = S.dQ
c     S ... S-matrix written into FILE.INP
c     St.M.S=1, M is the mass matrix in g/mol
c     s=SFACR.S, s is then in atomic units, is written in SMAT.SCR
c     si.FF.sj=delta(i,j)*ei^2, ei is the normal mode energy in a.u.
c     q ... dimensionless normal mode coordinate, qi=sqrt(ei) Qi
c
c     read S and e, transform into a.u.:
      open(7,file='F.INP')
      read(7,*)nm,N,nat
      do 8 i=1,3*nat
      e(i)=0.0d0
      do 8 j=1,3*nat
8     s(i,j)=0.0d0
      do 7 i=1,nat
7     read(7,*)
      read(7,*)
      do 6 i=1,nat
      do 6 iq=1,nm
6     read(7,*)idum,idum,(s(3*(i-1)+k,N-iq+1),k=1,3)
      read(7,*)
      read(7,*) (E(N-iq+1),iq=1,nm)
      do 9 iq=1,nm
      E(N-iq+1)=E(N-iq+1)/cm
      do 9 i=1,nat
      do 9 k=1,3
9     s(3*(i-1)+k,N-iq+1)=s(3*(i-1)+k,N-iq+1)*SFACR
      close(7)
      write(6,6002)nat,nm,N
      write(3,6002)nat,nm,N
6002  format('  S read from F.INP, low modes first, nat nm N: ',3i5)
C
      INQUIRE(FILE='A.OUT',EXIST=OPT)
      IF(.NOT.OPT)CALL REPORT('File A.OUT not found.')
      inquire(file='FILE.TEN',exist=lten)
      inquire(file='FILE.FC',exist=lfcd)
      INQUIRE(FILE='TR.OUT',EXIST=ltrf)
C
      OPEN(2,FILE='A.OUT')
c     file with rotations matrices and mass centers:
      if(ltrf)OPEN(21,FILE='TR.OUT')
      ltot=0
C
c     find geometry
      write(6,*)' Looking for geometry'
  201 READ(2,1111,END=202)S50
      ltot=ltot+1
1111  FORMAT(A50)
      IF(s50(2:18).EQ.'Z-matrix   Atomic')then
       DO 41 I=1,2
       ltot=ltot+1
41     READ(2,*)
       l=0
5      READ(2,1111)s50
       ltot=ltot+1
       IF(s50(2:4).NE.'---')THEN
        l=l+1
        BACKSPACE 2
        READ(2,2009)iz(l),(r(l,i),i=1,3)
2009    format(6x,i10,4x,3f15.8)
        GOTO 5
       ENDIF

       nat=l

       if(ltrf)then
        read(21,*)((A(I,J),I=1,3),J=1,3),((T(i),i=1,3),j=1,nat)
        write(6,6412)A,T
6412    format(/,' Transformation matrix',/,3(3F10.4,/),/,
     1  ' Shift ',/,3F10.4,/)

        write(6,*)'Exceptionally change Y <-> -Y   !!!!!!!!!!!!!!!!!!!'
        write(3,*)'Exceptionally change Y <-> -Y   !!!!!!!!!!!!!!!!!!!'
        do i=1,nat
         r(i,2)=-r(i,2)
        enddo

        do i=1,3
         dipn(i)=0.0d0
         do j=1,nat
          dipn(i)=dipn(i)+dble(iz(j))*r(j,i)
         enddo
        enddo

        do 36 i=1,nat
        do 36 j=1,3
        rp(i,j)=-T(j)
        do 36 l=1,3
36      rp(i,j)=rp(i,j)+A(l,j)*r(i,l)*0.529177d0
        do l=1,nat
         write(6,4000)iz(l),(r(l,i),i=1,3)
        enddo
        write(6,*)
        do l=1,nat
         write(6,4000)iz(l),(rp(l,i),i=1,3)
        enddo
        do 412 l=1,nat
        do 412 i=1,3
412     r(l,i)=rp(l,i)
       else
        do 411 l=1,nat
        do 411 i=1,3
411     r(l,i)=r(l,i)*bohr
       endif

       write(3,*)nat
       open(20,file='FILE.X')
       write(20,*)nat
       write(20,*)nat
       do 34 l=1,nat
       write(20,4000)iz(l),(r(l,i),i=1,3)
34     write(3,4000)iz(l),(r(l,i),i=1,3)
4000   format(I3,3F15.10,' 0 0 0 0 0 0 0 0.0')
       close(20)
       goto 203
      ENDIF
      goto 201
202   call report('Geometry not found')
203   do 55 ia=1,nat
      atsym='??'
      ASS=amave(iz(IA),atsym)
c
c     assign default mass, if not defined previously:
      if(am(3*(IA-1)+1).lt.0.0d0)then
       DO 551 I=1,3
551    AM(3*IA-3+I)=ASS
      endif
55    continue
c
      WRITE(3,1113)(AM(i),i=1,3*nat)
1113  FORMAT(4F15.8)
      IF(NAT.EQ.2.OR.LINEAR)THEN
       WRITE(3,*)'Linear molecule'
       N7=6
       LINEAR=.TRUE.
      ENDIF
      N=3*nat
C
      IF(step.gt.1.0d-9)then
       write(3,3000)step,step/bohr
       write(6,3000)step,step/bohr
       step=step/bohr
3000   format('Step defined as ',F10.5,'A (',F10.5,'au)')
      endif
C
      NSTEP=1+2*ndif
      write(3,*)nstep,' steps expected'
      write(6,*)nstep,' steps expected'
c
c     read-in zero point:
      lapt=.false.
      ldip=.false.
      laat=.false.
      lttt=.false.
      lx=.false.
      lfc=.false.
      lff=.false.
c
c     zero-out the tensors
      call readar0(NT3,N,FCAR0,APT0,AAT0,ALPHA0,dip0,polar0,GG0,AA0,
     1gten0,aten0,optrot0,ajm0,sigma0)
c
c     read current point from the output
      call readara(NT3,N,FCAR0,APT0,AAT0,ALPHA0,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip0,ltot,polar0,GG0,AA0,gten0,aten0,optrot0,
     1ajm0,sigma0,loptrot,lnmr,ljj,lff,lpolar,ldip)
      call w36('zero point finished')
      write(6,*)ltot,' line in A.OUT'
      if(lapt)write(6,*)'APT found'
      if(laat)write(6,*)'AAT found'
      if(lttt)write(6,*)'TTT found'
      if(lfc)write(6,*)'FF found'
      if(lx)write(6,*)'X found'
      if(ldip)then
       write(3,3700)(dip0(i),i=1,3)
       write(6,3700)(dip0(i),i=1,3)
3700   format(' Dipole         ',3F10.4)

       dip0(2)=-dip0(2)
       do i=1,3
        dip0(i)=dip0(i)
       enddo
       call w36('Nuclear part added')
       write(3,3700)(dip0(i),i=1,3)
       write(6,3700)(dip0(i),i=1,3)
       do 37 j=1,3
       dipt(j)=0.0d0
       do 37 l=1,3
37     dipt(j)=dipt(j)+A(l,j)*dip0(l)
       do 38 j=1,3
38     dip0(j)=dipt(j)
       write(6,*)dsqrt(dip0(1)**2+dip0(2)**2+dip0(3)**2)*2.5417d0

       call w36('Dipole transformed')
       write(3,3700)(dip0(i),i=1,3)
       write(6,3700)(dip0(i),i=1,3)
      endif
      write(3,3705)((polar0(i,j),i=1,3),j=1,3)
      write(6,3705)((polar0(i,j),i=1,3),j=1,3)
3705  format(' Polarizability ',3F10.4,/,
     1       '                ',3F10.4,/,
     1       '                ',3F10.4)
      if(ljj)then
       call w36('Spin-Spin Coupling')
       call WRITEM(3,NT0,N/3,ajm0)
       call WRITEM(6,NT0,N/3,ajm0)
      endif
      if(lnmr)then
       call w36('Chemical Shifts')
       do 3701 I=1,N/3
       write(3,3702)I,sigma0(I)
3701   write(6,3702)I,sigma0(I)
3702   format(i4,f15.6)
      endif
      if(loptrot)then
       call w36('Optical Rotation')
       write(3,3703)optrot0
       write(6,3703)optrot0
3703   format(f10.2)
      endif
c
c     load only harmonic ff if requested (debug option):
      if(lharm)then
       close(2)
       write(6,*)'lharm option called'
       write(3,*)'lharm option called'
       return
      endif
c
c     transform Cartesian FF into normal modes:
      call trafoq(FCAR0,FQ,S,N)
c
c     transform dipole derivatives into normal modes
      call trafopq(APT0,AAT0,APT0Q,AAT0Q,S,N)
c     write(6,*)N,APT0Q(N,1),APT0Q(N,2),APT0Q(N,3)
c     call report('debug')
c
c     transform polarizability derivatives into normal modes
      call trafoaq(ALPHA0,GG0,AA0,ALPHA0Q,G0Q,A0Q,S,N)

      allocate(CX3(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX3')
      allocate(CX4(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX4')
      allocate(ajmq(1:2*N,1:NAT,1:NAT),stat=is)
      if(is.ne.0)call report('cannot allocate ajmq')

c
c     zero-out/initialize anharmonic variables:
      DO 1 I=1,N
      DO 1 J=1,N
      DO 1 K=1,N
      CX3(I,J,K)=0.0d0
1     CX4(I,J,K)=0.0d0
c
      DO 54 ii=1,ndif
      I=nml(ii)
      DO 54 J=1,N
      DO 54 K=1,N
      CX3(I,J,K)=0.0d0
54    CX4(I,J,K)=-2.0d0*FQ(J,K)
c
      if(ldip)then
       do 547 i=1,N
       do 547 k=1,3
       aatn(i,k)=0.0d0
       aptn(i+N,k)=-2.0d0*dip0(k)
547    aptn(i,k)=0.0d0
      endif

      if(lapt.or.laat)then
       DO 541 II=1,N**2
       DO 541 K=1,3
       aataq(II,K)=0.0d0
       aptaq(N**2+II,K)=0.0d0
541    aptaq(II,K)=0.0d0
      endif
c
      if(lttt)then
       DO 542 II=1,N**2
       DO 542 J=1,9
       ALPHAA(II,J)=0.0d0
542    GGA(II,J)=0.0d0
       DO 5421 II=1,N**2
       DO 5421 J=1,27
5421   AAA(II,J)=0.0d0
      endif
      do 552 i=1,N
      do 552 k=1,3
      do 552 l=1,3
      alphan(k,l,i+N)=-2.0d0*polar0(k,l)
552   alphan(k,l,i)=0.0d0
c
c     first derivatives and diagonal second dervs:
      if(loptrot)then
       do 554 i=1,N
       optrotq(N+i)=-2.0d0*optrot0
554    optrotq(i)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(lnmr)then
       do 555 i=1,N
       do 555 j=1,N/3
       sigmaq(N+i,j)=-2.0d0*sigma0(j)
555    sigmaq(i,j)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(ljj)then
       do 556 i=1,N
       do 556 j=1,N/3
       do 556 k=1,N/3
       ajmq(N+i,j,k)=-2.0d0*ajm0(j,k)
556    ajmq(i,j,k)=0.0d0
      endif
c
c     start to read the shifted geometries:
      do 3333 IC=1,2*ndif
      I=IC
      if(IC.GT.ndif)I=IC-ndif
      write(6,*)'Point',IC,'(',I,'):',nml(I),ltot
      write(3,*)'Point',IC,'(',I,'):',nml(I),ltot
      if(IC.le.ndif)then
       ff=1.0d0
      else
       ff=-1.0d0
      endif
c
c     check, that we are at the right point, eventually extarct step:
      call chkgeosa(r,nat,step,S,rc,nml(I),ltot,ltrf)

        do i=1,3
         dipn(i)=0.0d0
         do j=1,nat
          dipn(i)=dipn(i)+dble(iz(j))*rc(j,i)
         enddo
        enddo
c
c     zero-out variables:
      call readar0(NT3,N,FCAR,APT,AAT,ALPHA,dip,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma)
c
c     read-in current values:
      call readara(NT3,N,FCAR,APT,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,optrot,
     1ajm,sigma,loptrot,lnmr,ljj,lff,lpolar,ldip)
      write(3,3700)(dip(j),j=1,3)

      dip(2)=-dip(2)
       do i=1,3
        dip(i)=dip(i)
       enddo
       call w36('Nuclear part added')
      do 39 j=1,3
      dipt(j)=0.0d0
      do 39 l=1,3
39    dipt(j)=dipt(j)+A(l,j)*dip(l)
      do 40 j=1,3
40    dip(j)=dipt(j)
      write(3,*)'dipole transformed'

      write(3,3700)(dip(j),j=1,3)
      write(3,3705)((polar(k,j),k=1,3),j=1,3)
      if(ljj)then
       write(3,*)'Spin-Spin Coupling'
       call WRITEM(3,NT0,N/3,ajm)
      endif
      if(lnmr)then
       write(3,*)'Chemical Shifts'
       do 3704 j=1,N/3
3704   write(3,3702)j,sigma(j)
      endif
      if(loptrot)then
       write(3,*)'Optical Rotation'
       write(3,3703)optrot
      endif
c
c     transform Cartesian derivatives to normal modes:
      call trafoq(FCAR,FQ,S,N)
      call trafopq(APT,AAT,APTQ,AATQ,S,N)
      call trafoaq(ALPHA,GG,AA,ALPHAQ,GQ,AAQ,S,N)
c
c     do the numerical differentiations:
      DO 3 J=1,N
      DO 3 K=1,N
      CX3(nml(I),J,K)=CX3(nml(I),J,K)+FQ(J,K)*ff
3     CX4(nml(I),J,K)=CX4(nml(I),J,K)+FQ(J,K)
c
      do 553 j=1,3
      do 553 k=1,3
      alphan(j,k,nml(I)+N)=alphan(j,k,nml(I)+N)+polar(j,k)
553   alphan(j,k,nml(I))=alphan(j,k,nml(I))+ff*polar(j,k)
c
      if(ldip)then
       do 548 j=1,3
       aptn(nml(I)+N,j)=aptn(nml(I)+N,j)+dip(j)
548    aptn(nml(I),j)=aptn(nml(I),j)+ff*dip(j)
      endif

      if(lapt.or.laat)then
       DO 543 II=1,N
       DO 543 K=1,3
       ind=nml(I)+N*(II-1)
       aataq(ind,K)=aataq(ind,K)+AATQ(II,K)*ff
543    aptaq(ind,K)=aptaq(ind,K)+APTQ(II,K)*ff
      endif
c
      if(lttt)then
       DO 544 II=1,N
       ind1=nml(I)+N*(II-1)
       DO 5441 J=1,3
       DO 5441 K=1,3
       ind2=J+3*(K-1)
       GGA(   ind1,ind2)=GGA(   ind1,ind2)+GQ(    J,K,II)*ff
5441   ALPHAA(ind1,ind2)=ALPHAA(ind1,ind2)+ALPHAQ(J,K,II)*ff
       DO 544 L=1,3
       ind2=J+3*(K-1)+9*(L-1)
544    AAA(   ind1,ind2)=AAA(   ind1,ind2)+AAQ(J ,K,L,II)*ff
      endif
c
      if(lnmr)then
       DO 545 II=1,N/3
       sigmaq(N+nml(I),II)=sigmaq(N+nml(I),II)+sigma(II)
545    sigmaq(nml(I),II)=sigmaq(nml(I),II)+sigma(II)*ff
      endif
c
      if(ljj)then
       DO 546 II=1,N/3
       DO 546 JJ=1,N/3
       ajmq(N+nml(I),II,JJ)=ajmq(N+nml(I),II,JJ)+ajm(II,JJ)
546    ajmq(nml(I),II,JJ)=ajmq(nml(I),II,JJ)+ajm(II,JJ)*ff
      endif
c
      if(loptrot)then
       optrotq(nml(I))=optrotq(nml(I))+optrot*ff
       optrotq(N+nml(I))=optrotq(N+nml(I))+optrot
      endif
c
3333  continue
c
      close(2)
C
      if(step.lt.1.0d-9)call report('Diff. step too small!')
c
c     dQ(in au)=step(current)/(bohr*SFAC)
c     CX4=[FF(+Q)+FF(-Q)-2FF]/dQ**2     CX3=[FF(+Q)-FF(-Q)]/(2dQ)
      f1=0.5d0* SFACR*bohr/step
      f2=1.0d0*(SFACR*bohr/step)**2
      DO 15 I=1,ndif
      DO 15 J=1,N
      DO 15 K=1,N
      CX3(nml(I),J,K)=CX3(nml(I),J,K)*f1
15    CX4(nml(I),J,K)=CX4(nml(I),J,K)*f2

      DO 161 I=ndif,1,-1
      ei=sqrt(E(nml(I)))
      do 161 j=1,3
      aptn(nml(I),j)=aptn(nml(I),j)*f1/ei
      aptn(nml(I)+N,j)=aptn(nml(I)+N,j)*f2/ei/ei
      APT0Q(nml(I),j)=APT0Q(nml(I),j)/ei
161   AAT0Q(nml(I),j)=AAT0Q(nml(I),j)*ei
c
c     for tensor properties, write the derivatives (au) with respect to q:
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENQ.TXT.SCR found on disk, unchanged')
      else
       if(.not.lapt)then
c       if no analytical derivatives, then use numerical:
        DO 162 I=ndif,1,-1
        do 162 j=1,3
162     APT0Q(nml(I),j)=aptn(nml(I),j)
       endif
       call wrten1q(dip0,ndif,lapt,aptn,APT0Q,NT3,AAT0Q,nml,N)
      endif
c
      DO 18 I=ndif,1,-1
      ei=sqrt(E(nml(I)))
      DO 18 J=ndif,1,-1
      ej=sqrt(E(nml(J)))
      ind=nml(I)+N*(nml(J)-1)
      do 18 k=1,3
      aptaq(ind,k)=aptaq(ind,k)/ei/ej*f1
18    aataq(ind,k)=aataq(ind,k)/ei*ej*f1
c     aataq = i-index coordinate, J -momentum

      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENAQ.TXT.SCR found on disk, unchanged')
      else
       call wrtenq(ndif,N,aptaq,aataq,NT3,nml)
      endif
c
      DO 19 I=1,ndif
      ei=sqrt(E(nml(I)))
      do 19 j=1,3
      do 19 k=1,3
      G0Q(j,k,nml(I))=G0Q(j,k,nml(I))/ei
      ALPHA0Q(j,k,nml(I))=ALPHA0Q(j,k,nml(I))/ei
      alphan(j,k,nml(I))=alphan(j,k,nml(I))*f1/ei
      do 19 l=1,3
19    A0Q(j,k,l,nml(I))=A0Q(j,k,l,nml(I))/ei

      call wrttq(polar0,ndif,nml,ALPHA0Q,alphan,gten0,aten0,
     1G0Q,A0Q,NT3)

      do 23 i=1,ndif
      ei=sqrt(E(nml(i)))
      do 23 j=i,ndif
      ej=sqrt(E(nml(j)))
      ind1=nml(I)+N*(nml(J)-1)
      ind2=nml(J)+N*(nml(I)-1)
      do 22 ix=1,9
      GGA(ind1,ix)   =0.5d0*(GGA(ind1,ix)   +GGA(ind2,ix)   )/ei/ej*f1
      GGA(ind2,ix)=GGA(ind1,ix)
      ALPHAA(ind1,ix)=0.5d0*(ALPHAA(ind1,ix)+ALPHAA(ind2,ix))/ei/ej*f1
22    ALPHAA(ind2,ix)=ALPHAA(ind1,ix)
      do 26 ix=1,27
      AAA(ind1,ix)   =0.5d0*(AAA(ind1,ix)   +AAA(ind2,ix)   )/ei/ej*f1
26    AAA(ind2,ix)=AAA(ind1,ix)
23    continue

      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTAQ.TXT.SCR found on disk, unchanged')
      else
       call wrttqaq(ndif,nml,N,NT3,ALPHAA,GGA,AAA)
      endif

      ipl=0
      open(21,file='PROP.TXT.SCR')
331   read(21,*,end=6333,err=6333)
      ipl=ipl+1
      goto 331
6333  write(6,*)ipl,' lines in PROP.TXT.SCR'
      write(3,*)ipl,' lines in PROP.TXT.SCR'
      if(ipl.eq.0)write(21,*)N7,N
c
      if(loptrot)then
      write(21,*)loptrot
      write(21,2125)1,optrot0
2125  format('Optical rotation:',/,i5,/,20x,f10.2)
      do 27 i=N7,N
      if(e(i).le.0.0d0)then
       write(21,2126)i,0.0d0,0.0d0
      else
       write(21,2126)i,optrotq(i)*f1/dsqrt(e(i)),optrotq(N+i)*f2/e(i)
      endif
27    continue
2126  format(20x,i5,2g15.5)
      endif
c
      write(21,*)lpolar
      write(21,2132)9
2132  format('Polarizability:',/,i5)
      do 32 i=1,3
      do 32 j=1,3
32    write(21,21281)i,j,polar0(i,j)
      do 33 i=1,3
      do 33 j=1,3
      do 33 k=N7,N
      if(e(k).le.0.0d0)then
       write(21,2130)i,j,k,0.0d0,0.0d0
      else
       write(21,2130)i,j,k,alphan(i,j,k)*f1/dsqrt(e(k)),
     1 alphan(i,j,N+k)*f2/e(k)
      endif
33    continue
c
      write(21,*)lnmr
      write(21,2127)N/3
2127  format('Chemical shifts:',/,i5)
      do 28 i=1,N/3
28    write(21,2131)i,sigma0(i)
2131  format(i20,g15.5)
      do 29 i=1,N/3
      do 29 j=N7,N
      if(e(j).le.0.0d0)then
       write(21,2128)i,j,0.0d0,0.0d0
      else
       write(21,2128)i,j,sigmaq(j,i)*f1/dsqrt(e(j)),
     1 sigmaq(N+j,i)*f2/e(j)
      endif
29    continue
2128  format(i20,i5,2g15.5)
c
      write(21,*)ljj
      write(21,2129)N/3*N/3
2129  format('Spin-Spin Couplings:',/,i5)
      do 30 i=1,N/3
      do 30 j=1,N/3
30    write(21,21281)i,j,ajm0(i,j)
21281 format(2i10,g15.5)
      do 31 i=1,N/3
      do 31 j=1,N/3
      do 31 k=N7,N
      if(e(k).le.0.0d0)then
       write(21,2130)i,j,k,0.0d0,0.0d0
      else
       write(21,2130)i,j,k,ajmq(k,j,i)*f1/dsqrt(e(k)),ajmq(N+k,j,i)
     1 *f2/e(k)
      endif
31    continue
2130  format(2i10,i5,2g15.5)

      close(21)
      call w36('PROP.TXT.SCR')
c
      call readg98si(NAT,N,R,XLIM,step,1,tol3,N7,S)

      if(.not.lff)call report('force field not found')
c
      write(6,*)'Symmetrizing cubics'
      NINDC=0
      imax=0
      jmax=0
      kmax=0
      imx=0
      jmx=0
      kmx=0
      dd=0.0d0
      dm=0.0d0
      DO 152 I=N7,N
      DO 152 J=I,N
      DO 152 K=J,N
      c0=CX3(I,J,K)
      CX3(I,J,K)=(CX3(I,J,K)+CX3(I,K,J)+CX3(J,I,K)
     1+           CX3(J,K,I)+CX3(K,I,J)+CX3(K,J,I))/6.0d0
      if(dabs(c0-CX3(I,J,K)).gt.dd)then
       dd=dabs(c0-CX3(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
152   NINDC=NINDC+1
      write(6,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
      write(3,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
8989  format(' Largest assymetry:',3i3,' c =',g12.4,' dc =',g12.4)
      write(6,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
      write(3,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
1989  format(' Largest constant :',3i3,' c =',g12.4)

c     control output
      INDC=0
      DO 421 I=N7,N
      DO 421 J=I,N
      DO 421 K=J,N
      do 4001 l=1,NCAN
4001  if(I.eq.ICAN(l).or.J.eq.ICAN(l).or.K.eq.ICAN(l))CX3(I,J,K)=0.0d0
      INDC=INDC+1
      EIJK=E(I)*E(J)*E(K)
      II=0
      IF(EIJK.LT.0)II=1
      EIJK=DSQRT(DABS(EIJK))
      CIJK=CX3(I,J,K)
      if(EIJK.gt.0.0d0)CIJK=CIJK/EIJK
      IF(II.EQ.0)WRITE(3,3002)I,J,K,CIJK*CM
      IF(II.EQ.1)WRITE(3,3003)I,J,K,CIJK*CM
3002  FORMAT(2X,3I3,F12.4,$)
3003  FORMAT(2X,3I3,F11.4,1Hi,$)
      IF(MOD(INDC,3).EQ.0)WRITE(3,*)
421   CONTINUE
      WRITE(3,*)
c
c     list large cubics
      open(23,file='CQQ.SCR.TXT')
      NQ=0
      NQT=0
      do 62 i=N7,N
      do 62 j=i,N
      do 62 k=j,N
      cqau=CX3(I,J,K)
      EIJK=dsqrt(abs(e(i)*e(j)*e(k)))
      if(EIJK.gt.0.0d0)cqcn=cqau/EIJK
      cqcm=cqcn*cm
      if(abs(cqcm).gt.tol3)then
       write(23,4333)I,J,K,cqcn,cqcm
4333   format(3I5,G16.8,F9.1)
       nq=nq+1
      endif
62    nqt=nqt+1
      close(23)
      write(6,6000)nqt,nq,tol3
      write(3,6000)nqt,nq,tol3
6000  format('Number of normal cubics ',I10,/,
     1       'Selected                ',I10,/,
     1       'Limit                   ',F10.7,/,
     1       'Writen in CQQ.SCR.TXT',/)
c
      write(6,*)'Symmetrizing quartics'
      imax=0
      jmax=0
      kmax=0
      dd=0.0d0
      imx=0
      jmx=0
      kmx=0
      dm=0.0d0
      DO 153 I=N7,N
      DO 153 J=N7,N
      DO 153 K=J,N
      c0=CX4(I,J,K)
      if(j.eq.i)then
c      iii
       if(k.eq.i)then
c       iiii
       else
c       iiik iiki
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       endif
      else
c      iij
       if(k.eq.i)then
c       iiji iiji
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       else
        if(k.eq.j)then
c        iijj jjii
         CX4(I,J,K)=(CX4(I,J,K)+CX4(J,I,I))/2.0d0
         CX4(J,I,I)=CX4(I,J,K)
        else
c        iijk iikj
         CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
         CX4(I,K,J)=CX4(I,J,K)
        endif
       endif
      endif
      if(dabs(c0-CX4(I,J,K)).gt.dd)then
       dd=dabs(c0-CX4(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
153   continue
      write(6,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
      write(3,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
8985  format(' Largest assymetry:',4i3,' d =',g12.4,' dd =',g12.4)
      write(6,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
      write(3,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
2989  format(' Largest constant :',4i3,' d =',g12.4)
c
c
c     write sparse quartics
      call write4(CX4,N7,N,NCAN,ICAN,E,tol4)

      deallocate(CX3)
      deallocate(CX4)
      deallocate(ajmq)

c
      RETURN
      END
c
      subroutine chkgeosa(r,nat,step,S,rc,ireq,ltot,ltrf)
      implicit none
      integer*4 nat,I,l,ic,ix,iq,ii,ireq,ltot,j
      include 'dimensions.h'
      real*8 r(NT0,3),tol,step,rc(NT0,3),dq,S(NT3,NT3),cm,E,AM,
     1SFACR,bohr,rp(NT0,3),A(3,3),T(3)
      COMMON/CEM/E(NT3)
      common/MASS/AM(NT3)
      character*50 S50
      logical ltrf
c
      cm=219470.0d0
      SFACR=0.02342179d0
      bohr=0.529177d0
c
  201 READ(2,1111,END=202)S50
      ltot=ltot+1
1111  FORMAT(A50)
      IF(s50(2:18).EQ.'Z-matrix   Atomic')then
       DO 41 I=1,2
       ltot=ltot+1
41     READ(2,*)
c      read current geometry
       do 1 l=1,nat
       ltot=ltot+1
1      READ(2,2009)I,(rc(l,ix),ix=1,3)
2009   format(6x,i10,4x,3f15.8)
       if(ltrf)then
        read(21,*)((A(I,J),I=1,3),J=1,3),((T(i),i=1,3),j=1,nat)
        write(6,*)'Exceptionally change Y <-> -Y   !!!!!!!!!!!!!!!!!!!'
        write(3,*)'Exceptionally change Y <-> -Y   !!!!!!!!!!!!!!!!!!!'
        do i=1,nat
         rc(i,2)=-rc(i,2)
        enddo
        do 36 i=1,nat
        do 36 j=1,3
        rp(i,j)=-T(j)
        do 36 l=1,3
36      rp(i,j)=rp(i,j)+A(l,j)*rc(i,l)*0.529177d0
        do 412 l=1,nat
        do 412 i=1,3
412     rc(l,i)=rp(l,i)
        write(6,6412)A,T
6412    format(/,' Transformation matrix',/,3(3F10.4,/),/,
     1  ' Shift ',/,3F10.4,/)
       else
        do 411 l=1,nat
        do 411 i=1,3
411     rc(l,i)=rc(l,i)*bohr
       endif
       tol=1.0d-4
       ic=0
c
c      Cartesian displacements from equilibrium
       DO 2 l=1,nat
c      write(6,888)l,(rc(l,ix),ix=1,3),(r(l,ix),ix=1,3)
c88    format(i3,6f10.4)
       DO 2 ix=1,3
2      rc(l,ix)=rc(l,ix)-r(l,ix)
c
c      normal mode displacements
       do 3 iq=1,3*nat
       dq=0.0d0
       do 4 l=1,nat
       do 4 ix=1,3
       ii=3*(l-1)+ix
4      dq=dq+AM(ii)*S(ii,iq)*rc(l,ix)
c
c      adapt to the strange pmz units dq=dq/SFACR:
       dq=dq/SFACR
       if(dabs(dq).gt.tol)then
        write(6,6000)iq,e(iq)*cm,dq,dq*SFACR/bohr
6000    format('mode',i4,f10.2,' cm-1',' dQ =',f10.4,' au:',f10.4)
        if(ireq.ne.iq)call report('errorneous mode numbering')
        ic=ic+1
        call chksti(dq,step)
       endif
3      continue
c
       if(ic.ne.1)then
        write(3,*)ic
        call report('deffective differentiation')
       endif
       return
      ENDIF
      goto 201
202   call report('Geometry not found')
      end
