       SUBROUTINE READAR(N0,N,F,P,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,optrot,ajm,
     2sigma,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
c
c     read force field and other properties from gaussian archive
c
      IMPLICIT none
      include 'dimensions.h'
      real*8 F(N0,N),P(NT0,3,3),X(3,NT0),ALPHA(3,3,NT3),
     1AAT(NT0,3,3),dip(3),polar(3,3),GG(3,3,NT3),AA(3,3,3,NT3),
     1gten(3,3),aten(3,3,3),sigma(*),ajm(NT0,NT0),
     1xg09(6,3*NT3),DEBYE,dipn,FU,fr,optrot,G(*)
      integer*4 i,i6,ia,ianmr,iat,ifr,ii1,ii2,in,ix,iy,iz,j,k,ln,
     1ltot,ltot0,n,n3,nat,nb,n0,n1
      CHARACTER*1 BUFF(160),NUMBER(80),L,AT(NT0),LE
      CHARACTER*5 SSTR
      CHARACTER*20 s20
      CHARACTER*160 s80
      CHARACTER*5 s5
      CHARACTER*2 LG
      COMMON/LINE/I
      LOGICAL LVCD,LGEO,LARCH,lapt,laat,lttt,lfc,lx,lten,lfcd,ldip,
     1lpolar,ljj,lnmr,loptrot,lff,lram,ltthere,lg09alpha,lharm,
     1lg09g,lg09a,lg09polar,lgr
      integer*4 iaa(6),jaa(6)
      data iaa/1,2,3,1,1,2/
      data jaa/1,2,3,2,3,3/
      integer*4 col
c
      lgr=.false.
      ltot0=0
      col=0
      ljj=.false.
      ltthere=.false.
      lff=.false.
      lnmr=.false.
      loptrot=.false.
      LARCH=.false.
      lharm=.false.
      ldip=.false.
      lpolar=.false.
      lg09polar=.false.
      LGEO=.FALSE.
      lg09alpha=.false.
      lg09g=.false.
      lg09a=.false.
      NAT=N/3
      NB=70
      LE='='
      LG='%%'
      LVCD=.false.
      ianmr=0
      DEBYE=2.541732d0
C
c     read 80 characters for non-archive strings:
c
c     NOTE:First character not read
c
5444  READ(2,7000,END=8888)(BUFF(I),I=1,80),(S5(I:I),I=1,5)
c     write(6,7000)(BUFF(I),I=1,80),(S5(I:I),I=1,5)
7000  FORMAT(1X,80A1,5A1)
      ltot=ltot+1
c
c     reading things that are not in archive:
      if(.not.LARCH)then
       do 1 I=1,80
1      s80(I:I)=BUFF(I)
       do 1001 I=1,5
1001   s80(80+I:80+I)=s5(I:I)
c      note, that the strings s80 are offset by 1 from the line beginning
c      write(6,*)'*'//s80(1:17)//'*'
       if(s80(1:20).eq.'Harmonic frequencies')lharm=.true.
c      Dipole moment (prefer this against that in the archive):
       IF(.not.ldip.and.s80(1:15).eq.'Dipole moment (')then
        read(2,'(a80)')s80
        if(s80(13:13).eq.'.')then
c        g03:
         read(s80,2407)(dip(IY),IY=1,3)
2407     format(3(6x,f11.4))
        else
c        g09:
         read(s80,2007)(dip(IY),IY=1,3)
2007     format(3(6x,f20.4))
        endif
        dipn=0.0d0
        do 2 IY=1,3
        dip(IY)=dip(IY)/DEBYE
2       dipn=dipn+dip(IY)**2
        dipn=dsqrt(dipn)
        ldip=.true.
        write(3,2008)(dip(IY),IY=1,3),dipn
2008    format(' Dipole ',3f11.4,' au (norm =',f11.4,')')
       endif
c      Optical Rotation:
       IF(s80(38:44).eq.'[Alpha]')then
        loptrot=.true.
        IF(s80(45:45).eq.'D')then
c        static Alpha:
         if(s80(48:48).eq.'s')then
          read(s80(58:69),*)optrot
         else
          read(s80(48:59),*)optrot
         endif
        ELSE
c        non-static Alpha:
         read(s80(59:70),*)optrot
        endif
       endif
c      Chemical Shifts:
       IF(s80(10:20).eq.'Isotropic =')then
        ianmr=ianmr+1
        read(s80(22:32),*)sigma(ianmr)
        read(s80(47:57),*)sigma(ianmr+NAT)
        lnmr=.true.
       endif
c      Gradient:
       IF(s80(36:58).eq.' Forces (Hartrees/Bohr)')then
        NAT=N/3
        read(2,*)
        read(2,*)
        do 9 I=1,NAT
9       read(2,*)(G(J+3*(I-1)),J=1,2),(G(J+3*(I-1)),J=1,3)
        lgr=.true.
       endif
c      Spin-Spin Couplings:
       IF(s80(1:40).EQ.'Total nuclear spin-spin coupling J (Hz):')then
        NAT=N/3
        N1=1
111     N3=N1+4
        IF(N3.GT.N)N3=NAT
        read(2,*)
        ltot=ltot+1
        DO 130 LN=N1,NAT
        ltot=ltot+1
130     READ(2,*)ajm(LN,N1),(ajm(LN,J),J=N1,MIN(LN,N3))
        N1=N1+5
        IF(N3.LT.NAT)GOTO 111
        DO 31 I=1,NAT
        DO 31 J=I,NAT
   31   ajm(I,J)=ajm(J,I)
        ljj=.true.
       ENDIF

c      g09 frequency-dependent ROA tensors, read after Harm. freq. list:
       IF(lharm.and.s80(22:44).eq.'Alpha(-w,w) derivatives')then
        read(s80(58:58),'(i1)')ifr
        read(s80(61:70),'(f10.6)')fr
c       read tensor
        write(3,*)'G09 alpha-tensor derivatives found'
        lg09alpha=.true.
        write(3,'(a,i1,a,f10.6,a)')'  frequency ',ifr,' = ',fr,' a.u.'
        ii1=0
8002    read(2,*)
        do 32 ix=1,3
32      read(2,8001)(xg09(ix,ii2),ii2=ii1+1,min(ii1+5,9*nat))
8001    format(8x,5e14.6)
        ii1=ii1+5
        if(ii1.lt.9*nat) goto 8002
        do 33 ix=1,3
        do 33 iy=1,3
        do 33 iat=1,n
33      ALPHA(iy,ix,iat)=xg09(ix,3*(iat-1)+iy)
        if(.not.lttt)then
         lttt=.true.
         inquire(file='FILE.TTT',exist=lram)
         if(lram)then
          call w36('FILE.TTT found, not overwritten')
         else
          open(22,file='FILE.TTT')
          CALL WRITETTT(N,NAT,ALPHA,GG,AA)
          close(22)
          call w36(' ALPHA written into FILE.TTT')
          ltthere=.true.
c         ltthere ... FILE.TTT is written at disk at this reading
         endif
        endif
       ENDIF


       IF(lharm.and.
     1  s80(22:42).eq.'Alpha(-w,w) frequency'.and..not.lpolar)THEN
        read(s80(45:45),'(i1)')ifr
        read(s80(48:57),'(f10.6)')fr
c       read tensor
        write(3,*)'Polarizability'
        lg09polar=.true.
        lpolar=.true.
        write(3,'(a,i1,a,f10.6,a)')'  frequency ',ifr,' = ',fr,' a.u.'
        read(2,*)
        do 38 ix=1,3
38      read(2,*)polar(ix,1),(polar(ix,iy),iy=1,3)
       ENDIF

       IF(lharm.and.
     1  s80(22:59).eq.'FD Optical Rotation Tensor derivatives')THEN
        read(s80(73:73),'(i1)')ifr
        read(s80(76:85),'(f10.6)')fr
c       read tensor
        write(3,*)'G09 G-tensor derivatives found'
        lg09g=.true.
        write(3,'(a,i1,a,f10.6,a)')'  frequency ',ifr,' = ',fr,' a.u.'
        ii1=0
8003    read(2,*)
        do 34 ix=1,3
34      read(2,8001)(xg09(ix,ii2),ii2=ii1+1,min(ii1+5,9*nat))
        ii1=ii1+5
        if(ii1.lt.9*nat) goto 8003
        do 35 ii1=1,3
        do 35 ii2=1,3*n
35      GG(mod(ii2-1,3)+1,ii1,(ii2+2)/3)=xg09(ii1,ii2)
        if(ltthere)then
         open(22,file='FILE.TTT')
         CALL WRITETTT(N,NAT,ALPHA,GG,AA)
         close(22)
         call w36(' G written into FILE.TTT')
        endif
       ENDIF

       IF(lharm.and.s80(22:51).eq.'D-Q polarizability derivatives')THEN
        read(s80(65:65),'(i1)')ifr
        read(s80(68:77),'(f10.6)')fr
        write(3,*)'G09 A-tensor derivatives found'
        lg09a=.true.
        write(3,'(a,i1,a,f10.6,a)')'  frequency ',ifr,' = ',fr,' a.u.'
        ii1=0
8004    read(2,*)
        do 36 ix=1,6
36      read(2,8001)(xg09(ix,ii2),ii2=ii1+1,min(ii1+5,9*nat))
        ii1=ii1+5
        if(ii1.lt.9*nat) goto 8004
        do 37 ii1=1,6
        do 37 ii2=1,3*n
        ix=iaa(ii1)
        iy=jaa(ii1)
        iz=mod(ii2-1,3)+1
        iat=(ii2+2)/3
        AA(ix,iy,iz,iat)=xg09(ii1,ii2)*1.50d0
37      AA(iy,ix,iz,iat)=xg09(ii1,ii2)*1.50d0
        if(ltthere)then
         open(22,file='FILE.TTT')
         CALL WRITETTT(N,NAT,ALPHA,GG,AA)
         close(22)
         call w36(' A written into FILE.TTT')
        endif
       ENDIF

      endif
c
      READ(2,7000,END=8888)(BUFF(I),I=NB+1,2*NB)
c     write(6,7000)        (BUFF(I),I=NB+1,2*NB)
      ltot=ltot+1
      BACKSPACE 2
      ltot=ltot-1
      DO 51 I=1,2*NB-5
      DO 52 J=1,5
52    SSTR(J:J)=BUFF(I+J-1)
c
c     end of archive:
      IF(SSTR(1:4).EQ.']\\\\\@'.or.SSTR(1:4).EQ.']\\@')return
      IF(SSTR(1:4).EQ.']\|\|\@'.or.SSTR(1:4).EQ.']||@')return
c
      IF(SSTR(1:2).EQ.'\\\\'.or.SSTR(1:2).eq.'\\'.
     1or.SSTR(1:2).eq.'||')LARCH=.TRUE.
      IF(SSTR.EQ.'leDer'.and.BUFF(I-4).eq.'D')THEN
       write(3,*)'Atomic polar tensor found',ltot,I
       IF(.NOT.LARCH)GOTO 5444
       if(ltot.eq.ltot0.and.I.eq.col)then
        write(6,*)'short line'
        goto 5444
       endif
       ltot0=ltot
       col=I
       GOTO 6555
      ENDIF
      IF(SSTR(2:5).EQ.'\\AAT'.or.SSTR(2:5).eq.'\AAT')THEN
       IF(.NOT.LARCH)GOTO 5444
       WRITE(3,*)' Atomic axial tensor found'
       LVCD=.TRUE.
       GOTO 9555
      ENDIF
      IF(SSTR.EQ.'arDer')THEN
       IF(.NOT.LARCH)GOTO 5444
       WRITE(3,*)' Polarization Derivatives found'
       if(.not.lg09alpha)then
        GOTO 8555
       else
        WRITE(3,*)' Skipped because g09 present'
       endif
      ENDIF
C     NImag for g94, NIMAG for g92
      IF(SSTR.EQ.'NImag'.OR.SSTR.EQ.'NIMAG')THEN
       IF(.NOT.LARCH)GOTO 5444
       WRITE(3,*)' Second derivatives found'
       lff=.true.
       GOTO 5555
      ENDIF
      IF(SSTR.EQ.'\\Pola'.and..not.lpolar.and..not.lg09polar)THEN
       IF(.NOT.LARCH)GOTO 5444
       WRITE(3,*)' Polarizability found'
       lpolar=.true.
       GOTO 44555
      ENDIF
      IF(SSTR.EQ.'pole='.and..not.ldip)THEN
       IF(.NOT.LARCH)GOTO 5444
       WRITE(3,*)' Dipole in archive'
       ldip=.true.
       GOTO 4555
      ENDIF
      IF((.NOT.LGEO).AND.SSTR(1:2).EQ.LG)THEN
       IF(.NOT.LARCH)GOTO 5444
       call w36(' Geometry found')
       LGEO=.TRUE.
       GOTO 7555
      ENDIF
      IF(SSTR.EQ.'olDer')THEN
       IF(.NOT.LARCH)GOTO 5444
       WRITE(3,*)' A-tensor Derivatives found'
       if(.not.lg09a)then
        GOTO 11555
       else
        WRITE(3,*)' Skipped becuse g09 present'
       endif
      ENDIF
      IF(SSTR.EQ.'otDer')THEN
       IF(.NOT.LARCH)GOTO 5444
       WRITE(3,*)' G-tensor Derivatives found'
       if(.not.lg09g)then
        GOTO 10555
       else
        WRITE(3,*)' Skipped becuse g09 present'
       endif
      ENDIF
51    CONTINUE
c
      GOTO 5444
C
7555  I=I+1
C     I .. index of the letter to be gotten
      IF(I.GT.NB)THEN
       DO 74 K=1,NB
74     BUFF(K)=BUFF(K+NB)
       I=I-NB
       READ(2,*)
       ltot=ltot+1
      ENDIF
      DO 73 IA=1,NAT
C
C     Get element:
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      AT(IA)=L
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
C
      DO 773 IX=1,3
C     READ X(IX,IA):
      DO 75 J=1,20
75    NUMBER(J)=' '
      IN=0
7558  IN=IN+1
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      NUMBER(IN)=L
      IF(L.NE.','.AND.L.NE.'\'.AND.L.NE.'|'.AND.L.NE.'\\')GOTO 7558
      NUMBER(IN)=' '
      do j=1,20
       s20(j:j)=NUMBER(j)
      enddo
      read(s20,*)X(IX,IA)
773   CONTINUE
73    CONTINUE
c
      if(.not.lx)then
       lx=.true.
       open(20,file='FILEA.X')
       WRITE(20,*)' FILE.X from Gaussian archive'
       WRITE(20,*)NAT
       DO 777 IA=1,NAT
       K=0
       IF(AT(IA).EQ.'C')K=6
       IF(AT(IA).EQ.'O')K=8
       IF(AT(IA).EQ.'N')K=7
       IF(AT(IA).EQ.'H')K=1
       IF(AT(IA).EQ.'S')K=16
       IF(AT(IA).EQ.'P')K=15
       IF(K.EQ.0)WRITE(*,*)' Unknown atom ',AT(IA)
777    WRITE(20,1501)K,(X(IX,IA),IX=1,3)
1501   FORMAT(I4,3F15.8,' 0 0 0 0 0 0 0 0.0')
       WRITE(3,*)' Archive X written into FILEA.X'
       WRITE(6,*)' Archive X written into FILEA.X'
       close(20)
      endif
c
      BACKSPACE 2
      ltot=ltot-1
      GOTO 5444
C
C
C     Polarization derivatives
8555  I=I+1
C     I .. index of the letter to be gotten
      IF(I.GT.NB)THEN
       DO 78 K=1,NB
78     BUFF(K)=BUFF(K+NB)
       I=I-NB
       READ(2,*)
       ltot=ltot+1
      ENDIF
8556  I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      IF(L.NE.LE)GOTO 8556
      DO 80 IA=1,N
      DO 80 IX=1,3
      DO 80 IY=1,IX
C
C     READ ALPHA(IX,IY,IA)
      DO 79 J=1,20
79    NUMBER(J)=' '
      IN=0
8558  IN=IN+1
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      NUMBER(IN)=L
      IF(L.NE.','.AND.L.NE.'\\'.AND.L.NE.'\'.AND.L.NE.'|')GOTO 8558
      NUMBER(IN)=' '
      do j=1,20
       s20(j:j)=NUMBER(j)
      enddo
      read(s20,*)FU
      ALPHA(IY,IX,IA)=FU
80    ALPHA(IX,IY,IA)=FU
      if(.not.lttt)then
       lttt=.true.
       inquire(file='FILE.TTT',exist=lram)
       if(lram)then
        call w36('FILE.TTT found, not overwritten')
       else
        open(22,file='FILE.TTT')
        CALL WRITETTT(N,NAT,ALPHA,GG,AA)
        close(22)
        call w36(' ALPHA written into FILE.TTT')
        ltthere=.true.
c       ltthere ... FILE.TTT is written at disk at this reading
       endif
      endif
      BACKSPACE 2
      ltot=ltot-1
      GOTO 5444
C
C     Dipole derivatives
6555  I=I+4
C     I .. index of the letter to be gotten
      IF(I.GT.NB)THEN
       DO 54 K=1,NB
54     BUFF(K)=BUFF(K+NB)
       I=I-NB
       READ(2,*)
       ltot=ltot+1
      ENDIF
6556  I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      IF(L.NE.LE)GOTO 6556
      DO 53 IA=1,NAT
      DO 53 IX=1,3
      DO 53 IY=1,3
C
C     READ P(IA,IX,IY):
      DO 55 J=1,20
55    NUMBER(J)=' '
      IN=0
6558  IN=IN+1
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      NUMBER(IN)=L
      IF(L.NE.','.AND.L.NE.'\\'.AND.L.NE.'\'.AND.L.NE.'|')GOTO 6558
      NUMBER(IN)=' '
      do j=1,20
       s20(j:j)=NUMBER(j)
      enddo
      read(s20,*)FU
53    P(IA,IX,IY)=FU
      if(.not.lapt)then
       lapt=.true.
       if(lten)then
        write(6,*)'FILE.TEN found on disk, not overwritten'
        write(3,*)'FILE.TEN found on disk, not overwritten'
       else
        open(21,file='FILE.TEN')
        CALL WRITETEN(NT0,P,AAT,LVCD,NAT)
        close(21)
        write(3,*)' Atomic polar tensor written into FILE.TEN'
        write(6,*)' Atomic polar tensor written into FILE.TEN'
       endif
      endif
      BACKSPACE 2
      ltot=ltot-1
      GOTO 5444
C
C     Magnetic dipole derivatives
9555  I=I+J-2
C     I .. index of the letter to be gotten
      IF(I.GT.NB)THEN
       DO 56 K=1,NB
56     BUFF(K)=BUFF(K+NB)
       I=I-NB
       READ(2,*)
       ltot=ltot+1
      ENDIF
9556  I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      IF(L.NE.LE)GOTO 9556
      DO 58 IA=1,NAT
      DO 58 IX=1,3
      DO 58 IY=1,3
C
C     READ AAT(IA,IX,IY):
      DO 59 J=1,20
59    NUMBER(J)=' '
      IN=0
9558  IN=IN+1
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      NUMBER(IN)=L
      IF(L.NE.','.AND.L.NE.'\\'.AND.L.NE.'\'.AND.L.NE.'|')GOTO 9558
      NUMBER(IN)=' '
      do j=1,20
       s20(j:j)=NUMBER(j)
      enddo
      read(s20,*)FU
58    AAT(IA,IX,IY)=FU
      if(.not.laat)then
       laat=.true.
       if(lten)then
        write(6,*)'FILE.TEN found on disk, AAT not written'
        write(3,*)'FILE.TEN found on disk, AAT not written'
       else
        open(21,file='FILE.TEN')
        CALL WRITETEN(NT0,P,AAT,LVCD,NAT)
        close(21)
        write(3,*)' Tensors written into FILE.TEN'
        write(6,*)' Tensors written into FILE.TEN'
       endif
      endif
      BACKSPACE 2
      ltot=ltot-1
      GOTO 5444
C
C     Dipole
4555  I=I+3
C     I .. index of the letter to be gotten
      IF(I.GT.NB)THEN
       DO 57 K=1,NB
57     BUFF(K)=BUFF(K+NB)
       I=I-NB
       READ(2,*)
       ltot=ltot+1
      ENDIF
9557  I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      IF(L.NE.LE)GOTO 9557
      DO 60 IY=1,3
C
C     READ m(IY):
      DO 61 J=1,20
61    NUMBER(J)=' '
      IN=0
9559  IN=IN+1
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      NUMBER(IN)=L
      IF(L.NE.','.AND.L.NE.'\\'.AND.L.NE.'\'.AND.L.NE.'|')GOTO 9559
      NUMBER(IN)=' '
      do j=1,20
       s20(j:j)=NUMBER(j)
      enddo
      read(s20,*)FU
60    dip(IY)=FU
      BACKSPACE 2
      ltot=ltot-1
      GOTO 5444
C
C     Polarizability
44555 I=I+3
C     I .. index of the letter to be gotten
      IF(I.GT.NB)THEN
       DO K=1,NB
        BUFF(K)=BUFF(K+NB)
       ENDDO
       I=I-NB
       READ(2,*)
       ltot=ltot+1
      ENDIF
9551  I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      IF(L.NE.LE)GOTO 9551
      DO 70 IY=1,3
      DO 70 IX=1,IY
C
C     READ a(IX,IY):
      DO 71 J=1,20
71    NUMBER(J)=' '
      IN=0
9552  IN=IN+1
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      NUMBER(IN)=L
      IF(L.NE.','.AND.L.NE.'\\'.AND.L.NE.'\'.AND.L.NE.'|')GOTO 9552
      NUMBER(IN)=' '
      do j=1,20
       s20(j:j)=NUMBER(j)
      enddo
      read(s20,*)polar(IX,IY)
70    polar(IY,IX)=polar(IX,IY)
      BACKSPACE 2
      ltot=ltot-1
      GOTO 5444
C
C     G' derivatives
10555 I=I+J-1
C     I .. index of the letter to be gotten
      IF(I.GT.NB)THEN
       DO 786 K=1,NB
786    BUFF(K)=BUFF(K+NB)
       I=I-NB
       READ(2,*)
      ENDIF
85561 I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      IF(L.NE.LE)GOTO 85561
      DO 801 IA=1,N
      DO 801 IX=1,3
      DO 801 IY=1,3
C
C     READ G'(IX,IY,IA)
      DO 791 J=1,20
791   NUMBER(J)=' '
      IN=0
85581 IN=IN+1
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      NUMBER(IN)=L
      IF(L.NE.','.AND.L.NE.'\\'.AND.L.NE.'\')GOTO 85581
      NUMBER(IN)=' '
      REWIND 8
      WRITE(8,*)(NUMBER(J),J=1,20)
      REWIND 8
      READ(8,*)FU
801   GG(IX,IY,IA)=FU
      if(ltthere)then
       open(22,file='FILE.TTT')
       CALL WRITETTT(N,NAT,ALPHA,GG,AA)
       close(22)
       call w36(' G written into FILE.TTT')
      endif
      BACKSPACE 2
      GOTO 5444
C
C
C     A (dipole-quadrupole) derivatives
11555 I=I+4
C     I .. index of the letter to be gotten
      IF(I.GT.NB)THEN
       DO 787 K=1,NB
787    BUFF(K)=BUFF(K+NB)
       I=I-NB
       READ(2,*)
      ENDIF
85562 I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      IF(L.NE.LE)GOTO 85562
      DO 802 IA=1,N
      DO 802 IZ=1,3
      DO 802 I6=1,6
      IX=iaa(I6)
      IY=jaa(I6)
C
C     READ A(IX,IY,IZ,IA)
      DO 792 J=1,20
792   NUMBER(J)=' '
      IN=0
85582 IN=IN+1
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      NUMBER(IN)=L
      IF(L.NE.','.AND.L.NE.'\\'.AND.L.NE.'\')GOTO 85582
      NUMBER(IN)=' '
      REWIND 8
      WRITE(8,*)(NUMBER(J),J=1,20)
      REWIND 8
      READ(8,*)FU
      AA(IY,IX,IZ,IA)=FU*1.5d0
802   AA(IX,IY,IZ,IA)=FU*1.5d0
      inquire(file='FILE.TTT',exist=lram)
      if(ltthere)then
       open(22,file='FILE.TTT')
       CALL WRITETTT(N,NAT,ALPHA,GG,AA)
       close(22)
       call w36(' A written into FILE.TTT')
      endif
      BACKSPACE 7
      GOTO 5444
C
C     Force Field:
5555  I=I+1
C     I .. index of the letter to be gotten
      IF(I.GT.70)THEN
       DO 4 K=1,70
4      BUFF(K)=BUFF(K+70)
       I=I-70
       READ(2,*)
       ltot=ltot+1
      ENDIF
C     NB .. line length
5556  I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      IF(L.NE.'\'.and.L.NE.'|'.and.L.ne.'\\')GOTO 5556
5557  I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      IF(L.NE.'\'.and.L.ne.'\\'.and.L.NE.'|')GOTO 5557
      DO 3 IX=1,N
      DO 3 IY=1,IX
C
C     READ F(IX,IY):
      DO 5 J=1,20
5     NUMBER(J)=' '
      IN=0
5558  IN=IN+1
      I=I+1
      CALL GETLET(ltot,L,BUFF,NB)
      NUMBER(IN)=L
      IF(L.NE.','.AND.L.NE.'\\'.AND.L.NE.'\'.AND.L.NE.'|')GOTO 5558
      NUMBER(IN)=' '
      do j=1,20
       s20(j:j)=NUMBER(j)
      enddo
      read(s20,*)FU
      F(IX,IY)=FU
3     F(IY,IX)=FU
      if(.not.lfc)then
       lfc=.true.
       if(.not.lfcd)then
        open(21,file='FILE.FC')
        CALL WRITEFF(NT3,N,F)
        close(21)
        write(3,*)' Force field written into FILE.FC'
        write(6,*)' Force field written into FILE.FC'
       else
        write(3,*)' FILE.FC left on disk unchanged'
        write(6,*)' FILE.FC left on disk unchanged'
       endif
      endif
      return
C
8888  call w36('End of file encountered')
      return
      END

      SUBROUTINE WRITEFF(MX3,N,FCAR)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FCAR(MX3,N)
C     CONST=4.359828/0.5291772**2
c     CONST=1.0
      N1=1
1     N3=N1+4
      IF(N3.GT.N)N3=N
      DO 130 LN=N1,N
130   WRITE(21,17)LN,(FCAR(LN,J),J=N1,MIN(LN,N3))
      N1=N1+5
      IF(N3.LT.N)GOTO 1
17    FORMAT(I4,5D14.6)
      RETURN
      END
c
      SUBROUTINE WRITEFF2(MX3,N,FCAR)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FCAR(MX3,N)
      CONST=4.359828d0/0.5291772d0**2
      N1=1
1     N3=N1+4
      IF(N3.GT.N)N3=N
      DO 130 LN=N1,N
130   WRITE(21,17)LN,(FCAR(LN,J)/CONST,J=N1,MIN(LN,N3))
      N1=N1+5
      IF(N3.LT.N)GOTO 1
17    FORMAT(I4,5D14.6)
      RETURN
      END
c
      SUBROUTINE READFF(MX3,N,FCAR)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FCAR(MX3,N)
      N1=1
1     N3=N1+4
      IF(N3.GT.N)N3=N
      DO 130 i=N1,N
130   READ(21,*)FCAR(i,N1),(FCAR(i,J),J=N1,MIN(i,N3))
      N1=N1+5
      IF(N3.LT.N)GOTO 1
      do 2 i=1,n
      do 2 j=1,i-1
2     FCAR(j,i)=FCAR(i,j)
      RETURN
      END
c
      SUBROUTINE GETLET(ltot,L,BUFF,NB)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*1 BUFF(*)
      CHARACTER*1 L
      COMMON/LINE/I
      IF(I.GT.NB)THEN
       IF(I.GT.NB+1)THEN
        write(6,7000)(BUFF(J),J=1,70)
        WRITE(*,*)' Cannot read letter ',I
        STOP
       ENDIF
       I=1
       READ(2,7000)(BUFF(J),J=1,70)
       ltot=ltot+1
7000   FORMAT(1X,70A1)
      ENDIF
      L=BUFF(I)
      RETURN
      END

      SUBROUTINE WRITETEN(N0,P,A,LVCD,NAT)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION P(N0,3,3),A(N0,3,3)
      LOGICAL LVCD
      Z0=0.0d0
      WRITE(21,1500) NAT,NAT-6,0
1500  FORMAT(3I5)
      DO 10 L=1,NAT
      DO 10 J=1,3
10    WRITE(21,1501) (P(L,J,I),I=1,3),L
1501  FORMAT(3F14.8,I5,' (APT)')
1502  FORMAT(3F14.8,I5,' (AAT)')
1503  FORMAT(3F14.8,I5,' (AAT),nuclear part not used')
1504  FORMAT(3F14.8,I5,' (APT-velocity)')
      IF(.NOT.LVCD)THEN
       DO 220 L=1,NAT
       DO 220 J=1,3
220    WRITE(21,1502) (Z0,I=1,3),L
      ELSE
       DO 221 L=1,NAT
       DO 221 J=1,3
221    WRITE(21,1502) (A(L,J,I),I=1,3),L
      ENDIF
      DO 230 L=1,NAT
      DO 230 J=1,3
230   WRITE(21,1503) (Z0,I=1,3),L
      DO 100 L=1,NAT
      DO 100 J=1,3
100   WRITE(21,1504) (P(L,J,I),I=1,3),L
      RETURN
      END
C
      SUBROUTINE WRITETTT(N,NAT,ALPHA,G,A)
c     A is not multiplied by 3/2 here
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION ALPHA(3,3,N),G(3,3,N),A(3,3,3,N)
c
      WRITE(22,2000)NAT
2000  FORMAT(' ROA tensors, cartesian derivatives',/,I4,' atoms',/,
     1' The electric-dipolar electric-dipolar polarizability:',/,
     2' Atom/x    jx           jy           jz')
      DO 1 I=1,3
      WRITE(22,2002)I
2002  FORMAT(' Alpha(',I1,',J):')
      DO 1 L=1,NAT
      DO 1 IX=1,3
      IIND=3*(L-1)+IX
1     WRITE(22,2001)L,IX,(ALPHA(I,J,IIND),J=1,3)
2001  FORMAT(I5,1H ,I1,3F13.7)
      WRITE(22,2004)
2004  FORMAT(' The electric dipole magnetic dipole polarizability:',/,
     1       ' Atom/x    jx           jy           jz')
      DO 2 I=1,3
      WRITE(22,2003)I
2003  FORMAT(' G(',I1,',J):')
      DO 2 L=1,NAT
      DO 2 IX=1,3
      IIND=3*(L-1)+IX
2     WRITE(22,2001)L,IX,(G(I,J,IIND),J=1,3)
      WRITE(22,2005)
2005  FORMAT(' The electric dipole electric quadrupole polarizability:',
     2/,     ' Atom/x    kx           ky           kz')
      DO 3 I=1,3
      DO 3 J=1,3
      WRITE(22,2006)I,J
2006  FORMAT(' A(',I1,',',I1,',K):')
      DO 3 L=1,NAT
      DO 3 IX=1,3
      IIND=3*(L-1)+IX
3     WRITE(22,2001)L,IX,(A(K,J,I,IIND),K=1,3)
      WRITE(22,*)
      WRITE(22,*)
      DO 4 I=1,3
      WRITE(22,2002)I
      DO 4 L=1,NAT
      DO 4 IX=1,3
      IIND=3*(L-1)+IX
4     WRITE(22,2001)L,IX,(ALPHA(I,J,IIND),J=1,3)
      RETURN
      END

      SUBROUTINE READAR0(N0,N,F,APT,AAT,ALPHA,dip,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      include 'dimensions.h'
      DIMENSION F(N0,N),APT(NT0,3,3),ALPHA(3,3,NT3),AAT(NT0,3,3),dip(3),
     1polar(3,3),GG(3,3,NT3),AA(3,3,3,NT3),gten(3,3),aten(3,3,3),
     1ajm(NT0,NT0),sigma(*)
      nat=n/3
      if(nat.gt.NT0)then
       write(6,*)nat,NT0
       call report('Too many atoms')
      endif
      optrot=0.0d0
      DO 80 IX=1,3
      dip(IX)=0.0d0
      DO 80 IY=1,3
      polar(IX,IY)=0.0d0
      gten(IX,IY)=0.0d0
      DO 81 IYY=1,3
81    aten(IX,IY,IYY)=0.0d0
      DO 80 IA=1,NAT
      AAT(IA,IX,IY)=0.0d0
      APT(IA,IX,IY)=0.0d0
      DO 80 IZ=1,3
      GG(IX,IY,3*(IA-1)+IZ)=0.0d0
      ALPHA(IX,IY,3*(IA-1)+IZ)=0.0d0
      DO 80 IU=1,3
80    AA(IX,IY,IU,3*(IA-1)+IZ)=0.0d0
      DO 2 IX=1,N
      DO 2 IY=1,N
2     F(IY,IX)=0.0d0
      DO 3 IX=1,NAT
      sigma(IX)=0.0d0
      sigma(IX+NAT)=0.0d0
      DO 3 IY=1,NAT
3     ajm(IY,IX)=0.0d0
      return
      END
