      SUBROUTINE READDIFF(NAT,LINEAR,N,FCAR0,S,
     1AM,N7,R,step,tol4,tol3,NCAN,ICAN,XLIM)
c     from readg98i, but orderred 0,1-,1+,2-,2+ etc outputs in diff
c     directory
      IMPLICIT none
      integer*4 NAT,N,N7,i,j,k,l,ix,II,IDUM,IA,IC,ig98,
     1NINDC,imax,jmax,kmax,imx,jmx,kmx,NQ,NQT,ltot,ind,ind1,ind2,iq,
     1JJ,is,istart,ndif
      include 'dimensions.h'
      CHARACTER*50 S50
      CHARACTER*10 s10
      CHARACTER*2 atsym
      integer*4 iz(NT0),NCAN,ICAN(*),modemap(NT3),nml(NT3)
      real*8 FCAR0(NT3,NT3),FCAR(NT3,NT3),AM(NT3),R(NT0,3),APT(NT0,3,3),
     1XLIM,AAT(NT0,3,3),ALPHA(3,3,NT3),APT0(NT0,3,3),aptn(2*NT3,3),
     1AAT0(NT0,3,3),ALPHA0(3,3,NT3),dip(3),dip0(3),polar(3,3),
     1polar0(3,3),alphan(3,3,2*NT3),S(NT3,NT3),FQ(NT3,NT3),FQ0(NT3,NT3),
     1ALPHAA(NT3**2,9),GG(3,3,NT3),AA(3,3,3,NT3),APTQ(NT3,3),
     1GGA(NT3**2,9),AAA(NT3**2,27),AATQ(NT3,3),amave,
     1GG0(3,3,NT3),AA0(3,3,3,NT3),A0Q(3,3,3,NT3),
     1AAQ(3,3,3,NT3),ALPHAQ(3,3,NT3),ALPHA0Q(3,3,NT3),
     1rc(NT0,3),APT0Q(NT3,3),AAT0Q(NT3,3),
     1GQ(3,3,NT3),G0Q(3,3,NT3),gten(3,3),gten0(3,3),
     1aten(3,3,3),aten0(3,3,3),ajm(NT0,NT0),sigma(NT0*2),
     1sigmaq(2*NT3,NT0*2),
     1ajm0(NT0,NT0),sigma0(NT0*2),optrot,optrot0,optrotq(2*NT3),
     1aptaq(2*NT3**2,3),aataq(2*NT3**2,3),bohr,cm,SFACR,f1,f2,E,tol4,
     1tol3,step,ASS,ff,ei,ej,dd,dm,c0,cqau,cqcn,cqcm
c     large arrays:
      real*8,allocatable:: CX3(:,:,:),CX4(:,:,:),ajmq(:,:,:),G(:)
c     CX3(NT3,NT3,NT3) third energy derivatives
c     CX4(NT3,NT3,NT3) fourth energy derivatives
c     ajmq(2*NT3,NT0,NT0) spin-spin constant derivatives

      LOGICAL lex,lttt,lfc,lx,lff,lgr,
     1LINEAR,lapt,laat,lten,lfcd,lnmr,ljj,loptrot,lpolar
      COMMON/CEM/E(NT3)
      logical lzmat,lharm,lopt
      common/lop/lopt(300)
      equivalence (lharm,lopt(9)),(lzmat,lopt(10))
C
      call w36('Readdiff')
      call w36('^^^^^^^^')
      call w36('        ')

      bohr=0.529177d0
      cm=219470.0d0
      SFACR=0.02342179d0
c           =1/sqrt(amu), to transfer S into atomic units
c
c     Unit explanation:
c     -----------------
c     dX ... Cartesian coordinate displacement
c     dQ ... normal mode coordinate
c     dX = S.dQ
c     S ... S-matrix written into FILE.INP
c     St.M.S=1, M is the mass matrix in g/mol
c     s=SFACR.S, s is then in atomic units, is written in SMAT.SCR
c     si.FF.sj=delta(i,j)*ei^2, ei is the normal mode energy in a.u.
c     q ... dimensionless normal mode coordinate, qi=sqrt(ei) Qi
c

      inquire(file='FILE.TEN',exist=lten)
      inquire(file='FILE.FC',exist=lfcd)
C
c     find geometry-zero point
      OPEN(2,FILE='diff/0/FREE.OUT',status='old')
      write(6,*)' Looking for geometry'
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       write(6,1111)S50
       write(3,1111)S50
       DO 41 I=1,4
41     READ(2,*)
       l=0
5      READ(2,1111)s50
       IF(s50(2:4).NE.'---')THEN
        l=l+1
        BACKSPACE 2
        if(ig98.eq.0)then
         READ(2,*)IA,iz(l),(r(l,i),i=1,3)
        else
         READ(2,*)IA,iz(l),IDUM,(r(l,i),i=1,3)
        endif
        GOTO 5
       ENDIF
       nat=l
       write(3,*)nat
       open(20,file='FILE.X')
       write(20,*)nat
       write(20,*)nat
       do 34 l=1,nat
       write(20,4000)iz(l),(r(l,i),i=1,3)
34     write(3,4000)iz(l),(r(l,i),i=1,3)
4000   format(I3,3F15.10,' 0 0 0 0 0 0 0 0.0')
       close(20)
       goto 203
      ENDIF
      goto 201
202   call report('Geometry not found')
203   call w36(' ')
      call w36('Mass matrix:')
      allocate(G(3*nat))
      do 55 ia=1,nat
      atsym='??'
      ASS=amave(iz(IA),atsym)
c
c     assign default mass, if not defined previously:
      if(am(3*(IA-1)+1).lt.0.0d0)then
       DO 551 I=1,3
551    AM(3*IA-3+I)=ASS
      endif
55    continue
c
      WRITE(3,1113)(AM(i),i=1,3*nat)
1113  FORMAT(4F15.8)
      IF(NAT.EQ.2.OR.LINEAR)THEN
       WRITE(3,*)'Linear molecule'
       N7=6
       LINEAR=.TRUE.
      ENDIF
      N=3*nat
C
      inquire(file='CQQ.SCR.TXT',exist=lex)
      if(lex)then
       call w36('CQQ.SCR.TXT found on disk, rest of readg98i skipped')
       close(2)
       return
      endif
c
      IF(step.gt.1.0d-9)then
       write(3,3000)step,step/bohr
       write(6,3000)step,step/bohr
       step=step/bohr
3000   format('Step defined as ',F10.5,'A (',F10.5,'au)')
      endif
C
c     read-in zero point:
      lapt=.false.
      laat=.false.
      lttt=.false.
      lx=.false.
      lfc=.false.
      lff=.false.
      ltot=0
c
c     zero-out the tensors
      call readar0(NT3,N,FCAR0,APT0,AAT0,ALPHA0,dip0,polar0,GG0,AA0,
     1gten0,aten0,optrot0,ajm0,sigma0)
c
c     read current point from the output
      call readar(NT3,N,FCAR0,APT0,AAT0,ALPHA0,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip0,ltot,polar0,GG0,AA0,gten0,aten0,optrot0,
     1ajm0,sigma0,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      call w36('zero point finished')
      if(lapt)write(6,*)'APT found'
      if(laat)write(6,*)'AAT found'
      if(lttt)write(6,*)'TTT found'
      if(lfc)write(6,*)'FF found'
      if(lx)write(6,*)'X found'
      if(lgr)write(6,*)'Grad found'
      write(3,3700)(dip0(i),i=1,3)
      write(6,3700)(dip0(i),i=1,3)
3700  format(' Dipole         ',3F10.4)
      write(3,3705)((polar0(i,j),i=1,3),j=1,3)
      write(6,3705)((polar0(i,j),i=1,3),j=1,3)
3705  format(' Polarizability ',3F10.4,/,
     1       '                ',3F10.4,/,
     1       '                ',3F10.4)
      if(ljj)then
       call w36('Spin-Spin Coupling')
       call WRITEM(3,NT0,N/3,ajm0)
       call WRITEM(6,NT0,N/3,ajm0)
      endif
      if(lnmr)then
       call w36('Chemical Shifts  Anisotropies')
c      sigma - holds both isotropic and anisotropic part
       do 3701 I=1,N/3
       write(3,3702)I,sigma0(I),sigma0(I+N/3)
3701   write(6,3702)I,sigma0(I),sigma0(I+N/3)
3702   format(i4,2f15.6)
      endif
      if(loptrot)then
       call w36('Optical Rotation')
       write(3,3703)optrot0
       write(6,3703)optrot0
3703   format(f10.2)
      endif

      close(2)
c
c     transform Cartesian FF into normal modes:
      call trafoq(FCAR0,FQ0,S,N)
c
c     transform dipole derivatives into normal modes
      call trafopq(APT0,AAT0,APT0Q,AAT0Q,S,N)
c
c     transform polarizability derivatives into normal modes
      call trafoaq(ALPHA0,GG0,AA0,ALPHA0Q,G0Q,A0Q,S,N)
c
      is=0
      allocate(CX3(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX3')
      allocate(CX4(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX4')
      allocate(ajmq(1:2*N,1:NAT,1:NAT),stat=is)
      if(is.ne.0)call report('cannot allocate ajmq')

c     zero-out/initialize anharmonic variables:
      DO 1 I=1,N
      DO 1 J=1,N
      DO 1 K=1,N
      CX3(I,J,K)=0.0d0
1     CX4(I,J,K)=0.0d0
c
      if(lapt.or.laat)then
       DO 541 II=1,2*N
       DO 541 JJ=1,N
       DO 541 K=1,3
       aataq(     II+(JJ-1)*N,K)=0.0d0
541    aptaq(     II+(JJ-1)*N,K)=0.0d0
      endif
c
      if(lttt)then
       DO 542 II=1,N**2
       DO 542 J=1,9
       ALPHAA(II,J)=0.0d0
542    GGA(II,J)=0.0d0
       DO 5421 II=1,N**2
       DO 5421 J=1,27
5421   AAA(II,J)=0.0d0
      endif
      do 547 i=1,2*N
      do 547 k=1,3
547   aptn(i,k)=0.0d0
      do 552 i=1,2*N
      do 552 k=1,3
      do 552 l=1,3
552   alphan(k,l,i)=0.0d0
c
c     first derivatives and diagonal second dervs:
      if(loptrot)then
       do 554 i=1,2*N
554    optrotq(i)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(lnmr)then
       do 555 i=1,2*N
       do 555 j=1,2*N/3
555    sigmaq(i,j)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(ljj)then
       do 556 i=1,2*N
       do 556 j=1,N/3
       do 556 k=1,N/3
556    ajmq(i,j,k)=0.0d0
      endif
c
c     start to read the shifted geometries:
      IC=0
      do 7 i=1,N
7     modemap(i)=0
c     333333333333333333333333333333333333333333333333333333333333
3333  IC=IC+1
      write(s10,'(I10)')IC
      do 8 istart=1,len(s10)
8     if(s10(istart:istart).ne.' ')goto 6
6     inquire(file='diff/'//s10(istart:len(s10))//'/FREE.OUT',exist=lex)
      if(.not.lex)then
       call w36('end of differentiation')
       if(IC.eq.1)call report('not enough points found')
       goto 33331
      endif

      open(2,file='diff/'//s10(istart:len(s10))//'/FREE.OUT')
c     read geometry and check the diff. step:
      open(21,file='diff/'//s10(istart:len(s10))//'/t.inp')
      read(21,'(I4)')I
      close(21)
      I=N-I+1

      call chkgeod(r,nat,lzmat,step,S,rc,I,ff)
      modemap(I)=modemap(I)+1
c
c     initialize second derivatives:
      if(modemap(I).eq.1)then
       DO 56 J=1,N
       DO 56 K=1,N
56     CX4(I,J,K)=-2.0d0*FQ0(J,K)
       if(lapt.or.laat)then
        DO 57 JJ=1,N
        DO 57 K=1,3
57      aptaq(N**2+I+(JJ-1)*N,K)=-2.0d0*APT0Q(JJ,K)
       endif
       do 58 k=1,3
58     aptn(I+N,k)=-2.0d0*dip0(k)
       do 59 k=1,3
       do 59 l=1,3
59     alphan(k,l,I+N)=-2.0d0*polar0(k,l)
       if(loptrot)optrotq(N+I)=-2.0d0*optrot0
       if(lnmr)then
        do 60 i=1,N
60      sigmaq(N+i,j)=-2.0d0*sigma0(j)
       endif
       if(ljj)then
        do 61 j=1,N/3
        do 61 k=1,N/3
61      ajmq(N+I,j,k)=-2.0d0*ajm0(j,k)
       endif
      endif
c
c     zero-out variables:
      call readar0(NT3,N,FCAR,APT,AAT,ALPHA,dip,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma)
c
c     read-in current values:
      call readar(NT3,N,FCAR,APT,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,optrot,
     1ajm,sigma,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      write(3,3700)(dip(j),j=1,3)
      write(3,3705)((polar(k,j),k=1,3),j=1,3)
      if(ljj)then
       write(3,*)'Spin-Spin Coupling'
       call WRITEM(3,NT0,N/3,ajm)
      endif
      if(lnmr)then
       write(3,*)'Chemical Shifts Anisotropies'
       do 3704 j=1,N/3
3704   write(3,3702)j,sigma(j),sigma(j+N/3)
      endif
      if(loptrot)then
       write(3,*)'Optical Rotation'
       write(3,3703)optrot
      endif
c
c     transform Cartesian derivatives to normal modes:
      call trafoq(FCAR,FQ,S,N)
      call trafopq(APT,AAT,APTQ,AATQ,S,N)
      call trafoaq(ALPHA,GG,AA,ALPHAQ,GQ,AAQ,S,N)
c
c     do the numerical differentiations:
      DO 3 J=1,N
      DO 3 K=1,N
      CX3(I,J,K)=CX3(I,J,K)+FQ(J,K)*ff
3     CX4(I,J,K)=CX4(I,J,K)+FQ(J,K)
c
      do 548 j=1,3
      aptn(I+N,j)=aptn(I+N,j)+dip(j)
548   aptn(I,j)=aptn(I,j)+ff*dip(j)
      do 553 j=1,3
      do 553 k=1,3
      alphan(j,k,I+N)=alphan(j,k,I+N)+polar(j,k)
553   alphan(j,k,I)=alphan(j,k,I)+ff*polar(j,k)
c
      if(lapt.or.laat)then
       DO 543 II=1,N
       DO 543 K=1,3
       ind=I+N*(II-1)
       aptaq(N**2+ind,K)=aptaq(N**2+ind,K)+APTQ(II,K)
       aptaq(ind,K)=aptaq(ind,K)+APTQ(II,K)*ff
543    aataq(ind,K)=aataq(ind,K)+AATQ(II,K)*ff
      endif
c
      if(lttt)then
       DO 544 II=1,N
       ind1=I+N*(II-1)
       DO 544 J=1,3
       DO 544 K=1,3
       ind2=J+3*(K-1)
       GGA(   ind1,ind2)=GGA(   ind1,ind2)+GQ(    J,K,II)*ff
       ALPHAA(ind1,ind2)=ALPHAA(ind1,ind2)+ALPHAQ(J,K,II)*ff
       DO 544 L=1,3
       ind2=J+3*(K-1)+9*(L-1)
544    AAA(   ind1,ind2)=AAA(   ind1,ind2)+AAQ(J ,K,L,II)*ff
      endif
c
      if(lnmr)then
       DO 545 II=1,2*N/3
       sigmaq(N+I,II)=sigmaq(N+I,II)+sigma(II)
545    sigmaq(I,II)=sigmaq(I,II)+sigma(II)*ff
      endif
c
      write(6,*)'11',N,nat
      if(ljj)then
       DO 546 II=1,N/3
       DO 546 JJ=1,N/3
       ajmq(N+I,II,JJ)=ajmq(N+I,II,JJ)+ajm(II,JJ)
546    ajmq(I,II,JJ)=ajmq(I,II,JJ)+ajm(II,JJ)*ff
      endif
c
      if(loptrot)then
       optrotq(I)=optrotq(I)+optrot*ff
       optrotq(N+I)=optrotq(N+I)+optrot
      endif

      close(2)
c
      goto 3333
33331 continue
      write(3,3001)(modemap(i),i=1,N)
      write(6,3001)(modemap(i),i=1,N)
3001  format(80i1)
c
C
      if(step.lt.1.0d-9)call report('Diff. step too small!')
c
c     dQ(in au)=step(current)/(bohr*SFAC)
c     CX4=[FF(+Q)+FF(-Q)-2FF]/dQ**2     CX3=[FF(+Q)-FF(-Q)]/(2dQ)
      f1=0.5d0* SFACR*bohr/step
      f2=1.0d0*(SFACR*bohr/step)**2
      DO 15 I=N7,N
      DO 15 J=1,N
      DO 15 K=1,N
      CX3(I,J,K)=CX3(I,J,K)*f1
15    CX4(I,J,K)=CX4(I,J,K)*f2

      DO 161 I=N7,N
      ei=sqrt(E(I))
      do 161 j=1,3
      aptn(I,j)=aptn(I,j)*f1/ei
      aptn(I+N,j)=aptn(I+N,j)*f2/ei/ei
      APT0Q(I,j)=APT0Q(I,j)/ei
161   AAT0Q(I,j)=AAT0Q(I,j)*ei
c
c     for tensor properties, write the derivatives (au) with respect to q:
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENQ.TXT.SCR found on disk, unchanged')
      else
       if(.not.lapt)then
c       if no analytical derivatives, then use numerical:
        DO 162 I=N7,N
        do 162 j=1,3
162     APT0Q(I,j)=aptn(I,j)
       endif
       call wrten11q(dip0,lapt,aptn,APT0Q,NT3,AAT0Q,N7,N)
      endif
c
      DO 18 I=N7,N
      ei=sqrt(E(I))
      DO 18 J=N7,N
      ej=sqrt(E(J))
      ind=I+N*(J-1)
      do 18 k=1,3
      aptaq(ind,k)=aptaq(ind,k)/ei/ej*f1
c
c     third dipolar derivatives uiij = u(N**2+i+(j-1)N)
      aptaq(N**2+ind,k)=aptaq(N**2+ind,k)/ei/ei/ej*f2
18    aataq(ind,k)=aataq(ind,k)/ei*ej*f1
c     aataq = i-index coordinate, J -momentum

      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENAQ.TXT.SCR found on disk, unchanged')
      else
       call wrten12q(N,aptaq,aataq,NT3,N7)
      endif
c
      DO 19 I=N7,N
      ei=sqrt(E(I))
      do 19 j=1,3
      do 19 k=1,3
      G0Q(j,k,I)=G0Q(j,k,I)/ei
      ALPHA0Q(j,k,I)=ALPHA0Q(j,k,I)/ei
      alphan(j,k,I)=alphan(j,k,I)*f1/ei
      do 19 l=1,3
19    A0Q(j,k,l,I)=A0Q(j,k,l,I)/ei

      call wrttq11(polar0,N7,N,ALPHA0Q,alphan,gten0,aten0,
     1G0Q,A0Q,NT3)


      do 23 i=N7,N
      ei=sqrt(E(i))
      do 23 j=i,N
      ej=sqrt(E(j))
      ind1=I+N*(J-1)
      ind2=J+N*(I-1)
      do 22 ix=1,9
      GGA(ind1,ix)   =0.5d0*(GGA(ind1,ix)   +GGA(ind2,ix)   )/ei/ej*f1
      GGA(ind2,ix)=GGA(ind1,ix)
      ALPHAA(ind1,ix)=0.5d0*(ALPHAA(ind1,ix)+ALPHAA(ind2,ix))/ei/ej*f1
22    ALPHAA(ind2,ix)=ALPHAA(ind1,ix)
      do 26 ix=1,27
      AAA(ind1,ix)   =0.5d0*(AAA(ind1,ix)   +AAA(ind2,ix)   )/ei/ej*f1
26    AAA(ind2,ix)=AAA(ind1,ix)
23    continue

      ndif=N-N7+1
      do 4001 i=1,ndif
4001  nml(i)=N7+i-1

      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTAQ.TXT.SCR found on disk, unchanged')
      else
       call wrttqaq(ndif,nml,N,NT3,ALPHAA,GGA,AAA)
      endif


      inquire(file='PROP.TXT.SCR',exist=lex)
      if(lex)then
       call w36('PROP.TXT.SCR exists, now overwritten')
      else
       open(21,file='PROP.TXT.SCR')
       write(21,*)N7,N
c
       if(loptrot)then
        write(21,*)loptrot
        write(21,2125)1,optrot0
2125    format('Optical rotation:',/,i5,/,20x,f10.2)
        do 27 i=N7,N
        if(e(i).le.0.0d0)then
         write(21,2126)i,0.0d0,0.0d0
        else
         write(21,2126)i,optrotq(i)*f1/dsqrt(e(i)),optrotq(N+i)*f2/e(i)
        endif
27      continue
2126    format(20x,i5,2g15.5)
       endif
c
       if(lpolar)then
        write(21,*)lpolar
        write(21,2132)9
2132    format('Polarizability:',/,i5)
        do 32 i=1,3
        do 32 j=1,3
32      write(21,21281)i,j,polar0(i,j)
        do 33 i=1,3
        do 33 j=1,3
        do 33 k=N7,N
        if(e(k).le.0.0d0)then
         write(21,2130)i,j,k,0.0d0,0.0d0
        else
         write(21,2130)i,j,k,alphan(i,j,k)*f1/dsqrt(e(k)),
     1   alphan(i,j,N+k)*f2/e(k)
        endif
33      continue
       endif
c
       if(lnmr)then
        write(21,*)lnmr
        write(21,2127)N/3
2127    format('Chemical shifts:',/,i5)
        do 28 i=1,N/3
28      write(21,2131)i,sigma0(i)
2131    format(i20,2g15.5)
        do 29 i=1,N/3
        do 29 j=N7,N
        if(e(j).le.0.0d0)then
         write(21,2128)i,j,0.0d0,0.0d0
2128     format(i20,i5,4g15.5)
        else
         write(21,2128)i,j,sigmaq(j,i)*f1/dsqrt(e(j)),
     1   sigmaq(N+j,i)*f2/e(j)
        endif
29      continue

        write(21,*)lnmr
        write(21,2133)N/3
2133    format('Shift Anisotropies:',/,i5)
        do 281 i=1,N/3
281     write(21,2131)i,sigma0(i+N/3)
        do 291 i=1,N/3
        do 291 j=N7,N
        if(e(j).le.0.0d0)then
         write(21,2128)i,j,0.0d0,0.0d0
        else
         write(21,2128)i,j,sigmaq(j,i+N/3)*f1/dsqrt(e(j)),
     1   sigmaq(N+j,i+N/3)*f2/e(j)
        endif
291     continue
       endif
c
       if(ljj)then
        write(21,*)ljj
        write(21,2129)N/3*N/3
2129    format('Spin-Spin Couplings:',/,i5)
        do 30 i=1,N/3
        do 30 j=1,N/3
30      write(21,21281)i,j,ajm0(i,j)
21281   format(2i10,g15.5)
        do 31 i=1,N/3
        do 31 j=1,N/3
        do 31 k=N7,N
        if(e(k).le.0.0d0)then
         write(21,2130)i,j,k,0.0d0,0.0d0
        else
         write(21,2130)i,j,k,ajmq(k,j,i)*f1/dsqrt(e(k)),ajmq(N+k,j,i)
     1   *f2/e(k)
        endif
31      continue
2130    format(2i10,i5,2g15.5)
       endif

       close(21)
       call w36('PROP.TXT.SCR')
      endif
c
      call readg98si(NAT,N,R,XLIM,step,1,tol3,N7,S)

      if(.not.lff)call report('force field not found')
c
      call w36(' ')
      call w36('Symmetrizing cubics')
      NINDC=0
      imax=0
      jmax=0
      kmax=0
      imx=0
      jmx=0
      kmx=0
      dd=0.0d0
      dm=0.0d0
      DO 152 I=N7,N
      DO 152 J=I,N
      DO 152 K=J,N
      c0=CX3(I,J,K)
      CX3(I,J,K)=(CX3(I,J,K)+CX3(I,K,J)+CX3(J,I,K)
     1+           CX3(J,K,I)+CX3(K,I,J)+CX3(K,J,I))/6.0d0
      if(dabs(c0-CX3(I,J,K)).gt.dd)then
       dd=dabs(c0-CX3(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
152   NINDC=NINDC+1
      write(6,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
      write(3,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
8989  format(' Largest assymetry:',3i3,' c =',g12.4,' dc =',g12.4)
      write(6,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
      write(3,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
1989  format(' Largest constant :',3i3,' c =',g12.4)
c
c     list cubics into text file
      open(23,file='CQQ.SCR.TXT')
      NQ=0
      nqt=0
      do 62 i=N7,N
      do 62 j=i,N
      do 62 k=j,N

c     skip if no differentiation:
      if(modemap(i).eq.0.or.modemap(j).eq.0.or.modemap(k).eq.0)goto 62

c     skip if mode blocked:
      do 4002 l=1,NCAN
4002  if(I-N7+1.eq.ICAN(l).or.J-N7+1.eq.ICAN(l).or.K-N7+1.eq.ICAN(l))
     1goto 62
c
c     skip for negative frequencies:
      if(e(i).le.0.0d0.or.e(j).le.0.0d0.or.e(k).le.0.0d0)goto 62

      cqau=CX3(I,J,K)
      cqcn=cqau/dsqrt(abs(e(i)*e(j)*e(k)))
      cqcm=cqcn*cm
c
c     skip small constants:
      if(abs(cqcm).lt.tol3)goto 62
c
      write(23,2423)I,J,K,cqcn,cqcm
2423  format(3I5,G16.8,' ',F9.1)
      nq=nq+1
62    nqt=nqt+1
      close(23)
      write(6,6000)nqt,nq,tol3
      write(3,6000)nqt,nq,tol3
6000  format('Number of normal cubics ',I10,/,
     1       'Selected                ',I10,/,
     1       'Limit                   ',F10.7,/,
     1       'Writen in CQQ.SCR.TXT',/)

      call w36(' ')
      call w36('Symmetrizing quartics')
      imax=0
      jmax=0
      kmax=0
      dd=0.0d0
      imx=0
      jmx=0
      kmx=0
      dm=0.0d0
      DO 153 I=N7,N
      DO 153 J=N7,N
      DO 153 K=J,N
      c0=CX4(I,J,K)
      if(j.eq.i)then
c      iii
       if(k.eq.i)then
c       iiii
       else
c       iiik iiki
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       endif
      else
c      iij
       if(k.eq.i)then
c       iiji iiji
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       else
        if(k.eq.j)then
c        iijj jjii
         CX4(I,J,K)=(CX4(I,J,K)+CX4(J,I,I))/2.0d0
         CX4(J,I,I)=CX4(I,J,K)
        else
c        iijk iikj
         CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
         CX4(I,K,J)=CX4(I,J,K)
        endif
       endif
      endif
      if(dabs(c0-CX4(I,J,K)).gt.dd)then
       dd=dabs(c0-CX4(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
153   continue
      write(6,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
      write(3,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
8985  format(' Largest assymetry:',4i3,' d =',g12.4,' dd =',g12.4)

      write(6,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
      write(3,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
2989  format(' Largest constant :',4i3,' d =',g12.4)
c
c     zero if no differentiation:
      do 621 i=n7,n
      do 621 j=n7,n
      do 621 k=j,n
621   if(modemap(i).eq.0.or.modemap(j).eq.0.or.modemap(k).eq.0)
     1CX4(i,j,k)=0.0d0
c     write sparse quartics
      call write4(CX4,N7,N,NCAN,ICAN,E,tol4)
c
      deallocate(CX3)
      deallocate(CX4)
      deallocate(ajmq)

      do 35 i=1,nat
      do 35 iq=1,N
      do 35 k=1,3
35    S(3*(i-1)+k,N-iq+1)=S(3*(i-1)+k,N-iq+1)/SFACR
c
      call w36('Readdiff-ok')
      RETURN
      END
c     ============================================================
      subroutine chkgeod(r,nat,lzmat,step,S,rc,iq,ff)
      implicit none
      integer*4 nat,ig98,I,l,ix,iq,ii
      include 'dimensions.h'
      real*8 r(NT0,3),step,rc(NT0,3),dq,S(NT3,NT3),cm,E,AM,
     1SFACR,bohr,ropt,geotol,ff
      COMMON/CEM/E(NT3)
      common/MASS/AM(NT3)
      common/opt/ropt(100)
      equivalence (geotol,ropt(20))
      character*50 S50
      logical lzmat
c
      cm=219470.0d0
      SFACR=0.02342179d0
      bohr=0.529177d0
      ff=0.0d0
c
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       DO 41 I=1,4
41     READ(2,*)
c
c      read current geometry
       DO 1 l=1,nat
       if(ig98.eq.0)then
        READ(2,*)I,I,(rc(l,ix),ix=1,3)
       else
        READ(2,*)I,I,I,(rc(l,ix),ix=1,3)
       endif
1      continue
c
c      Cartesian displacements from equilibrium
       DO 2 l=1,nat
       DO 2 ix=1,3
2      rc(l,ix)=rc(l,ix)-r(l,ix)
c
c      normal mode displacements
       dq=0.0d0
       do 4 l=1,nat
       do 4 ix=1,3
       ii=3*(l-1)+ix
4      dq=dq+AM(ii)*S(ii,iq)*rc(l,ix)
c
c      adapt to the strange pmz units dq=dq/SFACR:
       dq=dq/SFACR
       write(3,6000)iq,e(iq)*cm,dq,dq*SFACR/bohr
       write(6,6000)iq,e(iq)*cm,dq,dq*SFACR/bohr
6000   format('mode',i4,f10.2,' cm-1',' dQ =',f10.4,' au:',f10.4)
       if(dq.gt.0.0d0)then
        ff=1.0d0
       else
        ff=-1.0d0
       endif
       call chksti(dq,step)
       return
      ENDIF
      goto 201
202   call report('Geometry not found')
      end

      subroutine wrten11q(dip0,lapt,aptn,APT0Q,NT3,AAT0Q,N7,N)
      implicit none
      integer*4 I,j,NT3,N,N7
      logical lapt
      real*8 dip0(3),aptn(2*NT3,3),APT0Q(NT3,3),AAT0Q(NT3,3)
      logical lex
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENQ.TXT.SCR on disk, not overwritten')
       return
      endif
      open(9,file='TENQ.TXT.SCR')
      write(9,9001)(dip0(j),j=1,3)
9001  format(3f15.7,' dipole (au)',/,
     1' Normal mode derivatives of dipole moment num num-second anal')
      write(9,*)N-N7+1,lapt
      DO 16 I=N7,N
      do 16 j=1,3
16    write(9,9000)I,I,j,aptn(I,j),aptn(I+N,j),APT0Q(I,j)
9000  format(3i5,3f12.6)
      write(9,9022)
9022  format(' AAT:')
      DO 17 I=N7,N
      do 17 j=1,3
17    write(9,9000)I,I,j,AAT0Q(I,j)
      close(9)
      call w36('APT AAT in TENQ.TXT.SCR')
      return
      end

      subroutine wrten12q(N,aptaq,aataq,NT3,N7)
      implicit none
      integer*4 I,J,ind1,ind2,k,N,NT3,N7
      real*8 aptaq(2*NT3**2,3),aataq(NT3**2,3)
      logical lex
      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENAQ.TXT.SCR on disk, not overwritten')
       return
      endif
      open(9,file='TENAQ.TXT.SCR')
      write(9,*)N7-N+1
      write(9,9002)
9002  format(' APT second derivatives',/,
     1'   Iq   Jq   ix          PIqJq          PJqIq  PIqIqJq')
      DO 18 I=N7,N
      DO 18 J=I,1,-1
      ind1=I+N*(J-1)
      ind2=J+N*(I-1)
      do 18 k=1,3
18    write(9,9003)I,J,k,aptaq(ind1,k),aptaq(ind2,k),
     1aptaq(N**2+ind1,k)
9003  format(3i5,3g15.5)
      write(9,9004)
9004  format(' AAT second derivatives',/,
     1'   Iq   Jp   ix          PIqJp          PJpIq')
      DO 1 I=N7,N
      DO 1 J=I,1,-1
      ind1=I+N*(J-1)
      ind2=J+N*(I-1)
      do 1 k=1,3
1     write(9,9003)I,J,k,aataq(ind1,k),aataq(ind2,k)
      close(9)
      call w36('Second dipole derivatives written to TENAQ.TXT.SCR')
      return
      end

      subroutine wrttq11(polar0,N7,N,ALPHA0Q,alphan,gten0,aten0,
     1G0Q,A0Q,NT3)
      implicit none
      integer*4 NT3,N7,N
      real*8 polar0(3,3),gten0(3,3),aten0(3,3,3),A0Q(3,3,3,NT3),
     1ALPHA0Q(3,3,NT3),G0Q(3,3,NT3),alphan(3,3,NT3)
      integer*4 i,j,k,l
      logical lex
      inquire(file='TTTQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTQ.TXT.SCR on disk, not overwritten')
       return
      endif
      open(9,file='TTTQ.TXT.SCR')
      write(9,9004)((polar0(i,j),i=1,3),j=1,3)
9004  format(3(3f15.7,' au',/),
     1' Normal mode polarizability derivatives num anal')
      write(9,*)N-N7+1
      DO 19 I=N7,N
      do 19 j=1,3
      do 19 k=1,3
19    write(9,9005)I,I,j,k,alphan(j,k,I),ALPHA0Q(j,k,I)
9005  format(4i5,2f10.6)
      write(9,9006)((gten0(i,j),i=1,3),j=1,3)
9006  format(3(3f15.7,' G au',/),
     1' Normal mode G-tensor derivatives:')
      DO 20 I=N7,N
      do 20 j=1,3
      do 20 k=1,3
20    write(9,9005)I,I,j,k,G0Q(j,k,I)
      write(9,9008)(((aten0(i,j,k),i=1,3),j=1,3),k=1,3)
9008  format(9(3f15.7,' A au',/),
     1' Normal mode A-tensor derivatives:')
      DO 21 I=N7,N
      do 21 j=1,3
      do 21 k=1,3
      do 21 l=1,3
21    write(9,9007)I,I,j,k,l,A0Q(j,k,l,I)
9007  format(5i5,2f10.6)
      close(9)
      call w36('nm pol der in TTTQ.TXT.SCR')
      return
      end
