      SUBROUTINE READG98i(NAT,LINEAR,N,FCAR0,S,AM,N7,R,HW,step,tol4,
     1tol3,NCAN,ICAN,XLIM)
      IMPLICIT none
      integer*4 NAT,N,N7,i,j,k,l,ix,II,ndif,nml,IDUM,IA,IC,ig98,NINDC,
     1imax,jmax,kmax,imx,jmx,kmx,NQ,NQT,ltot,ind,ind1,ind2,nstep,JJ,
     1ic1,ic2,ic3,ic4,kl,li
      include 'dimensions.h'
      CHARACTER*50 S50
      CHARACTER*2 atsym
      integer*4 iz(NT0),NCAN,ICAN(*)
      real*8 FCAR0(NT3,NT3),S(NT3,NT3),
     1AM(NT3),R(NT0,3),APT(NT0,3,3),AAT(NT0,3,3),ALPHA(3,3,NT3),
     1APT0(NT0,3,3),aptn(2*NT3,3),AAT0(NT0,3,3),ALPHA0(3,3,NT3),
     1alphan(3,3,2*NT3),GG(3,3,NT3),AA(3,3,3,NT3),AATQ(NT3,3),
     1APTQ(NT3,3),GG0(3,3,NT3),AA0(3,3,3,NT3),A0Q(3,3,3,NT3),
     1AAQ(3,3,3,NT3),ALPHAQ(3,3,NT3),ALPHA0Q(3,3,NT3),rc(NT0,3),
     1APT0Q(NT3,3),AAT0Q(NT3,3),GQ(3,3,NT3),G0Q(3,3,NT3),
     1sigma(NT0*2),sigma0(NT0*2),optrotq(2*NT3),rt(NT0,3),
     1bohr,CM,SFACR,f1,f2,E,tol4,tol3,step,ASS,ff,ei,ej,dd,dm,c0,cqau,
     1cqcn,cqcm,XLIM,amave,optrot,optrot0,gn,
     1dip(3),dip0(3),polar(3,3),polar0(3,3),gten(3,3),gten0(3,3),
     1aten(3,3,3),aten0(3,3,3),mijkl
c     sigma - holds both isotropic and anisotropic part
c     large arrays:
      real*8,allocatable:: CX3(:,:,:),CX4(:,:,:),ajmq(:,:,:),stepq(:),
     1FQ(:,:),ALPHAA(:,:),GGA(:,:),AAA(:,:),ajm(:,:),FCAR(:,:),
     1sigmaq(:,:),ajm0(:,:),aptaq(:,:),aataq(:,:),G(:),fg(:),
     1wij(:),uij(:),dr(:),su(:,:),FQu(:,:),Gu(:),Gm(:),FCARm(:,:),
     1p5(:),p6(:)
c     CX3(NT3,NT3,NT3) third energy derivatives
c     CX4(NT3,NT3,NT3) fourth energy derivatives
c     ajmq(2*NT3,NT0,NT0) spin-spin constant derivatives

c     curved coordinates:
      real*8,allocatable::ak(:),bkl(:),clj(:)

      LOGICAL HW,lex,lttt,lfc,lx,lff,lcmx,lgr,
     1LINEAR,OPT,lapt,laat,lten,lfcd,lnmr,ljj,loptrot,lpolar
      COMMON/CEM/E(NT3)
      common/cnmd/ndif,nml(NT3)
      logical lzmat,lharm,lopt,lqc
      common/lop/lopt(300)
      equivalence (lharm,lopt(9)),(lzmat,lopt(10)),(lcmx,lopt(33)),
     1(lqc,lopt(51))
      integer*4 iopt,ilqc,ilqcd,ilqct
      common/iop/iopt(300)
      equivalence (ilqc,iopt(21))
C
      call w36('Readg98i')
      call w36('^^^^^^^^')
      call w36('        ')

      allocate(FQ(NT3,NT3),ALPHAA(NT3**2,9),FCAR(NT3,NT3),
     1GGA(NT3**2,9),AAA(NT3**2,27),ajm(NT0,NT0),sigmaq(2*NT3,NT0*2),
     1ajm0(NT0,NT0),aptaq(2*NT3**2,3),aataq(NT3**2,3),FQu(NT3,NT3),
     1FCARm(NT3,NT3))

      bohr=0.529177d0
      CM=219470.0d0
      SFACR=0.02342179d0
c           =1/sqrt(amu), to transfer S into atomic units
c
c     Unit explanation:
c     -----------------
c     dX ... Cartesian coordinate displacement
c     dQ ... normal mode coordinate
c     dX = S.dQ
c     S ... S-matrix written into FILE.INP
c     St.M.S=1, M is the mass matrix in g/mol
c     s=SFACR.S, s is then in atomic units, is written in SMAT.SCR
c     si.FF.sj=delta(i,j)*ei^2, ei is the normal mode energy in a.u.
c     q ... dimensionless normal mode coordinate, qi=sqrt(ei) Qi
c
c     read S and e, transform into a.u.:
      call reads(S,N)
C
      INQUIRE(FILE='A.OUT',EXIST=OPT)
      IF(OPT)then
       call w36('ACES output registered')
       call READACESI(NAT,LINEAR,N,FCAR0,S,
     1AM,N7,R,HW,step,tol4,tol3,NCAN,ICAN,XLIM)
       stop
      endif

      INQUIRE(FILE='CP2K',EXIST=OPT)
      IF(OPT)then
       call w36('CP2K output registered')
       call READCASTEPi(NAT,N,FCAR0,S,AM,N7,R,step,tol4,tol3,NCAN,ICAN)
       return
      endif

      INQUIRE(FILE='CASTEP',EXIST=OPT)
      IF(OPT)then
       call w36('CASTEP output registered')
       call READCASTEPi(NAT,N,FCAR0,S,AM,N7,R,step,tol4,tol3,NCAN,ICAN)
       return
      endif

      INQUIRE(FILE='diff',EXIST=OPT)
      IF(OPT)then
       call w36('diff output registered')
       call READDIFF(NAT,LINEAR,N,FCAR0,S,
     1 AM,N7,R,step,tol4,tol3,NCAN,ICAN,XLIM)
       return
      endif

      INQUIRE(FILE='G.OUT',EXIST=OPT)
      IF(.NOT.OPT)CALL REPORT('File G.OUT not found.')
      inquire(file='FILE.TEN',exist=lten)
      inquire(file='FILE.FC',exist=lfcd)
C
      OPEN(2,FILE='G.OUT')
C
c     find geometry
      write(6,*)' Looking for geometry'
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    (lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       write(6,1111)S50
       write(3,1111)S50

c      rescue mode, read z-matrix geometry after charge:
c      write(6,*)lcmx
c      stop
       if(lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')then
        l=0
1555    l=l+1
        read(2,*,end=1556,err=1556)iz(l),(r(l,i),i=1,3)
        if(l.gt.NT0)call report('Too many atoms')
        goto 1555
1556    nat=l-1
        goto 1557
       endif

       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       DO 41 I=1,4
41     READ(2,*)
       l=0
5      READ(2,1111)s50
       IF(s50(2:4).NE.'---')THEN
        l=l+1
        BACKSPACE 2
        if(ig98.eq.0)then
         READ(2,*)IA,iz(l),(r(l,i),i=1,3)
        else
         READ(2,*)IA,iz(l),IDUM,(r(l,i),i=1,3)
        endif
        GOTO 5
       ENDIF
       nat=l

1557   write(3,*)nat
       open(20,file='FILE.X')
       write(20,*)nat
       write(20,*)nat
       do 34 l=1,nat
       write(20,4000)iz(l),(r(l,i),i=1,3)
34     write(3,4000)iz(l),(r(l,i),i=1,3)
4000   format(I3,3F15.10,' 0 0 0 0 0 0 0 0.0')
       close(20)
       goto 203
      ENDIF
      goto 201
202   call report('Geometry not found')
203   call w36(' ')
      call w36('Mass matrix:')
      do 55 ia=1,nat
      atsym='??'
      ASS=amave(iz(IA),atsym)
c
c     assign default mass, if not defined previously:
      if(am(3*(IA-1)+1).lt.0.0d0)then
       DO 551 I=1,3
551    AM(3*IA-3+I)=ASS
      endif
55    continue
c
      WRITE(3,1113)(AM(i),i=1,3*nat)
1113  FORMAT(4F15.8)
      IF(NAT.EQ.2.OR.LINEAR)THEN
       WRITE(3,*)'Linear molecule'
       N7=6
       LINEAR=.TRUE.
      ENDIF
      N=3*nat

      allocate(G(N),dr(N*N),Gu(N),Gm(N))

c     curved coordinates:
      if(lqc)then
       allocate(wij(N*N),uij(N*N),fg(N))
       call VZ(wij,0.0d0,N*N)
       call VZ(uij,0.0d0,N*N)
       call VZ( dr,0.0d0,N*N)
      endif

C
      inquire(file='CQQ.SCR.TXT',exist=lex)
      if(lex)then
       call w36('CQQ.SCR.TXT found on disk, rest of readg98i skipped')
       close(2)
       return
      endif
c
      IF(step.gt.1.0d-9)then
       write(3,3000)step,step/bohr
       write(6,3000)step,step/bohr
       step=step/bohr
3000   format('Step defined as ',F10.5,'A (',F10.5,'au)')
      endif
C
      NSTEP=1+2*ndif
      write(3,*)nstep,' harmonic force fields expected'
      write(6,*)nstep,' harmonic force fields expected'

c     read-in zero point:
c     Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0
      lapt=.false.
      laat=.false.
      lttt=.false.
      lx=.false.
      lfc=.false.
      lff=.false.
      lgr=.false.
      ltot=0
c
c     zero-out the tensors
      call readar0(NT3,N,FCAR0,APT0,AAT0,ALPHA0,dip0,polar0,GG0,AA0,
     1gten0,aten0,optrot0,ajm0,sigma0)
c
c     read current point from the output
      call readar(NT3,N,FCAR0,APT0,AAT0,ALPHA0,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip0,ltot,polar0,GG0,AA0,gten0,aten0,optrot0,
     1ajm0,sigma0,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      call w36('zero point finished')
      if(lapt)write(6,*)'APT found'
      if(laat)write(6,*)'AAT found'
      if(lttt)write(6,*)'TTT found'
      if(lfc)write(6,*)'FF found'
      if(lx)write(6,*)'X found'
      if(lgr)write(6,*)'Gradient found'
      write(3,3700)(dip0(i),i=1,3)
      write(6,3700)(dip0(i),i=1,3)
3700  format(' Dipole         ',3F10.4)
      write(3,3705)((polar0(i,j),i=1,3),j=1,3)
      write(6,3705)((polar0(i,j),i=1,3),j=1,3)
3705  format(' Polarizability ',3F10.4,/,
     1       '                ',3F10.4,/,
     1       '                ',3F10.4)
      if(ljj)then
       call w36('Spin-Spin Coupling')
       call WRITEM(3,NT0,N/3,ajm0)
       call WRITEM(6,NT0,N/3,ajm0)
      endif
      if(lnmr)then
       call w36('Chemical Shifts  Anisotropies')
       do 3701 I=1,N/3
       write(3,3702)I,sigma0(I),sigma0(I+N/3)
3701   write(6,3702)I,sigma0(I),sigma0(I+N/3)
3702   format(i4,2f15.6)
      endif
      if(loptrot)then
       call w36('Optical Rotation')
       write(3,3703)optrot0
       write(6,3703)optrot0
3703   format(f10.2)
      endif
c
c     load only harmonic ff if requested (debug option):
      if(lharm)then
       close(2)
       write(6,*)'lharm option called'
       write(3,*)'lharm option called'
       return
      endif
c
c     transform Cartesian FF into normal modes:
      call trafoq(FCAR0,FQ,S,N)
c
c     make gradient in mass-weighted coordinates
      call trafogm(G,Gm,N,iz)
c     make FF in mass-weighted coordinates
      call trafofm(FCAR0,FCARm,N,NT3,iz)
c     transform Gradient and FF into normal modes with unit matrix:
      allocate(su(NT3,NT3))
      call mksu(S,su,N,NT3,iz)
      call trafog(NT3,N,Gm,Gu,su)
      call trafoq(FCARm,FQu,su,N)
c
c     transform dipole derivatives into normal modes
      call trafopq(APT0,AAT0,APT0Q,AAT0Q,S,N)
c     write(6,*)N,APT0Q(N,1),APT0Q(N,2),APT0Q(N,3)
c     call report('debug')
c
c     transform polarizability derivatives into normal modes
      call trafoaq(ALPHA0,GG0,AA0,ALPHA0Q,G0Q,A0Q,S,N)
c
      allocate(CX3(1:N,1:N,1:N))
      allocate(CX4(1:N,1:N,1:N))
      allocate(ajmq(1:2*N,1:NAT,1:NAT))

c     zero-out/initialize anharmonic variables:
      DO 1 I=1,N
      DO 1 J=1,N
      DO 1 K=1,N
      CX3(I,J,K)=0.0d0
1     CX4(I,J,K)=0.0d0
c
      DO 54 ii=1,ndif
      I=nml(ii)
      DO 54 J=1,N
      DO 54 K=1,N
      CX3(I,J,K)=0.0d0
54    CX4(I,J,K)=-2.0d0*FQ(J,K)
c
      if(lapt.or.laat)then
       DO 541 II=1,N
       DO 541 JJ=1,N
       DO 541 K=1,3
       aataq(     II+(JJ-1)*N,K)=0.0d0
       aptaq(N**2+II+(JJ-1)*N,K)=-2.0d0*APT0Q(JJ,K)
541    aptaq(     II+(JJ-1)*N,K)=0.0d0
      endif
c
      if(lttt)then
       DO 542 II=1,N**2
       DO 542 J=1,9
       ALPHAA(II,J)=0.0d0
542    GGA(II,J)=0.0d0
       DO 5421 II=1,N**2
       DO 5421 J=1,27
5421   AAA(II,J)=0.0d0
      endif
      do 547 i=1,N
      do 547 k=1,3
      aptn(i+N,k)=-2.0d0*dip0(k)
547   aptn(i,k)=0.0d0
      do 552 i=1,N
      do 552 k=1,3
      do 552 l=1,3
      alphan(k,l,i+N)=-2.0d0*polar0(k,l)
552   alphan(k,l,i)=0.0d0
c
c     first derivatives and diagonal second dervs:
      if(loptrot)then
       do 554 i=1,N
       optrotq(N+i)=-2.0d0*optrot0
554    optrotq(i)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(lnmr)then
       do 555 i=1,N
       do 555 j=1,2*N/3
       sigmaq(N+i,j)=-2.0d0*sigma0(j)
555    sigmaq(i,j)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(ljj)then
       do 556 i=1,N
       do 556 j=1,N/3
       do 556 k=1,N/3
       ajmq(N+i,j,k)=-2.0d0*ajm0(j,k)
556    ajmq(i,j,k)=0.0d0
      endif
c
      allocate(stepq(N))
      do 558 I=1,N
558   stepq(I)=0.0d0
c     Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0

c     start to read the shifted geometries:
c     DIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIF
      do 3333 IC=1,2*ndif
      I=IC
      if(IC.GT.ndif)I=IC-ndif
      write(6,*)'Point',IC,'(',I,'):',nml(I),ltot
      write(3,*)'Point',IC,'(',I,'):',nml(I),ltot
      if(IC.le.ndif)then
       ff=1.0d0
      else
       ff=-1.0d0
      endif
c
c     check, that we are at the right point, eventually extract step:
      step=0.0d0
      call chkgeos(r,nat,lzmat,step,S,rc,nml(I))
      stepq(nml(I))=step
c
c     zero-out variables:
      call readar0(NT3,N,FCAR,APT,AAT,ALPHA,dip,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma)
c
c     read-in current values:
      call readar(NT3,N,FCAR,APT,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,optrot,
     1ajm,sigma,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      write(3,3700)(dip(j),j=1,3)
      write(3,3705)((polar(k,j),k=1,3),j=1,3)
      if(ljj)then
       write(3,*)'Spin-Spin Coupling'
       call WRITEM(3,NT0,N/3,ajm)
      endif
      if(lnmr)then
       write(3,*)'Chemical Shifts Anisotropies'
       do 3704 j=1,N/3
3704   write(3,3702)j,sigma(j),sigma(j+N/3)
      endif
      if(loptrot)then
       write(3,*)'Optical Rotation'
       write(3,3703)optrot
      endif
      if(lgr)then
       gn=0.0d0
       do 557 k=1,N
557    gn=gn+G(k)**2
       gn=dsqrt(gn/dble(N))
       write(6,7009)gn
       write(3,7009)gn
7009   format('|G| = ',g12.4)
      endif
c
c     transform Cartesian derivatives to normal modes:
      call trafoq(FCAR,FQ,S,N)

c     trafo gradient in to mass-weighted coordinates and change sign:
c     (actually forces are read, not gradient)
      call trafogm(G,Gm,N,iz)
c     make FF in mass-weighted coordinates:
      call trafofm(FCAR,FCARm,N,NT3,iz)
c     transform Cartesian derivatives to normal modes by su:
      call trafoq(FCARm,FQu,su,N)
      call trafog(NT3,N,Gm,Gu,su)

      call trafopq(APT,AAT,APTQ,AATQ,S,N)
      call trafoaq(ALPHA,GG,AA,ALPHAQ,GQ,AAQ,S,N)

c     do the numerical differentiations:
      DO 3 J=1,N
      DO 3 K=1,N
      CX3(nml(I),J,K)=CX3(nml(I),J,K)+FQ(J,K)*ff
c     if(nml(I).eq.10.and.J.eq.10.and.K.eq.10)write(6,*)'2 ',FQ(J,K)
3     CX4(nml(I),J,K)=CX4(nml(I),J,K)+FQ(J,K)
c
      do 548 j=1,3
      aptn(nml(I)+N,j)=aptn(nml(I)+N,j)+dip(j)
548   aptn(nml(I),j)=aptn(nml(I),j)+ff*dip(j)
      do 553 j=1,3
      do 553 k=1,3
      alphan(j,k,nml(I)+N)=alphan(j,k,nml(I)+N)+polar(j,k)
553   alphan(j,k,nml(I))=alphan(j,k,nml(I))+ff*polar(j,k)
c
      if(lapt.or.laat)then
       DO 543 II=1,N
       DO 543 K=1,3
       ind=nml(I)+N*(II-1)
       aptaq(N**2+ind,K)=aptaq(N**2+ind,K)+APTQ(II,K)
       aptaq(ind,K)=aptaq(ind,K)+APTQ(II,K)*ff
543    aataq(ind,K)=aataq(ind,K)+AATQ(II,K)*ff
c      aataq - nml(I) index goes to coordinate, II is momentum
      endif
c
      if(lttt)then
       DO 544 II=1,N
       ind1=nml(I)+N*(II-1)
       DO 544 J=1,3
       DO 544 K=1,3
       ind2=J+3*(K-1)
       GGA(   ind1,ind2)=GGA(   ind1,ind2)+GQ(    J,K,II)*ff
       ALPHAA(ind1,ind2)=ALPHAA(ind1,ind2)+ALPHAQ(J,K,II)*ff
       DO 544 L=1,3
       ind2=J+3*(K-1)+9*(L-1)
544    AAA(   ind1,ind2)=AAA(   ind1,ind2)+AAQ(J ,K,L,II)*ff
      endif
c
      if(lnmr)then
       DO 545 II=1,2*N/3
       sigmaq(N+nml(I),II)=sigmaq(N+nml(I),II)+sigma(II)
545    sigmaq(nml(I),II)=sigmaq(nml(I),II)+sigma(II)*ff
      endif
c
      if(ljj)then
       DO 546 II=1,N/3
       DO 546 JJ=1,N/3
       ajmq(N+nml(I),II,JJ)=ajmq(N+nml(I),II,JJ)+ajm(II,JJ)
546    ajmq(nml(I),II,JJ)=ajmq(nml(I),II,JJ)+ajm(II,JJ)*ff
      endif
c
      if(loptrot)then
       optrotq(nml(I))=optrotq(nml(I))+optrot*ff
       optrotq(N+nml(I))=optrotq(N+nml(I))+optrot
      endif

      if(lqc)then
       call getfg(FQu,Gu,NT3,N,N7,fg,nml(I))
c      fg ... F-1 g product
       do 549 JJ=1,N
       wij(JJ+N*(nml(I)-1))=wij(JJ+N*(nml(I)-1))+fg(JJ)*ff
549    uij(JJ+N*(nml(I)-1))=uij(JJ+N*(nml(I)-1))+fg(JJ)

c      recalculate shifted geometry X(+/- dQ):
       do 701 II=1,nat
       do 701 JJ=1,3
c      xau = stepau            s             /sqrt(M)
c      ss=1
c           step/(bohr*SFAC)  S*sqrt(M)/SFAC SFAC/sqrt(M)
c      x(A) = xau *bohr
701    rt(II,JJ)=r(II,JJ)+S(JJ+3*(II-1),nml(I))*step/SFACR*ff
c      recaltulate corrected geometry:
       do 702 II=1,nat
       do 702 JJ=1,3
       do 702 K=1,N
702    rt(II,JJ)=rt(II,JJ)+S(JJ+3*(II-1),K)*fg(K)*bohr

       if(-nml(i).eq.7)then
        write(6,*)'mode ',nml(i),' step ',step
        write(6,*)'XQ +FG:'
        do 708  II=1,nat 
708     write(6,700) iz(II),(rt(II,JJ),JJ=1,3)
700     format(i4,3f12.6)
       endif

      endif
c
3333  continue
c     DIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIF
c
      close(2)

C
      if(stepq(nml(I)).lt.1.0d-9)call report('Diff. step too small!')
c
c     dQ(in au)=step(current)/(bohr*SFAC)
c     CX4=[FF(+Q)+FF(-Q)-2FF]/dQ**2     CX3=[FF(+Q)-FF(-Q)]/(2dQ)
      DO 15 I=1,ndif
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      DO 15 J=1,N
      DO 15 K=1,N
      CX3(nml(I),J,K)=CX3(nml(I),J,K)*f1
15    CX4(nml(I),J,K)=CX4(nml(I),J,K)*f2

      if(lqc)then
       DO 550 I=1,ndif
       f1=0.5d0*(SFACR*bohr/stepq(nml(I)))**3
       f2=0.5d0*(SFACR*bohr/stepq(nml(I)))**2
       do 550 JJ=1,N
       wij(JJ+N*(nml(I)-1))=-wij(JJ+N*(nml(I)-1))*f1
550    uij(JJ+N*(nml(I)-1))=-uij(JJ+N*(nml(I)-1))*f2
      endif

      DO 161 I=ndif,1,-1
      ei=sqrt(E(nml(I)))
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      do 161 j=1,3
      aptn(nml(I),j)=aptn(nml(I),j)*f1/ei
      aptn(nml(I)+N,j)=aptn(nml(I)+N,j)*f2/ei/ei
      APT0Q(nml(I),j)=APT0Q(nml(I),j)/ei
161   AAT0Q(nml(I),j)=AAT0Q(nml(I),j)*ei
c
c     for tensor properties, write the derivatives (au) with respect to q:
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENQ.TXT.SCR found on disk, unchanged')
      else
       if(.not.lapt)then
c       if no analytical derivatives, then use numerical:
        DO 162 I=ndif,1,-1
        do 162 j=1,3
162     APT0Q(nml(I),j)=aptn(nml(I),j)
       endif
       call wrten1q(dip0,ndif,lapt,aptn,APT0Q,NT3,AAT0Q,nml,N)
      endif
c
      DO 18 I=ndif,1,-1
      ei=sqrt(E(nml(I)))
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      DO 18 J=ndif,1,-1
      ej=sqrt(E(nml(J)))
      ind=nml(I)+N*(nml(J)-1)
      do 18 k=1,3
      aptaq(ind,k)=aptaq(ind,k)/ei/ej*f1
c
c     third dipolar derivatives uiij = u(N**2+i+(j-1)N)
      aptaq(N**2+ind,k)=aptaq(N**2+ind,k)/ei/ei/ej*f2
18    aataq(ind,k)=aataq(ind,k)/ei*ej*f1
c     aataq = i-index coordinate, J -momentum

      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENAQ.TXT.SCR found on disk, unchanged')
      else
       call wrtenq(ndif,N,aptaq,aataq,NT3,nml)
      endif
c
      DO 19 I=1,ndif
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      ei=sqrt(E(nml(I)))
      do 19 j=1,3
      do 19 k=1,3
      G0Q(j,k,nml(I))=G0Q(j,k,nml(I))/ei
      ALPHA0Q(j,k,nml(I))=ALPHA0Q(j,k,nml(I))/ei
      alphan(j,k,nml(I))=alphan(j,k,nml(I))*f1/ei
      do 19 l=1,3
19    A0Q(j,k,l,nml(I))=A0Q(j,k,l,nml(I))/ei

      call wrttq(polar0,ndif,nml,ALPHA0Q,alphan,gten0,aten0,
     1G0Q,A0Q,NT3)


      do 23 i=1,ndif
      ei=sqrt(E(nml(i)))
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      do 23 j=i,ndif
      ej=sqrt(E(nml(j)))
      ind1=nml(I)+N*(nml(J)-1)
      ind2=nml(J)+N*(nml(I)-1)
      do 22 ix=1,9
      GGA(ind1,ix)   =0.5d0*(GGA(ind1,ix)   +GGA(ind2,ix)   )/ei/ej*f1
      GGA(ind2,ix)=GGA(ind1,ix)
      ALPHAA(ind1,ix)=0.5d0*(ALPHAA(ind1,ix)+ALPHAA(ind2,ix))/ei/ej*f1
22    ALPHAA(ind2,ix)=ALPHAA(ind1,ix)
      do 26 ix=1,27
      AAA(ind1,ix)   =0.5d0*(AAA(ind1,ix)   +AAA(ind2,ix)   )/ei/ej*f1
26    AAA(ind2,ix)=AAA(ind1,ix)
23    continue

      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTAQ.TXT.SCR found on disk, unchanged')
      else
       call wrttqaq(ndif,nml,N,NT3,ALPHAA,GGA,AAA)
      endif

      inquire(file='PROP.TXT.SCR',exist=lex)
      if(lex)then
       call w36('PROP.TXT.SCR exists, now overwritten')
      else
       open(21,file='PROP.TXT.SCR')
       write(21,*)N7,N
c
       if(loptrot)then
        write(21,*)loptrot
        write(21,2125)1,optrot0
2125    format('Optical rotation:',/,i5,/,20x,f10.2)
        do 27 i=N7,N
        f1=0.5d0* SFACR*bohr/stepq(I)
        f2=1.0d0*(SFACR*bohr/stepq(I))**2
        if(e(i).le.0.0d0)then
         write(21,2126)i,0.0d0,0.0d0
        else
         write(21,2126)i,optrotq(i)*f1/dsqrt(e(i)),optrotq(N+i)*f2/e(i)
        endif
27      continue
2126    format(20x,i5,2g15.5)
       endif
c
       if(lpolar)then
        write(21,*)lpolar
        write(21,2132)9
2132    format('Polarizability:',/,i5)
        do 32 i=1,3
        do 32 j=1,3
32      write(21,21281)i,j,polar0(i,j)
        do 33 i=1,3
        do 33 j=1,3
        do 33 k=N7,N
        f1=0.5d0* SFACR*bohr/stepq(k)
        f2=1.0d0*(SFACR*bohr/stepq(k))**2
        if(e(k).le.0.0d0)then
         write(21,2130)i,j,k,0.0d0,0.0d0
        else
         write(21,2130)i,j,k,alphan(i,j,k)*f1/dsqrt(e(k)),
     1   alphan(i,j,N+k)*f2/e(k)
        endif
33      continue
       endif
c
       if(lnmr)then
        write(21,*)lnmr
        write(21,2127)N/3
2127    format('Chemical shifts:',/,i5)
        do 28 i=1,N/3
28      write(21,2131)i,sigma0(i)
2131    format(i20,2g15.5)
        do 29 i=1,N/3
        do 29 j=N7,N
        f1=0.5d0* SFACR*bohr/stepq(j)
        f2=1.0d0*(SFACR*bohr/stepq(j))**2
        if(e(j).le.0.0d0)then
         write(21,2128)i,j,0.0d0,0.0d0
2128     format(i20,i5,4g15.5)
        else
         write(21,2128)i,j,sigmaq(j,i)*f1/dsqrt(e(j)),
     1   sigmaq(N+j,i)*f2/e(j)
        endif
29      continue

        write(21,*)lnmr
        write(21,2133)N/3
2133    format('Shift Anisotropies:',/,i5)
        do 281 i=1,N/3
281     write(21,2131)i,sigma0(i+N/3)
        do 291 i=1,N/3
        do 291 j=N7,N
        f1=0.5d0* SFACR*bohr/stepq(j)
        f2=1.0d0*(SFACR*bohr/stepq(j))**2
        if(e(j).le.0.0d0)then
         write(21,2128)i,j,0.0d0,0.0d0
        else
         write(21,2128)i,j,sigmaq(j,i+N/3)*f1/dsqrt(e(j)),
     1   sigmaq(N+j,i+N/3)*f2/e(j)
        endif
291     continue
       endif
c
       if(ljj)then
        write(21,*)ljj
        write(21,2129)N/3*N/3
2129    format('Spin-Spin Couplings:',/,i5)
        do 30 i=1,N/3
        do 30 j=1,N/3
30      write(21,21281)i,j,ajm0(i,j)
21281   format(2i10,g15.5)
        do 31 i=1,N/3
        do 31 j=1,N/3
        do 31 k=N7,N
        f1=0.5d0* SFACR*bohr/stepq(k)
        f2=1.0d0*(SFACR*bohr/stepq(k))**2
        if(e(k).le.0.0d0)then
         write(21,2130)i,j,k,0.0d0,0.0d0
        else
         write(21,2130)i,j,k,ajmq(k,j,i)*f1/dsqrt(e(k)),ajmq(N+k,j,i)
     1   *f2/e(k)
        endif
31      continue
2130    format(2i10,i5,2g15.5)
       endif

       close(21)
       call w36('PROP.TXT.SCR')
      endif
c
      call readg98si(NAT,N,R,XLIM,step,1,tol3,N7,S)

      if(.not.lff)call report('force field not found')
c
      call w36(' ')
      call w36('Symmetrizing cubics')
      NINDC=0
      imax=0
      jmax=0
      kmax=0
      imx=0
      jmx=0
      kmx=0
      dd=0.0d0
      dm=0.0d0
      DO 152 I=N7,N
      DO 152 J=I,N
      DO 152 K=J,N
      c0=CX3(I,J,K)
      CX3(I,J,K)=(CX3(I,J,K)+CX3(I,K,J)+CX3(J,I,K)
     1+           CX3(J,K,I)+CX3(K,I,J)+CX3(K,J,I))/6.0d0
      if(dabs(c0-CX3(I,J,K)).gt.dd)then
       dd=dabs(c0-CX3(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
152   NINDC=NINDC+1
      write(6,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
      write(3,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
8989  format(' Largest assymetry:',3i3,' c =',g12.4,' dc =',g12.4)
      write(6,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
      write(3,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
1989  format(' Largest constant :',3i3,' c =',g12.4)

c     correct force field to curved coordinates:
      if(lqc)then
c      terms from quartic cartesian potential:

c      call testmode(NT0,NT3,nat,9,N,N7,r,Su,Uij,Wij,AM,iz)

       ilqcd=mod(ilqc,10)
       ilqct=mod(ilqc,100)/10
       write(3,7041)ilqc,ilqcd,ilqct
       write(6,7041)ilqc,ilqcd,ilqct
7041   format(' ILQC = ',i4,' ILQCD = ',i1,' ILQCT = ',i1,/)
       if(ilqcd.ne.0)then
c       potential correction
        do 704 i=N7,N
        do 704 j=N7,N
704     CX4(i,i,i)=CX4(i,i,i)-12.0d0*(e(j)*uij(j+N*(i-1)))**2
       endif
       if(ilqct.ne.0)then
c       kinetic energy - precalculate things
        allocate(bkl(N**2),ak(N),clj(N**2),p5(N),p6(N))
        do 706 i=N7,N
        ak(i)=0.0d0
        do 706 j=N7,N
        ak(i)=ak(i)+4.0d0*uij(j+N*(i-1))*uij(j+N*(i-1))*uij(i+N*(j-1))
        do 706 k=N7,N
 706    ak(i)=ak(i)+2.0d0*uij(k+N*(j-1))*uij(i+N*(k-1))*uij(k+N*(i-1))
        do 707 k=N7,N
        do 707 l=N7,N
        kl=l+N*(k-1)
        bkl(kl)=0.0d0
        do 707 i=N7,N
        bkl(kl)=bkl(kl)+4.0d0*
     1  uij(k+N*(i-1))*uij(i+N*(k-1))*uij(l+N*(i-1))*uij(i+N*(l-1))
        do 707 j=N7,N
707     bkl(kl)=bkl(kl)+(mijkl(N,i,j,k,i,wij,uij)
     1                  +mijkl(N,i,j,i,k,wij,uij))*
     1  uij(l+N*(j-1))*uij(j+N*(l-1))
     1  +mijkl(N,i,j,k,l,wij,uij)*uij(j+N*(i-1))*uij(i+N*(j-1))
        do 712 l=N7,N
        do 712 i=N7,N
        li=i+N*(l-1)
        clj(li)=0.0d0
        do 712 j=N7,N
 712    clj(li)=clj(li)+0.5d0*
     1  (mijkl(N,j,i,l,j,wij,uij)+mijkl(N,j,i,j,l,wij,uij))
        do 717 i=N7,N
        p5(i)=0.0d0
        p6(i)=0.0d0
        do 717 j=N7,N
        p5(i)=p5(i)-uij(j+N*(i-1))*e(j)**2*wij(j+N*(i-1))
        p6(i)=p6(i)-(e(j)*wij(j+N*(i-1)))**2/2.0d0
        do 717 k=N7,N
        p5(i)=p5(i)-uij(j+N*(i-1))*uij(k+N*(i-1))*CX3(i,j,k)/2.0d0
717     p6(i)=p6(i)-uij(j+N*(i-1))*wij(k+N*(i-1))*CX3(i,j,k)
     1             -uij(j+N*(i-1))*uij(k+N*(i-1))*CX4(i,j,k)/4.0d0
        call wrtt(N7,N,e,uij,wij,ak,bkl,clj,p5,p6)
        deallocate(bkl,ak,clj,p5,p6)
       endif
       call w36(' QC terms added ')
      endif
c
c     list cubics into text file
      open(23,file='CQQ.SCR.TXT')
      NQ=0
      nqt=0
      do 62 i=N7,N
      do 62 j=i,N
      do 62 k=j,N

c     skip if no differentiation:
      ic1=0
      ic2=0
      ic3=0
      do 622 ii=1,ndif
      if(nml(ii).eq.i)ic1=ic1+1
      if(nml(ii).eq.j)ic2=ic2+1
622   if(nml(ii).eq.k)ic3=ic3+1
      if(ic1.ne.1.or.ic2.ne.1.or.ic3.ne.1)goto 62

c     skip if mode blocked:
      do 4001 l=1,NCAN
4001  if(I-N7+1.eq.ICAN(l).or.J-N7+1.eq.ICAN(l).or.K-N7+1.eq.ICAN(l))
     1goto 62
c
c     skip for negative frequencies:
      if(e(i).le.0.0d0.or.e(j).le.0.0d0.or.e(k).le.0.0d0)goto 62

      cqau=CX3(I,J,K)
      cqcn=cqau/dsqrt(abs(e(i)*e(j)*e(k)))
      cqcm=cqcn*CM
c
c     skip small constants:
      if(abs(cqcm).lt.tol3)goto 62
c
      write(23,2423)I,J,K,cqcn,cqcm
2423  format(3I5,G16.8,' ',F9.1)
      nq=nq+1
62    nqt=nqt+1
      close(23)
      write(6,6000)nqt,nq,tol3
      write(3,6000)nqt,nq,tol3
6000  format('Number of normal cubics ',I10,/,
     1       'Selected                ',I10,/,
     1       'Limit                   ',F10.7,/,
     1       'Writen in CQQ.SCR.TXT',/)

      call w36(' ')
      call w36('Symmetrizing quartics')
      imax=0
      jmax=0
      kmax=0
      dd=0.0d0
      imx=0
      jmx=0
      kmx=0
      dm=0.0d0
      DO 153 I=N7,N
      DO 153 J=N7,N
      DO 153 K=J,N
      c0=CX4(I,J,K)
      if(j.eq.i)then
c      iii
       if(k.eq.i)then
c       iiii
       else
c       iiik iiki
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       endif
      else
c      iij
       if(k.eq.i)then
c       iiji iiji
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       else
        if(k.eq.j)then
c        iijj jjii
         CX4(I,J,K)=(CX4(I,J,K)+CX4(J,I,I))/2.0d0
         CX4(J,I,I)=CX4(I,J,K)
        else
c        iijk iikj
         CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
         CX4(I,K,J)=CX4(I,J,K)
        endif
       endif
      endif
      if(dabs(c0-CX4(I,J,K)).gt.dd)then
       dd=dabs(c0-CX4(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
153   continue
      write(6,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
      write(3,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
8985  format(' Largest assymetry:',4i3,' d =',g12.4,' dd =',g12.4)

      write(6,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
      write(3,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
2989  format(' Largest constant :',4i3,' d =',g12.4)
c
c     zero if no differentiation:
      do 621 i=n7,n
      do 621 j=n7,n
      do 621 k=j,n
      ic1=0
      ic2=0
      ic3=0
      ic4=0
      do 623 ii=1,ndif
      if(nml(ii).eq.i)ic1=ic1+1
      if(nml(ii).eq.i)ic2=ic2+1
      if(nml(ii).eq.j)ic3=ic3+1
623   if(nml(ii).eq.k)ic4=ic4+1
621   if(ic1.ne.1.or.ic2.ne.1.or.ic3.ne.1.or.ic4.ne.1)CX4(i,j,k)=0.0d0
c     write sparse quartics
      call write4(CX4,N7,N,NCAN,ICAN,E,tol4)
c
      deallocate(CX3)
      deallocate(CX4)
      deallocate(ajmq)

c599  do 35 i=1,nat
c     do 35 iq=1,N
c     do 35 k=1,3
c5    S(3*(i-1)+k,N-iq+1)=S(3*(i-1)+k,N-iq+1)/SFACR
c
      RETURN
      END
c
      subroutine trafog(NT3,N,G,Gu,S)
      implicit none
      integer*4 NT3,N,i,a
      real*8 G(*),S(NT3,NT3),Gu(*)
c     transform:
      DO 1 I=1,N
      Gu(I)=0.0d0
      DO 1 a=1,N
1     Gu(I)=Gu(I)+S(a,I)*G(a)

c     SFACR=0.02342179d0
c     sum(A) S(A,I)*S(A,J)*amave(iz((A+2)/3),sy)/SFACR**2 = d(I,J)

      return
      end
c
      subroutine trafoq(FCAR,FQ,S,N)
      implicit none
      integer*4 N,i,j,a,b
      include 'dimensions.h'
      real*8 FCAR(NT3,NT3),FQ(NT3,NT3),S(NT3,NT3),FT(NT3,NT3)
c     transform first index
      DO 1 I=1,N
      DO 1 a=1,N
      FT(I,a)=0.0d0
      DO 1 b=1,N
1     FT(I,a)=FT(I,a)+S(b,I)*FCAR(a,b)
c     transform second index
      DO 2 I=1,N
      DO 2 J=1,N
      FQ(I,J)=0.0d0
      DO 2 a=1,N
2     FQ(I,J)=FQ(I,J)+S(a,J)*FT(I,a)
      return
      end
c
      subroutine chkgeos(r,nat,lzmat,step,S,rc,ireq)
      implicit none
      integer*4 nat,ig98,I,l,ic,ix,iq,ii,ireq
      include 'dimensions.h'
      real*8 r(NT0,3),step,rc(NT0,3),dq,S(NT3,NT3),CM,E,AM,
     1SFACR,bohr,ropt,geotol
      COMMON/CEM/E(NT3)
      common/MASS/AM(NT3)
      common/opt/ropt(100)
      equivalence (geotol,ropt(20))
      character*50 S50
      logical lzmat,lcmx,lopt
      common/lop/lopt(300)
      equivalence (lcmx,lopt(33))
c
      CM=219470.0d0
      SFACR=0.02342179d0
      bohr=0.529177d0
c
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    (lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       if(lcmx.and.s50(2:7).eq.'Charge')ig98=-1
       if(ig98.ne.-1)then
        DO 41 I=1,4
41      READ(2,*)
       endif
       ic=0
c
c      read current geometry
       DO 1 l=1,nat
       if(ig98.eq.0)then
        READ(2,*)I,I,(rc(l,ix),ix=1,3)
       else
        if(ig98.eq.-1)then
         READ(2,*)I,(rc(l,ix),ix=1,3)
        else
         READ(2,*)I,I,I,(rc(l,ix),ix=1,3)
        endif
       endif
1      continue
c
c      Cartesian displacements from equilibrium
       DO 2 l=1,nat
       DO 2 ix=1,3
2      rc(l,ix)=rc(l,ix)-r(l,ix)
c
c      normal mode displacements
       do 3 iq=1,3*nat
       dq=0.0d0
       do 4 l=1,nat
       do 4 ix=1,3
       ii=3*(l-1)+ix
4      dq=dq+AM(ii)*S(ii,iq)*rc(l,ix)
c
c      adapt to the strange pmz units dq=dq/SFACR:
       dq=dq/SFACR
       if(dabs(dq).gt.geotol)then
        write(6,*)nat
        write(6,6000)iq,e(iq)*CM,dq,dq/(SFACR*bohr)
6000    format('mode',i4,f10.2,' cm-1',' dQ =',f10.4,' au:',f10.4)
        if(ireq.ne.iq)call report('errorneous mode numbering')
        ic=ic+1
        call chksti(dq,step)
       endif
3      continue
c
       if(ic.ne.1)then
        write(3,*)ic
        call report('deffective differentiation')
       endif
       return
      ENDIF
      goto 201
202   call report('Geometry not found')
      end

      subroutine chksti(d,step)
      real*8 d,step
      if(step.lt.1.0d-9)then
       step=dabs(d)
       write(3,3000)step
       write(6,3000)step
3000   format('Step set on the fly as ',F10.5)
      endif
      return
      end
c
      subroutine trafopq(APT,AAT,APTQ,AATQ,S,N)
      implicit none
      integer*4 N,i,j,a,b
      include 'dimensions.h'
      real*8 APT(NT0,3,3),AAT(NT0,3,3),APTQ(NT3,3),AATQ(NT3,3),
     1S(NT3,NT3)
      DO 1 i=1,3
      DO 1 a=1,N
      APTQ(a,i)=0.0d0
      AATQ(a,i)=0.0d0
      DO 1 b=1,N/3
      DO 1 j=1,3
      AATQ(a,i)=AATQ(a,i)+S(3*(b-1)+j,a)*AAT(b,j,i)
1     APTQ(a,i)=APTQ(a,i)+S(3*(b-1)+j,a)*APT(b,j,i)
      return
      end
c
      subroutine trafoaq(ALPHA,G,AA,ALPHAQ,GQ,AQ,S,N)
      implicit none
      integer*4 N,i,j,a,b,k
      include 'dimensions.h'
      real*8 ALPHA(3,3,NT3),G(3,3,NT3),AA(3,3,3,NT3),
     1S(NT3,NT3),ALPHAQ(3,3,NT3),GQ(3,3,NT3),AQ(3,3,3,NT3)
      DO 1 i=1,3
      DO 1 j=1,3
      DO 1 a=1,N
      ALPHAQ(i,j,a)=0.0d0
      GQ(    i,j,a)=0.0d0
      DO 11 b=1,N
      ALPHAQ(i,j,a)=ALPHAQ(i,j,a)+S(b,a)*ALPHA(i,j,b)
11    GQ(    i,j,a)=GQ(    i,j,a)+S(b,a)*G(    i,j,b)
      DO 1 k=1,3
      AQ(i,j,k,a)=0.0d0
      DO 1 b=1,N
1     AQ(i,j,k,a)=AQ(i,j,k,a)+S(b,a)*AA(i,j,k,b)
      return
      end

      SUBROUTINE WRITEM(io,MX3,N,FCAR)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FCAR(MX3,N)
      N1=1
1     N3=N1+4
      IF(N3.GT.N)N3=N
      WRITE(io,171)(J,J=N1,N3)
171   FORMAT(I4,5I14)
      DO 130 LN=N1,N
130   WRITE(io,17)LN,(FCAR(LN,J),J=N1,MIN(LN,N3))
      N1=N1+5
      IF(N3.LT.N)GOTO 1
17    FORMAT(I4,5D14.6)
      RETURN
      END

      subroutine wrttq(polar0,ndif,nml,ALPHA0Q,alphan,gten0,aten0,
     1G0Q,A0Q,NT3)
      implicit none
      integer*4 NT3
      real*8 polar0(3,3),gten0(3,3),aten0(3,3,3),A0Q(3,3,3,NT3),
     1ALPHA0Q(3,3,NT3),G0Q(3,3,NT3),alphan(3,3,NT3)
      integer*4 i,j,k,nml(*),l,ndif
      logical lex
      inquire(file='TTTQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTQ.TXT.SCR on disk, not overwritten')
       return
      endif
      open(9,file='TTTQ.TXT.SCR')
      write(9,9004)((polar0(i,j),i=1,3),j=1,3)
9004  format(3(3f15.7,' au',/),
     1' Normal mode polarizability derivatives num anal')
      write(9,*)ndif
      DO 19 I=1,ndif
      do 19 j=1,3
      do 19 k=1,3
19    write(9,9005)I,nml(I),j,k,alphan(j,k,nml(I)),ALPHA0Q(j,k,nml(I))
9005  format(4i5,2f12.6)
      write(9,9006)((gten0(i,j),i=1,3),j=1,3)
9006  format(3(3f15.7,' G au',/),
     1' Normal mode G-tensor derivatives:')
      DO 20 I=1,ndif
      do 20 j=1,3
      do 20 k=1,3
20    write(9,9005)I,nml(I),j,k,G0Q(j,k,nml(I))
      write(9,9008)(((aten0(i,j,k),i=1,3),j=1,3),k=1,3)
9008  format(9(3f15.7,' A au',/),
     1' Normal mode A-tensor derivatives:')
      DO 21 I=1,ndif
      do 21 j=1,3
      do 21 k=1,3
      do 21 l=1,3
21    write(9,9007)I,nml(I),j,k,l,A0Q(j,k,l,nml(I))
9007  format(5i5,2f13.6)
      close(9)
      call w36('nm pol der in TTTQ.TXT.SCR')
      return
      end

      subroutine wrten1q(dip0,ndif,lapt,aptn,APT0Q,NT3,AAT0Q,nml,N)
      implicit none
      integer*4 I,j,ndif,nml(*),NT3,N
      logical lapt
      real*8 dip0(3),aptn(2*NT3,3),APT0Q(NT3,3),AAT0Q(NT3,3)
      logical lex
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENQ.TXT.SCR on disk, not overwritten')
       return
      endif
      open(9,file='TENQ.TXT.SCR')
      write(9,9001)(dip0(j),j=1,3)
9001  format(3f15.7,' dipole (au)',/,
     1' Normal mode derivatives of dipole moment num num-second anal')
      write(9,*)ndif,lapt
      DO 16 I=ndif,1,-1
      do 16 j=1,3
16    write(9,9000)I,nml(I),j,aptn(nml(I),j),aptn(nml(I)+N,j),
     1APT0Q(nml(I),j)
9000  format(3i5,3f12.6)
      write(9,9022)
9022  format(' AAT:')
      DO 17 I=ndif,1,-1
      do 17 j=1,3
17    write(9,9000)I,nml(I),j,AAT0Q(nml(I),j)
      close(9)
      call w36('APT AAT in TENQ.TXT.SCR')
      return
      end

      subroutine wrtenq(ndif,N,aptaq,aataq,NT3,nml)
      implicit none
      integer*4 I,ndif,nml(*),J,ind1,ind2,k,N,NT3
      real*8 aptaq(2*NT3**2,3),aataq(NT3**2,3)
      logical lex
      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENAQ.TXT.SCR on disk, not overwritten')
       return
      endif
      open(9,file='TENAQ.TXT.SCR')
      write(9,*)ndif
      write(9,9002)
9002  format(' APT second derivatives',/,
     1'   Iq   Jq   ix          PIqJq          PJqIq  PIqIqJq')
      DO 18 I=ndif,1,-1
      DO 18 J=I,1,-1
      ind1=nml(I)+N*(nml(J)-1)
      ind2=nml(J)+N*(nml(I)-1)
      do 18 k=1,3
18    write(9,9003)nml(I),nml(J),k,aptaq(ind1,k),aptaq(ind2,k),
     1aptaq(N**2+ind1,k)
9003  format(3i5,3g15.5)
      write(9,9004)
9004  format(' AAT second derivatives',/,
     1'   Iq   Jp   ix          PIqJp          PJpIq')
      DO 1 I=ndif,1,-1
      DO 1 J=I,1,-1
      ind1=nml(I)+N*(nml(J)-1)
      ind2=nml(J)+N*(nml(I)-1)
      do 1 k=1,3
1     write(9,9003)nml(I),nml(J),k,aataq(ind1,k),aataq(ind2,k)
      close(9)
      call w36('Second dipole derivatives written to TENAQ.TXT.SCR')
      return
      end

      subroutine wrttqaq(ndif,nml,N,NT3,ALPHAA,GGA,AAA)
      implicit none
      integer*4 ndif,i,j,nml(*),N,NT3,ix
      real*8 ALPHAA(NT3**2,9),GGA(NT3**2,9),AAA(NT3**2,27)
      open(21,file='TTTAQ.TXT.SCR')
      write(21,*)' Normal mode polarizability second derivatives'
      write(21,*)ndif
      do 23 i=1,ndif
      do 23 j=i,ndif
      write(21,2124)i,j,nml(i),nml(j)
2124  format(4i5,' modes')
23    write(21,2121)(ALPHAA(nml(I)+N*(nml(J)-1),ix),ix=1,9)
2121  format(3f15.6)
      do 24 i=1,ndif
      do 24 j=i,ndif
      write(21,2124)i,j,nml(i),nml(j)
24    write(21,2121)(GGA(nml(I)+N*(nml(J)-1),ix),ix=1,9)
      do 25 i=1,ndif
      do 25 j=i,ndif
      write(21,2124)i,j,nml(i),nml(j)
25    write(21,2121)(AAA(nml(I)+N*(nml(J)-1),ix),ix=1,27)
      close(21)
      call w36('TTTAQ.TXT.SCR written')
      end

      subroutine rdttqaq(N,NT3,ALPHAA,GGA,AAA)
      implicit none
      integer*4 ndif,i,j,N,NT3,ix,ii,jj,jx
      real*8 ALPHAA(NT3**2,9),GGA(NT3**2,9),AAA(NT3**2,27)
      logical lex

      do 1 i=1,N**2
      do 1 ix=1,9
      ALPHAA(i,ix)=0.0d0
      GGA(i,ix)=0.0d0
      AAA(i,ix)=0.0d0
      AAA(i,ix+9)=0.0d0
1     AAA(i,ix+18)=0.0d0

      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)then
       open(21,file='TTTAQ.TXT.SCR')
       read(21,*)
       read(21,*)ndif
       do 23 i=1,ndif
       do 23 j=i,ndif
       read(21,*)ii,jj,ii,jj
       read(21,*)(ALPHAA(ii+N*(jj-1),ix),ix=1,3)
       read(21,*)(ALPHAA(ii+N*(jj-1),ix),ix=4,6)
23     read(21,*)(ALPHAA(ii+N*(jj-1),ix),ix=7,9)
       do 24 i=1,ndif
       do 24 j=i,ndif
       read(21,*)ii,jj,ii,jj
       read(21,*)(GGA(ii+N*(jj-1),ix),ix=1,3)
       read(21,*)(GGA(ii+N*(jj-1),ix),ix=4,6)
24     read(21,*)(GGA(ii+N*(jj-1),ix),ix=7,9)
       do 25 i=1,ndif
       do 25 j=i,ndif
       read(21,*)ii,jj,ii,jj
       do 25 jx=0,8
25     read(21,*)(AAA(ii+N*(jj-1),ix+jx*3),ix=1,3)
       close(21)
       call w36('TTTAQ.TXT.SCR read')
      else
       call w36('TTTAQ.TXT.SCR not found')
      endif
      end

c     ============================================================
      subroutine getfg(FQ,GQ,NT3,N,N7,fg,i)
c     FQ - normal mode force field
c     GQ - normal mode gradient
c     F,G - force fiels and gradient for modes except i
c     fg = F^-1 G 
      implicit none
      integer*4 NT3,N,N7,i,ii,jj,iq,jq,M
      real*8 FQ(NT3,NT3),GQ(*),fg(*)
      real*8,allocatable::F(:,:),G(:),FI(:,:),t(:)
      if(i.lt.N7.or.i.gt.N)then
       write(6,*)i,N
       call report('getfg - mode not in range')
      endif
      M=N-N7
      allocate(F(M,M),G(M),FI(M,M),t(M))
      ii=0
      do 1 iq=N7,N
      if(iq.ne.i)then
       ii=ii+1
       G(ii)=GQ(iq)
       jj=0
       do 2 jq=N7,N
       if(jq.ne.i)then
        jj=jj+1
        F(ii,jj)=FQ(iq,jq)
       endif
2      continue
      endif
1     continue

      call INV(F,FI,M,1.0d-25)

      do 3 iq=1,M
      t(iq)=0
      do 3 jq=1,M
3     t(iq)=t(iq)+FI(iq,jq)*G(jq)

      ii=0
      do 4 iq=N7,N
      if(iq.ne.i)then
       ii=ii+1
       fg(iq)=t(ii)
      else
       fg(iq)=0.0d0
      endif
4     continue
      return
      end
c     ============================================================
      SUBROUTINE INV(A,AI,N,TOL)                                     
      IMPLICIT none
      integer*4 N,oo,ii,jj,iw,io,kk,i2,j2
      REAL*8 TOL, A(N,N),AI(N,N),w                           
      real*8, allocatable ::E(:,:)

      allocate(E(N,2*N))

      DO 1  ii=1,N                                                 
      DO 1  jj=1,N                                                 
      e(ii,jj)=a(ii,jj)
      E(II,JJ+N)=0.0D0                                             
1     if (ii.EQ.jj)e(ii,jj+N)=1.0D0                                

      DO 2 ii=1,N-1                                                
      iw=ii
      if (DABS(e(iw,iw)).LT.TOL) then                                 
       DO 3 io=iw+1,N                                              
       oo=IO
       if (io.GT.N)oo=io-N                                    
3      if (DABS(e(oo,iw)).GE.TOL) goto 11                             
       call report('Inverse cannot be done')
11     CONTINUE                                                       
       DO 4 kk=1, 2*N                                              
       w=e(iw,kk)                                                     
       e(iw,kk)=e(oo,kk)                                              
4      e(oo,kk)=w                                                     
      ENDIF                                                           
      DO 2 jj=ii+1,N                                               
      DO 6 kk=ii+1, 2*N
6     e(jj,kk)=e(jj,kk)-e(ii,kk)*e(jj,ii)/e(ii,ii)                    
2     e(jj,ii)=0.0D0                                                  

      DO 7  ii=1, N-1
      i2=N-ii+1                                                    
      DO 7 jj=1,i2-1                                                  
      j2=i2-jj                                                        
      DO 9 kk=1, N                                                 
9     e(j2,kk+N)=e(j2,kk+N)-e(i2,kk+N)*e(j2,i2)/e(i2,i2)
7     e(j2,i2)=0.0D0
 
      DO 10 ii=1,N                                                 
      DO 10 jj=1,N                                                
10    AI(ii,jj)=e(ii,jj+N)/e(ii,ii)                                

      deallocate(E)
      RETURN                                                          
      END                     
c     ============================================================
      subroutine mksu(S,su,N,NT3,iz)
      implicit none
c     make unitary matrix su from S (su^t su = 1)
      integer*4 N,NT3,a,j,iz(*)
      real*8 S(NT3,NT3),amave,su(NT3,NT3),SFACR
      character*2 sy
      SFACR=0.02342179d0
      sy='xx'
      do 1 a=1,N
      do 1 j=1,N
1     su(a,j)=S(a,j)*dsqrt(amave(iz((a+2)/3),sy))/SFACR
c     SFACR=0.02342179d0
c     sum(A) S(A,I)*S(A,J)*amave(iz((A+2)/3),sy)/SFACR**2 = d(I,J)
      return
      end
c     ============================================================
      subroutine trafogm(G,Gm,N,iz)
      implicit none
      real*8 G(*),Gm(*),AMU,SFACR,amave
      integer*4 N,i,iz(*)
      character*2 sy
      sy='xx'
      SFACR=0.02342179d0
      AMU=1.0d0/SFACR**2
      do 1 i=1,N
c     change also sign - Forces to gradient:
1     Gm(i)=-G(i)/dsqrt(amave(iz((i+2)/3),sy)*AMU)
      return
      end
c     ============================================================
      subroutine  trafofm(FCAR,FCARm,N,NT3,iz)
      implicit none
      integer*4 NT3,N,i,j,iz(*)
      real*8 FCAR(NT3,NT3),FCARm(NT3,NT3),AMU,SFACR,amave,mi,mj
      character*2 sy
      sy='xx'
      SFACR=0.02342179d0
      AMU=1.0d0/SFACR**2
      do 1 i=1,N
      mi=amave(iz((i+2)/3),sy)*AMU
      do 1 j=1,N
      mj=amave(iz((j+2)/3),sy)*AMU
1     FCARm(i,j)=FCAR(i,j)/dsqrt(mi*mj)
      return
      end
c     ============================================================
      function mijkl(N,i,j,k,l,w,u)
      implicit none
      real*8 y,mijkl,w(*),u(*)
      integer*4 N,i,j,k,l
      y=0.0d0
      if(i.eq.k.and.i.eq.l)y=y+3.0d0*w(j+N*(i-1))
      if(j.eq.k.and.j.eq.l)y=y+3.0d0*w(i+N*(j-1))
      if(i.eq.l)y=y-4.0d0*u(k+N*(i-1))*u(j+N*(k-1))
      if(j.eq.k)y=y-4.0d0*u(l+N*(j-1))*u(i+N*(l-1))
      if(l.eq.k)y=y-4.0d0*u(i+N*(k-1))*u(j+N*(k-1))
      mijkl=y
      return
      end
c     ============================================================
c     ============================================================
      subroutine wrtt(N7,N,e,uij,wij,ak,bkl,clj,p5,p6)
      implicit none
      integer*4 N7,N,i,j
      real*8 e(*),uij(*),wij(*),ak(*),bkl(*),clj(*),CM,p5(*),p6(*),usj

      CM=219474.0d0

c     Uij in atomic units:
      open(10,file='UIJ.SCR.TXT')
      do 1 i=N7,N
      do 1 j=N7,N
1     write(10,100)i,j,uij(j+N*(i-1))
100   format(2i5,2g20.6)
      close(10)

c     Ak in CM
      open(10,file='AL.SCR.TXT')
      do 2 i=N7,N
2     write(10,100)i,i,ak(i)/dsqrt(dabs(e(i)))*CM
      close(10)

c     Bkl in cm
      open(10,file='BKL.SCR.TXT')
      do 3 i=N7,N
      do 3 j=N7,N
3     write(10,100)i,j,bkl(j+N*(i-1))/dsqrt(dabs(e(i)*e(j)))*CM
      close(10)

c     Cjl in cm
      open(10,file='CJL.SCR.TXT')
      do 4 i=N7,N
      do 4 j=N7,N
4     write(10,100)i,j,clj(j+N*(i-1))*dsqrt(dabs(e(j)/e(i)))*CM
      close(10)

c     USj in atomic units
      open(10,file='USJ.SCR.TXT')
      do 6 j=1,N
      usj=0.0d0
      do 51 i=1,N
51    usj=usj+uij(j+N*(i-1))
6     write(10,100)j,j,usj*dsqrt(dabs(e(j)))
      close(10)

c     UO in atomic units
      open(10,file='UO.SCR.TXT')
      do 7 i=N7,N
      do 7 j=N7,N
7     write(10,100)i,j,uij(j+N*(i-1))*dsqrt(dabs(e(j)))
      close(10)

c     UU in atomic units
      open(10,file='UU.SCR.TXT')
      do 9 i=N7,N
      do 9 j=N7,N
9     write(10,100)i,j,uij(j+N*(i-1))*dsqrt(dabs(e(j)/e(i)))
      close(10)

c     WW in cm
      open(10,file='WW.SCR.TXT')
      do 10 i=N7,N
      do 10 j=N7,N
10    write(10,100)i,j,wij(j+N*(i-1))*dsqrt(dabs(e(j)/e(i)))*CM
      close(10)

      open(10,file='P5.SCR.TXT')
      do 11 i=N7,N
11    write(10,100)i,i,p5(i)/(dsqrt(dabs(e(i))))**5*CM
      close(10)

      open(10,file='P6.SCR.TXT')
      do 12 i=N7,N
12    write(10,100)i,i,p6(i)/e(i)**3*CM
      close(10)


      call w36('T-constants written')
      return
      end
c     ============================================================
c     ============================================================
