      SUBROUTINE READG98P(NAT,LINEAR,N,FCAR0,AM,N7,R,XLIM,YLIM,step,
     1tol3,S)
c     same as readg98 (gaussian output, cartesian differentiation),
c     but ordered according to coordinates (0,x-,x+,y-,y+ etc)
      IMPLICIT none
      integer*4 i,j,k,N,nat,N7,l,ia,n33,n33t,is,jj
      include 'dimensions.h'
      integer*4 iz(NT0),ig98,ia98dumm,ltot,ii,ic,ix,
     1n44,n44t,iai,iaj,iak,ierr,m
      CHARACTER*50 S50
      CHARACTER*2 atsym,xyz(3)
      data xyz/'x','y','z'/
c     large arrays:
      real*8,allocatable:: CX3(:,:,:),CX4(:,:,:),ajmq(:,:,:)
c     real*8 CX3(NT3,NT3,NT3),CX4(NT3,NT3,NT3),ajmq(2*NT3,NT0,NT0)
c     rest:
      real*8,allocatable::G(:)
      real*8 FCAR0(NT3,NT3),FCAR(NT3,NT3),
     2AM(NT3),R(NT0,3),APT(NT0,3,3),tol3,
     1AAT(NT0,3,3),ALPHA(3,3,NT3),APT0(NT0,3,3),aptn(NT0,3,3),
     1AAT0(NT0,3,3),ALPHA0(3,3,NT3),dip(3),dip0(3),polar(3,3),
     1polar0(3,3),alphan(NT0,3,3,3),GG(3,3,NT3),GG0(3,3,NT3),
     1AATA(NT3,NT0,3,3),alphaa(NT3,3,3,NT3),APTA(NT3,NT0,3,3),
     1gaa(NT3,3,3,NT3),aaa(NT3,3,3,3,NT3),
     1gten(3,3),aten(3,3,3),gten0(3,3),aten0(3,3,3),amave,
     1sigma(2*NT0),sigma0(NT0),ajm(NT0,NT0),ajm0(NT0,NT0),
     1sigmaq(2*NT3,NT0),optrot,optrotq(NT3*2),
     1AA(3,3,3,NT3),AA0(3,3,3,NT3),bohr,ass,step,optrot0,ff,f1,f2,
     1ylim,xlim,S(NT3,NT3)
      LOGICAL lex,lttt,lfc,lx,lff,lxf,lcmx,
     1LINEAR,OPT,lapt,laat,lten,lfcd,lnmr,ljj,loptrot
      logical lzmat,lharm,lopt,lpolar,l411,lgr
      common/lop/lopt(300)
      equivalence (lharm,lopt(9)),(lzmat,lopt(10)),(lcmx,lopt(33)),
     1(l411,lopt(35))
C
      call w36(' ')
      call w36('Readg98p')
      call w36('^^^^^^^^')

      bohr=0.529177d0
C
      inquire(file='FILE.TEN',exist=lten)
      inquire(file='FILE.FC',exist=lfcd)
      inquire(file='FILE.X',exist=lxf)
      INQUIRE(FILE='G.OUT',EXIST=OPT)
      IF(.NOT.OPT)then
       CALL w36('File G.OUT not found, trying to read disk only.')
       if(.not.lxf)call report('FILE.X not found')
       if(.not.lfcd)call report('FILE.FC not found')
       call readdisk(NAT,FCAR0,AM,R,iz,LINEAR,N,N7)
       return
      endif
C
      OPEN(2,FILE='G.OUT')
C
c     find geometry
      write(6,*)' Looking for geometry'
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    (lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       write(6,1111)S50
       write(3,1111)S50
c      rescue mode, read z-matrix geometry after charge:
       if(lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')then
        l=0
1555    l=l+1
        read(2,*,end=1556,err=1556)iz(l),(r(l,i),i=1,3)
        if(l.gt.NT0)call report('Too many atoms')
        goto 1555
1556    nat=l-1
        goto 1557
       endif

       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       DO 41 I=1,4
41     READ(2,*)
       l=0
5      READ(2,1111)s50
       IF(s50(2:4).NE.'---')THEN
        l=l+1
        BACKSPACE 2
        if(ig98.eq.0)then
         READ(2,*)IA,iz(l),(r(l,i),i=1,3)
        else
         READ(2,*)IA,iz(l),IA98DUMM,(r(l,i),i=1,3)
        endif
        GOTO 5
       ENDIF
       nat=l
1557   write(3,*)nat
       open(20,file='FILE.X')
       write(20,*)nat
       write(20,*)nat
       do 34 l=1,nat
       write(20,4100)iz(l),(r(l,i),i=1,3)
34     write(3,4100)iz(l),(r(l,i),i=1,3)
4100   format(I3,3F15.10)
       close(20)
       goto 203
      ENDIF
      goto 201
202   call report('Geometry not found')
203   do 55 ia=1,nat
      atsym='??'
      ASS=amave(iz(IA),atsym)
c
c     assign default mass, if not defined previously:
      if(am(3*(IA-1)+1).lt.0.0d0)then
       DO 551 I=1,3
551    AM(3*IA-3+I)=ASS
      endif
55    continue
      write(6,*)nat,' atoms'
      write(3,*)nat,' atoms'
      allocate(G(3*nat))
c
      WRITE(3,1113)(AM(i),i=1,3*nat)
1113  FORMAT(4F15.8)
      IF(NAT.EQ.2.OR.LINEAR)THEN
       WRITE(3,*)'Linear molecule'
       N7=6
       LINEAR=.TRUE.
      ENDIF
      N=3*NAT
C
      IF(step.gt.1.0d-9)then
       write(3,3000)step,step/bohr
       write(6,3000)step,step/bohr
       step=step/bohr
3000   format('Step defined as ',F10.5,'A (',F10.5,'au)')
      endif
C
c
c     read-in zero point:
      lapt=.false.
      laat=.false.
      lttt=.false.
      lx=.false.
      lfc=.false.
      ltot=0
      call readar0(NT3,N,FCAR0,APT0,AAT0,ALPHA0,dip0,polar0,GG0,AA0,
     1gten0,aten0,optrot0,ajm0,sigma0)
      call readar(NT3,N,FCAR0,APT0,AAT0,ALPHA0,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip0,ltot,polar0,GG0,AA0,gten0,aten0,
     1optrot0,ajm0,sigma0,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      call w36('zero point finished')
      write(3,3700)(dip0(i),i=1,3)
      write(6,3700)(dip0(i),i=1,3)
3700  format(' Dipole         ',3F10.4)
      open(22,file='DIPOLE.TXT.SCR')
      write(22,3699)(dip0(i),i=1,3)
3699  format(3F15.7,' dipole (au)')
      write(22,3698)optrot0
      if(loptrot)write(6,3698)optrot0
3698  format(F15.7,' optrot')
      write(22,3697)
3697  format('Chemical shifts (ppm):')
      if(lnmr)call w36('NMR shifts found')
      do 558 i=1,nat
558   write(22,3696)i,sigma0(i)
3696  format(i5,F15.7)
      write(22,3695)
3695  format('Spin spin coupling:')
      do 559 i=1,nat
      do 559 j=1,nat
559   write(22,3694)i,j,ajm0(i,j)
3694  format(2i5,F15.7)
      close(22)
      if(lpolar)then
       write(3,3701)((polar0(i,j),i=1,3),j=1,3)
       write(6,3701)((polar0(i,j),i=1,3),j=1,3)
3701   format(' Polarizability ',3F10.4,/,
     1        '                ',3F10.4,/,
     1        '                ',3F10.4)
      endif
c
c     load only harmonic ff if requested:
      if(lharm)then
       close(2)
       write(6,*)'lharm option called'
       write(3,*)'lharm option called'
       return
      endif
c
      inquire(file='SCR.33',exist=lex)
      if(lex)then
       call w36('SCR.33 found, G.OUT will not be read further')
       close(2)
       return
      endif
c
      is=0
      allocate(CX3(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX3')
      allocate(CX4(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX4')

      DO 54 I=1,N
      DO 54 J=1,N
      DO 54 K=1,N
      CX3(I,J,K)=0.0d0
54    CX4(I,J,K)=0.0d0
c
      if(ljj.or.lnmr.or.loptrot)then
c      first derivatives 1..N as well as diagonal second derivatives 1..N:
       allocate(ajmq(1:2*N,1:NAT,1:NAT),stat=is)
       if(is.ne.0)call report('cannot allocate ajmq')
       DO 560 II=1,N
       optrotq(II)=0.0d0
       optrotq(N+II)=0.0d0
       DO 560 I=1,NAT
       sigmaq(II,I)=0.0d0
       sigmaq(N+II,I)=0.0d0
       DO 560 J=1,NAT
       ajmq(N+II,I,J)=0.0d0
560    ajmq(II,I,J)=0.0d0
      endif
c
      if(lapt.or.laat)then
       DO 541 II=1,N
       DO 541 I=1,NAT
       DO 541 J=1,3
       DO 541 K=1,3
       AATA(II,I,J,K)=0.0d0
541    APTA(II,I,J,K)=0.0d0
      endif
c
      if(lttt)then
       DO 542 II=1,N
       DO 542 I=1,N
       DO 542 J=1,3
       DO 542 K=1,3
       alphaa(II,J,K,I)=0.0d0
       gaa(II,J,K,I)=0.0d0
       DO 542 M=1,3
542    aaa(II,J,K,M,I)=0.0d0
      endif
      do 547 i=1,nat
      do 547 j=1,3
      do 547 k=1,3
547   aptn(i,j,k)=0.0d0
      do 552 i=1,nat
      do 552 j=1,3
      do 552 k=1,3
      do 552 l=1,3
552   alphan(i,j,k,l)=0.0d0
c
      IC=0
c     333333333333333333333333333333333333333333333333333333333333
3333  IC=IC+1
c
c     read geometry and check the diff. step:
      call chkgeop(r,NT0,nat,lzmat,step,I,ff,ierr,ia,ix)
      if(ierr.eq.99)goto 999
      write(6,6363)IC,step*bohr,I,ia,xyz(ix),ff
      write(3,6363)IC,step*bohr,I,ia,xyz(ix),ff
6363  format('Displacement:',I5,' Step(A):',f10.4,' Coord.:',I5,
     1' Atom:',I5,a1,' Sign:',f3.0)
c     initialize the relevant second derivatives
      if(ff.lt.0.0d0)then
       DO 562 J=1,N
       DO 562 K=1,N
562    CX4(I,J,K)=-2.0d0*FCAR0(J,K)
       if(ljj.or.lnmr.or.loptrot)then
        optrotq(N+I)=-2.0d0*optrot0
        DO 561 II=1,NAT
        sigmaq(N+I,II)=-2.0d0*sigma0(II)
        DO 561 JJ=1,NAT
561     ajmq(N+I,II,JJ)=-2.0d0*ajm0(II,JJ)
       endif
      endif
c
c     initialize archive reading:
      call readar0(NT3,N,FCAR,APT,AAT,ALPHA,dip,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma)
c     read gaussian archive:
      call readar(NT3,N,FCAR,APT,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      write(3,3700)(dip(j),j=1,3)
      write(3,3701)((polar(k,j),k=1,3),j=1,3)
c
      DO 3 J=1,N
      DO 3 K=1,N
      CX3(I,J,K)=CX3(I,J,K)+FCAR(J,K)*ff
3     CX4(I,J,K)=CX4(I,J,K)+FCAR(J,K)
c
      do 548 j=1,3
548   aptn(ia,ix,j)=aptn(ia,ix,j)+ff*dip(j)
      do 553 j=1,3
      do 553 k=1,3
553   alphan(ia,ix,j,k)=alphan(ia,ix,j,k)+ff*polar(j,k)
c
      if(lapt.or.laat)then
       DO 543 II=1,NAT
       DO 543 J=1,3
       DO 543 K=1,3
       AATA(I,II,J,K)=AATA(I,II,J,K)+AAT(II,J,K)*ff
543    APTA(I,II,J,K)=APTA(I,II,J,K)+APT(II,J,K)*ff
      endif
c
      if(ljj.or.lnmr.or.loptrot)then
       optrotq(I)=optrotq(I)+optrot*ff
       optrotq(N+I)=optrotq(N+I)+optrot
       DO 556 II=1,NAT
       sigmaq(I,II)=sigmaq(I,II)+sigma(II)*ff
       sigmaq(N+I,II)=sigmaq(N+I,II)+sigma(II)
       DO 556 J=1,NAT
       ajmq(I+N,II,J)=ajmq(I+N,II,J)+ajm(II,J)
556    ajmq(I,II,J)=ajmq(I,II,J)+ajm(II,J)*ff
      endif
c
      if(lttt)then
       DO 544 II=1,N
       DO 544 J=1,3
       DO 544 K=1,3
       alphaa(I,J,K,II)=alphaa(I,J,K,II)+ALPHA(J,K,II)*ff
       gaa(I,J,K,II)=gaa(I,J,K,II)+GG(J,K,II)*ff
       DO 544 M=1,3
544    aaa(I,J,K,M,II)=aaa(I,J,K,M,II)+AA(J,K,M,II)*ff
      endif
c
      goto 3333
c     333333333333333333333333333333333333333333333333333333333333
c
999   close(2)
C

      if(step.lt.1.0d-9)call report('Diff. step too small!')
c
      f1=1.0d0/STEP**2
      f2=0.5d0/STEP
      DO 15 I=1,N
      DO 15 J=1,N
      DO 15 K=1,N
      CX4(I,J,K)=CX4(I,J,K)*f1
      CX3(I,J,K)=CX3(I,J,K)*f2
15    CONTINUE
c
      do 549 ia=1,nat
      do 549 ix=1,3
      do 549 j=1,3
549   aptn(ia,ix,j)=aptn(ia,ix,j)*f2

      do 554 ia=1,nat
      do 554 ix=1,3
      do 554 j=1,3
      do 554 k=1,3
554   alphan(ia,ix,j,k)=alphan(ia,ix,j,k)*f2
c
      write(3,*)' numeric apt         analytic apt'
      do 550 ia=1,nat
      do 550 ix=1,3
      do 550 j=1,3
550   write(3,3009)aptn(ia,ix,j),APT0(ia,ix,j)
3009  format(2F10.5)
c
c
      write(3,*)' numeric PolDer         analytic PolDer'
      do 555 ia=1,nat
      do 555 ix=1,3
      do 555 j=1,3
      do 555 k=1,3
555   write(3,3010)ia,ix,j,k,alphan(ia,ix,j,k),
     1ALPHA0(j,k,3*(ia-1)+ix)
3010  format(i4,3i2,2F10.5)
c
      if(lttt)then
       DO 545 II=1,N
       DO 545 I=1,N
       DO 545 J=1,3
       DO 545 K=1,3
       alphaa(I,J,K,II)=alphaa(I,J,K,II)*f2
       gaa(I,J,K,II)=gaa(I,J,K,II)*f2
       DO 545 M=1,3
545    aaa(I,J,K,M,II)=aaa(I,J,K,M,II)*f2
       open(15,file='TTT.SCR',form='unformatted')
       write(15)((((alphaa(i,j,k,l),i=1,N),j=1,3),k=1,3),l=1,N)
       write(15)((((gaa(i,j,k,l),i=1,N),j=1,3),k=1,3),l=1,N)
       write(15)(((((1.5d0*
     1 aaa(i,j,k,m,l),i=1,N),j=1,3),k=1,3),m=1,3),l=1,N)
       close(15)
      endif
c
      if(lapt.or.laat)then
       DO 546 II=1,NAT
       DO 546 I=1,N
       DO 546 J=1,3
       DO 546 K=1,3
       AATA(I,II,J,K)=AATA(I,II,J,K)*f2
546    APTA(I,II,J,K)=APTA(I,II,J,K)*f2
       open(15,file='TEN.SCR',form='unformatted')
       write(15)((((APTA(i,j,k,l),i=1,N),j=1,nat),k=1,3),l=1,3)
       write(15)((((AATA(i,j,k,l),i=1,N),j=1,nat),k=1,3),l=1,3)
       close(15)
      endif
c
      if(ljj.or.lnmr.or.loptrot)then
       DO 557 I=1,N
       optrotq(N+I)=optrotq(N+I)*f1
       optrotq(I)=optrotq(I)*f2
       DO 557 II=1,NAT
       sigmaq(N+I,II)=sigmaq(N+I,II)*f1
       sigmaq(I,II)=sigmaq(I,II)*f2
       DO 557 J=1,NAT
       ajmq(N+I,II,J)=ajmq(N+I,II,J)*f1
557    ajmq(I,II,J)=ajmq(I,II,J)*f2
       inquire(file='NMR.SCR',exist=lex)
       if(lex)then
        call w36('NMR.SCR found on disk, not overwritten')
       else
        write(6,7009)N,NAT
        write(3,7009)N,NAT
7009    format('N=',i4,', NAT=',i4)
        call wrnmr(optrot0,optrotq,sigma0,sigmaq,ajm0,ajmq,
     1  NT3,NT0,N,nat,loptrot,lnmr,ljj)
       endif
       deallocate(ajmq)
      endif
c
      call readg98si(NAT,N,R,XLIM,step,0,tol3,N7,S)

      if(.not.lfc)then
       call report('Force fields not present, program finished.')
      endif
C
      N33=0
      N33T=0
      OPEN(4,FILE='SCR.33')
      DO 82 I=1,N
      DO 82 J=1,N
      DO 82 K=1,N
      N33T=N33T+1
      IF(ABS(CX3(I,J,K)).GE.YLIM)THEN
       N33=N33+1
       WRITE(4,4000)I,J,K,CX3(I,J,K)
4000   format(3i6,G16.8)
      ENDIF
82    CONTINUE
      CLOSE(4)
c
      if(l411)then
       call w36('Only cuartic constants related to one atom left')
       DO 84 I=1,N
       DO 84 J=1,N
       DO 84 K=1,N
       iai=(I+2)/3
       iaj=(J+2)/3
       iak=(K+2)/3
84     if(iai.ne.iaj.or.iai.ne.iak)CX4(I,J,K)=0.0d0
      endif

      N44=0
      N44T=0
      OPEN(4,FILE='SCR.44')
      DO 83 I=1,N
      DO 83 J=1,N
      DO 83 K=1,N
      N44T=N44T+1
      IF(ABS(CX4(I,J,K)).GE.XLIM)THEN
       N44=N44+1
       WRITE(4,4000)I,J,K,CX4(I,J,K)
      ENDIF
83    CONTINUE
      CLOSE(4)
c
      WRITE(6,5961)YLIM,XLIM,N33,100*N33/N33T,N33T,N44,N44*100/N44T,N44T
      WRITE(3,5961)YLIM,XLIM,N33,100*N33/N33T,N33T,N44,N44*100/N44T,N44T
5961  FORMAT(/,' Selected quartic and cubic cartesians written',/,
     1' into SCR.44 and SCR.33',/,
     3' Limit 3:',F10.6,/,
     4' Limit 4:',F10.6,/,
     5' Number of selected cubics  :',I10,'(',I3,'%), total ',I10,/,
     6' Number of selected quartics:',I10,'(',I3,'%), total ',I10)
      deallocate(CX3)
      deallocate(CX4)
      call w36('Readg98p-ok')
      RETURN
      END
c
      subroutine chkgeop(r,NT0,nat,lzmat,step,IFOUND,asign,ierr,ia,ix)
      implicit none
      integer*4 NT0,nat,ig98,I,l,ic,IFOUND,ierr,ia,ix
      real*8 r(NT0,3),x,y,z,tol,step,asign,bohr
      character*50 S50
      logical lzmat,lcmx,lopt
      common/lop/lopt(300)
      equivalence (lcmx,lopt(33))
c
      bohr=0.529177d0
      ierr=0
      IFOUND=0
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    (lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       if(lcmx.and.s50(2:7).eq.'Charge')ig98=-1
       if(ig98.ne.-1)then
        DO 41 I=1,4
41      READ(2,*)
       endif
       tol=1.0d-4
       ic=0
       DO 1 l=1,nat
       if(ig98.eq.0)then
        READ(2,*)I,I,x,y,z
       else
        if(ig98.eq.-1)then
         READ(2,*)I,x,y,z
        else
         READ(2,*)I,I,I,x,y,z
        endif
       endif
       if(abs(x-r(l,1)).gt.tol)then
        ic=ic+1
        IFOUND=3*(l-1)+1
        ia=l
        ix=1
        if(x.gt.r(l,1))then
         asign=1.0d0
        else
         asign=-1.0d0
        endif
        step=dabs(x-r(l,1))/bohr
       endif
       if(abs(y-r(l,2)).gt.tol)then
        ic=ic+1
        IFOUND=3*(l-1)+2
        ia=l
        ix=2
        if(y.gt.r(l,2))then
         asign=1.0d0
        else
         asign=-1.0d0
        endif
        step=dabs(y-r(l,2))/bohr
       endif
       if(abs(z-r(l,3)).gt.tol)then
        write(3,3003)l,z-r(l,3)
3003    format('Geo check: Z',I4,F10.6,' A')
        ic=ic+1
        IFOUND=3*(l-1)+3
        ia=l
        ix=3
        if(z.gt.r(l,3))then
         asign=1.0d0
        else
         asign=-1.0d0
        endif
        step=dabs(z-r(l,3))/bohr
       endif
1      continue
       if(ic.ne.1)then
        write(3,*)ic
        call report('defective differentiation found')
       endif
       return
      ENDIF
      goto 201
202   call w36('Geometry not found')
      ierr=99
      return
      end

      subroutine wrnmr(optrot0,optrotq,sigma0,sigmaq,ajm0,ajmq,
     1NT3,NT0,N,nat,loptrot,lnmr,ljj)
      implicit none
      integer*4 NT3,NT0,N,i,j,ii,nat
      real*8 optrot0,optrotq(*),sigma0(*),sigmaq(2*NT3,NT0),
     1ajm0(NT0,NT0),ajmq(2*N,nat,nat)
      logical loptrot,lnmr,ljj
      open(15,file='NMR.SCR.TXT')
      write(15,1)'Optical rotation:',loptrot
1     format(a17,/,L2)
      write(15,8)optrot0
8     format(g15.6)
      write(15,9)' OR Derivatives: '
9     format(a17,' i            ii')
      do 2 I=1,N
2     write(15,3)optrotq(I),optrotq(I+N),I
3     format(2G15.6,4i9)
      write(15,1)' NMR shielding:  ',lnmr
      do 5 i=1,nat
5     write(15,6)sigma0(i),i
6     format(g15.6,4i9)
      write(15,9)' shielding deriv.'
      do 10 ii=1,nat
      do 10 i=1,n
10    write(15,3)sigmaq(i,ii),sigmaq(i+N,ii),i,ii
      write(15,1)' J-Coupling      ',ljj
      do 11 ii=1,nat
      do 11 j=1,nat
11    write(15,6)ajm0(ii,j),ii,j
      write(15,9)' coupling deriv. '
      do 12 j=1,nat
      do 12 ii=1,nat
      do 12 i=1,n
12    write(15,3)ajmq(i,ii,j),ajmq(i+N,ii,j),i,j,ii
      close(15)
      return
      end

      subroutine rdnmr(optrot0,optrotq,sigma0,sigmaq,ajm0,ajmq,
     1NT3,NT0,N,nat,loptrot,lnmr,ljj)
      implicit none
      integer*4 NT3,NT0,N,i,j,ii,nat
      real*8 optrot0,optrotq(*),sigma0(*),sigmaq(2*NT3,NT0),
     1ajm0(NT0,NT0),ajmq(2*N,nat,nat)
      logical loptrot,lnmr,ljj
      open(15,file='NMR.SCR.TXT')
      read(15,*)
      read(15,*)loptrot
      read(15,*)optrot0
      read(15,*)
      do 2 I=1,N
2     read(15,*)optrotq(I),optrotq(I+N)
      read(15,*)
      read(15,*)lnmr
      do 5 i=1,nat
5     read(15,*)sigma0(i)
      read(15,*)
      do 10 ii=1,nat
      do 10 i=1,n
10    read(15,*)sigmaq(i,ii),sigmaq(i+N,ii)
      read(15,*)
      read(15,*)ljj
      do 11 ii=1,nat
      do 11 j=1,nat
11    read(15,*)ajm0(ii,j)
      read(15,*)
      do 12 j=1,nat
      do 12 ii=1,nat
      do 12 i=1,n
12    read(15,*)ajmq(i,ii,j),ajmq(i+N,ii,j)
      close(15)
      return
      end
