      SUBROUTINE READGi2(NAT,LINEAR,N,FCAR0,S,AM,N7,R,HW,step,tol4,
     1tol3,NCAN,ICAN,XLIM)
c     each mode  -2d -d 0 +d +2d
      IMPLICIT none
      integer*4 NAT,N,N7,i,j,k,l,ix,II,ndif,nml,IDUM,IA,IC,ig98,NINDC,
     1imax,jmax,kmax,imx,jmx,kmx,NQ,NQT,ltot,ind,ind1,ind2,nstep,JJ,
     1ic1,ic2,ic3,kl,li,i4
      include 'dimensions.h'
      CHARACTER*50 S50
      CHARACTER*2 atsym
      integer*4 iz(NT0),NCAN,ICAN(*)
      real*8 FCAR0(NT3,NT3),S(NT3,NT3),
     1AM(NT3),R(NT0,3),APT(NT0,3,3),AAT(NT0,3,3),ALPHA(3,3,NT3),
     1APT0(NT0,3,3),aptn(2*NT3,3),AAT0(NT0,3,3),ALPHA0(3,3,NT3),
     1alphan(3,3,2*NT3),GG(3,3,NT3),AA(3,3,3,NT3),AATQ(NT3,3),
     1APTQ(NT3,3),GG0(3,3,NT3),AA0(3,3,3,NT3),A0Q(3,3,3,NT3),
     1AAQ(3,3,3,NT3),ALPHAQ(3,3,NT3),ALPHA0Q(3,3,NT3),rc(NT0,3),
     1APT0Q(NT3,3),AAT0Q(NT3,3),GQ(3,3,NT3),G0Q(3,3,NT3),
     1sigma(NT0*2),sigma0(NT0*2),optrotq(2*NT3),f3,f4,
     1bohr,CM,SFACR,f1,f2,E,tol4,tol3,step,ASS,ff3,ei,ej,dd,dm,c0,cqau,
     1cqcn,cqcm,XLIM,amave,optrot,optrot0,gn,ff4,ff5,ff6,
     1dip(3),dip0(3),polar(3,3),polar0(3,3),gten(3,3),gten0(3,3),
     1aten(3,3,3),aten0(3,3,3),mijkl
c     sigma - holds both isotropic and anisotropic part
c     large arrays:
      real*8,allocatable:: CX3(:,:,:),CX4(:,:,:),ajmq(:,:,:),stepq(:),
     1FQ(:,:),ALPHAA(:,:),GGA(:,:),AAA(:,:),ajm(:,:),FCAR(:,:),
     1sigmaq(:,:),ajm0(:,:),aptaq(:,:),aataq(:,:),G(:),fg(:),
     1wij(:),uij(:),dr(:),su(:,:),FQu(:,:),Gu(:),Gm(:),FCARm(:,:),
     1p5(:),p6(:),CX5(:,:,:),CX6(:,:,:)
c     CXN(NT3,NT3,NT3) Nth energy derivatives
c     ajmq(2*NT3,NT0,NT0) spin-spin constant derivatives

c     curved coordinates:
      real*8,allocatable::ak(:),bkl(:),clj(:)

      LOGICAL HW,lex,lttt,lfc,lx,lff,lcmx,lgr,
     1LINEAR,OPT,lapt,laat,lten,lfcd,lnmr,ljj,loptrot,lpolar
      COMMON/CEM/E(NT3)
      common/cnmd/ndif,nml(NT3)
      logical lzmat,lharm,lopt,lqc
      common/lop/lopt(300)
      equivalence (lharm,lopt(9)),(lzmat,lopt(10)),(lcmx,lopt(33)),
     1(lqc,lopt(51))
      integer*4 iopt,ilqc,ilqcd,ilqct
      common/iop/iopt(300)
      equivalence (ilqc,iopt(21))
C
      call w36('Readg98i')
      call w36('^^^^^^^^')
      call w36('        ')

      allocate(FQ(NT3,NT3),ALPHAA(NT3**2,9),FCAR(NT3,NT3),
     1GGA(NT3**2,9),AAA(NT3**2,27),ajm(NT0,NT0),sigmaq(2*NT3,NT0*2),
     1ajm0(NT0,NT0),aptaq(2*NT3**2,3),aataq(NT3**2,3),FQu(NT3,NT3),
     1FCARm(NT3,NT3))

      bohr=0.529177d0
      CM=219470.0d0
      SFACR=0.02342179d0
c           =1/sqrt(amu), to transfer S into atomic units
c
c     Unit explanation:
c     -----------------
c     dX ... Cartesian coordinate displacement
c     dQ ... normal mode coordinate
c     dX = S.dQ
c     S ... S-matrix written into FILE.INP
c     St.M.S=1, M is the mass matrix in g/mol
c     s=SFACR.S, s is then in atomic units, is written in SMAT.SCR
c     si.FF.sj=delta(i,j)*ei^2, ei is the normal mode energy in a.u.
c     q ... dimensionless normal mode coordinate, qi=sqrt(ei) Qi
c
c     read S and e, transform into a.u.:
      call reads(S,N)
C
      INQUIRE(FILE='A.OUT',EXIST=OPT)
      IF(OPT)then
       call w36('ACES output registered')
       call READACESI(NAT,LINEAR,N,FCAR0,S,
     1AM,N7,R,HW,step,tol4,tol3,NCAN,ICAN,XLIM)
       stop
      endif

      INQUIRE(FILE='CP2K',EXIST=OPT)
      IF(OPT)then
       call w36('CP2K output registered')
       call READCASTEPi(NAT,N,FCAR0,S,AM,N7,R,step,tol4,tol3,NCAN,ICAN)
       return
      endif

      INQUIRE(FILE='CASTEP',EXIST=OPT)
      IF(OPT)then
       call w36('CASTEP output registered')
       call READCASTEPi(NAT,N,FCAR0,S,AM,N7,R,step,tol4,tol3,NCAN,ICAN)
       return
      endif

      INQUIRE(FILE='diff',EXIST=OPT)
      IF(OPT)then
       call w36('diff output registered')
       call READDIFF(NAT,LINEAR,N,FCAR0,S,
     1 AM,N7,R,step,tol4,tol3,NCAN,ICAN,XLIM)
       return
      endif

      INQUIRE(FILE='G.OUT',EXIST=OPT)
      IF(.NOT.OPT)CALL REPORT('File G.OUT not found.')
      inquire(file='FILE.TEN',exist=lten)
      inquire(file='FILE.FC',exist=lfcd)
C
      OPEN(2,FILE='G.OUT')
C
c     find geometry
      write(6,*)' Looking for geometry'
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    (lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       write(6,1111)S50
       write(3,1111)S50

c      rescue mode, read z-matrix geometry after charge:
c      write(6,*)lcmx
c      stop
       if(lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')then
        l=0
1555    l=l+1
        read(2,*,end=1556,err=1556)iz(l),(r(l,i),i=1,3)
        if(l.gt.NT0)call report('Too many atoms')
        goto 1555
1556    nat=l-1
        goto 1557
       endif

       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       DO 41 I=1,4
41     READ(2,*)
       l=0
5      READ(2,1111)s50
       IF(s50(2:4).NE.'---')THEN
        l=l+1
        BACKSPACE 2
        if(ig98.eq.0)then
         READ(2,*)IA,iz(l),(r(l,i),i=1,3)
        else
         READ(2,*)IA,iz(l),IDUM,(r(l,i),i=1,3)
        endif
        GOTO 5
       ENDIF
       nat=l

1557   write(3,*)nat
       open(20,file='FILE.X')
       write(20,*)nat
       write(20,*)nat
       do 34 l=1,nat
       write(20,4000)iz(l),(r(l,i),i=1,3)
34     write(3,4000)iz(l),(r(l,i),i=1,3)
4000   format(I3,3F15.10,' 0 0 0 0 0 0 0 0.0')
       close(20)
       goto 203
      ENDIF
      goto 201
202   call report('Geometry not found')
203   call w36(' ')
      call w36('Mass matrix:')
      do 55 ia=1,nat
      atsym='??'
      ASS=amave(iz(IA),atsym)
c
c     assign default mass, if not defined previously:
      if(am(3*(IA-1)+1).lt.0.0d0)then
       DO 551 I=1,3
551    AM(3*IA-3+I)=ASS
      endif
55    continue
c
      WRITE(3,1113)(AM(i),i=1,3*nat)
1113  FORMAT(4F15.8)
      IF(NAT.EQ.2.OR.LINEAR)THEN
       WRITE(3,*)'Linear molecule'
       N7=6
       LINEAR=.TRUE.
      ENDIF
      N=3*nat

      allocate(G(N),dr(N*N),Gu(N),Gm(N))

c     curved coordinates:
      if(lqc)then
       allocate(wij(N*N),uij(N*N),fg(N))
       call VZ(wij,0.0d0,N*N)
       call VZ(uij,0.0d0,N*N)
       call VZ( dr,0.0d0,N*N)
      endif

C
      inquire(file='CQQ.SCR.TXT',exist=lex)
      if(lex)then
       call w36('CQQ.SCR.TXT found on disk, rest of readg98i skipped')
       close(2)
       return
      endif
c
      IF(step.gt.1.0d-9)then
       write(3,3000)step,step/bohr
       write(6,3000)step,step/bohr
       step=step/bohr
3000   format('Step defined as ',F10.5,'A (',F10.5,'au)')
      endif
C
      NSTEP=1+4*ndif
      write(3,*)nstep,' harmonic force fields expected'
      write(6,*)nstep,' harmonic force fields expected'

c     read-in zero point:
c     Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0
      lapt=.false.
      laat=.false.
      lttt=.false.
      lx=.false.
      lfc=.false.
      lff=.false.
      lgr=.false.
      ltot=0
c
c     zero-out the tensors
      call readar0(NT3,N,FCAR0,APT0,AAT0,ALPHA0,dip0,polar0,GG0,AA0,
     1gten0,aten0,optrot0,ajm0,sigma0)
c
c     read current point from the output
      call readar(NT3,N,FCAR0,APT0,AAT0,ALPHA0,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip0,ltot,polar0,GG0,AA0,gten0,aten0,optrot0,
     1ajm0,sigma0,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      call w36('zero point finished')
      if(lapt)write(6,*)'APT found'
      if(laat)write(6,*)'AAT found'
      if(lttt)write(6,*)'TTT found'
      if(lfc)write(6,*)'FF found'
      if(lx)write(6,*)'X found'
      if(lgr)write(6,*)'Gradient found'
      write(3,3700)(dip0(i),i=1,3)
      write(6,3700)(dip0(i),i=1,3)
3700  format(' Dipole         ',3F10.4)
      write(3,3705)((polar0(i,j),i=1,3),j=1,3)
      write(6,3705)((polar0(i,j),i=1,3),j=1,3)
3705  format(' Polarizability ',3F10.4,/,
     1       '                ',3F10.4,/,
     1       '                ',3F10.4)
      if(ljj)then
       call w36('Spin-Spin Coupling')
       call WRITEM(3,NT0,N/3,ajm0)
       call WRITEM(6,NT0,N/3,ajm0)
      endif
      if(lnmr)then
       call w36('Chemical Shifts  Anisotropies')
       do 3701 I=1,N/3
       write(3,3702)I,sigma0(I),sigma0(I+N/3)
3701   write(6,3702)I,sigma0(I),sigma0(I+N/3)
3702   format(i4,2f15.6)
      endif
      if(loptrot)then
       call w36('Optical Rotation')
       write(3,3703)optrot0
       write(6,3703)optrot0
3703   format(f10.2)
      endif
c
c     load only harmonic ff if requested (debug option):
      if(lharm)then
       close(2)
       write(6,*)'lharm option called'
       write(3,*)'lharm option called'
       return
      endif
c
c     transform Cartesian FF into normal modes:
      call trafoq(FCAR0,FQ,S,N)
c
c     make gradient in mass-weighted coordinates
      call trafogm(G,Gm,N,iz)
c     make FF in mass-weighted coordinates
      call trafofm(FCAR0,FCARm,N,NT3,iz)
c     transform Gradient and FF into normal modes with unit matrix:
      allocate(su(NT3,NT3))
      call mksu(S,su,N,NT3,iz)
      call trafog(NT3,N,Gm,Gu,su)
      call trafoq(FCARm,FQu,su,N)
c
c     transform dipole derivatives into normal modes
      call trafopq(APT0,AAT0,APT0Q,AAT0Q,S,N)
c     write(6,*)N,APT0Q(N,1),APT0Q(N,2),APT0Q(N,3)
c     call report('debug')
c
c     transform polarizability derivatives into normal modes
      call trafoaq(ALPHA0,GG0,AA0,ALPHA0Q,G0Q,A0Q,S,N)
c
      allocate(CX3(N,N,N),CX4(N,N,N),CX5(N,N,N),CX6(N,N,N))
      allocate(ajmq(1:2*N,1:NAT,1:NAT))

c     zero-out/initialize anharmonic variables:
      DO 1 I=1,N
      DO 1 J=1,N
      DO 1 K=1,N
      CX3(I,J,K)=0.0d0
      CX4(I,J,K)=0.0d0
      CX5(I,J,K)=0.0d0
1     CX6(I,J,K)=0.0d0
c
      DO 54 ii=1,ndif
      I=nml(ii)
      DO 54 J=1,N
      DO 54 K=1,N
      CX4(I,J,K)=-2.0d0*FQ(J,K)
54    CX6(I,J,K)= 6.0d0*FQ(J,K)
c
      if(lapt.or.laat)then
       DO 541 II=1,N
       DO 541 JJ=1,N
       DO 541 K=1,3
       aataq(     II+(JJ-1)*N,K)=0.0d0
       aptaq(N**2+II+(JJ-1)*N,K)=-2.0d0*APT0Q(JJ,K)
541    aptaq(     II+(JJ-1)*N,K)=0.0d0
      endif
c
      if(lttt)then
       DO 542 II=1,N**2
       DO 542 J=1,9
       ALPHAA(II,J)=0.0d0
542    GGA(II,J)=0.0d0
       DO 5421 II=1,N**2
       DO 5421 J=1,27
5421   AAA(II,J)=0.0d0
      endif
      do 547 i=1,N
      do 547 k=1,3
      aptn(i+N,k)=-2.0d0*dip0(k)
547   aptn(i,k)=0.0d0
      do 552 i=1,N
      do 552 k=1,3
      do 552 l=1,3
      alphan(k,l,i+N)=-2.0d0*polar0(k,l)
552   alphan(k,l,i)=0.0d0
c
c     first derivatives and diagonal second dervs:
      if(loptrot)then
       do 554 i=1,N
       optrotq(N+i)=-2.0d0*optrot0
554    optrotq(i)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(lnmr)then
       do 555 i=1,N
       do 555 j=1,2*N/3
       sigmaq(N+i,j)=-2.0d0*sigma0(j)
555    sigmaq(i,j)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(ljj)then
       do 556 i=1,N
       do 556 j=1,N/3
       do 556 k=1,N/3
       ajmq(N+i,j,k)=-2.0d0*ajm0(j,k)
556    ajmq(i,j,k)=0.0d0
      endif
c
      allocate(stepq(N))
      do 558 I=1,N
558   stepq(I)=0.0d0
c     Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0Z0

c     start to read the shifted geometries:
c     -2d -d d +d
c     DIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIF
      i4=-3
      I=1
      do 3333 IC=1,4*ndif
      i4=i4+1
      if(i4.eq.0)i4=1
      if(i4.gt.2)then
       i4=-2
       I=I+1
      endif
      write(6,6005)IC,I,i4,nml(I),ltot
      write(3,6005)IC,I,i4,nml(I),ltot
6005  format(/,' Point',i4,' (',i4,'), shift',i2,' mode',i4,' line',i7)
      call sff(i4,ff3,ff4,ff5,ff6)
c
c     check, that we are at the right point, extract step:
      step=0.0d0
      call chkgeos(r,nat,lzmat,step,S,rc,nml(I))
      if(i4.eq.1)stepq(nml(I))=step
c
c     zero-out variables:
      call readar0(NT3,N,FCAR,APT,AAT,ALPHA,dip,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma)
c
c     read-in current values:
      call readar(NT3,N,FCAR,APT,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,optrot,
     1ajm,sigma,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      write(3,3700)(dip(j),j=1,3)
      write(3,3705)((polar(k,j),k=1,3),j=1,3)
      if(ljj)then
       write(3,*)'Spin-Spin Coupling'
       call WRITEM(3,NT0,N/3,ajm)
      endif
      if(lnmr)then
       write(3,*)'Chemical Shifts Anisotropies'
       do 3704 j=1,N/3
3704   write(3,3702)j,sigma(j),sigma(j+N/3)
      endif
      if(loptrot)then
       write(3,*)'Optical Rotation'
       write(3,3703)optrot
      endif
      if(lgr)then
       gn=0.0d0
       do 557 k=1,N
557    gn=gn+G(k)**2
       gn=dsqrt(gn/dble(N))
       write(6,7009)gn
       write(3,7009)gn
7009   format('|G| = ',g12.4)
      endif
c
c     transform Cartesian derivatives to normal modes:
      call trafoq(FCAR,FQ,S,N)

c     trafo gradient in to mass-weighted coordinates and change sign:
c     (actually forces are read, not gradient)
      call trafogm(G,Gm,N,iz)
c     make FF in mass-weighted coordinates:
      call trafofm(FCAR,FCARm,N,NT3,iz)
c     transform Cartesian derivatives to normal modes by su:
      call trafoq(FCARm,FQu,su,N)
      call trafog(NT3,N,Gm,Gu,su)

      call trafopq(APT,AAT,APTQ,AATQ,S,N)
      call trafoaq(ALPHA,GG,AA,ALPHAQ,GQ,AAQ,S,N)

c     do the numerical differentiations:
      DO 3 J=1,N
      DO 3 K=1,N
      CX3(nml(I),J,K)=CX3(nml(I),J,K)+FQ(J,K)*ff3
      CX4(nml(I),J,K)=CX4(nml(I),J,K)+FQ(J,K)*ff4
      CX5(nml(I),J,K)=CX5(nml(I),J,K)+FQ(J,K)*ff5
3     CX6(nml(I),J,K)=CX6(nml(I),J,K)+FQ(J,K)*ff6
c
      do 548 j=1,3
      aptn(nml(I),j)  =aptn(nml(I),j)  +ff3*dip(j)
548   aptn(nml(I)+N,j)=aptn(nml(I)+N,j)+ff4*dip(j)
      do 553 j=1,3
      do 553 k=1,3
      alphan(j,k,nml(I))  =alphan(j,k,nml(I))  +ff3*polar(j,k)
553   alphan(j,k,nml(I)+N)=alphan(j,k,nml(I)+N)+ff4*polar(j,k)
c
      if(lapt.or.laat)then
       DO 543 II=1,N
       DO 543 K=1,3
       ind=nml(I)+N*(II-1)
       aptaq(ind,K)=aptaq(ind,K)+APTQ(II,K)*ff3
       aataq(ind,K)=aataq(ind,K)+AATQ(II,K)*ff3
543    aptaq(N**2+ind,K)=aptaq(N**2+ind,K)+APTQ(II,K)*ff4
c      aataq - nml(I) index goes to coordinate, II is momentum
      endif
c
      if(lttt)then
       DO 544 II=1,N
       ind1=nml(I)+N*(II-1)
       DO 544 J=1,3
       DO 544 K=1,3
       ind2=J+3*(K-1)
       GGA(   ind1,ind2)=GGA(   ind1,ind2)+GQ(    J,K,II)*ff3
       ALPHAA(ind1,ind2)=ALPHAA(ind1,ind2)+ALPHAQ(J,K,II)*ff3
       DO 544 L=1,3
       ind2=J+3*(K-1)+9*(L-1)
544    AAA(   ind1,ind2)=AAA(   ind1,ind2)+AAQ(J ,K,L,II)*ff3
      endif
c
      if(lnmr)then
       DO 545 II=1,2*N/3
       sigmaq(nml(I),II)  =sigmaq(nml(I),II)  +sigma(II)*ff3
545    sigmaq(N+nml(I),II)=sigmaq(N+nml(I),II)+sigma(II)*ff4
      endif
c
      if(ljj)then
       DO 546 II=1,N/3
       DO 546 JJ=1,N/3
       ajmq(nml(I),II,JJ)  =ajmq(nml(I),II,JJ)  +ajm(II,JJ)*ff3
546    ajmq(N+nml(I),II,JJ)=ajmq(N+nml(I),II,JJ)+ajm(II,JJ)*ff4
      endif
c
      if(loptrot)then
       optrotq(nml(I))  =optrotq(nml(I))  +optrot*ff3
       optrotq(N+nml(I))=optrotq(N+nml(I))+optrot*ff4
      endif

      if(lqc)then
       call getfg(FQu,Gu,NT3,N,N7,fg,nml(I))
c      fg ... F-1 g product
       do 549 JJ=1,N
       wij(JJ+N*(nml(I)-1))=wij(JJ+N*(nml(I)-1))+fg(JJ)*ff3
549    uij(JJ+N*(nml(I)-1))=uij(JJ+N*(nml(I)-1))+fg(JJ)*ff4
      endif
c
3333  continue
c     DIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIFDIF
c
      close(2)

C
      if(stepq(nml(I)).lt.1.0d-9)call report('Diff. step too small!')
c
c     dQ(in au)=step(current)/(bohr*SFAC)
c     CX3=[         FF(+Q)     -FF(-Q)        ]/( 2dQ  )
c     CX4=[         FF(+Q)-2FF +FF(-Q)        ]/  dQ**2     
c     CX5=[FF(+2Q)-2FF(+Q)    +2FF(-Q)-FF(-2Q)]/(2dQ**3)
c     CX6=[FF(+2Q)-4FF(+Q)+6FF-4FF(-Q)+FF(-2Q)]/  dQ**4
      DO 15 I=1,ndif
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      f3=0.5d0*(SFACR*bohr/stepq(nml(I)))**3
      f4=1.0d0*(SFACR*bohr/stepq(nml(I)))**4
      DO 15 J=1,N
      DO 15 K=1,N
      CX3(nml(I),J,K)=CX3(nml(I),J,K)*f1
      CX4(nml(I),J,K)=CX4(nml(I),J,K)*f2
      CX5(nml(I),J,K)=CX5(nml(I),J,K)*f3
15    CX6(nml(I),J,K)=CX6(nml(I),J,K)*f4

      if(lqc)then
       DO 550 I=1,ndif
       f1=0.5d0*(SFACR*bohr/stepq(nml(I)))**3
       f2=0.5d0*(SFACR*bohr/stepq(nml(I)))**2
       do 550 JJ=1,N
       wij(JJ+N*(nml(I)-1))=-wij(JJ+N*(nml(I)-1))*f1
550    uij(JJ+N*(nml(I)-1))=-uij(JJ+N*(nml(I)-1))*f2
      endif

      DO 161 I=ndif,1,-1
      ei=sqrt(E(nml(I)))
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      do 161 j=1,3
      aptn(nml(I),j)=aptn(nml(I),j)*f1/ei
      aptn(nml(I)+N,j)=aptn(nml(I)+N,j)*f2/ei/ei
      APT0Q(nml(I),j)=APT0Q(nml(I),j)/ei
161   AAT0Q(nml(I),j)=AAT0Q(nml(I),j)*ei
c
c     for tensor properties, write the derivatives (au) with respect to q:
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENQ.TXT.SCR found on disk, unchanged')
      else
       if(.not.lapt)then
c       if no analytical derivatives, then use numerical:
        DO 162 I=ndif,1,-1
        do 162 j=1,3
162     APT0Q(nml(I),j)=aptn(nml(I),j)
       endif
       call wrten1q(dip0,ndif,lapt,aptn,APT0Q,NT3,AAT0Q,nml,N)
      endif
c
      DO 18 I=ndif,1,-1
      ei=sqrt(E(nml(I)))
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      DO 18 J=ndif,1,-1
      ej=sqrt(E(nml(J)))
      ind=nml(I)+N*(nml(J)-1)
      do 18 k=1,3
      aptaq(ind,k)=aptaq(ind,k)/ei/ej*f1
c
c     third dipolar derivatives uiij = u(N**2+i+(j-1)N)
      aptaq(N**2+ind,k)=aptaq(N**2+ind,k)/ei/ei/ej*f2
18    aataq(ind,k)=aataq(ind,k)/ei*ej*f1
c     aataq = i-index coordinate, J -momentum

      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENAQ.TXT.SCR found on disk, unchanged')
      else
       call wrtenq(ndif,N,aptaq,aataq,NT3,nml)
      endif
c
      DO 19 I=1,ndif
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      ei=sqrt(E(nml(I)))
      do 19 j=1,3
      do 19 k=1,3
      G0Q(j,k,nml(I))=G0Q(j,k,nml(I))/ei
      ALPHA0Q(j,k,nml(I))=ALPHA0Q(j,k,nml(I))/ei
      alphan(j,k,nml(I))=alphan(j,k,nml(I))*f1/ei
      do 19 l=1,3
19    A0Q(j,k,l,nml(I))=A0Q(j,k,l,nml(I))/ei

      call wrttq(polar0,ndif,nml,ALPHA0Q,alphan,gten0,aten0,
     1G0Q,A0Q,NT3)


      do 23 i=1,ndif
      ei=sqrt(E(nml(i)))
      f1=0.5d0* SFACR*bohr/stepq(nml(I))
      f2=1.0d0*(SFACR*bohr/stepq(nml(I)))**2
      do 23 j=i,ndif
      ej=sqrt(E(nml(j)))
      ind1=nml(I)+N*(nml(J)-1)
      ind2=nml(J)+N*(nml(I)-1)
      do 22 ix=1,9
      GGA(ind1,ix)   =0.5d0*(GGA(ind1,ix)   +GGA(ind2,ix)   )/ei/ej*f1
      GGA(ind2,ix)=GGA(ind1,ix)
      ALPHAA(ind1,ix)=0.5d0*(ALPHAA(ind1,ix)+ALPHAA(ind2,ix))/ei/ej*f1
22    ALPHAA(ind2,ix)=ALPHAA(ind1,ix)
      do 26 ix=1,27
      AAA(ind1,ix)   =0.5d0*(AAA(ind1,ix)   +AAA(ind2,ix)   )/ei/ej*f1
26    AAA(ind2,ix)=AAA(ind1,ix)
23    continue

      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTAQ.TXT.SCR found on disk, unchanged')
      else
       call wrttqaq(ndif,nml,N,NT3,ALPHAA,GGA,AAA)
      endif

      inquire(file='PROP.TXT.SCR',exist=lex)
      if(lex)then
       call w36('PROP.TXT.SCR exists, now overwritten')
      else
       open(21,file='PROP.TXT.SCR')
       write(21,*)N7,N
c
       if(loptrot)then
        write(21,*)loptrot
        write(21,2125)1,optrot0
2125    format('Optical rotation:',/,i5,/,20x,f10.2)
        do 27 i=N7,N
        f1=0.5d0* SFACR*bohr/stepq(I)
        f2=1.0d0*(SFACR*bohr/stepq(I))**2
        if(e(i).le.0.0d0)then
         write(21,2126)i,0.0d0,0.0d0
        else
         write(21,2126)i,optrotq(i)*f1/dsqrt(e(i)),optrotq(N+i)*f2/e(i)
        endif
27      continue
2126    format(20x,i5,2g15.5)
       endif
c
       if(lpolar)then
        write(21,*)lpolar
        write(21,2132)9
2132    format('Polarizability:',/,i5)
        do 32 i=1,3
        do 32 j=1,3
32      write(21,21281)i,j,polar0(i,j)
        do 33 i=1,3
        do 33 j=1,3
        do 33 k=N7,N
        f1=0.5d0* SFACR*bohr/stepq(k)
        f2=1.0d0*(SFACR*bohr/stepq(k))**2
        if(e(k).le.0.0d0)then
         write(21,2130)i,j,k,0.0d0,0.0d0
        else
         write(21,2130)i,j,k,alphan(i,j,k)*f1/dsqrt(e(k)),
     1   alphan(i,j,N+k)*f2/e(k)
        endif
33      continue
       endif
c
       if(lnmr)then
        write(21,*)lnmr
        write(21,2127)N/3
2127    format('Chemical shifts:',/,i5)
        do 28 i=1,N/3
28      write(21,2131)i,sigma0(i)
2131    format(i20,2g15.5)
        do 29 i=1,N/3
        do 29 j=N7,N
        f1=0.5d0* SFACR*bohr/stepq(j)
        f2=1.0d0*(SFACR*bohr/stepq(j))**2
        if(e(j).le.0.0d0)then
         write(21,2128)i,j,0.0d0,0.0d0
2128     format(i20,i5,4g15.5)
        else
         write(21,2128)i,j,sigmaq(j,i)*f1/dsqrt(e(j)),
     1   sigmaq(N+j,i)*f2/e(j)
        endif
29      continue

        write(21,*)lnmr
        write(21,2133)N/3
2133    format('Shift Anisotropies:',/,i5)
        do 281 i=1,N/3
281     write(21,2131)i,sigma0(i+N/3)
        do 291 i=1,N/3
        do 291 j=N7,N
        f1=0.5d0* SFACR*bohr/stepq(j)
        f2=1.0d0*(SFACR*bohr/stepq(j))**2
        if(e(j).le.0.0d0)then
         write(21,2128)i,j,0.0d0,0.0d0
        else
         write(21,2128)i,j,sigmaq(j,i+N/3)*f1/dsqrt(e(j)),
     1   sigmaq(N+j,i+N/3)*f2/e(j)
        endif
291     continue
       endif
c
       if(ljj)then
        write(21,*)ljj
        write(21,2129)N/3*N/3
2129    format('Spin-Spin Couplings:',/,i5)
        do 30 i=1,N/3
        do 30 j=1,N/3
30      write(21,21281)i,j,ajm0(i,j)
21281   format(2i10,g15.5)
        do 31 i=1,N/3
        do 31 j=1,N/3
        do 31 k=N7,N
        f1=0.5d0* SFACR*bohr/stepq(k)
        f2=1.0d0*(SFACR*bohr/stepq(k))**2
        if(e(k).le.0.0d0)then
         write(21,2130)i,j,k,0.0d0,0.0d0
        else
         write(21,2130)i,j,k,ajmq(k,j,i)*f1/dsqrt(e(k)),ajmq(N+k,j,i)
     1   *f2/e(k)
        endif
31      continue
2130    format(2i10,i5,2g15.5)
       endif

       close(21)
       call w36('PROP.TXT.SCR')
      endif
c
      call readg98si(NAT,N,R,XLIM,step,1,tol3,N7,S)

      if(.not.lff)call report('force field not found')
c
      call w36(' ')
      call w36('Symmetrizing cubics')
      NINDC=0
      imax=0
      jmax=0
      kmax=0
      imx=0
      jmx=0
      kmx=0
      dd=0.0d0
      dm=0.0d0
      DO 152 I=N7,N
      DO 152 J=I,N
      DO 152 K=J,N
      c0=CX3(I,J,K)
      CX3(I,J,K)=(CX3(I,J,K)+CX3(I,K,J)+CX3(J,I,K)
     1+           CX3(J,K,I)+CX3(K,I,J)+CX3(K,J,I))/6.0d0
      if(dabs(c0-CX3(I,J,K)).gt.dd)then
       dd=dabs(c0-CX3(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
152   NINDC=NINDC+1
      write(6,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
      write(3,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
8989  format(' Largest assymetry:',3i3,' c =',g12.4,' dc =',g12.4)
      write(6,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
      write(3,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
1989  format(' Largest constant :',3i3,' c =',g12.4)

c     correct force field to curved coordinates:
      if(lqc)then
c      terms from quartic cartesian potential:

c      call testmode(NT0,NT3,nat,9,N,N7,r,Su,Uij,Wij,AM,iz)

       ilqcd=mod(ilqc,10)
       ilqct=mod(ilqc,100)/10
       write(3,7041)ilqc,ilqcd,ilqct
       write(6,7041)ilqc,ilqcd,ilqct
7041   format(' ILQC = ',i4,' ILQCD = ',i1,' ILQCT = ',i1,/)
       if(ilqcd.ne.0)then
c       potential correction
        do 704 i=N7,N
        do 704 j=N7,N
704     CX4(i,i,i)=CX4(i,i,i)-12.0d0*(e(j)*uij(j+N*(i-1)))**2
       endif
       if(ilqct.ne.0)then
c       kinetic energy - precalculate things
        allocate(bkl(N**2),ak(N),clj(N**2),p5(N),p6(N))
        do 706 i=N7,N
        ak(i)=0.0d0
        do 706 j=N7,N
        ak(i)=ak(i)+4.0d0*uij(j+N*(i-1))*uij(j+N*(i-1))*uij(i+N*(j-1))
        do 706 k=N7,N
 706    ak(i)=ak(i)+2.0d0*uij(k+N*(j-1))*uij(i+N*(k-1))*uij(k+N*(i-1))
        do 707 k=N7,N
        do 707 l=N7,N
        kl=l+N*(k-1)
        bkl(kl)=0.0d0
        do 707 i=N7,N
        bkl(kl)=bkl(kl)+4.0d0*
     1  uij(k+N*(i-1))*uij(i+N*(k-1))*uij(l+N*(i-1))*uij(i+N*(l-1))
        do 707 j=N7,N
707     bkl(kl)=bkl(kl)+(mijkl(N,i,j,k,i,wij,uij)
     1                  +mijkl(N,i,j,i,k,wij,uij))*
     1  uij(l+N*(j-1))*uij(j+N*(l-1))
     1  +mijkl(N,i,j,k,l,wij,uij)*uij(j+N*(i-1))*uij(i+N*(j-1))
        do 712 l=N7,N
        do 712 i=N7,N
        li=i+N*(l-1)
        clj(li)=0.0d0
        do 712 j=N7,N
 712    clj(li)=clj(li)+0.5d0*
     1  (mijkl(N,j,i,l,j,wij,uij)+mijkl(N,j,i,j,l,wij,uij))
        do 717 i=N7,N
        p5(i)=0.0d0
        p6(i)=0.0d0
        do 717 j=N7,N
        p5(i)=p5(i)-uij(j+N*(i-1))*e(j)**2*wij(j+N*(i-1))
        p6(i)=p6(i)-(e(j)*wij(j+N*(i-1)))**2/2.0d0
        do 717 k=N7,N
        p5(i)=p5(i)-uij(j+N*(i-1))*uij(k+N*(i-1))*CX3(i,j,k)/2.0d0
717     p6(i)=p6(i)-uij(j+N*(i-1))*wij(k+N*(i-1))*CX3(i,j,k)
     1             -uij(j+N*(i-1))*uij(k+N*(i-1))*CX4(i,j,k)/4.0d0
        call wrtt(N7,N,e,uij,wij,ak,bkl,clj,p5,p6)
        deallocate(bkl,ak,clj,p5,p6)
       endif
       call w36(' QC terms added ')
      endif
c
c     list cubics into text file
      open(23,file='CQQ.SCR.TXT')
      NQ=0
      nqt=0
      do 62 i=N7,N
      do 62 j=i,N
      do 62 k=j,N

c     skip if no differentiation:
      ic1=0
      ic2=0
      ic3=0
      do 622 ii=1,ndif
      if(nml(ii).eq.i)ic1=ic1+1
      if(nml(ii).eq.j)ic2=ic2+1
622   if(nml(ii).eq.k)ic3=ic3+1
      if(ic1.ne.1.or.ic2.ne.1.or.ic3.ne.1)goto 62

c     skip if mode blocked:
      do 4001 l=1,NCAN
4001  if(I-N7+1.eq.ICAN(l).or.J-N7+1.eq.ICAN(l).or.K-N7+1.eq.ICAN(l))
     1goto 62
c
c     skip for negative frequencies:
      if(e(i).le.0.0d0.or.e(j).le.0.0d0.or.e(k).le.0.0d0)goto 62

      cqau=CX3(I,J,K)
      cqcn=cqau/dsqrt(abs(e(i)*e(j)*e(k)))
      cqcm=cqcn*CM
c
c     skip small constants:
      if(abs(cqcm).lt.tol3)goto 62
c
      write(23,2423)I,J,K,cqcn,cqcm
2423  format(3I5,G16.8,' ',F9.1)
      nq=nq+1
62    nqt=nqt+1
      close(23)
      write(6,6000)nqt,nq,tol3
      write(3,6000)nqt,nq,tol3
6000  format('Number of normal cubics ',I10,/,
     1       'Selected                ',I10,/,
     1       'Limit                   ',F10.7,/,
     1       'Writen in CQQ.SCR.TXT',/)

      call wr456(4,N,CX4,ndif,nml,N7,E,tol4)
      call wr456(5,N,CX5,ndif,nml,N7,E,tol4)
      call wr456(6,N,CX6,ndif,nml,N7,E,tol4)
c
      RETURN
      END

      subroutine sff(i4,ff3,ff4,ff5,ff6)
      integer*4 i4
      real*8 ff3,ff4,ff5,ff6
      if(i4.eq.-2)then
       ff3 =  0.0d0
       ff4 =  0.0d0
       ff5 = -1.0d0
       ff6 =  1.0d0
      else
       if(i4.eq.-1)then
        ff3 = -1.0d0
        ff4 =  1.0d0
        ff5 =  2.0d0
        ff6 = -4.0d0
       else
        if(i4.eq. 1)then
         ff3 =  1.0d0
         ff4 =  1.0d0
         ff5 = -2.0d0
         ff6 = -4.0d0
        else
         if(i4.eq. 2)then
          ff3 =  0.0d0
          ff4 =  0.0d0
          ff5 =  1.0d0
          ff6 =  1.0d0
         else
          write(6,*)i4
          write(3,*)i4
          call report('Unknown i4')
         endif
        endif
       endif
      endif
      return
      end

      subroutine wr456(ic,N,CX4,ndif,nml,N7,E,tol4)
      implicit none
      integer*4 ic,imax,jmax,kmax,imx,jmx,kmx,I,J,K,ndif,nml(*),
     1ic1,ic2,ic3,ic4,ii,N7,N
      real*8 CX4(N,N,N),dd,dm,c0,E(*),tol4
      call w36(' ')
      if(ic.eq.4)call w36('Symmetrizing quartics')
      if(ic.eq.5)call w36('Symmetrizing quintics')
      if(ic.eq.6)call w36('Symmetrizing sextics')
      imax=0
      jmax=0
      kmax=0
      dd=0.0d0
      imx=0
      jmx=0
      kmx=0
      dm=0.0d0
      DO 153 I=N7,N
      DO 153 J=N7,N
      DO 153 K=J,N
      c0=CX4(I,J,K)
      if(j.eq.i)then
c      iii
       if(k.eq.i)then
c       iiii
       else
c       iiik iiki
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       endif
      else
c      iij
       if(k.eq.i)then
c       iiji iiji
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       else
        if(k.eq.j)then
c        iijj jjii - only quartic
         if(ic.eq.4)then
          CX4(I,J,K)=(CX4(I,J,K)+CX4(J,I,I))/2.0d0
          CX4(J,I,I)=CX4(I,J,K)
         endif
        else
c        iijk iikj
         CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
         CX4(I,K,J)=CX4(I,J,K)
        endif
       endif
      endif
      if(dabs(c0-CX4(I,J,K)).gt.dd)then
       dd=dabs(c0-CX4(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
153   continue
      write(6,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
      write(3,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
8985  format(' Largest assymetry:',4i3,' d =',g12.4,' dd =',g12.4)

      write(6,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
      write(3,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
2989  format(' Largest constant :',4i3,' d =',g12.4)
c
c     zero if no differentiation:
      do 621 i=n7,n
      do 621 j=n7,n
      do 621 k=j,n
      ic1=0
      ic2=0
      ic3=0
      ic4=0
      do 623 ii=1,ndif
      if(nml(ii).eq.i)ic1=ic1+1
      if(nml(ii).eq.i)ic2=ic2+1
      if(nml(ii).eq.j)ic3=ic3+1
623   if(nml(ii).eq.k)ic4=ic4+1
621   if(ic1.ne.1.or.ic2.ne.1.or.ic3.ne.1.or.ic4.ne.1)CX4(i,j,k)=0.0d0
      call write456(ic,CX4,N7,N,E,tol4)
      return
      end

      subroutine write456(ic,cx4,N7,N,e,tol4)
      implicit none
      integer*4 N7,N,NQ,nqt,i,ic,j,k
      real*8 cx4(N,N,N),e(*),cm,cqcn,tol4
c     write AH constants 4-6
      cm=219470.0d0
      if(ic.eq.4)open(23,file='DQQ.SCR.TXT')
      if(ic.eq.5)open(23,file='5QQ.SCR.TXT')
      if(ic.eq.6)open(23,file='6QQ.SCR.TXT')
      nQ=0
      nqt=0
      do 621 i=n7,n
      do 621 j=n7,n
      do 621 k= j,n
      cqcn=cx4(i,j,k)/dsqrt(abs(e(i)**(ic-2)*e(j)*e(k)))
c     write only big:
      if(dabs(cqcn*cm).ge.tol4)then
       write(23,5333)I,J,K,cqcn,cqcn*cm
5333   format(3I6,G16.8,' ',f9.1)
       nq=nq+1
      endif
621   nqt=nqt+1 
      close(23)
      write(6,6001)nqt,nq,tol4
      write(3,6001)nqt,nq,tol4
6001  format('number of constants       ',I10,/,
     1       'Selected                  ',I10,/,
     1       'Limit                     ',F10.7,' cm-1',/)
      return
      end
