      SUBROUTINE setstatex1(N)
c
c     define vibrational states in Cartesian basis
c     algorithm for unlimited excitation number
c
      implicit none
      integer*4 N,I,NAT,IDUMM,LEXCL,NHBIG,II,id,jd,iex,Nexc,
     1iopt,icem,ic
      include 'dimensions.h'
      INTEGER*4 STATE(NT3),NACT,ice
      real*8 x(3*NT0),cut1,dist,ropt,eii,distm
      integer*4 IT(NM0),IS(NM0),ICC(NM0,ME0),
     1IBIGSYM(NM0),IN(NM0,ME0),si(ME0)
      COMMON/DIA1/NHBIG,IT,IS,IBIGSYM,ICC,IN
      COMMON/RUNCON/LEXCL
      COMMON/opt/ropt(100)
      COMMON/iop/iopt(300)
      equivalence (cut1,ropt(4)),(icem,iopt(8))
      logical live
      COMMON/lcbe/eii(NT3),live(NT3)
      common/excc/ice(ME0)

c
c     LEXCL - maximal number of excitations
c     icem - maximal number of excited centers
      if(LEXCL.gt.ME0)call report('Max number of excitation exceeded')
      write(6,6009)LEXCL,cut1,icem
      write(3,6009)LEXCL,cut1,icem
6009  format(' LEXCL =',i3,', cut1 = ',f10.2,'A, icem =',i3)
      do 2 I=1,LEXCL
2     write(3,6099)I,ice(I)
6099  format(i3,'x exc. state resides up to',i4,' centers')
c
c     number of active centers:
      NACT=0
      do 1 I=1,N
1     IF(live(I))NACT=NACT+1
      call statereport(NACT)
      OPEN(4,FILE='FILE.X')
      READ(4,*)
      READ(4,*)NAT
      DO 111 I=1,NAT
111   READ(4,*)IDUMM,(x(II+3*(I-1)),II=1,3)
      CLOSE(4)
c
      NHBIG=0

C     Ground state:
      DO  1965 I=1,N
1965  STATE(I)=0
      call repx(STATE,N,icem)
c
c     states Nexc excited
      do 3 Nexc=1,LEXCL

c     distribute Nexc excitations upon N centers:
c     initial indices - all to the first center:
      do 41 iex=1,Nexc
41    si(iex)=1
5     DO  1966 I=1,N
1966  STATE(I)=0
c     write(6,6000)(si(i),i=1,Nexc)
c000  format(20i3)
      do 4 iex=1,Nexc
      if(live(si(iex)))then
       state(si(iex))=state(si(iex))+1
      else
       goto 7
      endif
4     continue
      distm=0.0d0
      do 6 id=1,N
      do 6 jd=id+1,N
      if(state(id).ne.state(jd))then
       if(dist(id,jd,x).gt.distm)distm=dist(id,jd,x)
      endif
6     continue
      if(distm.lt.cut1)call repx(STATE,N,icem)
c     in the next round, start placing last excitation to the next center:
7     continue
c
c     find index to be changed
      do 8 ic=Nexc,1,-1
8     if(si(ic).lt.N)goto 9
      goto 3
9     do 10 i=ic+1,Nexc
10    si(i)=si(ic)+1
      si(ic)=si(ic)+1
c
      goto 5
c
3     continue
C
      WRITE(6,3013)NHBIG
      WRITE(3,3013)NHBIG
3013  FORMAT(I6,' states selected into the Hamiltonian')
      RETURN
      END
