      SUBROUTINE SGFOURIER(N,NMM,NEE,VMM,SMALLE,IERR,MV,J1,s1,MVTOT,
     1lftg)
c     Fast-Fourier-transform spectral generation
      implicit none
      INTEGER*4 N,NMM,NEE,IERR,MV,J1,MVTOT,iel,imi,ipr,
     1nff,OMP_GET_THREAD_NUM,n5,NGE0,NAT,
     1NK0,iti,itj,itkl,l,io,NGR0,iuu,nfft,np,ji
      include 'dimensions.h'
      PARAMETER (NGE0=24,n5=5,NK0=52,NGR0=100)
c
c     NK0=1+3+3+9+9+27   scalar+u+m+alpha+G'+A
      real*8 VMM, SMALLE(*),a33(NM0),dt,con,dd,EPS,debye,sf,random,
     1ACUT,DIAG,pi,clight,CM,SFU,ELJK,
     1tpc,WG,dttpc,PP(NT0,3,3),AI(NT0,3,3),JJ(NT0,3,3),
     1PV(NT0,3,3),QP(3,NT3),QI(3,NT3),QJ(3,NT3),QM(3,NT3),SM(NT3,NT3),
     1ALPHA(NT3,3,3),ALPHAQ(NT3,3,3),E(NT3),W(NT3),QMQ(3,NT3,NT3),
     1QPQ(3,NT3,NT3),MGD(3),MED(3),MND(3),PPQ(NT0,3,3,NT3),ALIM,CGK,
     1IIQ(NT0,3,3,NT3),CLIGHTAU,AUD,PPV(NT0,3,3,NT3),R(3,NT0),BOHR,
     1JJQ(NT0,3,3,NT3),PVT(NT0,3,3),PPT(NT0,3,3),FGEO,ELIMIT,
     1GTENQ(NT3,3,3),GTEN(NT3,3,3),ATEN(NT3,3,3,3),ATENQ(NT3,3,3,3),
     1alphaaq(NT3**2,9),aptaq(2*NT3**2,3),aataq(NT3**2,3),
     1ELJKQ,A,ni,w0,s1r,s1i,ggaq(NT3**2,9),aaaq(NT3**2,27)
c
c     large
      real*8,allocatable::
     1GR(:),abb(:),sto(:),dta(:),ur(:),ui(:),sr(:),si(:),sff(:)
c     GR(NM0*NK0),abb(nbuff)
      integer*4,allocatable:: jbb(:)
c     jbb(nbuff)
c
c     omp variables:
      integer*4 iis,i,iit,ii,k,j,ix,i2,N11,N22
      character*10 s10
      real*8 ANORM,rr(NM0),ri(NM0),r0(NM0),
     2r2r(NM0),r2i(NM0),rrmm(NM0),rimm(NM0),rrm(NM0),
     3rim(NM0),t,ttpc,cg,sg,AXR(NM0),AXI(NM0),
     4w_i,
     5SAL0,SAL1,SAG0,SAG1,SA1,sar(nproc0),sai(nproc0)

      character*1 s1
      logical lftg,LG,ldisk,lopt,lto
      common/lop/lopt(300)
      equivalence (LG,lopt(30)),(lto,lopt(40))
      integer*4 IYS,CHT(NGE0,NGE0),IG,IGG,KG,ID,j33(NM0),
     1nn(NM0),mm(NM0),idum
      character*3 SSTR
      COMMON/SYMCOM/IYS(NT3),CHT,IG,IGG,KG,ID(NGE0),SSTR
      integer*4 iopt,NWV,nmd,nproc,iprint,NOAT
      common/iop/iopt(300)
      equivalence (NWV,iopt(12)),(nmd,iopt(13)),(nproc,iopt(14)),
     1(iprint,iopt(16))
      real*8 ropt,wmin,wmax,DW,stemp,etlim,etal,det,TEMP,wmaxf
      common/opt/ropt(100)
      equivalence (wmin,ropt(8)),(wmax,ropt(9)),
     1(dt,ropt(10)),(DW,ropt(11)),(ni,ropt(12)),(w0,ropt(13)),
     1(stemp,ropt(14)),(etlim,ropt(17)),(etal,ropt(18)),(det,ropt(19))
      integer*4 nstart(nproc0),nend(nproc0),mclock,
     1it0,OMP_GET_MAX_THREADS,OMP_GET_NUM_PROCS,N7,N3,NGROUND,
     1IGROUND(NGR0),N1,N2,IZERO,SJ(NT3),SK(NT3),KK,NBG,IT,IS,IBIGSYM,
     1ICC,IN,IQ,iu,iz,JQ,PR,iy,STATE1(NT3),STATE2(NT3)
      logical L4
      COMMON/SUM/A,STATE1,STATE2,N7,N3,L4
      logical RAMAN,WRQ,AD,lex,GEO,WRONLY,LVCD,LTEN,LTTT,LRESTART,LINS,
     1lex1,lex2
      common/OPTW/WRQ
      COMMON/DIA1/NBG,IT(NM0),IS(NM0),IBIGSYM(NM0),
     1ICC(NM0,ME0),IN(NM0,ME0)

c
      CALL SPAR(AD,GEO,WRQ,RAMAN,WRONLY,FGEO,IGROUND,NGROUND,NGR0,
     1N1,N2,
     1ELIMIT,IZERO,CM,AUD,CLIGHTAU,BOHR,LVCD,LTEN,
     2LTTT,ACUT,LRESTART,LINS,TEMP)
      call INIP(AI,JJ,PV,NT0)
      IG=MAX(IGROUND(1),1)
      if(IG.ne.1)call report('IG <> 1 not implemented')

      clight=2.99792458D8
      debye=2.541732d0
      it0=mclock()
      pi=4.0d0*atan(1.0d0)
      tpc=2.0d0*pi*clight*100.0d0*1.0d-15
c     2pi c v t dimensionless, v[cm-1], t[fs]
      dttpc=dt*tpc
c
      nfft=nint(exp((aint(log(dble(nmd))/log(2.0d0))+1.0d0)*log(2.0d0)))
      write(6,6003)nmd,nfft
      write(3,6003)nmd,nfft
6003  format(' Zero filling :',i8,' -> ',i8)
      WMIN=0.0d0
      wmaxf=1.0d0/(clight*100.0d0*1.0d-15*dt)/2.0d0
      if(wmaxf.lt.wmax)call report('dt too large')
c     w = -1/(2t) .... + 1/(2t)
      dd=wmaxf/dble(nfft/2)
      np=int((wmax-wmin)/dd)
      write(3,6001)wmaxf,WMIN,WMAX,dd,np,nmd,dt,w0,ni,NWV,iprint,
     1omp_get_num_procs(),omp_get_max_threads(),nproc,lftg,
     1DW,LG,stemp,NWV
      write(6,6001)wmaxf,WMIN,WMAX,dd,np,nmd,dt,w0,ni,NWV,iprint,
     1omp_get_num_procs(),omp_get_max_threads(),nproc,lftg,
     1DW,LG,stemp,NWV
6001  format(/,/,'Fourier-based spectra generation',/,/,
     1       ' Fourier wmax              ',f10.1,' cm-1',/,
     1       ' Spectral interval ',f10.1,' - ',f10.1,' cm-1',/,
     1       ' increment         ',f10.1,' cm-1',/,
     2       ' number of spectral points ',i15,/,
     2       ' number of MD points       ',i15,/,
     2       ' integration time step fs  ',f15.3,/,
     2       ' damping barrier           ',f15.3,' cm-1',/,
     2       ' damping limit             ',f15.3,/,
     2       ' number of simultanous spec',i15,/,
     2       ' iprint                    ',i15,/,
     2       ' available processors      ',i15,/,
     2       ' maximum of threads        ',i15,/,
     2       ' requested processors      ',i15,/,
     2       ' use exact ground          ',l15,/,
     2       ' convolution width         ',f15.3,' cm-1',/,
     2       ' Gaussian convolutionn     ',l15,/,
     2       ' spectral temperature      ',f15.1,' K',/,
     2       ' number of random vectors  ',i15,/)
      if(NWV.gt.NWV0)call report('Too many vectors requested')
c
c
      allocate(sff(1:np),stat=I)
      if(I.ne.0)call report('Not enough memory for sff')
c     pre-calculate convolution points
      nff=0
      w_i=-dd
      do 111 j=1,np
      w_i=w_i+dd
      con=sf(DW,LG,0.0d0,w_i)
      if(con.gt.1.0d-3)then
       nff=nff+1
       sff(nff)=con
      else
       goto 112
      endif
111   continue
112   continue
      write(6,*)np,' convolution points'
c
c     read in Hamiltonian
      DIAG=0.0d0
      ANORM=0.0d0
      OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
      read(2)
      iel=0
      DO 222 I=1,N
      READ(2)nn(I),(j33(ii),ii=1,nn(I)),(a33(ii),ii=1,nn(I))
      DO 222 ii=1,nn(I)
      iel=iel+1
      if(j33(ii).eq.I)DIAG=DIAG+DABS(a33(ii))
222   ANORM=ANORM+ABS(a33(ii))
      close(2)
      ANORM=2.0d0*ANORM/(DBLE(N*(N-1)))
      DIAG=DIAG/DBLE(N)*2.0d0
      write(6,6002)ANORM,DIAG
      write(3,6002)ANORM,DIAG
6002  format('Avearage element :',f20.10,/,
     1       'Avearage diagonal:',f20.10)

      write(6,4001)iel
      write(3,4001)iel
4001  format(i10,' elements')
      if(lto)then
       call w36('Empirical Hamiltonian scaling')
       write(3,2966)etlim,det,etal
       write(6,2966)etlim,det,etal
2966   format(' Elim = ',f8.1,' cm-1',/,
     1        ' dE   = ',f8.1,' cm-1',/,
     2        ' sf   = ',f8.1)
       endif
      allocate(jbb(1:iel),abb(1:iel),stat=I)
      if(I.eq.0)then
       iel=0
       OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
       read(2)
       DO 223 I=1,N
       READ(2)nn(I),(j33(ii),ii=1,nn(I)),(a33(ii),ii=1,nn(I))
       if(lto.and.j33(nn(I)).eq.I)then
        if(a33(nn(I)).gt.etlim)a33(nn(I))=a33(nn(I))*
     1  (etal+(1.0d0-etal)*exp(-(a33(nn(I))-etlim)**2/det**2))
       endif
       mm(i)=iel
       DO 223 ii=1,nn(I)
       iel=iel+1
       jbb(iel)=j33(ii)
223    abb(iel)=a33(ii)
       close(2)
       ldisk=.false.
       write(6,4900)(iel*8+iel*4+N*8)/1000
       write(3,4900)(iel*8+iel*4+N*8)/1000
4900   format(' Matrix loaded into memory',i12,' kb')
      else
       call w36('disk-based route')
       ldisk=.true.
      endif
c
      OPEN(2,FILE='FILE.X')
      READ(2,*)
      READ(2,*)NOAT
      DO 34 K=1,NOAT
      READ(2,*)idum,(R(I,K),I=1,3)
      DO 34 I=1,3
34    R(I,K)=R(I,K)/BOHR
      CLOSE(2)
      call w36('Coordinates from FILE.X')
c
c     read the dipole derivatives
      if(LTEN)then
       CALL READFD(PP,AI,JJ,PV,NT0)
       call w36('Dipole derivatives from FILE.TEN')
      endif
c
      if(LTTT)THEN
       call READTENTTT(NT3,NOAT,ALPHA,GTEN,ATEN)
       call w36('Polarizability derivatives from FILE.TTT')
      endif
c
c     transform to internal coordinates or get from disk
c     energies and S-matrix in atomic units:
      OPEN(2,FILE='SMAT.SCR',FORM='UNFORMATTED')
      READ(2)NAT,(E(I),I=1,3*NAT),((SM(I,J),J=1,3*NAT),I=1,3*NAT)
      CLOSE(2)
      do 903 I=1,3*NAT
903   W(I)=E(I)

      call w36('S-matrix from SMAT.SCR')
      N11=N7
      N22=N3
      CALL TT(N3,N7,QP,QJ,QI,QM,N3/3,SM,RAMAN,ALPHAQ,ALPHA,WRQ,
     1E,W,QPQ,QMQ ,AD,MGD,MND,MED,AI,JJ,PP,IIQ,PPQ,N11,N22,
     2CLIGHTAU,AUD,PPV,R,JJQ,PVT,PPT,GTENQ,ATENQ,GTEN,ATEN)
c
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       if(.not.LTEN)call rdten1q(QP,QM,N3,NT3)
      endif

      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call rdtenq(aptaq,aataq,N3,NT3)
       close(21)
       do i=N7,N3
       do j=N7,N3
       do ix=1,3
       QPQ(ix,i,j)=aptaq(i+(j-1)*N3,ix)
       QMQ(ix,i,j)=aataq(i+(j-1)*N3,ix)
       enddo
       enddo
       enddo
      endif
      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)call rdttqaq(N3,NT3,alphaaq,ggaq,aaaq)

c     get all in debyes:
      do 902 ix=1,3
      do 902 i=1,N3
      QP(ix,i)=QP(ix,i)*debye/dsqrt(2.0d0)
      QM(ix,i)=QM(ix,i)*debye*dsqrt(2.0d0)*E(i)/137.035d0
      do 902 j=1,N3
      QPQ(ix,i,j)=QPQ(ix,i,j)*debye/dsqrt(2.0d0)
902   QMQ(ix,i,j)=QMQ(ix,i,j)*debye*dsqrt(2.0d0)*dsqrt(dabs(E(j)*E(i)))
     1/137.035d0

      call w36(' Dipole derivatives')
      call w36(' #   e(cm-1)    d (debye^2)   m (debye^2)')
      do 900 i=N7,n3
900   write(6,901)i,E(i)*219470.0d0,
     1QP(1,i)**2+QP(2,i)**2+QP(3,i)**2,QM(1,i)**2+QM(2,i)**2+QM(3,i)**2
901   format(i4,f10.2,2g15.5)

c     ground state = sum(J) CFIG(J) * fi(J)
c     fi(J) ... Harmonic oscillator basis
c
c     G..GI and GR are the imaginary and real part, imaginary is zero
c     store there all vectors:
c     1     ... ground state
c     2-4   ... the dipole vector
c     5-7   ... the magnetic dipole
c     8-16  ... polarizability
c     17-25 ... G'
c     26-52 ... A'
      ALIM=1.0d-6/DSQRT(DBLE(N))
      allocate(GR(1:N*NK0),stat=i)
      if(i.ne.0)call report('cannot allocate GR')
      inquire(file='IV.SCR',exist=lex)
      if(lex)then
       open(4,file='IV.SCR',form='unformatted')
       read(4)WG,(GR(i),i=1,N*NK0)
       close(4)
       call w36('Inital vectors read from IV.SCR')
      else
       call w36('Constructing inital vectors')
       do 361 I=1,NK0*N
361    GR(I)=0.0d0
c
c      set ground state vector
       if(lftg)then
c       exact
        inquire(file='CFI.SCR',exist=lex1)
        inquire(file=s1//'E.SCR',exist=lex2)
        if(lex1.and.lex2)then
         call w36('CFI.SCR and '//s1//'E.SCR found on disk')
        else
         call MITINX(N,NMM,NEE,VMM,SMALLE,IERR,MV,J1,s1,MVTOT,1)
        endif
        OPEN(45,FILE='CFI.SCR',FORM='UNFORMATTED')
        DO 1003 J=1,1+J1-2
1003    READ(45)
        read(45)(GR(I),I=1,N)
        close(45)
        OPEN(4,FILE=s1//'E.SCR',FORM='UNFORMATTED')
        read(4)WG
        CLOSE(4)
        write(6,703)J1,WG
        write(3,703)J1,WG
703     format(' Ground state read from CFI.SCR',/,
     1         ' J1:',i2,' E= ',F15.3,' cm-1')
       else
c       approximate
        GR(1)=1.0d0
        call w36('Ground state set as first harmonic')
        WG=0.0d0
       endif
c
c      ground = sum(k) cg_k fi_K
c      VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
       do 36 K=1,N
       write(6,*)K,' of ',N
c      retrieve state K:
       DO 808 KK=N7,N3
808    SK(KK)=0
       DO 809 KK=1,IS(K)
809    SK(ICC(K,KK))=IN(K,KK)
       CGK=GR(K)
c      skip states with low weights:
       IF(ABS(CGK).GT.ALIM)then
        do 37 J=1,N
c       retrieve state J:
        DO 812 KK=N7,N3
812     SJ(KK)=0
        DO 815 KK=1,IS(J)
815     SJ(ICC(J,KK))=IN(J,KK)
c
c      <J|O|K>CG_K
c      22222222222222222222222222222222222222222222222222222222222222222
c
C       FUNCTION S1QIS2(S1,IQ,S2)
c       if(J.eq.16955)write(6,9000)(SJ(IQ),IQ=N7,N3)
c       if(J.eq.16955)write(6,9000)(SK(IQ),IQ=N7,N3)
c000    format(80I1)
        if(iabs(IT(K)-IT(J)).eq.1)then
         DO 814 IQ=N7,N3
C        <S1|Qi|S2> in dimensionless coordinates
         DO 59 I=N7,N3
         IF(I.NE.IQ)THEN
          IF(SJ(I).NE.SK(I))GOTO 4445
          GOTO 59
         ENDIF
         IF(SJ(I).EQ.SK(I)+1)THEN
          SFU=DSQRT(DBLE(SJ(I))/2.0d0)*CGK
          GOTO 59
         ENDIF
         IF(SJ(I).EQ.SK(I)-1)THEN
          SFU=DSQRT(DBLE(SK(I))/2.0d0)*CGK
          GOTO 59
         ENDIF
         GOTO 4445
59       CONTINUE
c        first derivatives du/dqi qi:
         GR(J+ 1   *N)=GR(J+ 1   *N)+SFU*QP(1,IQ)
         GR(J+ 2   *N)=GR(J+ 2   *N)+SFU*QP(2,IQ)
         GR(J+ 3   *N)=GR(J+ 3   *N)+SFU*QP(3,IQ)
         GR(J+(1+3)*N)=GR(J+(1+3)*N)+SFU*QM(1,IQ)
         GR(J+(2+3)*N)=GR(J+(2+3)*N)+SFU*QM(2,IQ)
         GR(J+(3+3)*N)=GR(J+(3+3)*N)+SFU*QM(3,IQ)

         IF(RAMAN)THEN
          do 705 ix=1,3
          do 705 iy=1,3
          ii=ix+3*(iy-1)
          GR(J+(ii+ 6)*N)=GR(J+(ii+ 6)*N)+SFU*ALPHAQ(IQ,ix,iy)
          GR(J+(ii+15)*N)=GR(J+(ii+15)*N)+SFU*GTENQ(IQ,ix,iy)
          do 705 iz=1,3
          ii=ix+3*(iy-1)+9*(iz-1)
705       GR(J+(ii+24)*N)=GR(J+(ii+24)*N)+SFU*ATENQ(IQ,ix,iy,iz)
         ENDIF

4445     CONTINUE
814      CONTINUE
        endif

        IF(AD.and.iabs(IT(K)-IT(J)).le.2)THEN
         DO 8141 IQ=N7,N3
c        second derivatives diagonal, <Qi^2> (JQ=IQ):
         DO 52 I=N7,N3
         IF(I.NE.IQ)THEN
          IF(SJ(I).NE.SK(I))GOTO 25555
          GOTO 52
         ENDIF
         IF(SJ(I).EQ.SK(I))THEN
          PR=(2*SJ(I)+1)*(2*SK(I)+1)
          GOTO 52
         ENDIF
         IF(SJ(I).EQ.SK(I)+2)THEN
          PR=SJ(I)*(SJ(I)-1)
          GOTO 52
         ENDIF
         IF(SJ(I).EQ.SK(I)-2)THEN
          PR=SK(I)*(SK(I)-1)
          GOTO 52
         ENDIF
         GOTO 25555
52       CONTINUE
         SFU=DSQRT(DBLE(PR))*0.25d0
c        (1/2) from matrix element x (1/2) from the taylor expansion
         ELJK=SFU*CGK
         if(RAMAN)then
          iu=IQ+(IQ-1)*N3
          GR(J+(1+ 6)*N)=GR(J+(1+ 6)*N)+ELJK*alphaaq(iu,1)
          GR(J+(2+ 6)*N)=GR(J+(2+ 6)*N)+ELJK*alphaaq(iu,2)
          GR(J+(3+ 6)*N)=GR(J+(3+ 6)*N)+ELJK*alphaaq(iu,3)
          GR(J+(4+ 6)*N)=GR(J+(4+ 6)*N)+ELJK*alphaaq(iu,4)
          GR(J+(5+ 6)*N)=GR(J+(5+ 6)*N)+ELJK*alphaaq(iu,5)
          GR(J+(6+ 6)*N)=GR(J+(6+ 6)*N)+ELJK*alphaaq(iu,6)
          GR(J+(7+ 6)*N)=GR(J+(7+ 6)*N)+ELJK*alphaaq(iu,7)
          GR(J+(8+ 6)*N)=GR(J+(8+ 6)*N)+ELJK*alphaaq(iu,8)
          GR(J+(9+ 6)*N)=GR(J+(9+ 6)*N)+ELJK*alphaaq(iu,9)
         endif
         GR(J+ 1   *N)=GR(J+ 1   *N)+ELJK*QPQ(1,IQ,IQ)
         GR(J+(1+3)*N)=GR(J+(1+3)*N)+ELJK*QMQ(1,IQ,IQ)
         GR(J+ 2   *N)=GR(J+ 2   *N)+ELJK*QPQ(2,IQ,IQ)
         GR(J+(2+3)*N)=GR(J+(2+3)*N)+ELJK*QMQ(2,IQ,IQ)
         GR(J+ 3   *N)=GR(J+ 3   *N)+ELJK*QPQ(3,IQ,IQ)
         GR(J+(3+3)*N)=GR(J+(3+3)*N)+ELJK*QMQ(3,IQ,IQ)
25555    CONTINUE
c
c        second derivatives off-diagonal
         DO 8141 JQ=IQ+1,N3
C        IQJQ is JQIQ, so take it twice:
C        FUNCTION S1QIQJS2(S1,IQ,JQ,S2)
C        <S1|Qi Qj |S2> in dimensionless coordinates
         PR=1
         DO 11 I=N7,N3
         IF(I.NE.IQ.AND.I.NE.JQ)THEN
          IF(SJ(I).NE.SK(I))GOTO 8141
          GOTO 11
         ENDIF
         IF(SJ(I).EQ.SK(I)+1)THEN
          PR=PR*SJ(I)
          GOTO 11
         ENDIF
         IF(SJ(I).EQ.SK(I)-1)THEN
          PR=PR*SK(I)
          GOTO 11
         ENDIF
         GOTO 8141
11       CONTINUE
c        (1/2)from mat.element x (1/2) from Taylor x 2 from ij=ji
         ELJKQ=DSQRT(DBLE(PR))*0.5d0*CGK
         if(RAMAN)then
          iu=IQ+(JQ-1)*N3
          GR(J+(1+ 6)*N)=GR(J+(1+ 6)*N)+ELJKQ*alphaaq(iu,1)
          GR(J+(2+ 6)*N)=GR(J+(2+ 6)*N)+ELJKQ*alphaaq(iu,2)
          GR(J+(3+ 6)*N)=GR(J+(3+ 6)*N)+ELJKQ*alphaaq(iu,3)
          GR(J+(4+ 6)*N)=GR(J+(4+ 6)*N)+ELJKQ*alphaaq(iu,4)
          GR(J+(5+ 6)*N)=GR(J+(5+ 6)*N)+ELJKQ*alphaaq(iu,5)
          GR(J+(6+ 6)*N)=GR(J+(6+ 6)*N)+ELJKQ*alphaaq(iu,6)
          GR(J+(7+ 6)*N)=GR(J+(7+ 6)*N)+ELJKQ*alphaaq(iu,7)
          GR(J+(8+ 6)*N)=GR(J+(8+ 6)*N)+ELJKQ*alphaaq(iu,8)
          GR(J+(9+ 6)*N)=GR(J+(9+ 6)*N)+ELJKQ*alphaaq(iu,9)
         endif
         GR(J+ 1   *N)=GR(J+ 1   *N)+ELJKQ*QPQ(1,IQ,JQ)
         GR(J+(1+3)*N)=GR(J+(1+3)*N)+ELJKQ*QMQ(1,IQ,JQ)
         GR(J+ 2   *N)=GR(J+ 2   *N)+ELJKQ*QPQ(2,IQ,JQ)
         GR(J+(2+3)*N)=GR(J+(2+3)*N)+ELJKQ*QMQ(2,IQ,JQ)
         GR(J+ 3   *N)=GR(J+ 3   *N)+ELJKQ*QPQ(3,IQ,JQ)
         GR(J+(3+3)*N)=GR(J+(3+3)*N)+ELJKQ*QMQ(3,IQ,JQ)
8141     CONTINUE
        ENDIF
c       22222222222222222222222222222222222222222222222222222222222222222
37      continue
       endif
36     continue
c      VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
       open(4,file='IV.SCR',form='unformatted')
       write(4)WG,(GR(i),i=1,N*NK0)
       close(4)
       call w36('Inital vectors written to IV.SCR')
      endif
c
c     set up parallel parameters:
      if(nproc.gt.omp_get_num_procs())
     1call report('not enough processors')
      if(nproc.gt.omp_get_max_threads())
     1write(6,*)'Number of threads will increase'
      call omp_set_num_threads(nproc)
      call omp_set_dynamic(0)
      call omp_set_nested(0)
c
c     precalculate parallel distributions for "non-parralezable" loops:
      call ppd(nproc,nproc0,nstart,nend,N)
c
c     allocate the time-components for FFT:
      allocate(ur(1:NK0*nmd),ui(1:NK0*nmd),stat=I)
      if(I.ne.0)call report('Not enough memory for FFT ui')
      allocate(sr(1:NK0*np),si(1:NK0*np),stat=I)
      if(I.ne.0)call report('Not enough memory for FFT si')
      allocate(dta(2*nfft),stat=I)
      if(I.ne.0)call report('Not enough memory for FFT data')
      allocate(sto(1:n5*np),stat=I)
      if(I.ne.0)call report('Not enough memory for FFT sto')
c
c     initialize total spectra
      do 13 i=1,np*n5
13    sto(i)=0.0d0
c
      do 899 iis=1,NWV
c
c     initialize spectra
      do 8991 i=1,np*NK0
      si(i)=0.0d0
8991  sr(i)=0.0d0
c
c     Initialize trial vector-real and imaginary part,rr, ri
c     and ground state vector yr, yi
      ANORM=0.0d0
      do 8992 i=1,N
      rr(i)=random(0)-0.5d0
      ri(i)=0.0d0
8992  ANORM=ANORM+rr(i)**2
      ANORM=1.0d0/dsqrt(ANORM)
      do 81 i=1,N
81    rr(i)=rr(i)*ANORM
c
c     remember zero time
      do 86 i=1,N
86    r0(i)=rr(i)
c
      do 8993 i=1,N
      r2r(i) =0.0d0
      r2i(i) =0.0d0
      rrm(i) =rr(i)
      rim(i) =ri(i)
      rrmm(i)=rr(i)
8993  rimm(i)=ri(i)
c
      if (ldisk)call report('ldisk not implemented')
c
c     do the propagation:
c     ######################################################
      t=-dt
      do 3 iit=1,nmd
      t=t+dt
      ttpc=t*tpc
      cg=cos(WG*ttpc)
      sg=sin(WG*ttpc)
c
c     mutliply st by FF, store in AX:
C$OMP PARALLEL DO PRIVATE(I,imi,s1r,s1i,ii,ji)  DEFAULT(SHARED)
      DO 4 I=1,N
      imi=mm(I)
      s1r=0.0d0
      s1i=0.0d0
      DO 41 ii=1,nn(I)
      ji=imi+ii
      s1r=s1r+abb(ji)*rr(jbb(ji))
41    s1i=s1i+abb(ji)*ri(jbb(ji))
      AXR(I)=s1r
4     AXI(I)=s1i

c
c     Y(t+dt)=Y(t)-(i/h) H Y  dt + ni(w0-H/h) Y dt + 0.5 d^2Y/dt^2 dt^2
c                  Re=Re+Im
c                  Im=Im-iRe
c     Y=Y(0)exp(-iwt)exp[ni(w0-w)t]
C$OMP PARALLEL  DO PRIVATE(i) DEFAULT(SHARED)
      do 5 i=1,N
      rr(i)=rr(i)*(1.0d0+ni*w0*dttpc)+(AXI(i)-ni*AXR(i))*dttpc+r2r(i)
5     ri(i)=ri(i)*(1.0d0+ni*w0*dttpc)-(AXR(i)+ni*AXI(i))*dttpc+r2i(i)
c
c     normalize
c     call nmz(rr,ri,N)
C$OMP PARALLEL DEFAULT(SHARED) PRIVATE(ipr,j,s1r)
      ipr=OMP_GET_THREAD_NUM()+1
      s1r=0.0d0
      do 1 j=nstart(ipr),nend(ipr)
1     s1r=s1r+rr(j)**2+ri(j)**2
      sar(ipr)=s1r
C$OMP END PARALLEL
      s1r=0.0d0
      do 12 j=1,nproc
12    s1r=s1r+sar(j)
      if(dabs(s1r-1.0d0).gt.0.3d0)write(6,*)'norm very high',a
      s1r=1.0d0/dsqrt(s1r)
C$OMP PARALLEL DO PRIVATE(j) DEFAULT(SHARED)
      do 7  j=1,N
      ri(j)=ri(j)*s1r
7     rr(j)=rr(j)*s1r
c
C$OMP PARALLEL DO PRIVATE(i) DEFAULT(SHARED)
      do 8 i=1,N
c     calculate second derivatives:
      r2r(i)=(rr(i)+rrmm(i))*0.5d0-rrm(i)
      r2i(i)=(ri(i)+rimm(i))*0.5d0-rim(i)
c     remember vectors:
      rrmm(i)=rrm(i)
      rimm(i)=rim(i)
      rrm(i)=rr(i)
8     rim(i)=ri(i)
c
c     time-dependent dipole moments and autocorrelation function:
c     ur real, ui imaginary
c            i:1      f(t) = R*(t).R(0)exp(-iwGt)
c              2... 4 u(t) = R*(t).G(t)
c              5... 7 m
c              8...16 al
c             17...25 G'
c             26...52 A'
      iuu=(iit-1)*NK0
c
c     i=1:
C$OMP PARALLEL DEFAULT(SHARED) PRIVATE(ipr,j,s1r,s1i)
      ipr=OMP_GET_THREAD_NUM()+1
      s1r=0.0d0
      s1i=0.0d0
      do 712 j=nstart(ipr),nend(ipr)
c
c     r0 exp(-iwGt) =r0 cos -i r0 sin
c     Re (   R*(t).r0 exp(-iwGt)) =Re R Re r0 exp(-iwGt) + Im Im
c                                 =Re R r0 cg + Im R (-r(0) sg)
c     Im (   R*(t).r0 exp(-iwGt)) =Re R Im r0 exp(-iwGt) - Im Re
c                                 =-Re R r0 sg - Im R (r(0) cg)
      s1r=s1r+(rr(j)*cg-ri(j)*sg)*r0(j)
712   s1i=s1i-(rr(j)*sg+ri(j)*cg)*r0(j)
      sar(ipr)=s1r
      sai(ipr)=s1i
C$OMP END PARALLEL
      s1r=0.0d0
      s1i=0.0d0
      DO 9 j=1,nproc
      s1r=s1r+sar(j)
9     s1i=s1i+sar(j)
      ur(i+iuu)=s1r*dt
      ui(i+iuu)=s1i*dt

c     i>1:
C$OMP PARALLEL DO PRIVATE(i,s1r,s1i,j) DEFAULT(SHARED)
      do 10 i=2,NK0
      s1r=0.0d0
      s1i=0.0d0
      do 711 j=1,N
c     propagate ground state analytically
c     Re G =   Re G(0)*cg
c     Im G = - Re G(0)*sg
c
      s1r=s1r + (rr(j)*cg-ri(j)*sg)*GR(j+(i-1)*N)
711   s1i=s1i - (rr(j)*sg+ri(j)*cg)*GR(j+(i-1)*N)
      ur(i+iuu)=s1r*dt
10    ui(i+iuu)=s1i*dt
c
      if(mod(iit,iprint).eq.0)then
       write(6,700)iis,iit,t
700    format(i3,'. spectrum',
     1 i10,'. step,',' time ',f15.2,' fs')
       write(s10,701)iis
701    format(i10)
      endif
c
3     continue
c     ######################################################
c
      call w36('FFT started')
c     loop over moments:
      do 72 j=1,NK0
c     rewrite to dta string:
      do 721 iit=1,nmd
      dta(2*iit-1)=ur(j+(iit-1)*NK0)
721   dta(2*iit  )=ui(j+(iit-1)*NK0)
c     zero-filling:
      do 722 iit=nmd+1,nfft
      dta(2*iit-1)=0.0d0
722   dta(2*iit  )=0.0d0
c     FFT inverse transform:
      call four1(dta,nfft,-1.0d0)
c     add to spectrum, part of positive frequencies only:
      do 72 i=1,np
      sr(i+(j-1)*np)=sr(i+(j-1)*np)+dta(2*i-1)
72    si(i+(j-1)*np)=si(i+(j-1)*np)+dta(2*i  )
      call w36('FFT finished')
c
c     Sum up the intensity spectra:
c     1 correlation R*(t).R(0).exp(-iwGt)
c     2 abs direct
c     3 vcd direct
c     4 Raman1
c     5 ROA1
      do 8997 i=1,np
c     R*(t).R(0)exp(-iwGt)
      sto(i)=sto(i)+sr(i)
      do 89971 ix=1,3
      ii=ix*np
c     R*(t).u(t)
      sto(i+  np)=sto(i+  np)+sr(i+ii)*sr(i+ii)+si(i+ii)*si(i+ii)
      i2=(ix+3)*np
89971 sto(i+2*np)=sto(i+2*np)+sr(i+ii)*sr(i+i2)+si(i+ii)*si(i+i2)
c9971 sto(i+2*NP)=sto(i+2*NP)+sr(i+ii)*si(i+i2)+si(i+ii)*sr(i+i2)(1)
c9971 sto(i+2*NP)=sto(i+2*NP)+sr(i+ii)*sr(i+i2)+si(i+ii)*si(i+i2)-works(2)
c9971 sto(i+2*NP)=sto(i+2*NP)+sr(i+ii)*si(i+i2)-si(i+ii)*sr(i+i2)-does not work

      SAL0=0.0d0
      SAL1=0.0d0
      SAG0=0.0d0
      SAG1=0.0d0
      SA1=0.0d0
      DO 6 II=1,3
      DO 6 J=1,3
      iti=II+3*(II-1)
      itj=J+3*(J-1)
      io=II+3*(J-1)
c     SAL0=SAL0+ALPHA(IQ,I,I)*    ALPHA(IQ,J,J)
      SAL0=SAL0+sr(i+(iti+6)*np)*sr(i+(itj+6)*np)+
     1si(i+(iti+6)*np)*si(i+(itj+6)*np)
c     SAL1=SAL1+ALPHA(IQ,I,J)*    ALPHA(IQ,I,J)
      SAL1=SAL1+sr(i+(io+6)*np)*sr(i+(io+6)*np)+
     1si(i+(io+6)*np)*si(i+(io+6)*np)
c     SAG0=SAG0+ALPHA(IQ,I,I)*    G(IQ,J,J)
      SAG0=SAG0+sr(i+(iti+6)*np)*sr(i+(itj+15)*np)+
     1si(i+(iti+6)*np)*si(i+(itj+15)*np)
c     SAG1=SAG1+ALPHA(IQ,I,J)*    G(IQ,I,J)
      SAG1=SAG1+sr(i+(io+6)*np)*sr(i+(io+15)*np)+
     1si(i+(io+6)*np)*si(i+(io+15)*np)
      DO 6 K=1,3
      DO 6 L=1,3
c     SA1=SA1+EPS(I,K,L)*ALPHA(IQ,I,J)*A(IQ,K,L,J)/3.0d0
      itkl=K+3*(L-1)+9*(J-1)
6     SA1=SA1+EPS(II,K,L)*(sr(i+(io+6)*np)*sr(i+(itkl+24)*np)+
     1                     si(i+(io+6)*np)*si(i+(itkl+24)*np))/3.0d0
c
c     180 backscattering IL+IR
      sto(i+3*np)=sto(i+3*np)+7.0d0*SAL1+SAL0
c
c     180 backscattering IR-IL
8997  sto(i+4*np)=sto(i+4*np)+8.0d0*(3.0d0*SAG1-SAG0+SA1)

899   continue

      deallocate(ur,ui,dta)
c
      call wrs(   0,np,WMIN,dd,NWV,'S.PRN',0,N,nmd,dt,sto,stemp)
      call wrs(  np,np,WMIN,dd,NWV,'D.PRN',1,N,nmd,dt,sto,stemp)
      call wrs(2*np,np,WMIN,dd,NWV,'R.PRN',2,N,nmd,dt,sto,stemp)
      if(RAMAN)then
       call wrs(3*np,np,WMIN,dd,NWV,'RAM.PRN',3,N,nmd,dt,sto,stemp)
       call wrs(4*np,np,WMIN,dd,NWV,'ROA.PRN',4,N,nmd,dt,sto,stemp)
      endif
c
      write(3,6009)dble(mclock()-it0)/100.0d0
      write(6,6009)dble(mclock()-it0)/100.0d0
6009  format(' Time: ',f15.2,' sec')
      call report('Program finished')
      deallocate(GR,sto,sr,si,sff)
      if(.not.ldisk)deallocate(jbb,abb)
      RETURN
      END

      SUBROUTINE SGFOURIERslow(N,NMM,NEE,VMM,SMALLE,IERR,MV,J1,s1,MVTOT,
     1lftg)
c     "Slow" Fourier-transform spectral generation
      implicit none
      INTEGER*4 N,NMM,NEE,IERR,MV,J1,MVTOT,iel,imi,ipr,iis,i,iit,ii,
     1OMP_GET_THREAD_NUM,n5,NGE0,NAT,k,j,ix,i2,
     1NK0,iti,itj,itkl,l,io,NGR0,np,ji
      include 'dimensions.h'
      PARAMETER (NGE0=24,n5=5,NK0=52,NGR0=100)
c
c     NK0=1+3+3+9+9+27   scalar+u+m+alpha+G'+A
      real*8 VMM, SMALLE(*),a33(NM0),dt,dd,EPS,debye,random,
     1ACUT,DIAG,pi,clight,CM,SFU,ELJK,
     1tpc,WG,dttpc,PP(NT0,3,3),AI(NT0,3,3),JJ(NT0,3,3),
     1PV(NT0,3,3),QP(3,NT3),QI(3,NT3),QJ(3,NT3),QM(3,NT3),SM(NT3,NT3),
     1ALPHA(NT3,3,3),ALPHAQ(NT3,3,3),E(NT3),W(NT3),QMQ(3,NT3,NT3),
     1QPQ(3,NT3,NT3),MGD(3),MED(3),MND(3),PPQ(NT0,3,3,NT3),ALIM,CGK,
     1IIQ(NT0,3,3,NT3),CLIGHTAU,AUD,PPV(NT0,3,3,NT3),R(3,NT0),BOHR,
     1JJQ(NT0,3,3,NT3),PVT(NT0,3,3),PPT(NT0,3,3),FGEO,ELIMIT,
     1GTENQ(NT3,3,3),GTEN(NT3,3,3),ATEN(NT3,3,3,3),ATENQ(NT3,3,3,3),
     1alphaaq(NT3**2,9),aptaq(2*NT3**2,3),aataq(NT3**2,3),
     1ELJKQ,A,ni,w0,s1r,s1i,ANORM,rr(NM0),ri(NM0),r0(NM0),
     2r2r(NM0),r2i(NM0),rrmm(NM0),rimm(NM0),rrm(NM0),
     3rim(NM0),t,ttpc,cg,sg,AXR(NM0),AXI(NM0),se,ce,
     5SAL0,SAL1,SAG0,SAG1,SA1,sar(nproc0),sai(nproc0),
     1ggaq(NT3**2,9),aaaq(NT3**2,27)
c
c     large
      real*8,allocatable:: GR(:),abb(:),sto(:),ur(:),ui(:),sr(:),si(:)
c     GR(NM0*NK0),abb(nbuff)
      integer*4,allocatable:: jbb(:)
c     jbb(nbuff)
      character*10 s10
      character*1 s1
      logical lftg,ldisk,lopt,lto
      common/lop/lopt(300)
      equivalence (lto,lopt(40))
      integer*4 IYS,CHT(NGE0,NGE0),IG,IGG,KG,ID,j33(NM0),N11,N22,
     1nn(NM0),mm(NM0),idum
      character*3 SSTR
      COMMON/SYMCOM/IYS(NT3),CHT,IG,IGG,KG,ID(NGE0),SSTR
      integer*4 iopt,NWV,nmd,nproc,iprint,NOAT
      common/iop/iopt(300)
      equivalence (NWV,iopt(12)),(nmd,iopt(13)),(nproc,iopt(14)),
     1(NP,iopt(15)),(iprint,iopt(16))
      real*8 ropt,wmin,wmax,stemp,etlim,etal,det,TEMP
      common/opt/ropt(100)
      equivalence (wmin,ropt(8)),(wmax,ropt(9)),
     1(dt,ropt(10)),(ni,ropt(12)),(w0,ropt(13)),
     1(stemp,ropt(14)),(etlim,ropt(17)),(etal,ropt(18)),(det,ropt(19))
      integer*4 nstart(nproc0),nend(nproc0),mclock,
     1it0,OMP_GET_MAX_THREADS,OMP_GET_NUM_PROCS,N7,N3,NGROUND,
     1IGROUND(NGR0),N1,N2,IZERO,SJ(NT3),SK(NT3),KK,NBG,IT,IS,IBIGSYM,
     1ICC,IN,IQ,iu,iz,JQ,PR,iy,STATE1(NT3),STATE2(NT3)
      logical L4
      COMMON/SUM/A,STATE1,STATE2,N7,N3,L4
      logical RAMAN,WRQ,AD,lex,GEO,WRONLY,LVCD,LTEN,LTTT,LRESTART,LINS,
     1lex1,lex2
      common/OPTW/WRQ
      COMMON/DIA1/NBG,IT(NM0),IS(NM0),IBIGSYM(NM0),
     1ICC(NM0,ME0),IN(NM0,ME0)

c
      CALL SPAR(AD,GEO,WRQ,RAMAN,WRONLY,FGEO,IGROUND,NGROUND,NGR0,
     1N1,N2,
     1ELIMIT,IZERO,CM,AUD,CLIGHTAU,BOHR,LVCD,LTEN,
     2LTTT,ACUT,LRESTART,LINS,TEMP)
      call INIP(AI,JJ,PV,NT0)
      IG=MAX(IGROUND(1),1)
      if(IG.ne.1)call report('IG <> 1 not implemented')

      clight=2.99792458D8
      debye=2.541732d0
      it0=mclock()
      pi=4.0d0*atan(1.0d0)
      tpc=2.0d0*pi*clight*100.0d0*1.0d-15
c     2pi c v t dimensionless, v[cm-1], t[fs]
      dttpc=dt*tpc
c
      dd=(WMAX-WMIN)/dble(NP-1)
      write(3,6001)WMIN,WMAX,dd,np,nmd,dt,w0,ni,NWV,iprint,
     1omp_get_num_procs(),omp_get_max_threads(),nproc,lftg,
     1stemp,NWV
      write(6,6001)WMIN,WMAX,dd,np,nmd,dt,w0,ni,NWV,iprint,
     1omp_get_num_procs(),omp_get_max_threads(),nproc,lftg,
     1stemp,NWV
6001  format(/,/,'Fourier-based spectra generation',/,/,
     1       ' Spectral interval ',f10.1,' - ',f10.1,' cm-1',/,
     1       ' increment         ',f10.1,' cm-1',/,
     2       ' number of spectral points ',i15,/,
     2       ' number of MD points       ',i15,/,
     2       ' integration time step fs  ',f15.3,/,
     2       ' damping barrier           ',f15.3,' cm-1',/,
     2       ' damping limit             ',f15.3,/,
     2       ' number of simultanous spec',i15,/,
     2       ' iprint                    ',i15,/,
     2       ' available processors      ',i15,/,
     2       ' maximum of threads        ',i15,/,
     2       ' requested processors      ',i15,/,
     2       ' use exact ground          ',l15,/,
     2       ' spectral temperature      ',f15.1,' K',/,
     2       ' number of random vectors  ',i15,/)
      if(NWV.gt.NWV0)call report('Too many vectors requested')
c
c     read in Hamiltonian
      DIAG=0.0d0
      ANORM=0.0d0
      OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
      read(2)
      iel=0
      DO 222 I=1,N
      READ(2)nn(I),(j33(ii),ii=1,nn(I)),(a33(ii),ii=1,nn(I))
      DO 222 ii=1,nn(I)
      iel=iel+1
      if(j33(ii).eq.I)DIAG=DIAG+DABS(a33(ii))
222   ANORM=ANORM+ABS(a33(ii))
      close(2)
      ANORM=2.0d0*ANORM/(DBLE(N*(N-1)))
      DIAG=DIAG/DBLE(N)*2.0d0
      write(6,6002)ANORM,DIAG
      write(3,6002)ANORM,DIAG
6002  format('Avearage element :',f20.10,/,
     1       'Avearage diagonal:',f20.10)

      write(6,4001)iel
      write(3,4001)iel
4001  format(i10,' elements')
      if(lto)then
       call w36('Empirical Hamiltonian scaling')
       write(3,2966)etlim,det,etal
       write(6,2966)etlim,det,etal
2966   format(' Elim = ',f8.1,' cm-1',/,
     1        ' dE   = ',f8.1,' cm-1',/,
     2        ' sf   = ',f8.1)
       endif
      allocate(jbb(1:iel),abb(1:iel),stat=I)
      if(I.eq.0)then
       iel=0
       OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
       read(2)
       DO 223 I=1,N
       READ(2)nn(I),(j33(ii),ii=1,nn(I)),(a33(ii),ii=1,nn(I))
       if(lto.and.j33(nn(I)).eq.I)then
        if(a33(nn(I)).gt.etlim)a33(nn(I))=a33(nn(I))*
     1  (etal+(1.0d0-etal)*exp(-(a33(nn(I))-etlim)**2/det**2))
       endif
       mm(i)=iel
       DO 223 ii=1,nn(I)
       iel=iel+1
       jbb(iel)=j33(ii)
223    abb(iel)=a33(ii)
       close(2)
       ldisk=.false.
       write(6,4900)(iel*8+iel*4+N*8)/1000
       write(3,4900)(iel*8+iel*4+N*8)/1000
4900   format(' Matrix loaded into memory',i12,' kb')
      else
       call w36('disk-based route')
       ldisk=.true.
      endif
c
      OPEN(2,FILE='FILE.X')
      READ(2,*)
      READ(2,*)NOAT
      DO 34 K=1,NOAT
      READ(2,*)idum,(R(I,K),I=1,3)
      DO 34 I=1,3
34    R(I,K)=R(I,K)/BOHR
      CLOSE(2)
      call w36('Coordinates from FILE.X')
c
c     read the dipole derivatives
      if(LTEN)then
       CALL READFD(PP,AI,JJ,PV,NT0)
       call w36('Dipole derivatives from FILE.TEN')
      endif
c
      if(LTTT)THEN
       call READTENTTT(NT3,NOAT,ALPHA,GTEN,ATEN)
       call w36('Polarizability derivatives from FILE.TTT')
      endif
c
c     transform to internal coordinates or get from disk
c     energies and S-matrix in atomic units:
      OPEN(2,FILE='SMAT.SCR',FORM='UNFORMATTED')
      READ(2)NAT,(E(I),I=1,3*NAT),((SM(I,J),J=1,3*NAT),I=1,3*NAT)
      CLOSE(2)
      do 903 I=1,3*NAT
903   W(I)=E(I)

      call w36('S-matrix from SMAT.SCR')
      N11=N7
      N22=N3
      CALL TT(N3,N7,QP,QJ,QI,QM,N3/3,SM,RAMAN,ALPHAQ,ALPHA,WRQ,
     1E,W,QPQ,QMQ ,AD,MGD,MND,MED,AI,JJ,PP,IIQ,PPQ,N11,N22,
     2CLIGHTAU,AUD,PPV,R,JJQ,PVT,PPT,GTENQ,ATENQ,GTEN,ATEN)
c
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       if(.not.LTEN)call rdten1q(QP,QM,N3,NT3)
      endif

      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call rdtenq(aptaq,aataq,N3,NT3)
       close(21)
       do i=N7,N3
       do j=N7,N3
       do ix=1,3
       QPQ(ix,i,j)=aptaq(i+(j-1)*N3,ix)
       QMQ(ix,i,j)=aataq(i+(j-1)*N3,ix)
       enddo
       enddo
       enddo
      endif
      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)call rdttqaq(N3,NT3,alphaaq,ggaq,aaaq)

c     get all in debyes:
      do 902 ix=1,3
      do 902 i=1,N3
      QP(ix,i)=QP(ix,i)*debye/dsqrt(2.0d0)
      QM(ix,i)=QM(ix,i)*debye*dsqrt(2.0d0)*E(i)/137.035d0
      do 902 j=1,N3
      QPQ(ix,i,j)=QPQ(ix,i,j)*debye/dsqrt(2.0d0)
902   QMQ(ix,i,j)=QMQ(ix,i,j)*debye*dsqrt(2.0d0)*dsqrt(dabs(E(j)*E(i)))
     1/137.035d0

      call w36(' Dipole derivatives')
      call w36(' #   e(cm-1)    d (debye^2)   m (debye^2)')
      do 900 i=N7,n3
900   write(6,901)i,E(i)*219470.0d0,
     1QP(1,i)**2+QP(2,i)**2+QP(3,i)**2,QM(1,i)**2+QM(2,i)**2+QM(3,i)**2
901   format(i4,f10.2,2g15.5)

c     ground state = sum(J) CFIG(J) * fi(J)
c     fi(J) ... Harmonic oscillator basis
c
c     G..GI and GR are the imaginary and real part, imaginary is zero
c     store there all vectors:
c     1     ... ground state
c     2-4   ... the dipole vector
c     5-7   ... the magnetic dipole
c     8-16  ... polarizability
c     17-25 ... G'
c     26-52 ... A'
      ALIM=1.0d-6/DSQRT(DBLE(N))
      allocate(GR(1:N*NK0),stat=i)
      if(i.ne.0)call report('cannot allocate GR')
      inquire(file='IV.SCR',exist=lex)
      if(lex)then
       open(4,file='IV.SCR',form='unformatted')
       read(4)WG,(GR(i),i=1,N*NK0)
       close(4)
       call w36('Initial vectors read from IV.SCR')
      else
       call w36('Constructing inital vectors')
       do 361 I=1,NK0*N
361    GR(I)=0.0d0
c
c      set ground state vector
       if(lftg)then
c       exact
        inquire(file='CFI.SCR',exist=lex1)
        inquire(file=s1//'E.SCR',exist=lex2)
        if(lex1.and.lex2)then
         call w36('CFI.SCR and '//s1//'E.SCR found on disk')
        else
         call MITINX(N,NMM,NEE,VMM,SMALLE,IERR,MV,J1,s1,MVTOT,1)
        endif
        OPEN(45,FILE='CFI.SCR',FORM='UNFORMATTED')
        DO 1003 J=1,1+J1-2
1003    READ(45)
        read(45)(GR(I),I=1,N)
        close(45)
        OPEN(4,FILE=s1//'E.SCR',FORM='UNFORMATTED')
        read(4)WG
        CLOSE(4)
        write(6,703)J1,WG
        write(3,703)J1,WG
703     format(' Ground state read from CFI.SCR',/,
     1         ' J1:',i2,' E= ',F15.3,' cm-1')
       else
c       approximate
        GR(1)=1.0d0
        call w36('Ground state set as first harmonic')
        WG=0.0d0
       endif
c
c      ground = sum(k) cg_k fi_K
c      VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
       do 36 K=1,N
       write(6,*)K,' of ',N
c      retrieve state K:
       DO 808 KK=N7,N3
808    SK(KK)=0
       DO 809 KK=1,IS(K)
809    SK(ICC(K,KK))=IN(K,KK)
       CGK=GR(K)
c      skip states with low weights:
       IF(ABS(CGK).GT.ALIM)then
        do 37 J=1,N
c       retrieve state J:
        DO 812 KK=N7,N3
812     SJ(KK)=0
        DO 815 KK=1,IS(J)
815     SJ(ICC(J,KK))=IN(J,KK)
c
c      <J|O|K>CG_K
c      22222222222222222222222222222222222222222222222222222222222222222
c
C       FUNCTION S1QIS2(S1,IQ,S2)
c       if(J.eq.16955)write(6,9000)(SJ(IQ),IQ=N7,N3)
c       if(J.eq.16955)write(6,9000)(SK(IQ),IQ=N7,N3)
c000    format(80I1)
        if(iabs(IT(K)-IT(J)).eq.1)then
         DO 814 IQ=N7,N3
C        <S1|Qi|S2> in dimensionless coordinates
         DO 59 I=N7,N3
         IF(I.NE.IQ)THEN
          IF(SJ(I).NE.SK(I))GOTO 4445
          GOTO 59
         ENDIF
         IF(SJ(I).EQ.SK(I)+1)THEN
          SFU=DSQRT(DBLE(SJ(I))/2.0d0)*CGK
          GOTO 59
         ENDIF
         IF(SJ(I).EQ.SK(I)-1)THEN
          SFU=DSQRT(DBLE(SK(I))/2.0d0)*CGK
          GOTO 59
         ENDIF
         GOTO 4445
59       CONTINUE
c        first derivatives du/dqi qi:
         GR(J+ 1   *N)=GR(J+ 1   *N)+SFU*QP(1,IQ)
         GR(J+ 2   *N)=GR(J+ 2   *N)+SFU*QP(2,IQ)
         GR(J+ 3   *N)=GR(J+ 3   *N)+SFU*QP(3,IQ)
         GR(J+(1+3)*N)=GR(J+(1+3)*N)+SFU*QM(1,IQ)
         GR(J+(2+3)*N)=GR(J+(2+3)*N)+SFU*QM(2,IQ)
         GR(J+(3+3)*N)=GR(J+(3+3)*N)+SFU*QM(3,IQ)

         IF(RAMAN)THEN
          do 705 ix=1,3
          do 705 iy=1,3
          ii=ix+3*(iy-1)
          GR(J+(ii+ 6)*N)=GR(J+(ii+ 6)*N)+SFU*ALPHAQ(IQ,ix,iy)
          GR(J+(ii+15)*N)=GR(J+(ii+15)*N)+SFU*GTENQ(IQ,ix,iy)
          do 705 iz=1,3
          ii=ix+3*(iy-1)+9*(iz-1)
705       GR(J+(ii+24)*N)=GR(J+(ii+24)*N)+SFU*ATENQ(IQ,ix,iy,iz)
         ENDIF

4445     CONTINUE
814      CONTINUE
        endif

        IF(AD.and.iabs(IT(K)-IT(J)).le.2)THEN
         DO 8141 IQ=N7,N3
c        second derivatives diagonal, <Qi^2> (JQ=IQ):
         DO 52 I=N7,N3
         IF(I.NE.IQ)THEN
          IF(SJ(I).NE.SK(I))GOTO 25555
          GOTO 52
         ENDIF
         IF(SJ(I).EQ.SK(I))THEN
          PR=(2*SJ(I)+1)*(2*SK(I)+1)
          GOTO 52
         ENDIF
         IF(SJ(I).EQ.SK(I)+2)THEN
          PR=SJ(I)*(SJ(I)-1)
          GOTO 52
         ENDIF
         IF(SJ(I).EQ.SK(I)-2)THEN
          PR=SK(I)*(SK(I)-1)
          GOTO 52
         ENDIF
         GOTO 25555
52       CONTINUE
         SFU=DSQRT(DBLE(PR))*0.25d0
c        (1/2) from matrix element x (1/2) from the taylor expansion
         ELJK=SFU*CGK
         if(RAMAN)then
          iu=IQ+(IQ-1)*N3
          GR(J+(1+ 6)*N)=GR(J+(1+ 6)*N)+ELJK*alphaaq(iu,1)
          GR(J+(2+ 6)*N)=GR(J+(2+ 6)*N)+ELJK*alphaaq(iu,2)
          GR(J+(3+ 6)*N)=GR(J+(3+ 6)*N)+ELJK*alphaaq(iu,3)
          GR(J+(4+ 6)*N)=GR(J+(4+ 6)*N)+ELJK*alphaaq(iu,4)
          GR(J+(5+ 6)*N)=GR(J+(5+ 6)*N)+ELJK*alphaaq(iu,5)
          GR(J+(6+ 6)*N)=GR(J+(6+ 6)*N)+ELJK*alphaaq(iu,6)
          GR(J+(7+ 6)*N)=GR(J+(7+ 6)*N)+ELJK*alphaaq(iu,7)
          GR(J+(8+ 6)*N)=GR(J+(8+ 6)*N)+ELJK*alphaaq(iu,8)
          GR(J+(9+ 6)*N)=GR(J+(9+ 6)*N)+ELJK*alphaaq(iu,9)
         endif
         GR(J+ 1   *N)=GR(J+ 1   *N)+ELJK*QPQ(1,IQ,IQ)
         GR(J+(1+3)*N)=GR(J+(1+3)*N)+ELJK*QMQ(1,IQ,IQ)
         GR(J+ 2   *N)=GR(J+ 2   *N)+ELJK*QPQ(2,IQ,IQ)
         GR(J+(2+3)*N)=GR(J+(2+3)*N)+ELJK*QMQ(2,IQ,IQ)
         GR(J+ 3   *N)=GR(J+ 3   *N)+ELJK*QPQ(3,IQ,IQ)
         GR(J+(3+3)*N)=GR(J+(3+3)*N)+ELJK*QMQ(3,IQ,IQ)
25555    CONTINUE
c
c        second derivatives off-diagonal
         DO 8141 JQ=IQ+1,N3
C        IQJQ is JQIQ, so take it twice:
C        FUNCTION S1QIQJS2(S1,IQ,JQ,S2)
C        <S1|Qi Qj |S2> in dimensionless coordinates
         PR=1
         DO 11 I=N7,N3
         IF(I.NE.IQ.AND.I.NE.JQ)THEN
          IF(SJ(I).NE.SK(I))GOTO 8141
          GOTO 11
         ENDIF
         IF(SJ(I).EQ.SK(I)+1)THEN
          PR=PR*SJ(I)
          GOTO 11
         ENDIF
         IF(SJ(I).EQ.SK(I)-1)THEN
          PR=PR*SK(I)
          GOTO 11
         ENDIF
         GOTO 8141
11       CONTINUE
c        (1/2)from mat.element x (1/2) from Taylor x 2 from ij=ji
         ELJKQ=DSQRT(DBLE(PR))*0.5d0*CGK
         if(RAMAN)then
          iu=IQ+(JQ-1)*N3
          GR(J+(1+ 6)*N)=GR(J+(1+ 6)*N)+ELJKQ*alphaaq(iu,1)
          GR(J+(2+ 6)*N)=GR(J+(2+ 6)*N)+ELJKQ*alphaaq(iu,2)
          GR(J+(3+ 6)*N)=GR(J+(3+ 6)*N)+ELJKQ*alphaaq(iu,3)
          GR(J+(4+ 6)*N)=GR(J+(4+ 6)*N)+ELJKQ*alphaaq(iu,4)
          GR(J+(5+ 6)*N)=GR(J+(5+ 6)*N)+ELJKQ*alphaaq(iu,5)
          GR(J+(6+ 6)*N)=GR(J+(6+ 6)*N)+ELJKQ*alphaaq(iu,6)
          GR(J+(7+ 6)*N)=GR(J+(7+ 6)*N)+ELJKQ*alphaaq(iu,7)
          GR(J+(8+ 6)*N)=GR(J+(8+ 6)*N)+ELJKQ*alphaaq(iu,8)
          GR(J+(9+ 6)*N)=GR(J+(9+ 6)*N)+ELJKQ*alphaaq(iu,9)
         endif
         GR(J+ 1   *N)=GR(J+ 1   *N)+ELJKQ*QPQ(1,IQ,JQ)
         GR(J+(1+3)*N)=GR(J+(1+3)*N)+ELJKQ*QMQ(1,IQ,JQ)
         GR(J+ 2   *N)=GR(J+ 2   *N)+ELJKQ*QPQ(2,IQ,JQ)
         GR(J+(2+3)*N)=GR(J+(2+3)*N)+ELJKQ*QMQ(2,IQ,JQ)
         GR(J+ 3   *N)=GR(J+ 3   *N)+ELJKQ*QPQ(3,IQ,JQ)
         GR(J+(3+3)*N)=GR(J+(3+3)*N)+ELJKQ*QMQ(3,IQ,JQ)
8141     CONTINUE
        ENDIF
c       22222222222222222222222222222222222222222222222222222222222222222
37      continue
       endif
36     continue
c      VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
       open(4,file='IV.SCR',form='unformatted')
       write(4)WG,(GR(i),i=1,N*NK0)
       close(4)
       call w36('Inital vectors written to IV.SCR')
      endif
c
c     set up parallel parameters:
      if(nproc.gt.omp_get_num_procs())
     1call report('not enough processors')
      if(nproc.gt.omp_get_max_threads())
     1write(6,*)'Number of threads will increase'
      call omp_set_num_threads(nproc)
      call omp_set_dynamic(0)
      call omp_set_nested(0)
c
c     precalculate parallel distributions for "non-parralezable" loops:
      call ppd(nproc,nproc0,nstart,nend,N)
c
c     allocate the time-components for FFT:
      allocate(ur(1:NK0),ui(1:NK0),stat=I)
      if(I.ne.0)call report('Not enough memory for FFT ui')
      allocate(sr(1:NK0*np),si(1:NK0*np),stat=I)
      if(I.ne.0)call report('Not enough memory for FFT si')
      allocate(sto(1:n5*np),stat=I)
      if(I.ne.0)call report('Not enough memory for FFT sto')
c
c     initialize total spectra
      do 13 i=1,np*n5
13    sto(i)=0.0d0
c
      do 899 iis=1,NWV
c
c     initialize spectra
      do 8991 i=1,np*NK0
      si(i)=0.0d0
8991  sr(i)=0.0d0
c
c     Initialize trial vector-real and imaginary part,rr, ri
c     and ground state vector yr, yi
      ANORM=0.0d0
      do 8992 i=1,N
      rr(i)=random(0)-0.5d0
      ri(i)=0.0d0
8992  ANORM=ANORM+rr(i)**2
      ANORM=1.0d0/dsqrt(ANORM)
      do 81 i=1,N
81    rr(i)=rr(i)*ANORM
c
c     remember zero time
      do 86 i=1,N
86    r0(i)=rr(i)
c
      do 8993 i=1,N
      r2r(i) =0.0d0
      r2i(i) =0.0d0
      rrm(i) =rr(i)
      rim(i) =ri(i)
      rrmm(i)=rr(i)
8993  rimm(i)=ri(i)
c
      if (ldisk)call report('ldisk not implemented')
c
c     do the propagation:
c     ######################################################
      t=-dt
      do 3 iit=1,nmd
      t=t+dt
      ttpc=t*tpc
      cg=cos(WG*ttpc)
      sg=sin(WG*ttpc)
c
c     mutliply st by FF, store in AX:
C$OMP PARALLEL DO PRIVATE(I,imi,s1r,s1i,ii,ji)  DEFAULT(SHARED)
      DO 4 I=1,N
      imi=mm(I)
      s1r=0.0d0
      s1i=0.0d0
      DO 41 ii=1,nn(I)
      ji=imi+ii
      s1r=s1r+abb(ji)*rr(jbb(ji))
41    s1i=s1i+abb(ji)*ri(jbb(ji))
      AXR(I)=s1r
4     AXI(I)=s1i

c
c     Y(t+dt)=Y(t)-(i/h) H Y  dt + ni(w0-H/h) Y dt + 0.5 d^2Y/dt^2 dt^2
c                  Re=Re+Im
c                  Im=Im-iRe
c     Y=Y(0)exp(-iwt)exp[ni(w0-w)t]
C$OMP PARALLEL  DO PRIVATE(i) DEFAULT(SHARED)
      do 5 i=1,N
      rr(i)=rr(i)*(1.0d0+ni*w0*dttpc)+(AXI(i)-ni*AXR(i))*dttpc+r2r(i)
5     ri(i)=ri(i)*(1.0d0+ni*w0*dttpc)-(AXR(i)+ni*AXI(i))*dttpc+r2i(i)
c
c     normalize
c     call nmz(rr,ri,N)
C$OMP PARALLEL DEFAULT(SHARED) PRIVATE(ipr,j,s1r)
      ipr=OMP_GET_THREAD_NUM()+1
      s1r=0.0d0
      do 1 j=nstart(ipr),nend(ipr)
1     s1r=s1r+rr(j)**2+ri(j)**2
      sar(ipr)=s1r
C$OMP END PARALLEL
      s1r=0.0d0
      do 12 j=1,nproc
12    s1r=s1r+sar(j)
      if(dabs(s1r-1.0d0).gt.0.3d0)write(6,*)'norm very high',a
      s1r=1.0d0/dsqrt(s1r)
C$OMP PARALLEL DO PRIVATE(j) DEFAULT(SHARED)
      do 7  j=1,N
      ri(j)=ri(j)*s1r
7     rr(j)=rr(j)*s1r
c
C$OMP PARALLEL DO PRIVATE(i) DEFAULT(SHARED)
      do 8 i=1,N
c     calculate second derivatives:
      r2r(i)=(rr(i)+rrmm(i))*0.5d0-rrm(i)
      r2i(i)=(ri(i)+rimm(i))*0.5d0-rim(i)
c     remember vectors:
      rrmm(i)=rrm(i)
      rimm(i)=rim(i)
      rrm(i)=rr(i)
8     rim(i)=ri(i)
c
c     time-dependent dipole moments and autocorrelation function:
c     ur real, ui imaginary
c            i:1      f(t) = R*(t).R(0)exp(-iwGt)
c              2... 4 u(t) = R*(t).G(t)
c              5... 7 m
c              8...16 al
c             17...25 G'
c             26...52 A'
c
c     i=1:
C$OMP PARALLEL DEFAULT(SHARED) PRIVATE(ipr,j,s1r,s1i)
      ipr=OMP_GET_THREAD_NUM()+1
      s1r=0.0d0
      s1i=0.0d0

      do 712 j=nstart(ipr),nend(ipr)
c
c     r0 exp(-iwGt) =r0 cos -i r0 sin
c     Re (   R*(t).r0 exp(-iwGt)) =Re R Re r0 exp(-iwGt) + Im Im
c                                 =Re R r0 cg + Im R (-r(0) sg)
c     Im (   R*(t).r0 exp(-iwGt)) =Re R Im r0 exp(-iwGt) - Im Re
c                                 =-Re R r0 sg - Im R (r(0) cg)
      s1r=s1r+(rr(j)*cg-ri(j)*sg)*r0(j)
712   s1i=s1i-(rr(j)*sg+ri(j)*cg)*r0(j)
      sar(ipr)=s1r
      sai(ipr)=s1i
C$OMP END PARALLEL
      s1r=0.0d0
      s1i=0.0d0
      DO 9 j=1,nproc
      s1r=s1r+sar(j)
9     s1i=s1i+sar(j)
      ur(1)=s1r*dt
      ui(1)=s1i*dt

c     i>1:
C$OMP PARALLEL DO PRIVATE(i,s1r,s1i,j) DEFAULT(SHARED)
      do 10 i=2,NK0
      s1r=0.0d0
      s1i=0.0d0
      do 711 j=1,N
c     propagate ground state analytically
c     Re G =   Re G(0)*cg
c     Im G = - Re G(0)*sg
c
      s1r=s1r + (rr(j)*cg-ri(j)*sg)*GR(j+(i-1)*N)
711   s1i=s1i - (rr(j)*sg+ri(j)*cg)*GR(j+(i-1)*N)
      ur(i)=s1r*dt
10    ui(i)=s1i*dt
c
      if(mod(iit,iprint).eq.0)then
       write(6,700)iis,iit,t
700    format(i3,'. spectrum',
     1 i10,'. step,',' time ',f15.2,' fs')
       write(s10,701)iis
701    format(i10)
      endif
c
c     accumulate FT =int u(t)e(-iwt) dt
C$OMP PARALLEL DO PRIVATE(i,j,ce,se) DEFAULT(SHARED)
      do 83 i=1,np
      ce=cos(ttpc*(WMIN+dd*dble(i-1)))
      se=sin(ttpc*(WMIN+dd*dble(i-1)))
c     f(t) exp(-iwt) +f*(t) exp(+iwt)
c     wr(1)=2.0d0*(ce*ur(1)+se*ui(1))
c     wi(1)=0.0d0
      do 83 j=1,NK0
      sr(i+(j-1)*np)=sr(i+(j-1)*np)+ce*ur(j)+se*ui(j)
83    si(i+(j-1)*np)=si(i+(j-1)*np)+ce*ui(j)-se*ur(j)

3     continue
c     ######################################################
c
c     Sum up the intensity spectra:
c     1 correlation R*(t).R(0).exp(-iwGt)
c     2 abs direct
c     3 vcd direct
c     4 Raman1
c     5 ROA1
      do 8997 i=1,np
c     R*(t).R(0)exp(-iwGt)
      sto(i)=sto(i)+sr(i)
      do 89971 ix=1,3
      ii=ix*np
c     R*(t).u(t)
      sto(i+  np)=sto(i+  np)+sr(i+ii)*sr(i+ii)+si(i+ii)*si(i+ii)
      i2=(ix+3)*np
89971 sto(i+2*np)=sto(i+2*np)+sr(i+ii)*sr(i+i2)+si(i+ii)*si(i+i2)
c9971 sto(i+2*NP)=sto(i+2*NP)+sr(i+ii)*si(i+i2)+si(i+ii)*sr(i+i2)(1)
c9971 sto(i+2*NP)=sto(i+2*NP)+sr(i+ii)*sr(i+i2)+si(i+ii)*si(i+i2)-works(2)
c9971 sto(i+2*NP)=sto(i+2*NP)+sr(i+ii)*si(i+i2)-si(i+ii)*sr(i+i2)-does not work

      SAL0=0.0d0
      SAL1=0.0d0
      SAG0=0.0d0
      SAG1=0.0d0
      SA1=0.0d0
      DO 6 II=1,3
      DO 6 J=1,3
      iti=II+3*(II-1)
      itj=J+3*(J-1)
      io=II+3*(J-1)
c     SAL0=SAL0+ALPHA(IQ,I,I)*    ALPHA(IQ,J,J)
      SAL0=SAL0+sr(i+(iti+6)*np)*sr(i+(itj+6)*np)+
     1si(i+(iti+6)*np)*si(i+(itj+6)*np)
c     SAL1=SAL1+ALPHA(IQ,I,J)*    ALPHA(IQ,I,J)
      SAL1=SAL1+sr(i+(io+6)*np)*sr(i+(io+6)*np)+
     1si(i+(io+6)*np)*si(i+(io+6)*np)
c     SAG0=SAG0+ALPHA(IQ,I,I)*    G(IQ,J,J)
      SAG0=SAG0+sr(i+(iti+6)*np)*sr(i+(itj+15)*np)+
     1si(i+(iti+6)*np)*si(i+(itj+15)*np)
c     SAG1=SAG1+ALPHA(IQ,I,J)*    G(IQ,I,J)
      SAG1=SAG1+sr(i+(io+6)*np)*sr(i+(io+15)*np)+
     1si(i+(io+6)*np)*si(i+(io+15)*np)
      DO 6 K=1,3
      DO 6 L=1,3
c     SA1=SA1+EPS(I,K,L)*ALPHA(IQ,I,J)*A(IQ,K,L,J)/3.0d0
      itkl=K+3*(L-1)+9*(J-1)
6     SA1=SA1+EPS(II,K,L)*(sr(i+(io+6)*np)*sr(i+(itkl+24)*np)+
     1                     si(i+(io+6)*np)*si(i+(itkl+24)*np))/3.0d0
c
c     180 backscattering IL+IR
      sto(i+3*np)=sto(i+3*np)+7.0d0*SAL1+SAL0
c
c     180 backscattering IR-IL
8997  sto(i+4*np)=sto(i+4*np)+8.0d0*(3.0d0*SAG1-SAG0+SA1)

899   continue

      deallocate(ur,ui)
c
      call wrs(   0,np,WMIN,dd,NWV,'S.PRN',0,N,nmd,dt,sto,stemp)
      call wrs(  np,np,WMIN,dd,NWV,'D.PRN',1,N,nmd,dt,sto,stemp)
      call wrs(2*np,np,WMIN,dd,NWV,'R.PRN',2,N,nmd,dt,sto,stemp)
      if(RAMAN)then
       call wrs(3*np,np,WMIN,dd,NWV,'RAM.PRN',3,N,nmd,dt,sto,stemp)
       call wrs(4*np,np,WMIN,dd,NWV,'ROA.PRN',4,N,nmd,dt,sto,stemp)
      endif
c
      write(3,6009)dble(mclock()-it0)/100.0d0
      write(6,6009)dble(mclock()-it0)/100.0d0
6009  format(' Time: ',f15.2,' sec')
      call report('Program finished')
      deallocate(GR,sto,sr,si)
      if(.not.ldisk)deallocate(jbb,abb)
      RETURN
      END

c
c     subroutine sadd(s,c,q,i,np,n)
c     implicit none
c     real*8 s(*),q(*),c
c     integer*4 i,np,j,n
c     correlation:
c     do 1 j=1,n
c     s(i+(j-1)*np)=s(i+(j-1)*np)+c*q(j)
c     return
c     end

      function sf(d,g,x,x0)
      implicit none
      logical g
      real*8 pi,spi,sf,d,x,x0,dd
      pi=4.0d0*atan(1.0d0)
      spi=dsqrt(pi)
      dd=((x-x0)/d)**2
c     write(6,*)d,x,x0,g
      if(g)then
       if(dd.lt.20.0d0)then
        sf=exp(-dd)/d/spi
       else
        sf=0.0d0
       endif
      else
       if(dd.lt.1000.0d0)then
        sf=1.0d0/d/(dd+1.0d0)/pi
       else
        sf=0.0d0
       endif
      endif
      return
      end

c     subroutine nmz(r,i,N)
c     implicit none
c     real*8 r(*),i(*),a
c     integer*4 N,j
c     a=0.0d0
c     do 1 j=1,N
c     a=a+r(j)**2+i(j)**2
c     if(dabs(a-1.0d0).gt.0.3d0)write(6,*)'norm very high',a
c     a=1.0d0/dsqrt(a)
c     do 2 j=1,N
c     i(j)=i(j)*a
c     r(j)=r(j)*a
c     return
c     end

      subroutine wrs(n1,np,WMIN,dd,NWV,s,ic,N,nmd,dt,o,stemp)
      implicit none
      character*(*) s
      integer*4 n1,np,NWV,i,N,nmd,ic
      real*8 c2,pi,WMIN,dd,wi,dt,o(*),dw,clight,x,stemp
      pi=4.0d0*atan(1.0d0)
      clight=2.99792458D8
c     dw (of delta-function) ~ 1/T
      dw=1.0d0/(2.0d0*pi*clight*100.0d0*dt*dble(nmd)*1.0d-15)
c     108.7=1/9.184e-3
      c2=1.0d0
      if(ic.eq.1)c2=
     1dble(N)*dsqrt(2.0d0*pi)*dw/4.0d0/pi**2*108.7d0/NWV*7.0d-7
      if(ic.eq.2)c2=
     1dble(N)*dsqrt(2.0d0*pi)*dw/4.0d0/pi**2*435.0d0/NWV*7.0d-11
      open(91,file=s)
      wi=WMIN-dd
      do 64 i=1,NP
      wi=wi+dd
      x=o(n1+i)*c2
      if(ic.eq.1)x=x*wi
      if(ic.eq.2)x=x*wi
      if(ic.eq.3)x=x*dsqrt(dabs(wi))/3120.0d0/
     1(1.0d0-exp(-(1.44d0*wi/stemp)))
      if(ic.eq.4)x=x*dsqrt(dabs(wi))/3120.0d0/
     1(1.0d0-exp(-(1.44d0*wi/stemp)))
64    write(91,494)wi,x
494   format(g15.6,' ',g15.6)
      close(91)
      write(6,*)s,' written'
      return
      end

      FUNCTION EPS(I,J,K)
      IMPLICIT INTEGER*4 (I-N)
      REAL*8 EPS
      EPS=0.0D0
      if(I.EQ.1)then
       IF(J.EQ.2.AND.K.EQ.3)THEN
        EPS= 1.0D0
       ELSE
        IF(J.EQ.3.AND.K.EQ.2)EPS= -1.0d0
       ENDIF
      else
       if(I.EQ.2)then
        IF(J.EQ.3.AND.K.EQ.1)THEN
         EPS= 1.0D0
        ELSE
         IF(J.EQ.1.AND.K.EQ.3)EPS=-1.0D0
        ENDIF
       else
        IF(J.EQ.1.AND.K.EQ.2)THEN
         EPS= 1.0D0
        ELSE
         IF(J.EQ.2.AND.K.EQ.1)EPS=-1.0D0
        ENDIF
       endif
      endif
      RETURN
      END

      SUBROUTINE four1(data,nn,asign)
c     Fast Fourier Tranform (FFT) from Numerical recepies, with some
c     changes for real*8 precision
      implicit none
c     nn .. number of complex numbers (2*nn real ones)
c     Input  "time"                 Output "frequency"
c     data(   1) Real f0            Real F0
c     data(   2) Im   f0            Im   F0
c     data(   3) Real f1            Real F1   freq=1/(ND)
c     data(   4) Im   f1   etc      Im   F1   freq=1/(ND)
c     .....
c     data( N-1)                    Real      freq=(N/2-1)/(ND)
c     data( N  )                    Im        freq=(N/2-1)/(ND)
c     data( N+1)                    Real      freq=+1/(2ND)
c     data( N+2)                    Im        freq=-1/(2ND)
c     data( N+3)                    Real      freq=-(N/2-1)/(ND)
c     data( N+4)                    Im        freq=-(N/2-1)/(ND)
c     .....
c     data(2N 4)       f(N-1)D      Im        freq=-1/(ND)
c     return the same ordering. f0 zero-frequency
c     Replaces data(1:2*nn) by its discrete Fourier transform, if asign is
c     input as 1; or replaces data(1:2*nn) by nn times its inverse discrete
c     Fourier transform, if asign is input as -1.
c     data is a complex array of length nn or, equivalently, a real array
c     of length 2*nn. nn MUST be an integer power of 2
c     (this is not checked for!).
      INTEGER*4 nn
      REAL*8 data(*),asign
      INTEGER*4 i,istep,j,m,mmax,n
      REAL*8 tempi,tempr,theta,wi,wpi,wpr,wr,wtemp
c
      n=2*nn
      j=1
c
c     bit reversal section:
      do 11 i=1,n,2
      if(j.gt.i)then
c      exchange two complex numbers:
       tempr=data(j)
       tempi=data(j+1)
       data(j)=data(i)
       data(j+1)=data(i+1)
       data(i)=tempr
       data(i+1)=tempi
      endif
      m=nn
1     if ((m.ge.2).and.(j.gt.m)) then
       j=j-m
       m=m/2
       goto 1
      endif
11    j=j+m
c
c     Danielson-Lanczos section:
      mmax=2
c     Outer loop executed log2 nn times.
2     if (n.gt.mmax) then
       istep=2*mmax
c      Initialize for the trigonometric recurrence:
       theta=6.28318530717959d0/(asign*dble(mmax))
       wpr=-2.d0*sin(0.5d0*theta)**2
       wpi=sin(theta)
       wr=1.d0
       wi=0.d0
c      Two nested inner loops:
       do 13 m=1,mmax,2
       do 12 i=m,n,istep
       j=i+mmax
c      Danielson-Lanczos formula:
       tempr=wr*data(j)-wi*data(j+1)
       tempi=wr*data(j+1)+wi*data(j)
       data(j)=data(i)-tempr
       data(j+1)=data(i+1)-tempi
       data(i)=data(i)+tempr
12     data(i+1)=data(i+1)+tempi
c      Trigonometric recurrence:
       wtemp=wr
       wr=wr*wpr-wi*wpi+wr
13     wi=wi*wpr+wtemp*wpi+wi
       mmax=istep
c      Not yet done:
       goto 2
      endif
c     All done:
      return
      END

      subroutine ppd(nproc,nproc0,nstart,nend,N)
      implicit none
      integer*4 nproc,nproc0,nstart(*),nend(*),nd,N,nrest,ipr
c
      if(nproc.gt.nproc0)call report('too many processors requested')
      nd=N/nproc
      nrest=N-nd*nproc
      nstart(1)=1
      nend(1)=nd
      if(nrest.ge.1)nend(1)=nend(1)+1
      do 7 ipr=2,nproc
      nstart(ipr)=nend(ipr-1)+1
      nend(ipr)=nstart(ipr)+nd-1
7     if(nrest.ge.ipr)nend(ipr)=nend(ipr)+1
      return
      end


      function random(i)
      implicit none
      real*8 random
      integer*4 i
c
c     Algorithm AS 183 Appl. Statist. (1982) vol.31, no.2
c
c     Returns a pseudo-random number rectangularly distributed
c     between 0 and 1.   The cycle length is 6.95E+12 (See page 123
c     of Applied Statistics (1984) vol.33), not as claimed in the
c     original article.
c
c     IX, IY and IZ should be set to integer values between 1 and
c     30000 before the first entry.
c
      integer*4 ix, iy, iz
      common /randc/ ix, iy, iz
c
      ix = mod(171 * ix, 30269)
      iy = mod(172 * iy, 30307)
      iz = mod(170 * iz, 30323)
      random = mod(dble(ix) / 30269.0d0 + dble(iy) / 30307.0d0 +
     1                        dble(iz) / 30323.0d0, 1.0d0)
      return
      end
