      FUNCTION SUMT(N,N7,U,ak,bkl,clj,usj,uo,uu,ww,
     1S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
C     A = < STATE1 | T-curved | STATE2> (without the harmonic term) 
      IMPLICIT none
      INTEGER*4 S1,S2,PR,i,j,nse,ndee,ndeo,ii,ic,N7,N,iq,jj,
     1S2i,S1i,S2k,K,S1k,S1j,S2j,
     1S1_Ncent,S1_Lexc(*),S1_Lcent(*),
     1S2_Ncent,S2_Lexc(*),S2_Lcent(*),
     1nse_c(*),nse_S1(*),ndeo_S1(*),ndeo_S2(*),
     1ndee_c(*),ndeo_c(*),ndee_S1(*),ndee_S2(*)
      real*8 SUMT,U(*),ak(*),bkl(*),clj(*),CM,
     1usj(*),r1,r2,s3,s4,s5,s6,s7,s9,s10,s11,
     1s12,s13,el,eli,elid,elj,eljd,uo(*),uu(*),ww(*)
      logical ldelta
c
c     ndee .. number of different excitations, even difference
c     ndeo .. number of different excitations, odd difference
c     nse  .. number of same excitations

      call detndee(ndee,ndeo,nse,S1_Ncent,S2_Ncent,S1_Lcent,
     1S2_Lcent,nse_c,nse_S1,ndee_c,ndee_S1,ndee_S2, ndeo_c, ndeo_S1, 
     2ndeo_S2,S1_Lexc,S2_Lexc)

      ldelta=ndee.eq.0.and.ndeo.eq.0.and.nse.eq.S1_Ncent

      r1=0.0d0
      r2=0.0d0
c     USj <s1| d/dqj |s2>
c     Aj  <s1| qj    |s2>
      if(ndeo.eq.1)then
       if(ndee.eq.0)THEN
        S1=ndeo_S1(1)
        S2=ndeo_S2(1)
        if(S1.EQ.S2-1)then
         r1=dsqrt(dble(S2)/2.0d0)*usj(ndeo_c(1))
         r2=dsqrt(dble(S2)/2.0d0)* ak(ndeo_c(1))
        else
         if(S1.EQ.S2+1)then
          r1=-dsqrt(dble(S1)/2.0d0)*usj(ndeo_c(1))
          r2= dsqrt(dble(S1)/2.0d0)* ak(ndeo_c(1))
         endif
        endif
c       <m| d/dqj |n> = sqrt(w/2h)(sqrt(m) d_n,m-1 - sqrt(n) d_n,m+1)
c       <m| qj    |n> = sqrt(w/2h)(sqrt(m) d_n,m-1 + sqrt(n) d_n,m+1)
       endif
      endif

c     s3=B_jj <s1| qj^2  |s2>
      s3=0.0d0
c     <A||A>:
      if(ldelta)then
       do 6 II=N7,N
       S1=0
       do 8 jj=1,nse
8      IF(nse_c(jj).eq.II)S1=nse_S1(jj)
6      s3=s3+bkl(II+N*(II-1))*DBLE(2*S1+1)/2.0d0
c      <n|q^2|n>=(2N+1)*(h/2w)
      else
c      <A||B>, A<>B:
       if(ndee.eq.1.and.ndeo.eq.0)then
        II=ndee_c(1)
        S1=ndee_S1(1)
        S2=ndee_S2(1)
        if(S1.eq.S2-2)then
         s3=s3+bkl(II+N*(II-1))*dsqrt(DBLE(S2*(S2-1)))/2.0d0
        else
         if(S1.eq.S2+2)then
          s3=s3+bkl(II+N*(II-1))*dsqrt(DBLE(S1*(S1-1)))/2.0d0
         endif
        endif
       endif
c      <m|q^2|n> = h/(2w){sqrt[(m*(m-1)] d_n,m-2 + (2m+1) d_n,m
c                        +sqrt[(n*(n-1)] d_n,m+2}
      endif

c     s4=B_ij <s1| qi qj  |s2>  j<>j:
      s4=0.0d0
      if(ndeo.eq.2.and.ndee.eq.0)then
       S1i=ndeo_S1(1)
       S2i=ndeo_S2(1)
       if(S1i.EQ.S2i-1)then
        PR=S2i
       else
        if(S1i.EQ.S2i+1)then
         PR=S1i
        else
         goto 10
        endif
       endif
       S1j=ndeo_S1(2)
       S2j=ndeo_S2(2)
       if(S1j.EQ.S2j-1)then
        PR=PR*S2j
       else
        if(S1j.EQ.S2j+1)then
         PR=PR*S1j
        else
         goto 10
        endif
       endif
       I=ndeo_c(1)
       J=ndeo_c(2)
       s4=s4+dsqrt(dble(PR))*(bkl(I+N*(J-1))+bkl(J+N*(I-1)))/2.0d0
c      <m|q|n> =sqrt[h/(2w)] [sqrt(m) d_n,m-1 + sqrt(n) d_n,m+1]
      endif
10    continue


c     s5=C_jj <s1| qj  d/dqj |s2>
      s5=0.0d0
c     <A||A>:
      if(ldelta)then
       do 11 II=N7,N
11     s5=s5+clj(II+N*(II-1))/2.0d0
c      <n|q d/dq|n> = 1/2
      else
c      <A||B>, A<>B:
       if(ndee.eq.1.and.ndeo.eq.0)then
        II=ndee_c(1)
        S1=ndee_S1(1)
        S2=ndee_S2(1)
        if(S1.eq.S2-2)then
         s5=s5+clj(II+N*(II-1))*dsqrt(DBLE(S2*(S2-1)))/2.0d0
        else
         if(S1.eq.S2+2)then
          s5=s5-clj(II+N*(II-1))*dsqrt(DBLE(S1*(S1-1)))/2.0d0
         endif
        endif
       endif
c      <m|q d/dq|n> =(1/2) {sqrt[m(m-1)] d_n,m-2 + d_n,m -sqrt[n(n-1)] d_n,m+2 }
      endif

c     s6=C_ij <s1| qi d/dqj  |s2>  i<>j:
      s6=0.0d0
      if(ndeo.eq.2.and.ndee.eq.0)then
       S1i=ndeo_S1(1)
       S2i=ndeo_S2(1)
       if(S1i.EQ.S2i-1)then
        eli= dsqrt(dble(S2i))
        elid=eli
       else
        if(S1i.EQ.S2i+1)then
         eli = dsqrt(dble(S1i))
         elid=-eli
        else
         goto 13
        endif
       endif
       S1j=ndeo_S1(2)
       S2j=ndeo_S2(2)
       if(S1j.EQ.S2j-1)then
        elj= dsqrt(dble(S2j))
        eljd=elj
       else
        if(S1j.EQ.S2j+1)then
         elj=  dsqrt(dble(S1j))
         eljd=-elj
        else
         goto 13
        endif
       endif
       J=ndeo_c(1)
       I=ndeo_c(2)
       s6=s6+(eli *eljd*clj(J+N*(I-1))+elid*elj *clj(I+N*(J-1)))/2.0d0
c      <m|  q |n> =sqrt[h/(2w)] [sqrt(m) d_n,m-1 + sqrt(n) d_n,m+1]
c      <m|d/dq|n> =sqrt[w/(2h)] [sqrt(m) d_n,m-1 - sqrt(n) d_n,m+1]
      endif
13    continue

c     s7= 2 UOij <s1| qi d^2/dqi dqj  |s2> i<>j 
      s7=0.0d0
      if(ndeo.eq.1)then
       S1j=ndeo_S1(1)
       S2j=ndeo_S2(1)
c      <d/dqj>:
c      <m|d/dq|n> =sqrt[w/(2h)] [sqrt(m) d_n,m-1 - sqrt(n) d_n,m+1]
       if(S1j.EQ.S2j-1)then
        elj=dsqrt(dble(S2j)/2.0d0)
       else
        IF(S1j.EQ.S2j+1)THEN
         elj=-dsqrt(dble(S1j)/2.0d0)
        ELSE
         goto 14
        ENDIF
       endif
       J=ndeo_c(1)
       IF(ndee.eq.0)THEN
        do 57 I=N7,N
57      if(I.ne.J)s7=s7+elj*UO(J+N*(I-1))
c       <n|q d/dq|n> =1/2, 2 * (1/2) = 1
       ELSE
        if(ndee.eq.1)then
         S1i=ndee_S1(1)
         S2i=ndee_S2(1)
         I=ndee_c(1)
         if(S1i.EQ.S2i-2)then
c         <m|q d/dq|m-2> =1/2 sqrt(m*(m-1))
          s7=s7+elj*DSQRT(DBLE(S2i*(S2i-1)))*UO(J+N*(I-1))
         else
          if(S1i.EQ.S2i+2)then
c          <n-2|q d/dq|n> = -1/2 sqrt(n*(n-1))
           s7=s7-elj*DSQRT(DBLE(S1i*(S1i-1)))*UO(J+N*(I-1))
          endif
         endif
        endif
       ENDIF
      endif
14    continue


c     s9 = -2 uuji uuji <s1| qj^2 d^2/dqi^2 |s2> i <> j
      s9=0.0d0
      if(ndeo.eq.0)then
       if(ndee.eq.0)then
        do 62 I=N7,N
        S1=0
        do 52 iq=1,nse
52      if(nse_c(iq).eq.I)S1=nse_S1(iq)
c       <n|     q^2|n> = h/(2w) (2m+1)
c       <n|  d2/q^2|n> =-h/(2w) (2m+1)
        eli = dble(2*S1+1)/2.0d0
        elid=-dble(2*S1+1)/2.0d0
        do 62 J=N7,N
        if(J.ne.I)then
         S2=0
         do 56 iq=1,nse
56       if(nse_c(iq).eq.J)S2=nse_S1(iq)
         elj = dble(2*S2+1)/2.0d0
         eljd=-dble(2*S2+1)/2.0d0
         s9=s9-2.0d0*uu(I+N*(J-1))**2*elj*elid
     1        -2.0d0*uu(J+N*(I-1))**2*eli*eljd
        endif
62      continue
c      <m|     q^2|n> = h/(2w){sqrt[(m*(m-1)] d_n,m-2 + (2m+1) d_n,m
c                        +sqrt[(n*(n-1)] d_n,m+2}
c      <m|d^2/dq^2|n> = h/(2w){sqrt[(m*(m-1)] d_n,m-2 - (2m+1) d_n,m
c                        +sqrt[(n*(n-1)] d_n,m+2}
       else
        if(ndee.eq.1)then
         S1i=ndee_S1(1)
         S2i=ndee_S2(1)
         I=ndee_c(1)
         if(S1i.eq.S2i-2)then
          eli = dsqrt(dble(S2i*(S2i-1)))/2.0d0
c         <m|     q^2|m-2> = h/(2w) sqrt[(m*(m-1)] =  <m|  d2/q^2|m-2>
         else
          if(S1i.eq.S2i+2)then
           eli = dsqrt(dble(S1i*(S1i-1)))/2.0d0
c          <n-2|     q^2|n> = h/(2w) sqrt[(n*(n-1)] =  <n-2|  d2/q^2|n>
          else
           goto 15
          endif
         endif
         do 63 J=N7,N
         if(J.ne.I)then
          S1j=0
          do 53 iq=1,nse
53        if(nse_c(iq).eq.J)S1j=nse_S1(iq)
          elj = dble(2*S1j+1)/2.0d0
          eljd=-dble(2*S1j+1)/2.0d0
          s9=s9-2.0d0*eli*(uu(I+N*(J-1))**2*elj+uu(J+N*(I-1))**2*eljd)
         endif
63       continue
        else
         if(ndee.eq.2)then
          S1i=ndee_S1(1)
          S2i=ndee_S2(1)
          I=ndee_c(1)
          if(S1i.eq.S2i-2)then
           el=dsqrt(dble(S2i*(S2i-1)))/2.0d0
          else
           if(S1i.eq.S2i+2)then
            el=dsqrt(dble(S1i*(S1i-1)))/2.0d0
           else
            goto 15
           endif
          endif
          S1j=ndee_S1(2)
          S2j=ndee_S2(2)
          J=ndee_c(2)
          if(S1j.eq.S2j-2)then
           el=el*dsqrt(dble(S2j*(S2j-1)))/2.0d0
          else
           if(S1j.eq.S2j+2)then
            el=el*dsqrt(dble(S1j*(S1j-1)))/2.0d0
           else
            goto 15
           endif
          endif
          s9=s9-2.0d0*(uu(I+N*(J-1))**2+uu(J+N*(I-1))**2)*el
         endif 
        endif
       endif
      endif
15    continue

      s10=0.0d0
c     s10=3 (i<>j) wwij <s1| qi^2 d/dqi d/dqj |s2>
      if(ndeo.eq.2.and.ndee.eq.0)then
       do 88 ic=1,2
       if(ic.eq.1)then
        S1i=ndeo_S1(1)
        S2i=ndeo_S1(1)
        I  =ndeo_c(1)
        S1j=ndeo_S1(2)
        S2j=ndeo_S1(2)
        J  =ndeo_c(2)
       else
        S1i=ndeo_S1(2)
        S2i=ndeo_S1(2)
        I  =ndeo_c(2)
        S1j=ndeo_S1(1)
        S2j=ndeo_S1(1)
        J  =ndeo_c(1)
       endif
c      iiij:
c      <m| q d^2/dq^2|n> =(1/2)sqrt[w/(2h)] { sqrt[(m*(m-1)(m-2)] d_n,m-3 
c                                            +sqrt[(n*(n-1)(n-2)] d_n,m+3 
c      - (m-2) sqrt(m) d_n,m-1- (n+2) sqrt(n) d_n,m+1}
       IF(S1i.EQ.S2i-3)THEN
        eli=dsqrt(dble(S2i*(S2i-1)*(S1i-2))/8.0d0)
       ELSE
        IF(S1i.EQ.S2i+3)THEN
         eli=dsqrt(dble(S1i*(S1i-1)*(S1i-2))/8.0d0)
        ELSE
         IF(S1i.EQ.S2i-1)THEN
          eli=-dsqrt(dble(S2i*(S2i+2)**2)/8.0d0)
         ELSE
          IF(S1i.EQ.S2i+1)THEN
           eli=-dsqrt(dble(S1i*(S1i-2)**2)/8.0d0)
          ELSE
           goto 88
          ENDIF
         ENDIF
        ENDIF
        if(S1j.EQ.S2j-1)THEN
c        <m|  d/dq|m-1> =sqrt[w/(2h)] sqrt(m)
         s10=s10+eli*dsqrt(dble(S2j)/2.0d0)*ww(J+N*(I-1))*3.0d0
        else
         if(S1j.EQ.S2j+1)THEN
          s10=s10-eli*dsqrt(dble(S1j)/2.0d0)*ww(J+N*(I-1))*3.0d0
c         <n-1|  d/dq|n> = - sqrt[w/(2h)] sqrt(n)
         endif
        endif
       ENDIF
88     continue
      endif

      s11=0.0d0
c     s11=-2 uuki uukj <s1| qk^2 d/dqi dqj |s2> (ijk alldif)
      if(ndeo.eq.2)then
       S1i=ndeo_S1(1)
       S2i=ndeo_S1(1)
       I  =ndeo_c(1)
       S2i=ndeo_S2(1)
       S1j=ndeo_S1(2)
       S2j=ndeo_S2(2)
       J  =ndeo_c(2)
c      <m|d/dq|n> =sqrt[w/(2h)] [sqrt(m) d_n,m-1 - sqrt(n) d_n,m+1]
       IF(S1i.EQ.S2i-1)THEN
        el=dsqrt(dble(S2i)/2.0d0)
       ELSE
        IF(S1i.EQ.S2i+1)THEN
         el=-dsqrt(dble(S1i)/2.0d0)
        else
         goto 17
        endif
       endif
       IF(S1j.EQ.S2j-1)THEN
        el=el*dsqrt(dble(S2j)/2.0d0)
       ELSE
        IF(S1j.EQ.S2j+1)THEN
         el=-el*dsqrt(dble(S1j)/2.0d0)
        else
         goto 17
        endif
       endif
       if(ndee.eq.0)then
        do 64 K=N7,N
        if(K.ne.I.and.K.ne.J)then
         S1k=0
         do 54 iq=1,nse
54       if(nse_c(iq).eq.K)S1k=nse_S1(iq)
         s11=s11-2.0d0*uu(I+N*(K-1))*uu(J+N*(K-1))*dble(2*S1k+1)
c        last 2.00 - ij = ji, but <qk^>=0.5, 0.5 x 2 = 1
        endif
64      continue
       else
        if(ndee.eq.1)then
         S1k=ndee_S1(1)
         S2k=ndee_S1(1)
         K=ndee_c(1)
         if(S1k.eq.S2k-2)then
          el=el*dsqrt(dble(S2k*(S2k-1)))/2.0d0
         else
          if(S1k.eq.S2k+2)then
           el=el*dsqrt(dble(S1k*(S1k-1)))/2.0d0
          else
           goto 17
          endif
         endif
         s11=s11-2.0d0*uu(I+N*(K-1))*uu(J+N*(K-1))*el*2.0d0
c        last 2.00 - ij = ji
        endif
       endif
c      <m|     q^2|n> = h/(2w){sqrt[(m*(m-1)] d_n,m-2 + (2m+1) d_n,m
c                        +sqrt[(n*(n-1)] d_n,m+2}

      endif
17    continue

c     s12= - 4 Uij uuji <s1| qj qi d^2/dqi^2 |s2> i<>j
      s12=0.0d0
      if(ndeo.eq.2.and.ndee.eq.0)then
       do 18 ic=1,2
       if(ic.eq.1)then
        S1i=ndeo_S1(1)
        S2i=ndeo_S2(1)
        I  =ndeo_c(1)
        S1j=ndeo_S1(2)
        S2j=ndeo_S2(2)
        J  =ndeo_c(2)
       else
        S1i=ndeo_S1(2)
        S2i=ndeo_S2(2)
        I  =ndeo_c(2)
        S1j=ndeo_S1(1)
        S2j=ndeo_S2(1)
        J  =ndeo_c(1)
       endif
c      <m| q d^2/dq^2|n> =(1/2)sqrt[w/(2h)] { sqrt[(m*(m-1)(m-2)] d_n,m-3 
c                                            +sqrt[(n*(n-1)(n-2)] d_n,m+3 
c      - (m-2) sqrt(m) d_n,m-1 - (n+2) sqrt(n) d_n,m+1}
       IF(S1i.EQ.S2i-3)THEN
        el=dsqrt(dble(S2i*(S2i-1)*(S2i-2))/8.0d0)
       ELSE
        IF(S1i.EQ.S2i+3)THEN
         el=dsqrt(dble(S1i*(S1i-1)*(S1i-2))/8.0d0)
        ELSE
         IF(S1i.EQ.S2i-1)THEN
          el=-dsqrt(dble(S2i*(S2i-2)*(S2i-2))/8.0d0)
         else
          IF(S2i.EQ.S1i-1)THEN
           el=-dsqrt(dble(S1i*(S1i+2)*(S1i+2))/8.0d0)
          else
           goto 18
          endif
         endif 
        ENDIF
       ENDIF
c      <m|q|n> =sqrt[h/(2w)] [sqrt(m) d_n,m-1 + sqrt(n) d_n,m+1]
       IF(S1j.EQ.S2j-1)THEN
        el=el*dsqrt(dble(S2j)/2.0d0)
       ELSE
        IF(S1i.EQ.S2j+1)THEN
         el=el*dsqrt(dble(S1j)/2.0d0)
        else
         goto 18
        endif
       ENDIF
       s12=s12-4.0d0*U(J+N*(I-1))*uu(I+N*(J-1))*el
18     continue
      endif


c     s13= - 4 Ujk uuki <s1| qj qk d^2/dqi dqj |s2> i<>j 
      s13=0.0d0
      if(ndeo.eq.2)then
       do 20 ic=1,2
       if(ic.eq.1)then
        S1i=ndeo_S1(1)
        S2i=ndeo_S2(1)
        I  =ndeo_c(1)
        S1k=ndeo_S1(2)
        S2k=ndeo_S2(2)
        K  =ndeo_c(2)
       else
        S1i=ndeo_S1(2)
        S2i=ndeo_S2(2)
        I  =ndeo_c(2)
        S1k=ndeo_S1(1)
        S2k=ndeo_S2(1)
        K  =ndeo_c(1)
       endif
c      <m|q|n> =sqrt[h/(2w)] [sqrt(m) d_n,m-1 + sqrt(n) d_n,m+1]
       IF(S1k.EQ.S2k-1)THEN
        el=dsqrt(dble(S2k)/2.0d0)
       ELSE
        IF(S1k.EQ.S2k+1)THEN
         el=dsqrt(dble(S1k)/2.0d0)
        else
         goto 20
        endif
       ENDIF
c      <m|d/dq|n> =sqrt[w/(2h)] [sqrt(m) d_n,m-1 - sqrt(n) d_n,m+1]
       IF(S1i.EQ.S2i-1)THEN
        el=el*dsqrt(dble(S2i)/2.0d0)
       ELSE
        IF(S1i.EQ.S2i+1)THEN
         el=-el*dsqrt(dble(S1i)/2.0d0)
        else
         goto 20
        endif
       ENDIF
       if(ndee.eq.1)then
        S1j=ndee_S1(1)
        S2j=ndee_S2(1)
        J=ndee_c(1)
c       <m|d^2/dq^2|n> = h/(2w){sqrt[(m*(m-1)] d_n,m-2 - (2m+1) d_n,m
c                         +sqrt[(n*(n-1)] d_n,m+2}
        IF(S1j.EQ.S2j-2)THEN
         el=el*dsqrt(dble(S2j*(S2j-1)))/2.0d0
        ELSE
         IF(S1j.EQ.S2j+2)THEN
          el=el*dsqrt(dble(S1j*(S1j-1)))/2.0d0
         else
          goto 20
         endif
         s13=s13-4.0d0*U(K+N*(J-1))*uu(I+N*(K-1))*el
        ENDIF
       else
        if(ndee.eq.0)then
         do 65 J=N7,N
         if(J.ne.I.and.J.ne.K)then
          S1j=0
          do 55 iq=1,nse
55        if(nse_c(iq).eq.J)S1j=nse_S1(iq)
          s13=s13+2.0d0*U(K+N*(J-1))*uu(I+N*(K-1))*dble(2*S1j+1)
c         -4 x (-1/2) = +2
         endif
65       continue
        endif
       endif
20     continue
      endif

      CM=219474.0d0
c     write(6,600)r1*CM,r2*CM,s3*CM,s4*CM,s5*CM,s6*CM,s7*CM,
c    1s9*CM,s10*CM,s11*CM,s12*CM,s13*CM
 600  format(6g12.4)

      SUMT=r1+r2+s3+s4+s5+s6+s7+s9+s10+s11+s12+s13

      RETURN
      END
