      SUBROUTINE CONTROL(S,F,N,N7,tol,E,AM)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      real*8 S(NT3,NT3),F(NT3,NT3),T(NT3,NT3),E(*),AM(*)
c
      call w36(' ')
      call w36('Control')
      call w36('^^^^^^^')
      SFACR=0.02342179d0
      write(6,6000)tol,N7,N
      write(3,6000)tol,N7,N
6000  format(' tol = ',G10.4,', N7 =',I2,', N = ',I5)
      call w36('S-Matrix Orthonormality Test St.S=1')
      ic=0
      DO 8 I=N7,N
      DO 8 J=N7,N
      qij=0.0d0
      DO 81 II=1,N
81    qij=qij+S(II,I)*AM(II)*S(II,J)
      qij=qij/SFACR**2
      if((I.EQ.J.and.abs(qij-1.0d0).gt.tol).
     1 or.(I.ne.J.and.abs(qij).gt.tol))then
       ic=ic+1
       write(6,*)I,J,qij
       write(3,*)I,J,qij
      endif
8     continue
      if(ic.eq.0)then
       call w36('passed')
      else
       call w36('not passed')
      endif

      call w36('Diagonal test St.Fm.S=w(diag)')
      ic=0
c
c     first index
      DO 2 I=1,N
      DO 2 JJ=1,N
      T(I,JJ)=0.0d0
      DO 2 II=1,N
2     T(I,JJ)=T(I,JJ)+S(II,I)*F(II,JJ)/dsqrt(AM(II))
C
C     second index
      DO 1 I=1,N
      DO 1 J=1,N
      qij=0.0d0
      DO 11 JJ=1,N
11    qij=qij+S(JJ,J)*T(I,JJ)/dsqrt(AM(JJ))
      if(I.ne.J.and.abs(qij).gt.tol)then
       ic=ic+1
       write(6,*)I,J,qij
       write(3,*)I,J,qij
      endif
      if(I.EQ.J.and.abs(qij-E(I)**2).gt.tol)then
       ic=ic+1
       write(6,*)I,J,qij,E(I)**2
       write(3,*)I,J,qij,E(I)**2
      endif
1     continue
      if(ic.eq.0)then
       call w36('passed')
      else
       call w36('not passed')
      endif
C     S(unitary, for mass weighted x)=S/SFACR*DSQRT(AM)
      OPEN(4,FILE='SMAT.SCR',FORM='UNFORMATTED')
      WRITE(4)N/3,(E(I),I=1,N),((S(I,J),J=1,N),I=1,N),SFACR
      CLOSE(4)
      RETURN
      END
