      SUBROUTINE DODQ(S,N,L4,N7,HW,LP4,IP4,LXS,XLIM,NCAN,ICAN,tol4)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      DIMENSION S(NT3,N),U(NT0*3,NT0*3),ICAN(*)
      real*8,allocatable:: CX4(:,:,:),CQ4(:,:,:),DJKL(:,:,:)
c     CX4(NT3,NT3,N),CQ4(NT3,NT3,N),DJKL(NT3,NT3,NT3)
      INTEGER A,B,C,D
      LOGICAL L4,HW,LP4,LXS
      COMMON/CEM/E(NT3)
      CM=219470.0d0
      NAT=N/3
      Z0=0.0d0
      TWO=DBLE(2)
      allocate(CQ4(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CQ4 in dodq')
      allocate(CX4(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX4 in dodq')
      allocate(DJKL(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate DJKL in dodq')
C
C     Sparse cartesian FF:
      IF(LXS)THEN
C      Do not project:
       IF(.NOT.LP4)THEN
        WRITE(6,*)' Transforming quartics, sparse DX -> DQ:'

        DO 1 I=N7,N
        DO 1 J=N7,N
        DO 1 K=N7,N
1       CQ4(I,J,K)=Z0
        N44=0
        OPEN(4,FILE='SCR.44')
28      READ(4,*,END=38)IC,JC,KC,CON
        IF(IC.NE.JC)THEN
         IF(IC.NE.KC)THEN
          IF(KC.EQ.JC)THEN
           GOTO 30
          ELSE
           GOTO 40
          ENDIF
         ELSE
          GOTO 20
         ENDIF
        ELSE
         IF(JC.EQ.KC)THEN
          GOTO 10
         ELSE
          JC=KC
          GOTO 20
         ENDIF
        ENDIF
C
C       iii
10      DO 11 I=N7,N
        SIA=S(IC,I)*S(IC,I)*CON
        DO 11 J=N7,N
        SJA=S(IC,J)*SIA
        DO 11 K=J,N
11      CQ4(I,J,K)=CQ4(I,J,K)+S(IC,K)*SJA
        GOTO 99
C
C       iij
20      DO 21 I=N7,N
        SI1=S(IC,I)*S(IC,I)*CON
        SI2=S(IC,I)*S(JC,I)*CON
        DO 21 J=N7,N
        SJ1=SI1*S(IC,J)
        SJ2=SI1*S(JC,J)+(SI2+SI2)*S(IC,J)
        DO 21 K=J,N
21      CQ4(I,J,K)=CQ4(I,J,K)+S(IC,K)*SJ2+S(JC,K)*SJ1
        GOTO 99
C
C       ijj
30      DO 31 I=N7,N
        SI1=S(IC,I)*S(IC,I)*CON
        SI2=S(IC,I)*S(JC,I)*(CON+CON)
        SI3=S(JC,I)*S(JC,I)*CON
        DO 31 J=N7,N
        SJ1=SI1*S(JC,J)+SI2*S(IC,J)
        SJ3=SI2*S(JC,J)+SI3*S(IC,J)
        DO 31 K=J,N
31      CQ4(I,J,K)=CQ4(I,J,K)+SJ1*S(JC,K)
     1                       +SJ3*S(IC,K)
        GOTO 99
C
C       ijk
40      DO 41 I=N7,N
        SI1=S(IC,I)*S(IC,I)*CON
        SI2=S(IC,I)*S(JC,I)*(CON+CON)
        SI3=S(IC,I)*S(KC,I)*(CON+CON)
        SI4=S(JC,I)*S(KC,I)*(CON+CON)
        DO 41 J=N7,N
        SJ1=SI1*S(JC,J)+SI2*S(IC,J)
        SJ2=SI1*S(KC,J)+SI3*S(IC,J)
        SJ5=SI2*S(KC,J)+SI3*S(JC,J)+SI4*S(IC,J)
        DO 41 K=J,N
41      CQ4(I,J,K)=CQ4(I,J,K)+S(KC,K)*SJ1+
     1     S(JC,K)*SJ2+S(IC,K)*SJ5
C
99      N44=N44+1
        GOTO 28
38      CLOSE(4)
C
        WRITE(3,*)N44,' cartesian quartics read from SCR.44'
        DO 50 I=N7,N
        DO 50 J=N7,N
        DO 50 K=N7,J-1
50      CQ4(I,J,K)=CQ4(I,K,J)
        GOTO 999
       ENDIF
C      (Do not project)
C
       DO 82 I=1,N
       DO 82 J=1,N
       DO 82 K=1,N
82     CX4(I,J,K)=Z0
       N44=0
       OPEN(4,FILE='SCR.44',FORM='UNFORMATTED')
84     READ(4,*,END=83)I,J,K,CX4(I,J,K)
       CX4(I,K,J)=CX4(I,J,K)
       IF(J.EQ.K)CX4(J,I,I)=CX4(I,J,J)
       N44=N44+1
       GOTO 84
83     CLOSE(4)
       WRITE(3,*)N44,' cartesian quartics read from SCR.44'
      ENDIF
C     (sparse FF)
C
C     Check translational symmetry:
      C111=Z0
      C211=Z0
      C311=Z0
      DO 43 L=2,NAT
      C111=C111-CX4(1,1,3*L-2)
      C211=C211-CX4(1,1,3*L-1)
43    C311=C311-CX4(1,1,3*L  )
      WRITE(3,333)C111,C211,C311,CX4(1,1,1),CX4(1,1,2),CX4(1,1,3)
      WRITE(6,333)C111,C211,C311,CX4(1,1,1),CX4(1,1,2),CX4(1,1,3)
333   FORMAT(1X,'Sum rule for quartics',/,1X,3F15.10,/,1X,3F15.10,/,/)
C
Ciijk=Ciikj=Cikij=Cijik=Cijki=Cikji=Cjiik=Ckiij=Cjiki=Ckiji=Cjkii=Ckjii
C both for normal and cartesians, i the double index
C
C     Project-out rotational and translational components:
      IF(LP4)THEN
       WRITE(6,*)'Projecting zero vib. from quartics (',IP4,'times).'
C
C      Write quartic ff on the disk, to save computer memory, i<=j<=k<=l:
       OPEN(55,FILE='OLD.SCR',FORM='UNFORMATTED')
       OPEN(5,FILE='TEQ.SCR',FORM='UNFORMATTED')
       IF(IP4.EQ.0)GOTO 444
       CALL DOMA(U,NT0*3,N,HW)
       IC=1
3333   REWIND 5
       DO 52 I=1,N
       WRITE(6,*)I,' of ',N
C
C      Calculate cubic block I(JKL), write temporarily into CQ4
       DO 53 J=I,N
       DO 53 K=J,N
       DO 53 L=K,N
C
C      Contribution of old ("Exact") quartics, S1-S4:
       S1=0.0d0
       S2=0.0d0
       S3=0.0d0
       S4=0.0d0
       DO 552 II=1,N
       AIII=U(I,II)
       AJII=U(J,II)
       AKII=U(K,II)
       ALII=U(L,II)
C      iiii:
       S1=S1+AIII*AJII*AKII*ALII*CX4(II,II,II)
       DO 552 JJ=II+1,N
       AIJJ=U(I,JJ)
       AJJJ=U(J,JJ)
       AKJJ=U(K,JJ)
       ALJJ=U(L,JJ)
C      iijj=jiij=ijij (and i>j):
       S2=S2+CX4(II,JJ,JJ)*
     1 (AIII*(AJII*AKJJ*ALJJ+AJJJ*(AKJJ*ALII+AKII*ALJJ))+
     2  AIJJ*(AJII*AKII*ALJJ+(AJJJ*AKII+AJII*AKJJ)*ALII))
C      iiij=iiji=ijii=jiii (and i>j):
       S3=S3+CX4(II,II,JJ)*(
     1 AIII*(AJII*(AKII*ALJJ+AKJJ*ALII))+
     2      ((AIII*AJJJ+AIJJ*AJII)*AKII)*ALII)
     3     +CX4(JJ,JJ,II)*(
     4 AIJJ*(AJJJ*(AKJJ*ALII+AKII*ALJJ))+
     5      ((AIJJ*AJII+AIII*AJJJ)*AKJJ)*ALJJ)
       SKL=AKII*ALJJ+AKJJ*ALII
       SJL=AJII*ALJJ+AJJJ*ALII
       SJK=AJII*AKJJ+AJJJ*AKII
       SIL=AIII*ALJJ+AIJJ*ALII
       SIK=AIII*AKJJ+AIJJ*AKII
       SIJ=AIII*AJJJ+AIJJ*AJII
       DO 553 KK=1,N
       IF(KK.EQ.II.OR.KK.EQ.JJ)GOTO 553
C      kkij=kikj=kijk=ikkj=ikjk=ijkk and i>j:
       S4=S4+CX4(KK,II,JJ)*(
     1 U(I,KK)*U(J,KK)*SKL+U(I,KK)*U(K,KK)*SJL+U(I,KK)*U(L,KK)*SJK+
     2 U(J,KK)*U(K,KK)*SIL+U(J,KK)*U(L,KK)*SIK+U(K,KK)*U(L,KK)*SIJ)
553    CONTINUE
552    CONTINUE
53     CQ4(J,K,L)=S1+S2+S3+S4
C
C      For higher iterations pick the new off-dia
C      i<j<k<l 4!=24 combinations
       IF(IC.GT.1)THEN
        REWIND 55
        DO 532 A=1,N
C
        READ(55)(((DJKL(B,C,D),D=C,N),C=B,N),B=A,N)
        AIA=U(I,A)
        DO 532 B=A+1,N
        AIB=U(I,B)
        DO 532 C=B+1,N
        AIC=U(I,C)
        DO 532 D=C+1,N
        AID=U(I,D)
        DO 532 J=I,N
        CON=DJKL(B,C,D)
        AIAJB=CON*AIA*U(J,B)
        AIAJC=CON*AIA*U(J,C)
        AIAJD=CON*AIA*U(J,D)
        AIBJA=CON*AIB*U(J,A)
        AIBJC=CON*AIB*U(J,C)
        AIBJD=CON*AIB*U(J,D)
        AICJA=CON*AIC*U(J,A)
        AICJB=CON*AIC*U(J,B)
        AICJD=CON*AIC*U(J,D)
        AIDJA=CON*AID*U(J,A)
        AIDJB=CON*AID*U(J,B)
        AIDJC=CON*AID*U(J,C)
        DO 532 K=J,N
        SLA=(AICJD+AIDJC)*U(K,B)+
     1      (AIBJD+AIDJB)*U(K,C)+(AIBJC+AICJB)*U(K,D)
        SLB=(AIAJD+AIDJA)*U(K,C)+
     1      (AIAJC+AICJA)*U(K,D)+(AIDJC+AICJD)*U(K,A)
        SLC=(AIAJB+AIBJA)*U(K,D)+
     1      (AIBJD+AIDJB)*U(K,A)+(AIAJD+AIDJA)*U(K,B)
        SLD=(AICJB+AIBJC)*U(K,A)+
     1      (AIAJC+AICJA)*U(K,B)+(AIBJA+AIAJB)*U(K,C)
        DO 532 L=K,N
532     CQ4(J,K,L)=CQ4(J,K,L)+
     1   SLA*U(L,A)+SLB*U(L,B)+SLC*U(L,C)+SLD*U(L,D)
       ENDIF
52     WRITE(5)(((CQ4(J,K,L),L=K,N),K=J,N),J=I,N)
C
C      Calculate difference from old diagonals:
       IOP=1
       CALL PICK(CQ4,CX4,DIFF,IOP,NT3,N)
C
C      Go back, if IP4>IC
       IF(IC.LT.IP4)THEN
        IC=IC+1
        WRITE(6,*)' Projection repeated (#',IC,'):'
        WRITE(3,*)' Projection repeated (#',IC,'):'
        GOTO 3333
       ENDIF
C
C      Take new diagonals:
444    IOP=0
       CALL PICK(CQ4,CX4,DIFF,IOP,NT3,N)
       CLOSE(5)
       CLOSE(55)
      ENDIF
c
c     write projected quartics on the disk
      OPEN(22,FILE='XX4P.SCR.TXT',FORM='UNFORMATTED')
      DO 55 I=1,N
      DO 55 J=1,N
      DO 55 K=1,N
55    if(dabs(CX4(I,J,K)).gt.XLIM)write(22,2222)I,J,K,CX4(I,J,K)
2222  format(3i6,G16.8)
      close(22)
C
      WRITE(6,*)' Transforming quartics, semidiagonals ...'
C     Calculate D(I,I,J,K)=S(A,I)*S(B,I)*S(C,J)*S(D,K)*DX(A,B,C,D):
      DO 46 I=N7,N
      WRITE(6,*)I,' of ',N
      DO 46 J=N7,N
      DO 46 K=J,N
      S1=Z0
      S2=Z0
      S3=Z0
      S4=Z0
      DO 2 IC=1,N
      SIA=S(IC,I)
      SJA=S(IC,J)
      SKA=S(IC,K)
C     iiii:
      S1=S1+CX4(IC,IC,IC)*SIA*SIA*SJA*SKA
      DO 3 JC=1,N
      IF(JC.EQ.IC)GOTO 3
      SIB=S(JC,I)
      SJB=S(JC,J)
      SKB=S(JC,K)
      IF(JC.GT.IC)THEN
C      iijj=jiij=ijij (and i>j):
       S2=S2+CX4(IC,JC,JC)*
     1  (SIA*(SIA*SJB*SKB+SIB*(SJA*SKB+SJB*SKA))+
     2   SIB*(SIB*SJA*SKA+SIA*(SJB*SKA+SJA*SKB)) )
C      iiij=iiji=ijii=jiii (and i>j):
       S3=S3+CX4(IC,IC,JC)*(SIA*(SIA*(SJA*SKB+SJB*SKA) +
     1                           SIB*(SJA*SKA+SJA*SKA)))+
     2       CX4(JC,JC,IC)*(SIB*(SIB*(SJB*SKA+SJA*SKB) +
     3                           SIA*(SJB*SKB+SJB*SKB)))
      ENDIF
      S01=(SIA*SIA*SJB+TWO*SIA*SJA*SIB)
      S02=(SIA*SIA*SKB+TWO*SIA*SKA*SIB)
      S03=TWO*(SIA*SJA*SKB+SIA*SKA*SJB+SIB*SJA*SKA)
C      iijk=ijik=jiik=jiki=ijki=jkii (and k<j):
      DO 4 KC=JC+1,N
      IF(KC.EQ.IC)GOTO 4
      S4=S4+CX4(IC,JC,KC)*(S(KC,K)*S01+S(KC,J)*S02+S(KC,I)*S03)
4     CONTINUE
3     CONTINUE
2     CONTINUE
46    CQ4(I,J,K)=S1+S2+S3+S4
C
      DO 54 I=N7,N
      DO 54 J=N7,N
      DO 54 K=J+1,N
54    CQ4(I,K,J)=CQ4(I,J,K)
C
999   call write4(CQ4,N7,N,NCAN,ICAN,E,tol4)

      WRITE(3,3000)((N-N7+1)*(N-N7+1+1))/2
3000  FORMAT(/,I8,' OF DIAGONAL QUARTIC FORCE CONSTANTS: ',/)
      IQFC=0
      DO 421 I=N7,N
      DO 421 J=I,N
      IQFC=IQFC+1
      EIJ=ABS(E(I)*E(J))
      IF(E(I).LT.0.0d0.AND.E(J).LT.0.0d0)EIJ=-EIJ
C     Check imaginary frequencies
      IF((E(I).LT.0.0d0.AND.E(J).GT.0.0d0).OR.
     1  (E(I).GE.0.0d0.AND.E(J).LT.0.0d0)    )THEN
       WRITE(3,3004)IQFC,I,I,J,J,CQ4(I,J,J)/EIJ*CM
       GOTO 421
      ENDIF
      WRITE(3,3002)IQFC,I,I,J,J,CQ4(I,J,J)/EIJ*CM
421   CONTINUE
3002  FORMAT(1X,I6,2X,4I3,F14.4,' cm^-1')
3004  FORMAT(1X,I6,2X,4I3,F13.3,1Hi,' cm^-1')
      IF(L4)THEN
       NN=N-N7+1
       WRITE(3,3009)(NN**2*(NN+1)-NN*(NN-1)-NN*(NN+1))/2
3009  FORMAT(/,I8,' of off-diagonal quartics')
       IQFC=0
       DO 45 I=N7,N
       DO 45 J=N7,N
       DO 45 K=J+1,N
       IQFC=IQFC+1
       EJK=ABS(E(I))*DSQRT(ABS(E(J)*E(K)))
       IF(E(I).LT.0.0d0.AND.E(J).GT.0.0d0.AND.E(K).GT.0.0d0)THEN
        WRITE(3,3005)I,I,J,K,CQ4(I,J,K)/EJK*CM
        GOTO 45
       ENDIF
       IF(E(J).LT.0.0d0.OR.E(K).LT.0.0d0)THEN
        WRITE(3,3007,advance='no')I,I,J,K,CQ4(I,J,K)/EJK*CM
        GOTO 45
       ENDIF
       WRITE(3,3003,advance='no')I,I,J,K,CQ4(I,J,K)/EJK*CM
3005   FORMAT(1X,4I3,F10.1,1Hi,$)
3007   FORMAT(1X,4I3,F10.1,1H&,$)
3003   FORMAT(1X,4I3,F11.2,$)
45     IF((IQFC/3)*3.EQ.IQFC)WRITE(3,*)
       WRITE(3,*)
      ENDIF
      NCTO=N+4*N*(N-1)+3*N*(N-1)+6*N*(N-1)*(N-2)
      WRITE(3,*)NCTO,' of original quartic cartesians'
      NCTO=N*N*N*N
      WRITE(3,*)NCTO,' - complete quartic FF'
      deallocate(CQ4)
      deallocate(CX4)
      deallocate(DJKL)
      RETURN
      END
