      SUBROUTINE DOHIM4(ISTART,IEND,ISB,Kb,nproc)
      implicit none
      include 'dimensions.h'
      integer*4 ISTART,IEND,ISB,Kb,nproc,NDIM,ild,i,it0,
     1mclock,IISTART,IHH,i33,J,JHH,K,II,maxj,ilqct,noff,
     1omp_get_num_procs,omp_get_max_threads
      real*8 nel,aveo,aved,CM,EI,EJ,hmaxj,HII,HOFF,fsumsf,
     1fsumsqf,sumt,SUM5,SUM6
      LOGICAL LASCR,la1scr
      character*1 s1

      integer*4 iopt,ilqc
      common/iop/iopt(300)
      equivalence (ilqc,iopt(21))

      logical lopt,lqc,lnm2
      common/lop/lopt(300)
      equivalence (lqc,lopt(51)),(lnm2,lopt(52))

      real*8 E
      COMMON/CEM/E(NT3)

      integer*4 NBG,IT,IS,IBIGSYM,ICC,IN
      COMMON/DIA1/NBG,IT(NM0),IS(NM0),IBIGSYM(NM0),
     1ICC(NM0,ME0),IN(NM0,ME0)

      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      integer*4 NCAN,ICAN,NZF,IBR,IERM
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM

      real*8 ropt,HSLIM
      common/opt/ropt(100)
      equivalence (HSLIM,ropt(7))

      logical L4
      INTEGER*4 STATE1(NT3),STATE2(NT3),N7,N
      real*8 A
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4

      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent

      real*8 CIJK,D
      COMMON/DIA2A/CIJK(NT3,NT3,NT3)
      COMMON/VQA/D(NT3,NT3,NT3)
      real*8,allocatable::a33(:),tem(:),u(:),ak(:),bkl(:),
     1clj(:),usj(:),uo(:),uu(:),ww(:),p5(:),p6(:),
     1c5(:,:,:),c6(:,:,:)
      integer*4,allocatable::j33(:)

      integer*4,allocatable::nse_c(:),nse_S1(:),ndeo_S1(:),ndeo_S2(:),
     1ndee_c(:),ndeo_c(:),ndee_S1(:),ndee_S2(:)

      call w36(' ')
      call w36('Dohim4')
      call w36('^^^^^^')

      allocate(a33(NM0),j33(NM0))

      NDIM=IEND-ISTART+1
      allocate(tem(NDIM))
      ild=0
      ilqct=mod(ilqc,100)/10
      write(6,6001)ISTART,IEND,ISB,Kb,N7,LSPARSE,nproc,lqc,ilqc
      write(3,6001)ISTART,IEND,ISB,Kb,N7,LSPARSE,nproc,lqc,ilqc
6001  format(
     1  ' ISTART:',I8,' IEND:',I8,' ISB:',I5,'   Kb:',I5,' N7:',I5,
     2/,' SPARSE:',L8,' NPRO:',I8,' LQC:',l5,' ILQC:',I5)
      write(s1,4000)Kb
4000  format(i1)

c     set up parallel parameters:
      if(nproc.gt.omp_get_num_procs())then
       write(6,*)nproc,omp_get_num_procs()
       call report('not enough proce')
      endif
      if(nproc.gt.omp_get_max_threads())
     1write(6,*)'Number of threads will increase'
      call omp_set_num_threads(nproc)
      call omp_set_dynamic(0)
      call omp_set_nested(0)

      inquire(FILE=s1//'A2.SCR',exist=LASCR)
      inquire(FILE=s1//'A.SCR',exist=la1scr)
      if(LASCR.or.la1scr)then
       if(lASCR)then
        write(6,*)s1//'A2.SCR found on disk'
        OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
       else
        write(6,*)s1//'A.SCR found on disk'
        OPEN(2,FILE=s1//'A.SCR',FORM='UNFORMATTED')
       endif
       read(2,end=2999,err=2999)i
       ild=ild+1
       do 200 i=1,NDIM
       read(2,end=2999,err=2999)
200    ild=ild+1
2999   close(2)
       write(6,*)ild,' lines'
       write(3,*)ild,' lines'
       if(ISB.eq.1.and.ild.eq.NDIM+1)then
        write(6,*)'calculation skipped'
        return
       endif
      endif

      if((lqc.and.ilqct.ne.0).or.lnm2)then
c      nse_c   same centers, ME0
c      nse_S1  their excitations, ME0
c      ndee_c  different centers, even,ME0
c      ndee_S1 excitations on even different centers, up to ME0
c      ndee_S2 excitations on even different centers, up to ME0
c      ndeo_c  different centers, odd,2ME0
c      ndeo_S1 excitations on odd different centers, up to 2ME0
c      ndeo_S2 excitations on odd different centers, up to 2ME0
       allocate(nse_c(ME0),nse_S1(ME0),ndee_c(ME0),ndee_S1(ME0),
     1 ndee_S2(ME0),ndeo_c(2*ME0),ndeo_S1(2*ME0),ndeo_S2(2*ME0))
       nse_c(1)=0
       nse_S1(1)=0
       ndeo_S1(1)=0
       ndeo_S2(1)=0
       ndee_c(1)=0
       ndeo_c(1)=0
       ndee_S1(1)=0
       ndee_S2(1)=0
      endif

      if(lqc.and.ilqct.ne.0)then
       allocate(u(N*N),ak(N),bkl(N*N),clj(N*N),usj(N),
     1 uo(N*N),uu(N*N),ww(N*N),p5(N),p6(N))
       call rrtt(N,u,ak,bkl,clj,usj,uo,uu,ww,p5,p6)
      endif

      if(lnm2)then
       allocate(c5(N,N,N),c6(N,N,N))
       call load56(c5,c6,N7,N)
      endif


      it0=mclock()
      nel=0.0d0
      aveo=0.0d0
      aved=0.0d0
      CM=219470.0d0
      WRITE(3,3000)
      WRITE(6,3000)
3000  FORMAT(' Diagonal Hamiltonian:',/,
     1       ' line          hii  harmonic    jmax    hijmax ',/,
     280(1H-))

      OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
      if(ild.gt.0)then
       do 2001 i=1,ild
2001   read(2)
       IISTART=ISTART+ild-1
       IHH=ild-1
       write(6,2006)ISTART,ild,IISTART,NDIM
2006   format(' ISTART:',I6,' ild:', I6,' IISTART:',I6,' NDIM:',I20)
      else
       WRITE(2)NDIM
       IISTART=ISTART
       IHH=0
      endif
c
      DO 29 I=IISTART,IEND
      IHH=IHH+1
      i33=0

C     Define state i:
      EI=0.0d0
      DO 1 II=N7,N
1     STATE1(II)=0
      S1_Ncent=IS(I)
      S1_Nexc=IT(I)
      DO 4 K=1,IS(I)
      EI=EI+DBLE(IN(I,K))*E(ICC(I,K))
      S1_Lcent(K)=ICC(I,K)
      S1_Lexc(K)=IN(I,K)
4     STATE1(ICC(I,K))=IN(I,K)
c
C$OMP PARALLEL DO PRIVATE(K,JHH,J,EJ,S2_Ncent,
C$OMP+S2_Lcent,S2_Lexc)  DEFAULT(SHARED)
      DO 2 J=ISTART,IEND
      JHH=J-ISTART+1
      EJ=0.0d0
      S2_Ncent=IS(J)
      DO 6 K=1,IS(J)
      EJ=EJ+DBLE(IN(J,K))*E(ICC(J,K))
      S2_Lcent(K)=ICC(J,K)
6     S2_Lexc(K)=IN(J,K)
      TEM(JHH)=FSUMSF(N7,N,CIJK,S1_Ncent,S1_Lexc,S1_Lcent,
     1S2_Ncent,S2_Lexc,S2_Lcent)+FSUMSQF(N,N7,D,S1_Ncent,
     2S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent)
      if(ilqct.ne.0.and.lqc)then
       TEM(JHH)=TEM(JHH)+sumt(N,N7,u,ak,bkl,clj,usj,uo,uu,ww,
     1 S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     2 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      endif
      if(lnm2)then
       TEM(JHH)=TEM(JHH)+
     1 SUM5(N,N7,c5,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)+
     1 SUM6(N,N7,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      endif
2     CONTINUE
c
c     diagonal components:
      HII=(EI+TEM(IHH))*CM
      nel=nel+1.0d0
      i33=i33+1
      a33(i33)=HII
      j33(i33)=IHH
      aved=aved+dabs(a33(i33))

c     number of off-diagonals:
      noff=0
c     maximal off-diagonal component and its index:
      hmaxj=0.0d0
      DO 22 J=ISTART,IEND
      if(J.ne.I)then
       JHH=J-ISTART+1
       HOFF=TEM(JHH)
       if(dabs(HOFF*CM).ge.dabs(hmaxj))then
        maxj=J
        hmaxj=HOFF*CM
       endif
       EJ=0.0d0
       DO 7 K=1,IS(J)
7      EJ=EJ+DBLE(IN(J,K))*E(ICC(J,K))
       if(dabs(HOFF*CM).gt.HSLIM)then
        noff=noff+1
        i33=i33+1
        j33(i33)=JHH
        a33(i33)=HOFF*CM
        aveo=aveo+dabs(a33(i33))
        nel=nel+1.0d0
       endif
      endif
22    continue
c
      write(3,3030)I,HII,EI*CM,maxj,hmaxj,(mclock()-it0)/100
      write(6,3030)I,HII,EI*CM,maxj,hmaxj,(mclock()-it0)/100
3030  format(I8,2F10.2,i8,F10.2,I10,' sec')
c
      WRITE(2)i33,(j33(JHH),JHH=1,i33),(a33(JHH),JHH=1,i33)
29    CONTINUE
c     I
c
      CLOSE(2)
      WRITE(3,6000)s1,HSLIM,nel,nel/dble(NDIM)/dble(NDIM+1)*50.0d0,
     1dble(NDIM)*dble(NDIM+1)/2.0d0,nel*(4.0d0+8.0d0)/1000.0d0,
     1aved/dble(NDIM),aveo/nel
      WRITE(6,6000)s1,HSLIM,nel,nel/dble(NDIM)/dble(NDIM+1)*50.0d0,
     1dble(NDIM)*dble(NDIM+1)/2.0d0,nel*(4.0d0+8.0d0)/1000.0d0,
     1aved/dble(NDIM),aveo/nel
6000  format(' Hamiltonian written into ',a1,'A2.SCR',/,
     1' Cut of Hij limit / cm-1:              ',f10.5,/,
     2' Number of elements bigger then cutoff:',f20.0,' (',f5.1,'%)',/,
     3' Total number of elements :            ',f20.0,/,
     3' Memory required :                     ',f10.0,' kbytes',/,
     3' Average diagonal element:             ',f10.2,/,
     3' Average off diagonal element:         ',f10.2)
      write(6,6009)(mclock()-it0)/100
      write(3,6009)(mclock()-it0)/100
6009  format(' H done in                      ',i10,' sec')
      call w36('Dohim-ok')
      RETURN
      END
c
