      SUBROUTINE ENAF(ASL,EOLD)
c     perturbation calculation with possible degenerate levels
c     fast version
      implicit none
      include 'dimensions.h'
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0),
     1iex,Nexc,Excmax,nme
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent
      real*8 CM,A,ASL,EE,E,
     1srt,an0,ani,erat,EOLD(*),Eground

c     real*8,allocatable::AW(:),EM3(:),EM5(:),EC0(:),EC2(:),EC4(:),
c    1EQD(:),EEF(:),EEO(:),EM1(:),EK1(:),EK3(:),EK5(:),
c    1intH(:,:),intAH(:,:),QM(:,:),QP(:,:),
      real*8 AW(NT3),
     2intH(NT3,4),intAH(NT3,4),
     1QM(3,NT3),QP(3,NT3)

      real*8,allocatable::aptaq(:,:),aataq(:,:),m2(:,:),int2(:,:),
     1alphaaq(:,:),gaq(:,:),aaq(:,:),moments(:,:),alphaq(:,:,:),
     1gq(:,:,:),aq(:,:,:,:),d1(:,:),d2(:,:),p5(:),p6(:),
     1ak(:),bkl(:),clj(:),u(:),usj(:),uo(:),uu(:),ww(:),
     1c5(:,:,:),c6(:,:,:),ECC(:),Emono(:)

      integer*4 I,IBR,ICAN,IERM,IOPT,
     1IT0,IX,IY,IZ,J,LEXCL,MCLOCK,NCAN,NQ1,NZF,
     1ind,II,ilqc,ilqct,NN,IC,mt,l,ll
      COMMON/CEM/E(NT3)
      INTEGER*4 STATE1(NT3),STATE2(NT3),N7,N
      LOGICAL L4
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,LSPARSE,
     1LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      COMMON/RUNCON/LEXCL
      common/iop/iopt(300)
      equivalence (NQ1,iopt(1)),(ilqc,iopt(21))
      logical lopt,LFFF,lex,lqc,lnm2,lcomb
      common/lop/lopt(300)
      equivalence (LFFF,lopt(43)),(lqc,lopt(51)),(lnm2,lopt(52)),
     1(lcomb,lopt(53))
      integer*4,allocatable::nse_c(:),nse_S1(:),ndeo_S1(:),ndeo_S2(:),
     1ndee_c(:),ndeo_c(:),ndee_S1(:),ndee_S2(:),si(:)

      call w36(' ')
      call w36('Enaf')
      call w36('^^^^')
c
c     later replace by actual dimensions:
c     allocate(AW(NT3),EM3(NT3),EM5(NT3),EC0(NT3),EC2(NT3),
c    1EC4(NT3),EQD(NT3),EEF(NT3),EEO(NT3),EM1(NT3),
c    2EK1(NT3),EK3(NT3),EK5(NT3),intH(NT3,4),intAH(NT3,4),
c    1QM(3,NT3),QP(3,NT3),
      allocate(aptaq(2*NT3**2,3),aataq(NT3**2,3),
     1alphaaq(NT3**2,9),gaq(NT3**2,9),aaq(NT3**2,27),moments(NT3,51),
     1alphaq(3,3,NT3),gq(3,3,NT3),aq(3,3,3,NT3),d1(NT3,51),
     1d2(NT3**2,51))

      CM=219470.0d0
      write(3,3636)LFFF,QUARTIC,LSPARSE,lqc,ilqc,NQ1,N7,N,lnm2,lcomb
      write(6,3636)LFFF,QUARTIC,LSPARSE,lqc,ilqc,NQ1,N7,N,lnm2,lcomb
3636  format(/,' PERTURBATIONAL CALCULATION ENAF',/,/,
     1' LFF =',l7,' QUARTIC = ',l4,' LSPARSE = ',l2,/,
     1' LQC =',l7,' ILQC    = ',i4,' NQ1     = ',i2,' N7      = ',i2,/,
     1' N   =',i7,' LNM2    = ',l4,' LCOMB   = ',l2)
      ilqct=mod(ilqc,100)/10

      if(N.gt.NT3)call report('N > NT3')

      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
      if(lnm2)then
       allocate(c5(N,N,N),c6(N,N,N))
       call load56(c5,c6,N7,N)
      endif

      if(lnm2.or.(lqc.and.ilqct.ne.0))then
c      nse_c   same centers, ME0
c      nse_S1  their excitations, ME0
c      ndee_c  different centers, even,ME0
c      ndee_S1 excitations on even different centers, up to ME0
c      ndee_S2 excitations on even different centers, up to ME0
c      ndeo_c  different centers, odd,2ME0
c      ndeo_S1 excitations on odd different centers, up to 2ME0
c      ndeo_S2 excitations on odd different centers, up to 2ME0
       allocate(nse_c(ME0),nse_S1(ME0),ndee_c(ME0),ndee_S1(ME0),
     1 ndee_S2(ME0),ndeo_c(2*ME0),ndeo_S1(2*ME0),ndeo_S2(2*ME0))

       nse_c(1)=0
       nse_S1(1)=0
       ndeo_S1(1)=0
       ndeo_S2(1)=0
       ndee_c(1)=0
       ndeo_c(1)=0
       ndee_S1(1)=0
       ndee_S2(1)=0
      endif

      if(lqc.and.ilqct.ne.0)then
       allocate(u(N*N),ak(N),bkl(N*N),clj(N*N),usj(N),
     1 uo(N*N),uu(N*N),ww(N*N),p5(N),p6(N))
       call rrtt(N,u,ak,bkl,clj,usj,uo,uu,ww,p5,p6)
      endif

c     read dipole derivatives:
      do 101 i=1,N
      do 101 ix=1,3
      QM(ix,i)=0.0d0
101   QP(ix,i)=0.0d0
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)call rdten1q(QP,QM,N,NT3)

c     read second dipole derivatives is available:
      call rdtenq(aptaq,aataq,N,NT3)

c     read polarizability derivatives
      do 103 i=1,N
      do 103 ix=1,3
      do 103 iy=1,3
      alphaq(ix,iy,i)=0.0d0
      gq(ix,iy,i)=0.0d0
      do 103 iz=1,3
103   aq(ix,iy,iz,i)=0.0d0
      inquire(file='TTTQ.TXT.SCR',exist=lex)
      if(lex)call readtttq(NT3,alphaq,gq,aq,N,N7)

c     read second polarizability derivatives
      call rdttqaq(N,NT3,alphaaq,gaq,aaq)

      DO 33 I=N7,N
      STATE1(I)=0
      STATE2(I)=0
      DO 33 ix=1,4
      intAH(I,ix)=0.0d0
33    intH(I,ix)=0.0d0
      S1_Nexc=0
      S1_Ncent=0
      S2_Nexc=0
      S2_Ncent=0
      S1_Lexc(1)=0
      S1_Lcent(1)=0
      S2_Lexc(1)=0
      S2_Lcent(1)=0

      Eground=0.0d0
      allocate(Emono(N))
      call vz(Emono,0.0d0,N)
      if(lcomb)then
c      combination transitions
       mt=(N-N7+1)*(N-N7+1+1)/2
       allocate(ECC(mt))
       call vz(ECC,0.0d0,mt)
      endif

      NN=N
C
C     GROUND STATE2: add to all interactions
      call addscomb(E,LSPARSE,lnm2,c5,c6,NN,ECC,
     1S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,ndee_S1,ndeo_S1,
     2S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent,ndee_S2,ndeo_S2,
     3nse_S1,nse_c,ndee_c,ndeo_c,Emono,
     1Eground,ilqct,lqc,0.0d0,lcomb,QUARTIC,LH40,NZF,
     1ak,bkl,clj,u,uo,usj,uu,ww)

C     EXCITED STATES:
      it0=mclock()
      Excmax=min(5,LEXCL)
      if(lnm2)Excmax=min(7,LEXCL)
      allocate(si(Excmax))
      do 3 Nexc=1,Excmax
      WRITE(6,*)Nexc,mclock()-it0
c     distribute Nexc excitations upon centers N7..N:
c     initial indices - all to the first center:
      do 41 iex=1,Nexc
41    si(iex)=N7
      if(HW)write(6,6000)(si(i),i=1,Nexc)
5     DO  1966 I=N7,N
1966  STATE2(I)=0
6000  format(20i3)
      do 4 iex=1,Nexc
4     STATE2(si(iex))=STATE2(si(iex))+1

c     check that the state is allowed:
      nme=0
      do 11 I=N7,N
11    if(STATE2(I).gt.0)nme=nme+1
      if(nme.le.NQ1)then
C      Energy:
       EE=0.0d0
       DO 1002 II=N7,N
1002   EE=EE+dble(STATE2(II))*E(II)
c      record to newer coding:
       call rcstate(S2_Ncent,S2_Nexc,S2_Lcent,S2_Lexc,STATE2,N7,N)

c      investigate the interaction to ground,first and double excited
       call addscomb(E,LSPARSE,lnm2,c5,c6,NN,ECC,S1_Nexc,S1_Ncent,
     1 S1_Lexc,S1_Lcent,ndee_S1,ndeo_S1,S2_Nexc,S2_Ncent,S2_Lexc,
     1 S2_Lcent,ndee_S2,ndeo_S2,nse_S1,nse_c,ndee_c,ndeo_c,Emono,
     1 Eground,ilqct,lqc,EE,lcomb,QUARTIC,LH40,NZF,
     1 ak,bkl,clj,u,uo,usj,uu,ww)
c
      endif
c     find index to be changed
      do 8 ic=Nexc,1,-1
8     if(si(ic).lt.N)goto 9
      goto 3
9     do 10 i=ic+1,Nexc
10    si(i)=si(ic)+1
      si(ic)=si(ic)+1
      goto 5
3     continue
C
      WRITE(3,501)
      WRITE(6,501)
501   format(' State       EHarm Correction     WAnharm',/,
     1       ' -----------------------------------------')
      WRITE(3,502)0,0.0d0,Eground*CM,0.0d0
      WRITE(6,502)0,0.0d0,Eground*CM,0.0d0
502   FORMAT (i6,3F12.2)
      DO 399 I=N7,N
      AW(I)=(Emono(I)+E(I))*CM
      write(3,502)I,E(I)*CM,Emono(I)*CM,(Emono(I)+E(I)-Eground)*CM
399   write(6,502)I,E(I)*CM,Emono(I)*CM,(Emono(I)+E(I)-Eground)*CM

      if(lcomb)then
       write(6,6009)
       write(3,6009)
6009   format(/,' Overtone and combination bands:',/,
     1 '   #   N   M  E_harmonic  Correction W_corrected',/,
     2 ' -----------------------------------------------')
       WRITE(3,6010)0,0,0,0.0d0,Eground*CM,0.0d0
       WRITE(6,6010)0,0,0,0.0d0,Eground*CM,0.0d0
       ic=0
       do 14 i=N7,N
       do 14 j=i,N
       ic=ic+1
       write(3,6010)ic,i,j,(E(i)+E(j))*CM,ECC(ic)*CM,
     1 (E(i)+E(j)+ECC(ic)-Eground)*CM
14     write(6,6010)ic,i,j,(E(i)+E(j))*CM,ECC(ic)*CM,
     1 (E(i)+E(j)+ECC(ic)-Eground)*CM
6010   format(3i4,3F12.2)
      endif

c     IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

      srt=dsqrt(2.0d0)

      do 115 I=N7,N
c     first derivatives according to I:
c
c     harmonic transition moments  1...3 magnetic
c                                  4...6 electric
c                                  7..15 polarizability
c                                 16..24 G'
c                                 25..51 A
      do 117 ix=1,3
      d1(I,   ix)                  =QM(ix,I)
      d1(I, 3+ix)                  =QP(ix,I)
      do 117 iy=1,3
      d1(I, 6+ix+(iy-1)*3)         =alphaq(ix,iy,I)
      d1(I,15+ix+(iy-1)*3)         =gq(ix,iy,I)
      do 117 iz=1,3
117   d1(I,24+ix+(iy-1)*3+(iz-1)*9)=aq(ix,iy,iz,I)
c     second derivatives according to I, for each J:
      do 115 J=N7,N
      II=J+(I-1)*N
      do 115 ix=1,3
      d2(II,   ix)                  =aataq(II,ix)
      d2(II, 3+ix)                  =aptaq(II,ix)
      do 115 iy=1,3
      ind=ix+3*(iy-1)
      d2(II, 6+ind)                 =alphaaq(II,ind)
      d2(II,15+ind)                 =gaq(II,ind)
      do 115 iz=1,3
      ind=ix+3*(iy-1)+9*(iz-1)
115   d2(II,24+ind)                 =aaq(II,ind)

      write(3,6363)
      write(6,6363)
6363  format('    Intensity correction',/,
     1'    HARMONIC:__________________________________',
     2'__________ ANHARMONIC:_________________________________',/,
     3' mode        w          D          R      Raman',
     4'        ROA          D          R      Raman        ROA',/,
     5102(1h-))
c     107107107107107107107107107107107107107107107107107107107107
      do 107 I=N7,N
c
c     chech norms of state 0 and i within PT2:
      an0=1.0d0
      ani=1.0d0
c
c     perturbed moment:
c     <I'|P|0'> ~ <I|P|0> + sum(j<>0,j<>i)(Vj0/e0jPij+Vij/eijPj0)+Vi0/e0i/2*Pii
c
c     calculate harmonic intensities <I|P|0> = Pi <1|Qi|0>:
      do 1071 iz=1,51
1071  moments(I,iz)=d1(I,iz)/srt
      call intens(intH,moments,NT3,I)

c     fast lane:
      do 1072 iz=1,51
      moments(I,iz)=d1(I,iz)/srt

      call zs(STATE2,N7,N)
      S2_Nexc=0
      S2_Ncent=0
      call zs(STATE1,N7,N)
      STATE1(I)=2
      S1_Nexc=2
      S1_Ncent=1
      S1_Lexc(1)=2
      S1_Lcent(1)=I
c     <2i|V|0> (1)
c              du
c     u = u0 + -- <0|V/E|i+2> <i1|Qi|i2>
c              dQ
      moments(I,iz)=moments(I,iz)+d1(I,iz)*
     1erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I)+E(I),
     1lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)

      call zs(STATE1,N7,N)
      STATE1(I)=3
      S1_Nexc=3
      S1_Ncent=1
      S1_Lexc(1)=3
      S1_Lcent(1)=I
c     <3i|V|0> (2)
c              1 d^2u
c     u = u0 + - ---- <n|V/E|i+3> <i3|Qi^2|i1>
c              2 dQ^2
c    <1|q^2|3>=sqrt(3*2)/2
      moments(I,iz)=moments(I,iz)+d2(I+(I-1)*N,iz)*dsqrt(6.0d0)/4.0d0*
     1erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I)+E(I)+E(I),
     1lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)

      call zs(STATE1,N7,N)
      STATE1(I)=1
      S1_Nexc=1
      S1_Ncent=1
      S1_Lexc(1)=1
      S1_Lcent(1)=I
c     <1i|V|0> (3)
c              1 d^2u
c     u = u0 + - ---- <n|V/E|i> <i1|Qi^2|i1>
c              2 dQi^2
c    <1|q^2|1>=3/2
      moments(I,iz)=moments(I,iz)+d2(I+(I-1)*N,iz)*0.75d0*
     1erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I),
     1lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)

      do 1073 J=N7,N
      if(J.ne.I)then
       call zs(STATE2,N7,N)
       S2_Nexc=0
       S2_Ncent=0
       call zs(STATE1,N7,N)
       STATE1(I)=1
       STATE1(J)=1
       S1_Nexc=2
       S1_Ncent=2
       S1_Lexc(1)=1
       S1_Lexc(2)=1
       S1_Lcent(1)=I
       S1_Lcent(2)=J
c     <1J1I| V|0> (4)
c              du
c     u = u0 + -- <n|V/E|ij> <i1j1|Qj|i1>
c              dQ
c      <j|Qj|0>=1/sqRT(2)   ... in d1 already
       moments(I,iz)=moments(I,iz)+d1(J,iz)/srt*
     1 erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I)+E(J),
     1 lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)

       call zs(STATE2,N7,N)
       STATE2(I)=1
       S2_Nexc=1
       S2_Ncent=1
       S2_Lexc(1)=1
       S2_Lcent(1)=I
       call zs(STATE1,N7,N)
       STATE1(J)=1
       S1_Nexc=1
       S1_Ncent=1
       S1_Lexc(1)=1
       S1_Lcent(1)=J
c      <i|V|1J> (5)
c              du
c     u = u0 + -- <j|V/E|i> <0|Qj|j1>
c              dQj
       moments(I,iz)=moments(I,iz)+d1(J,iz)/srt*
     1 erat(LSPARSE,S1_Nexc,S2_Nexc,E(I),E(J),
     1 lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      endif
1073  continue

      do 1074 II=N7,N
      do 1074 J=N7,N
      if(II.ne.J)then
       call zs(STATE2,N7,N)
       STATE2(I)=1
       S2_Nexc=1
       S2_Ncent=1
       S2_Lexc(1)=1
       S2_Lcent(1)=I
       call zs(STATE1,N7,N)
       STATE1(II)=1
       STATE1(J)=1
       S1_Nexc=2
       S1_Ncent=2
       S1_Lexc(1)=1
       S1_Lexc(2)=1
       S1_Lcent(1)=II
       S1_Lcent(2)=J
c      <i|V|1II1J> (6)
c     <3i|V|0>
c              1   d^2u
c     u = u0 + - -------- <i+1|V/E|ii+1 j+1> <ii+1 j+1|QiiQj|0>
c              2 dQIIdQJ
c
c    <0|qiqj|ij>=1/2
       moments(I,iz)=moments(I,iz)+d2(II+(J-1)*N,iz)/4.0d0*
     1 erat(LSPARSE,S1_Nexc,S2_Nexc,E(I),E(II)+E(J),
     1 lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      endif
1074  continue

      do 1075 II=N7,N
      call zs(STATE2,N7,N)
      STATE2(I)=1
      S2_Nexc=1
      S2_Ncent=1
      S2_Lexc(1)=1
      S2_Lcent(1)=I
      call zs(STATE1,N7,N)
      S1_Nexc=0
      S1_Ncent=0
c     <i|V|0> (7)
c              1   d^2u
c     u = u0 + - -------- <i|V/E|0> <i|QII^2|i>
c              2 dQIIdQII
c    <0|QII^2|0>=1/2
      moments(I,iz)=moments(I,iz)+d2(II+(II-1)*N,iz)/4.0d0*
     1erat(LSPARSE,S1_Nexc,S2_Nexc,E(I),0.0d0,
     1lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      call zs(STATE2,N7,N)
      STATE2(I)=1
      S2_Nexc=1
      S2_Ncent=1
      S2_Lexc(1)=1
      S2_Lcent(1)=I
      call zs(STATE1,N7,N)
      S1_Nexc=2
      S1_Ncent=1
      S1_Lexc(1)=2
      S1_Lcent(1)=II
c     <i|V|2II> (8)
c              1   d^2u
c     u = u0 + - -------- <i|V/E|2II> <2II|QII^2|0>
c              2 dQIIdQII
c    <2|Q^2|0>=1/sqrt(2)
      moments(I,iz)=moments(I,iz)+d2(II+(II-1)*N,iz)/4.0d0*srt*
     1erat(LSPARSE,S1_Nexc,S2_Nexc,E(I),2*E(II),
     1lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
1075  continue

      do 1076 II=N7,N
      if(II.ne.I)then
       call zs(STATE2,N7,N)
       STATE2(I)=1
       STATE2(II)=2
       S2_Nexc=3
       S2_Ncent=2
       S2_Lexc(1)=1
       S2_Lcent(1)=I
       S2_Lexc(2)=2
       S2_Lcent(2)=II
       call zs(STATE1,N7,N)
       S1_Nexc=0
       S1_Ncent=0
c      <1i2II|V|0> (9)
c              1   d^2u
c     u = u0 + - -------- <0|V/E|i+2II> <i 2II|QII^2|i>
c              2 dQIIdQII
       moments(I,iz)=moments(I,iz)+d2(II+(II-1)*N,iz)/4.0d0*srt*
     1 erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I)+2*E(II),
     1 lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
       call zs(STATE2,N7,N)
       STATE2(I)=1
       S2_Nexc=1
       S2_Ncent=1
       S2_Lexc(1)=1
       S2_Lcent(1)=I
       call zs(STATE1,N7,N)
       S1_Nexc=0
       S1_Ncent=0
c      <1i|V|0> (10)
c              1   d^2u
c     u = u0 + - -------- <0|V/E|i> <0|QII^2|0>
c              2 dQIIdQII
       moments(I,iz)=moments(I,iz)+d2(II+(II-1)*N,iz)/4.0d0*
     1 erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I),
     1 lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      endif
1076  continue

      do 1077 II=N7,N
      do 1077 J=N7,N
      if(II.ne.I.and.J.ne.I.and.II.ne.J)then
       call zs(STATE2,N7,N)
       STATE2(I)=1
       STATE2(II)=1
       STATE2(J)=1
       S2_Nexc=3
       S2_Ncent=3
       S2_Lexc(1)=1
       S2_Lcent(1)=I
       S2_Lexc(2)=1
       S2_Lcent(2)=II
       S2_Lexc(3)=1
       S2_Lcent(3)=J
       call zs(STATE1,N7,N)
       S1_Nexc=0
       S1_Ncent=0
c      <1i1II1J|V|0>(11)
c              1   d^2u
c     u = u0 + - -------- <0|V/E|i ii j> <i ii j|Qii Qj|0>
c              2 dQIIdQII
       moments(I,iz)=moments(I,iz)+d2(J+(II-1)*N,iz)/4.0d0*srt*
     1 erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I)+E(II)+E(J),
     1 lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      endif
1077  continue

      do 1078 II=N7,N
      if(II.ne.I)then
       call zs(STATE2,N7,N)
       STATE2(II)=1
       S2_Nexc=1
       S2_Ncent=1
       S2_Lexc(1)=1
       S2_Lcent(1)=II
       call zs(STATE1,N7,N)
       S1_Nexc=0
       S1_Ncent=0
c      <1II|V|0> (12)
c              1   d^2u
c     u = u0 + - -------- <0|V/E|ii> <ii|Qii Qi|i> x 2
c              2 dQI dQII
       moments(I,iz)=moments(I,iz)+d2(I+(II-1)*N,iz)/2.0d0*
     1 erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(II),
     1 lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
       call zs(STATE2,N7,N)
       STATE2(II)=1
       STATE2(I)=2
       S2_Nexc=3
       S2_Ncent=2
       S2_Lexc(1)=1
       S2_Lcent(1)=II
       S2_Lexc(2)=2
       S2_Lcent(2)=I
c      <2i1II|V|0> (13)
c              1   d^2u
c     u = u0 + - -------- <0|V/E|ii 2i> <ii|Qii Qi|i> x 2
c              2 dQI dQII
       moments(I,iz)=moments(I,iz)+d2(I+(II-1)*N,iz)/srt*
     1 erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(II)+E(I)+E(I),
     1 lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      endif
1078  continue

1072  continue
      call intens(intAH,moments,NT3,I)
      do 7022 J=3,4
7022  intAH(I,J)=intAH(I,J)*2.0d0*E(I)
      do 7023 J=1,4
7023  intAH(I,J)=intAH(I,J)/dsqrt(an0*ani)
      write(3,60088)I,E(I)*CM,(intH( I,J),J=1,4),(intAH(I,J),J=1,4)
107   write(6,60088)I,E(I)*CM,(intH( I,J),J=1,4),(intAH(I,J),J=1,4)
60088 format(I4,F10.2,10(' ',G10.4))

c     107107107107107107107107107107107107107107107107107107107107
c
c     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      if(lcomb)then
       mt=(N-N7+1)*(N-N7+2)/2
       allocate(m2(mt,51),int2(mt,4))
       call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)
       ic=0
       do 6 i=N7,N
       do 6 j=i,N
       ic=ic+1
       do 7 ii=1,51
7      m2(ic,ii)=0.0d0
       if(i.eq.j)then
c       i = j   i = j   i = j   i = j   i = j   i = j   i = j   i = j  

        do 16 ii=1,51

c                  du   
c        sqrt(3/2) ---  <0 ...3i>                          (1)
c                  dQi 
        STATE1(I)=3
        S1_Nexc=3
        S1_Ncent=1
        S1_Lexc(1)=3
        S1_Lcent(1)=I
        m2(ic,ii)=m2(ic,ii)+dsqrt(1.5d0)*d1(i,ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I)+E(I)+E(I),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c         d^2u   
c        ------  <0 ...2i>                                 (2)
c         dQi^2 
        STATE1(I)=2
        S1_Nexc=2
        S1_Ncent=1
        S1_Lexc(1)=2
        S1_Lcent(1)=I
        m2(ic,ii)=m2(ic,ii)+d2(i+N*(i-1),ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I)+E(I),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c         1         d^2u     sqrt(3)  d^2u                  
c       ----------- ----  +  ------- ------<0 ...4i>         (3)
c        2*(sqrt(2) dQi^2       2     dQi^2                  
        STATE1(I)=4
        S1_Nexc=4
        S1_Ncent=1
        S1_Lexc(1)=4
        S1_Lcent(1)=I
        m2(ic,ii)=m2(ic,ii)+d2(i+N*(i-1),ii)/srt/2.0d0
     1  +dsqrt(3.0d0)/2.0d0*d2(i+N*(i-1),ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,4.0d0*E(I),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c         du                                    
c        -----  <0 ...i>                                          (4) 
c         dQi                                  
        STATE1(I)=1
        S1_Nexc=1
        S1_Ncent=1
        S1_Lexc(1)=1
        S1_Lcent(1)=I
        m2(ic,ii)=m2(ic,ii)+d1(i,ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(I),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

        do 16 l=N7,N

c                   du
c       1/sqrt(2) * --- <2i..l>                                   (5)
c                   dQl
        STATE1(l)=1
        S1_Nexc=1
        S1_Ncent=1
        S1_Lexc(1)=1
        S1_Lcent(1)=l
        STATE2(I)=2
        S2_Nexc=2
        S2_Ncent=1
        S2_Lexc(1)=2
        S2_Lcent(1)=I
        m2(ic,ii)=m2(ic,ii)+1.0d0/srt*d1(l,ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,2.0d0*E(i),E(l),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)


        if(l.ne.i)then

c                   d^2u
c       sqrt(2)/4 * -----  <ii..ll>                         (6)
c                   dQl^2
         STATE1(l)=2
         S1_Nexc=2
         S1_Ncent=1
         S1_Lexc(1)=2
         S2_Lcent(1)=l
         STATE2(I)=2
         S2_Nexc=2
         S2_Ncent=1
         S2_Lexc(1)=2
         S2_Lcent(1)=I
         m2(ic,ii)=m2(ic,ii)+srt/4.0d0*d2(l+N*(l-1),ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,2.0d0*E(i),2.0d0*E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c                   du
c       1/sqrt(2) * ---  <0..iil>                                    (7)
c                   dQl
         STATE1(i)=2
         STATE1(l)=1
         S1_Nexc=3
         S1_Ncent=2
         S1_Lexc(1)=1
         S1_Lexc(2)=2
         S1_Lcent(1)=l
         S1_Lcent(2)=i
         m2(ic,ii)=m2(ic,ii)+1.0d0/srt*d1(l,ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,2.0d0*E(i)+E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c                   d^2u
c       sqrt(2)/4 * ---  <0..iill>                                  (8)
c                   dQl^2
         STATE1(i)=2
         STATE1(l)=2
         S1_Nexc=4
         S1_Ncent=2
         S1_Lexc(1)=2
         S1_Lexc(2)=2
         S1_Lcent(1)=l
         S1_Lcent(2)=i
         m2(ic,ii)=m2(ic,ii)+srt/4.0d0*d2(l+N*(l-1),ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,2.0d0*(E(i)+E(l)),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c                   d^2u
c       sqrt(3/4) * ---  <0..iiil>                             (9)
c                   dQldQi
         STATE1(i)=3
         STATE1(l)=1
         S1_Nexc=4
         S1_Ncent=2
         S1_Lexc(1)=1
         S1_Lexc(2)=3
         S1_Lcent(1)=l
         S1_Lcent(2)=i
         m2(ic,ii)=m2(ic,ii)+dsqrt(0.75d0)*d2(i+N*(l-1),ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,3.0d0*E(i)+E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c                   d^2u
c       1/sqrt(2) * ---  <0..il>                              (10)
c                   dQldQi
         STATE1(i)=1
         STATE1(l)=1
         S1_Nexc=2
         S1_Ncent=2
         S1_Lexc(1)=1
         S1_Lexc(2)=1
         S1_Lcent(1)=l
         S1_Lcent(2)=i
         m2(ic,ii)=m2(ic,ii)+1.0d0/srt*d2(i+N*(l-1),ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(i)+E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c             d^2u
c       1/2 * ---  <ii..il>                              (11)
c             dQldQi
         STATE1(i)=1
         STATE1(l)=1
         S1_Nexc=2
         S1_Ncent=2
         S1_Lexc(1)=1
         S1_Lexc(2)=1
         S1_Lcent(1)=l
         S1_Lcent(2)=i
         STATE2(i)=2
         S2_Nexc=2
         S2_Ncent=1
         S2_Lexc(1)=2
         S2_Lcent(1)=i
         m2(ic,ii)=m2(ic,ii)+0.5d0*d2(i+N*(l-1),ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,2.0d0*E(i),E(i)+E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

        endif
        do 15 ll=N7,N
        if(l.ne.i.and.ll.ne.l.and.ll.ne.i)then
c             d^2u
c       1/4 * ---     <ii ... l ll>                              (12a)
c             dQldQll
         STATE1(ll)=1
         STATE1(l)=1
         S1_Nexc=2
         S1_Ncent=2
         S1_Lexc(1)=1
         S1_Lexc(2)=1
         S1_Lcent(1)=l
         S1_Lcent(2)=ll
         STATE2(i)=2
         S2_Nexc=2
         S2_Ncent=1
         S2_Lexc(1)=2
         S2_Lcent(1)=i
         m2(ic,ii)=m2(ic,ii)+0.25d0*d2(ll+N*(l-1),ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,2.0d0*E(i),E(ll)+E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c             d^2u
c       1/4 * ---     <0 ... l ll i i>                             (12b)
c             dQldQll
         STATE1(ll)=1
         STATE1(l)=1
         STATE1(i)=2
         S1_Nexc=4
         S1_Ncent=3
         S1_Lexc(1)=1
         S1_Lexc(2)=1
         S1_Lexc(3)=2
         S1_Lcent(1)=l
         S1_Lcent(2)=ll
         S1_Lcent(3)=i
         m2(ic,ii)=m2(ic,ii)+0.25d0*d2(ll+N*(l-1),ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,2.0d0*E(i)+E(ll)+E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

        endif
15      continue
16      continue
       else
c       i<>j  i<>j  i<>j  i<>j  i<>j  i<>j  i<>j  i<>j  i<>j  i<>j  i<>j
        
        do 19 ii=1,51

c       1 d^2u
c       - ---                                                      (1)
c       2 dQidQj
        m2(ic,ii)=0.5d0*d2(i+N*(j-1),ii)

c       3  d^2u      d^2u 
c       - (---    + ----- )   <0 ... ij>                           (2'a)
c       4  dQi^2     dQj^2 
        STATE1(i)=1
        STATE1(j)=1
        S1_Nexc=2
        S1_Ncent=2
        S1_Lexc(1)=1
        S1_Lexc(2)=1
        S1_Lcent(1)=i
        S1_Lcent(2)=j
        m2(ic,ii)=m2(ic,ii)+0.75d0*(d2(i+N*(i-1),ii)+d2(j+N*(j-1),ii))*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(i)+E(j),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c       srt  d^2u    
c       ---  ---       <ij ... ii>                               (2'b)
c        4   dQi^2   
        STATE1(i)=2
        S1_Nexc=2
        S1_Ncent=1
        S1_Lexc(1)=2
        S1_Lcent(1)=i
        STATE2(i)=1
        STATE2(j)=1
        S2_Nexc=2
        S2_Ncent=2
        S2_Lexc(1)=1
        S2_Lexc(2)=1
        S2_Lcent(1)=i
        S2_Lcent(2)=j
        m2(ic,ii)=m2(ic,ii)+srt*0.25d0*d2(i+N*(i-1),ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,E(i)+E(j),E(i)+E(i),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c       srt  d^2u    
c       ---  ---       <ij ... jj>                               (2'c)
c        4   dQj^2   
        STATE1(i)=2
        S1_Nexc=2
        S1_Ncent=1
        S1_Lexc(1)=2
        S1_Lcent(1)=j
        STATE2(i)=1
        STATE2(j)=1
        S2_Nexc=2
        S2_Ncent=2
        S2_Lexc(1)=1
        S2_Lexc(2)=1
        S2_Lcent(1)=i
        S2_Lcent(2)=j
        m2(ic,ii)=m2(ic,ii)+srt*0.25d0*d2(j+N*(j-1),ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,E(i)+E(j),E(j)+E(j),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c          1    du
c         -     ---   <0 ... j>                                 (3a)
c       sqrt(2) dQi
        STATE1(j)=1
        S1_Nexc=1
        S1_Ncent=1
        S1_Lexc(1)=1
        S1_Lcent(1)=j
        m2(ic,ii)=m2(ic,ii)+1.0d0/srt*d1(i,ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(j),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c          1    du
c         -     ---   <0 ... i>                                (3b)
c       sqrt(2) dQj
        STATE1(i)=1
        S1_Nexc=1
        S1_Ncent=1
        S1_Lexc(1)=1
        S1_Lcent(1)=i
        m2(ic,ii)=m2(ic,ii)+1.0d0/srt*d1(j,ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(i),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c        du
c        ---   <0 ... jji>                                      (4a)
c        dQj
        STATE1(i)=1
        STATE1(j)=2
        S1_Nexc=3
        S1_Ncent=2
        S1_Lexc(1)=1
        S1_Lcent(1)=i
        S1_Lexc(2)=2
        S1_Lcent(2)=j
        m2(ic,ii)=m2(ic,ii)+d1(j,ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(j)+E(j)+E(i),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c        du
c        ---   <0 ... jii>                                       (4b)
c        dQi
        STATE1(j)=1
        STATE1(i)=2
        S1_Nexc=3
        S1_Ncent=2
        S1_Lexc(1)=1
        S1_Lcent(1)=j
        S1_Lexc(2)=2
        S1_Lcent(2)=i
        m2(ic,ii)=m2(ic,ii)+d1(i,ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(j)+E(i)+E(i),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)


c        sqrt(6) du^2
c        ------- ----  <0 ... jjji>                               (5a)
c           4    dQj^2
        STATE1(j)=3
        STATE1(i)=1
        S1_Nexc=4
        S1_Ncent=2
        S1_Lexc(1)=3
        S1_Lcent(1)=j
        S1_Lexc(2)=1
        S1_Lcent(2)=i
        m2(ic,ii)=m2(ic,ii)+dsqrt(6.0d0)/4.0d0*d2(j+N*(j-1),ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,3.0d0*E(j)+E(i),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c        sqrt(6) du^2
c        ------- ----  <0 ... iiij>                            (5b)
c           4    dQi^2
        STATE1(i)=3
        STATE1(j)=1
        S1_Nexc=4
        S1_Ncent=2
        S1_Lexc(1)=3
        S1_Lcent(1)=i
        S1_Lexc(2)=1
        S1_Lcent(2)=j
        m2(ic,ii)=m2(ic,ii)+dsqrt(6.0d0)/4.0d0*d2(i+N*(i-1),ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,3.0d0*E(i)+E(j),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c         du^2
c         ----   <0 ... iijj>                                   (6)
c         dQidQj
        STATE1(i)=2
        STATE1(j)=2
        S1_Nexc=4
        S1_Ncent=2
        S1_Lexc(1)=2
        S1_Lcent(1)=i
        S1_Lexc(2)=2
        S1_Lcent(2)=j
        m2(ic,ii)=m2(ic,ii)+d2(i+N*(j-1),ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(i)+E(i)+E(j)+E(j),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c       1     du^2
c       -    ----   <0 ... ii>                                  (78a)
c       srt  dQidQj
        STATE1(i)=2
        S1_Nexc=2
        S1_Ncent=1
        S1_Lexc(1)=2
        S1_Lcent(1)=i
        m2(ic,ii)=m2(ic,ii)+1.0d0/srt*d2(i+N*(j-1),ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,2.0d0*E(i),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c       1     du^2
c       -    ----   <0 ... jj>                                   (78b)
c       srt  dQidQj
        STATE1(j)=2
        S1_Nexc=2
        S1_Ncent=1
        S1_Lexc(1)=2
        S1_Lcent(1)=j
        m2(ic,ii)=m2(ic,ii)+1.0d0/srt*d2(i+N*(j-1),ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,2.0d0*E(j),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

        do 18 l=N7,N

c       1     du
c       -    ----   <ij ... l>                                (9)
c       srt  dQ_l
        STATE1(l)=1
        S1_Nexc=1
        S1_Ncent=1
        S1_Lexc(1)=1
        S1_Lcent(1)=l
        STATE2(i)=1
        STATE2(j)=1
        S2_Nexc=2
        S2_Ncent=2
        S2_Lexc(1)=1
        S2_Lcent(1)=i
        S2_Lexc(2)=1
        S2_Lcent(2)=j
        m2(ic,ii)=m2(ic,ii)+1.0d0/srt*d1(l,ii)*
     1  erat(LSPARSE,S1_Nexc,S2_Nexc,E(i)+E(j),E(l),
     1  lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

        if(l.ne.i.and.l.ne.j)then

c          1       du^2
c         ---    ----     <0 ... iijl>                    (11a)
c         srt     dQ_ldQi
         STATE1(i)=2
         STATE1(j)=1
         STATE1(l)=1
         S1_Nexc=4
         S1_Ncent=3
         S1_Lexc(1)=2
         S1_Lcent(1)=i
         S1_Lexc(2)=1
         S1_Lcent(2)=j
         S1_Lexc(3)=1
         S1_Lcent(3)=l
         m2(ic,ii)=m2(ic,ii)+d2(i+N*(l-1),ii)/srt*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(j)+E(l)+E(i)+E(i),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c          1    du^2
c         ---    ----     <0 ... ijjl>                     (11b)
c          srt  dQ_ldQj
         STATE1(j)=2
         STATE1(i)=1
         STATE1(l)=1
         S1_Nexc=4
         S1_Ncent=3
         S1_Lexc(1)=2
         S1_Lcent(1)=j
         S1_Lexc(2)=1
         S1_Lcent(2)=i
         S1_Lexc(3)=1
         S1_Lcent(3)=l
         m2(ic,ii)=m2(ic,ii)+d2(j+N*(l-1),ii)/srt*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(j)+E(l)+E(j)+E(i),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)
c          1    du
c         ---    ----     <0 ... ijl>                     (12)
c          srt  dQ_l
         STATE1(i)=1
         STATE1(j)=1
         STATE1(l)=1
         S1_Nexc=3
         S1_Ncent=3
         S1_Lexc(1)=1
         S1_Lcent(1)=i
         S1_Lexc(2)=1
         S1_Lcent(2)=j
         S1_Lexc(3)=1
         S1_Lcent(3)=l
         m2(ic,ii)=m2(ic,ii)+d1(l,ii)/srt*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(i)+E(j)+E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c          1    d^2u
c         ---    ----     <0 ... li>                     (14a)
c          2    dQ_ldQj
         STATE1(l)=1
         STATE1(i)=1
         S1_Nexc=2
         S1_Ncent=2
         S1_Lexc(1)=1
         S1_Lcent(1)=l
         S1_Lexc(2)=1
         S1_Lcent(2)=i
         m2(ic,ii)=m2(ic,ii)+d2(l+N*(j-1),ii)/2.0d0*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(i)+E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c          1    d^2u
c         ---    ----     <0 ... lj>                     (14b)
c          2    dQ_ldQi
         STATE1(l)=1
         STATE1(j)=1
         S1_Nexc=2
         S1_Ncent=2
         S1_Lexc(1)=1
         S1_Lcent(1)=l
         S1_Lexc(2)=1
         S1_Lcent(2)=j
         m2(ic,ii)=m2(ic,ii)+d2(l+N*(i-1),ii)/2.0d0*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(j)+E(l),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c         1     du^2
c        ---    ----     <ij ... i l>                         (15a)
c         2     dQ_ldQi
         STATE1(l)=1
         STATE1(i)=1
         S1_Nexc=2
         S1_Ncent=2
         S1_Lexc(1)=1
         S1_Lcent(1)=l
         S1_Lexc(2)=1
         S1_Lcent(2)=i
         STATE2(i)=1
         STATE2(j)=1
         S2_Nexc=2
         S2_Ncent=2
         S2_Lexc(1)=1
         S2_Lcent(1)=i
         S2_Lexc(2)=1
         S2_Lcent(2)=j
         m2(ic,ii)=m2(ic,ii)+0.5d0*d2(i+N*(l-1),ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,E(i)+E(j),E(l)+E(i),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c         1     du^2
c        ---    ----     <ij ... j l>                         (15b)
c         2     dQ_ldQj
         STATE1(l)=1
         STATE1(i)=1
         S1_Nexc=2
         S1_Ncent=2
         S1_Lexc(1)=1
         S1_Lcent(1)=l
         S1_Lexc(2)=1
         S1_Lcent(2)=j
         STATE2(i)=1
         STATE2(j)=1
         S2_Nexc=2
         S2_Ncent=2
         S2_Lexc(1)=1
         S2_Lcent(1)=i
         S2_Lexc(2)=1
         S2_Lcent(2)=j
         m2(ic,ii)=m2(ic,ii)+0.5d0*d2(j+N*(l-1),ii)*
     1   erat(LSPARSE,S1_Nexc,S2_Nexc,E(i)+E(j),E(l)+E(j),
     1   lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

         do 132 ll=N7,N
         if(l.ne.ll.and.ll.ne.i.and.ll.ne.j)then
c           1     du^2
c          ---    ----     <ij ... l ll>                         (15c)
c           4     dQ_ldQll
          STATE1(l)=1
          STATE1(ll)=1
          S1_Nexc=2
          S1_Ncent=2
          S1_Lexc(1)=1
          S1_Lcent(1)=l
          S1_Lexc(2)=1
          S1_Lcent(2)=ll
          STATE2(i)=1
          STATE2(j)=1
          S2_Nexc=2
          S2_Ncent=2
          S2_Lexc(1)=1
          S2_Lcent(1)=i
          S2_Lexc(2)=1
          S2_Lcent(2)=j
          m2(ic,ii)=m2(ic,ii)+0.25d0*d2(ll+N*(l-1),ii)*
     1    erat(LSPARSE,S1_Nexc,S2_Nexc,E(i)+E(j),E(l)+E(ll),
     1 lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
          call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)

c          1     du^2
c         ---    ----     <0 ... i j l ll>               (16)
c          4     dQ_ldQll
          STATE1(j)=1
          STATE1(i)=1
          STATE1(l)=1
          STATE1(ll)=1
          S1_Nexc=4
          S1_Ncent=4
          S1_Lexc(1)=1
          S1_Lcent(1)=i
          S1_Lexc(2)=1
          S1_Lcent(2)=j
          S1_Lexc(3)=1
          S1_Lcent(3)=l
          S1_Lexc(4)=1
          S1_Lcent(4)=ll
          m2(ic,ii)=m2(ic,ii)+0.25d0*d2(ll+N*(l-1),ii)*
     1    erat(LSPARSE,S1_Nexc,S2_Nexc,0.0d0,E(j)+E(i)+E(l)+E(ll),
     1lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
          call za(STATE1,STATE2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)
         endif
132      continue
        endif
c       l<>i,l<>j
18      continue
c       l
19      continue
c       ii
       endif
c      i<>j
       call intens(int2,m2,mt,ic)
       int2(ic,3)=int2(ic,3)*2.0d0*(E(I)+E(J))
       int2(ic,4)=int2(ic,4)*2.0d0*(E(I)+E(J))
       write(3,60038)ic,I,J,(E(J)+E(I))*CM,(int2(ic,l),l=1,4)
6      write(6,60038)ic,I,J,(E(J)+E(I))*CM,(int2(ic,l),l=1,4)
60038  format(3I4,F10.2,10(' ',G10.4))
      endif
c     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      call replacedog(N,E,AW,Eground*CM,N7)
      call replacedogint(N,E,AW,Eground*CM,
     1 intAH,NT3,N7,mt,int2,lcomb,ECC)
      deallocate(aptaq,aataq,alphaaq,gaq,aaq,moments,
     1alphaq,gq,aq,d1,d2)
      if(lqc)then
       if(ilqct.ne.0)then
        deallocate(nse_c,nse_S1,ndeo_S1,ndeo_S2,
     1  ndee_c,ndeo_c,ndee_S1,ndee_S2,u,ak,bkl,clj,usj,
     1  uo,uu,ww,p5,p6)
c       call rrtt(N,u,ak,bkl,clj,usj,uo,uu,ww,p5,p6)
       endif
      endif
      call w36('Enaf-ok')
      WRITE(6,7019)(mclock()-it0)
7019  format(' time:',I10)
      call w36(' ')
      return
      END

      subroutine addexcitation(IQ,Nexc,Ncent,Lexc,Lcent,ME0)
      implicit none
      integer*4 IQ,Nexc,Ncent,Lexc(*),Lcent(*),ME0,i
      Nexc=Nexc+1
      do 1 i=1,Ncent
      if(Lcent(i).eq.IQ)then
       Lexc(i)=Lexc(i)+1
       return
      endif
1     continue
      Ncent=Ncent+1
      if(Ncent.gt.ME0)call report('Too many excitations')
      Lexc(Ncent)=1
      Lcent(Ncent)=IQ
      return
      end

      subroutine removeexcitation(IQ,Nexc,Ncent,Lexc,Lcent)
      implicit none
      integer*4 IQ,Nexc,Ncent,Lexc(*),Lcent(*),i,j
      if(Nexc.eq.0)call report('Cannot remove excitation')
      Nexc=Nexc-1
      do 1 i=1,Ncent
      if(Lcent(i).eq.IQ)then
       Lexc(i)=Lexc(i)-1
       if(Lexc(i).eq.0)then
        do 2 j=i,Ncent-1
2       Lexc(j)=Lexc(j+1)
        Ncent=Ncent-1
       endif
       return
      endif
1     continue
      if(Nexc.eq.0)call report('Error in removeexcitation')
      end
c     ============================================================
      subroutine replacedog(N,E,AW,EAG,N7)
      implicit none
      integer*4 N,i,j,N7
      real*8 E(*),CM,AW(*),EAG,w,d,r,rx,ai,ry,rt,cid9,cidx,cid8,
     1dep,roa,ram
      logical lex
      character*80 s80
      CM=219470.0d0
      inquire(file='DOG.TAB',exist=lex)
      if(lex)then
       call w36('DOG.TAB will be rewritten to DOG4.TAB')
       open(7,file='DOG.TAB')
       open(8,file='DOG4.TAB')
       do 1 i=1,3
       read(7,70)s80
1      write(8,70)s80
70     format(a80)
       j=0
2      read(7,*,end=88,err=88)i,w,d,r,rx,ai
       j=j+1
       if(j.le.N-N7+1)then
        if(dabs(w-E(N-j+1)*CM).gt.0.1d0)then
         call w36('different frequencies')
         write(6,36)j,w,E(N-j+1)*CM
36       format(i8,2f9.2)
        endif
        write(8,80)i,AW(N-j+1)-EAG,d,r,rx,ai
80      format(i5,5G15.6)
       else
        write(8,80)i,w,d,r,rx,ai
       endif
       goto 2
88     close(7)
       write(8,89)
89     format('------------')
       close(8)
      endif
c
      inquire(file='ROA.TAB',exist=lex)
      if(lex)then
       call w36('ROA.TAB will be rewritten to ROA4.TAB')
       open(7,file='ROA.TAB')
       open(8,file='ROA4.TAB')
       do 3 i=1,3
       read(7,70)s80
3      write(8,70)s80
       j=0
4      read(7,*,end=99,err=99)i,w,rx,ry,rt,cid9,cidx,cid8,dep,roa,ram
       j=j+1
       if(j.le.N-N7+1)then
        if(dabs(w-E(N-j+1)*CM).gt.0.1d0)then
         call w36('different frequencies')
         write(6,36)j,w,E(N-j+1)*CM
        endif
        write(8,81)j,AW(N-j+1)-EAG,rx,ry,rt,cid9,cidx,cid8,dep,roa,ram
81      format(i5,F9.2,6g12.3,f6.3,f12.2,f12.2)
       else
        write(8,81)j,w,rx,ry,rt,cid9,cidx,cid8,dep,roa,ram
       endif
       goto 4
99     close(7)
       write(8,89)
       close(8)
      endif
c
      return
      end
c     ============================================================
      subroutine replacedogint(N,E,AW,EAG,inte,NT3,N7,mt,int2,lcomb,ECC)
      implicit none
      integer*4 N,i,j,NT3,N7,mt,ic,io
      real*8 E(*),CM,AW(*),EAG,w,d,r,rx,ai,ry,rt,cid9,cidx,cid8,
     1dep,roa,ram,inte(NT3,4),int2(mt,4),ECC(*)
      logical lex,lcomb
      character*80 s80
      CM=219470.0d0
      inquire(file='DOG.TAB',exist=lex)
      if(lex)then
       call w36('DOG.TAB will be rewritten to DOG4I.TAB')
       open(7,file='DOG.TAB')
       open(8,file='DOG4I.TAB')
       do 1 i=1,3
       read(7,70)s80
1      write(8,70)s80
70     format(a80)
       j=0
2      read(7,*,end=88,err=88)i,w,d,r,rx,ai
       j=j+1
       if(j.le.N-N7+1)then
        if(dabs(w-E(N-j+1)*CM).gt.0.1d0)then
         call w36('different frequencies')
         write(6,36)j,w,E(N-j+1)*CM
36       format(i8,2f9.2)
        endif
        write(8,80)i,AW(N-j+1)-EAG,inte(N-j+1,1),inte(N-j+1,2),rx,ai
80      format(i5,5G15.6)
       else
        write(8,80)i,w,d,r,rx,ai
       endif
       goto 2
88     close(7)
       if(lcomb)then
        ic=0
        do 5 i=N7,N
        do 5 j=i,N
        ic=ic+1
        w=(E(I)+E(J)+ECC(ic))*CM-EAG
5       write(8,80)i,w,int2(ic,1),int2(ic,2)
       endif
       write(8,89)
89     format('------------')
       close(8)
      endif
c
      inquire(file='ROA.TAB',exist=lex)
      if(lex)then
       call w36('ROA.TAB will be rewritten to ROA4I.TAB')
       open(7,file='ROA.TAB')
       open(8,file='ROA4I.TAB')
       if(lcomb)open( 9,file='ROA4Iover.TAB')
       if(lcomb)open(10,file='ROA4Icomb.TAB')
       do 3 i=1,3
       read(7,70)s80
       write(8,70)s80
       if(lcomb)write( 9,70)s80
3      if(lcomb)write(10,70)s80
       j=0
4      read(7,*,end=99,err=99)i,w,rx,ry,rt,cid9,cidx,cid8,dep,roa,ram
       j=j+1
       if(j.le.N-N7+1)then
        if(dabs(w-E(N-j+1)*CM).gt.0.1d0)then
         call w36('different frequencies')
         write(6,36)j,w,E(N-j+1)*CM
        endif
        write(8,81)j,AW(N-j+1)-EAG,rx,ry,inte(N-j+1,3),
     1  cid9,cidx,cid8,dep,inte(N-j+1,4),ram
81      format(i5,F9.2,6g12.3,f6.3,f12.2,f12.2)
       else
        write(8,81)j,w,rx,ry,rt,cid9,cidx,cid8,dep,roa,ram
       endif
       goto 4
99     close(7)
       if(lcomb)then
        do 6 io=1,2
        ic=0
        do 6 i=N7,N
        do 6 j=i,N
        ic=ic+1
        w=(E(I)+E(J)+ECC(ic))*CM-EAG
        ram=int2(ic,3)
        roa=int2(ic,4)
        if(io.eq.1.and.i.eq.j)then
         write( 8,81)i,w,ram,ram,ram,0.0d0,0.0d0,0.0d0,0.0d0,roa,roa
         write( 9,80)i,w,int2(ic,3),int2(ic,4)
        endif
        if(io.eq.2.and.i.ne.j)then
         write( 8,81)i,w,ram,ram,ram,0.0d0,0.0d0,0.0d0,0.0d0,roa,roa
         write(10,82)ic,w,int2(ic,3),int2(ic,4),i,j
82       format(i5,3G15.6,2i4)
        endif
6       continue
        write(9,89)
        close(9)
        write(10,89)
        close(10)
       endif
       write(8,89)
       close(8)
      endif
c
      return
      end
c     ============================================================
      subroutine rdten1q(QP,QM,N,NT3)
      implicit none
      integer*4 N,NT3,i,ix,ndif,j,iq
      real*8 QP(3,NT3),QM(3,NT3)
      do 1 i=1,N
      do 1 ix=1,3
      QP(ix,i)=0.0d0
1     QM(ix,i)=0.0d0
      open(9,file='TENQ.TXT.SCR')
      read(9,*)
      read(9,*)
      read(9,*)ndif
      write(6,*)ndif
      DO 16 I=ndif,1,-1
      do 16 j=1,3
      read(9,*)iq,iq,ix,QP(ix,iq),QP(ix,iq),QP(ix,iq)
16    continue
      read(9,*)
      DO 17 I=ndif,1,-1
      do 17 j=1,3
17    read(9,*)iq,iq,ix,QM(ix,iq)
      close(9)
      call w36('Dipole derivatives from TENQ.TXT.SCR)')
      return
      end
c     ============================================================
      subroutine rdtenq(aptaq,aataq,N,NT3)
      implicit none
      integer*4 N,NT3,i,ix,ndif,J,k,iq,jq
      real*8 aptaq(2*NT3**2,3),aataq(NT3**2,3)
      logical lex
      do 2 i=1,N**2
      do 2 ix=1,3
      aptaq(i,ix)=0.0d0
      aptaq(N**2+i,ix)=0.0d0
2     aataq(i,ix)=0.0d0
      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       open(9,file='TENAQ.TXT.SCR')
       read(9,*)ndif
       read(9,*)
       read(9,*)
       DO 18 I=ndif,1,-1
       DO 18 J=I,1,-1
       do 18 k=1,3
18     read(9,*)iq,jq,ix,aptaq(iq+(jq-1)*N,ix),aptaq(jq+(iq-1)*N,ix),
     1 aptaq(N**2+iq+(jq-1)*N,ix)
       read(9,*)
       read(9,*)
       DO 1 I=ndif,1,-1
       DO 1 J=I,1,-1
       do 1 k=1,3
1      read(9,*)iq,jq,ix,aataq(iq+(jq-1)*N,ix),aataq(jq+(iq-1)*N,ix)
       close(9)
       call w36('Second dipole derivatives read from TENAQ.TXT.SCR')
      else
       call w36('Second dipole derivatives (TENAQ.TXT.SCR) not found')
      endif
      return
      end
c     ============================================================
      subroutine readtttq(NT3,alphaq,gq,aq,N,N7)
      implicit none
      integer*4 NT3,N,iq,i,j,k,l,N7,ndif,ix,jx,kx
      real*8 alphaq(3,3,NT3),gq(3,3,NT3),aq(3,3,3,NT3)

      do 4 iq=N7,N
      do 4 i=1,3
      do 4 j=1,3
      alphaq(i,j,iq)=0.0d0
      gq(i,j,iq)=0.0d0
      do 4 k=1,3
4     aq(i,j,k,iq)=0.0d0

      open(9,file='TTTQ.TXT.SCR')
      do 1 i=1,4
1     read(9,*)
      read(9,*)ndif
      DO 19 I=1,ndif
      do 19 j=1,3
      do 19 k=1,3
19    read(9,*)iq,iq,ix,jx,alphaq(ix,jx,iq),alphaq(ix,jx,iq)
      do 2 i=1,4
2     read(9,*)
      DO 20 I=1,ndif
      do 20 j=1,3
      do 20 k=1,3
20    read(9,*)iq,iq,ix,jx,gq(ix,jx,iq)
      do 3 i=1,10
3     read(9,*)
      DO 21 I=1,ndif
      do 21 j=1,3
      do 21 k=1,3
      do 21 l=1,3
21    read(9,*)iq,iq,ix,jx,kx,aq(ix,jx,kx,iq)
      close(9)
      call w36('Polarizability derivatives from TTTQ.TXT.SCR')
      return
      end
c     ============================================================
      subroutine zs(s,n7,n)
      implicit none
      integer*4 n7,n,i,s(*)
      DO 1008 i=n7,n
1008  s(i)=0
      return
      end
c     ============================================================
      subroutine intens(intensity,moments,NT3,I)
      implicit none
      integer*4 NT3,ix,jx,I,kx,lx
      real*8 intensity(NT3,4),moments(NT3,51),SAL0,SAL1,SAG0,SAG1,SA1,
     1SPAL,EPS,SDCP180,S180,D180,D,S90X,D90X,DX,S90Z,D90Z,DZ,YDY,YDX,
     1P1,AMU,BOHR,SpA3,beta2,gpisvejc,betaa,betag,roa3,roa2,ram2,
     1CID2,roa1,ram1,CID1,EXCNM,EXCA,ropt,CLIGHT,AUD
      common/opt/ropt(100)
      equivalence (ropt(21),EXCNM)

      AUD=2.541732d0
      CLIGHT=137.053d0
c     moments   1-3 magnetic
c               4-6 electric
c               7 etc. alpha, G', A
c     intensity 1 ABS   debye^2
c               2 VCD   debye^2
c               3 raman
c               4 roa
      intensity(I,1)=(moments(I,4)*moments(I,4)
     1               +moments(I,5)*moments(I,5)
     1               +moments(I,6)*moments(I,6))*AUD**2
      intensity(I,2)=(moments(I,4)*moments(I,1)
     1               +moments(I,5)*moments(I,2)
     1               +moments(I,6)*moments(I,3))*AUD**2*2.0d0/CLIGHT
      EXCA=EXCNM*10.0d0
      SAL0=0.0d0
      SAL1=0.0d0
      SAG0=0.0d0
      SAG1=0.0d0
      SA1=0.0d0
      SPAL=0.0d0
      DO 2003 ix=1,3
      SPAL=SPAL+moments(I,6+ix+(ix-1)*3)
      DO 2003 jx=1,3
      SAL0=SAL0+moments(I,6+ix+(ix-1)*3)*moments(I, 6+jx+(jx-1)*3)
      SAL1=SAL1+moments(I,6+ix+(jx-1)*3)*moments(I, 6+ix+(jx-1)*3)
      SAG0=SAG0+moments(I,6+ix+(ix-1)*3)*moments(I,15+jx+(jx-1)*3)
      SAG1=SAG1+moments(I,6+ix+(jx-1)*3)*moments(I,15+ix+(jx-1)*3)
      DO 2003 kx=1,3
      DO 2003 lx=1,3
c     this is not same as in new6, because new6 switches dipole and
c     one quadrupole index while reading tensor A:
c     if(EPS(ix,kx,lx).ne.0.0d0)
c    1write(6,*)ix,jx,kx,lx,EPS(ix,kx,lx),moments(I,6+ix+(jx-1)*3),
c    1                      moments(I,24+jx+(lx-1)*3+(kx-1)*9)/3.0d0
2003  SA1=SA1+EPS(ix,kx,lx)*moments(I,6+ix+(jx-1)*3)*
     1                      moments(I,24+jx+(lx-1)*3+(kx-1)*9)/3.0d0
c
c     IL+IR, backscattering, DCP_I
      SDCP180=3.0d0*SAL1-SAL0
c
c     IL+/-IR, backscattering
      S180=7.0d0*SAL1+SAL0
c     write(6,*)I,SAL0,SAL1,SAG0,SAG1,SA1
      D180=8.0d0*(3.0d0*SAG1-SAG0+SA1)
      D=D180
      IF(S180.gt.1.0d-9)D=D/S180
c
c     IL+/-IR, 90o, x
      S90X=7.0d0*SAL1+SAL0
      D90X=2.0d0*(7.0d0*SAG1+SAG0+SA1)
      DX=D90X
      IF(S90X.gt.1.0d-9)DX=DX/S90X
c
c     IL+/-IR, 90o, z
      S90Z=2.0d0*(3.0d0*SAL1-SAL0)
      D90Z=4.0d0*(3.0d0*SAG1-SAG0-SA1)
      DZ=D90Z
      IF(S90Z.gt.1.0d-9)DZ=DZ/S90Z
c
c     polarized backscattering components (YDY+YDX=S180):
      YDY=3.0d0*SAL1-SAL0
      YDX=4.0d0*SAL1+2.0d0*SAL0
      P1=YDY/YDX
c
c     Try to get Gaussian units:
      AMU=1822.0d0
      BOHR=0.529177d0
      SpA3=SPAL/3.0d0*dsqrt((AMU*BOHR**4))
      beta2=0.5d0*(3*SAL1-SAL0)*(AMU*BOHR**4)
      YDY=6.0d0*YDY*(AMU*BOHR**4)
      YDX=6.0d0*YDX*(AMU*BOHR**4)
c     gpisvejc=980.0
      gpisvejc=(AMU*BOHR**5)*1.0d4*2.0d0*4.0d0*atan(1.0d0)/EXCA
c
c     alphag=SAG0/9.0d0*gpisvejc
c
c     beta(A)^2=Delta2 in Gaussian:
      betaa=SA1*3.0d0/2.0d0*gpisvejc
      betag=(3.0d0*SAG1-SAG0)/2.0d0*gpisvejc
c
c     DCP 180
c     ram3=24.0d0*beta2
      roa3=8.0d0*(12.0d0*betag+4.0d0*betaa)
c
c     unknown:
      S90X=S90X*(AMU*BOHR**4)
      D90X=D90x*gpisvejc
      DX=D90X
      IF(S90X.gt.1.0d-9)DX=DX/S90X
c
c     ICP(90)=90Z
      roa2=8.0d0*(3.0d0*betag-betaa)
      ram2=12.0d0*beta2
      CID2=0.0d0
      if(ram2.gt.1.0d-9)CID2=roa2/ram2
c
c     ICP(180):
c     8/c*(12*beta(G')^2 + 4*beta(A)^2):
      roa1=96.0d0*(betag+betaa/3.0d0)
      ram1=4.0d0*(45.0d0*SpA3**2+7.0d0*beta2)
      CID1=0.0d0
      if(ram1.gt.1.0d-9)CID1=roa1/ram1
c     WRITE(4,3300)IQ,ECM,YDX,YDY,ram1,CID2,DX,CID1,P1,roa1,roa3
c300  FORMAT(I4,f9.2,6f9.2,f6.3,2f11.2)
      intensity(I,3)=ram1
      intensity(I,4)=roa1
      return
      end
c     ============================================================
      function erat(LSPARSE,S1_Nexc,S2_Nexc,e1,e2,
     1lnm2,c5,c6,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
c
c      <S1|V|S2>
c     ----------
c      (E1 - E2)^2
      implicit none
      include 'dimensions.h'
      integer*4 S1(NT3),S2(NT3),N7,N
      real*8 erat,e1,e2,AAf,A,V,SUM5,SUM6,c5(N,N,N),c6(N,N,N)
      integer*4 S1_Nexc,S2_Nexc,
     1S1_Ncent,S1_Lexc(*),S1_Lcent(*),
     1S2_Ncent,S2_Lexc(*),S2_Lcent(*),
     1nse_c(*),nse_S1(*),ndeo_S1(*),ndeo_S2(*),
     1ndee_c(*),ndeo_c(*),ndee_S1(*),ndee_S2(*)
      logical lnm2,LSPARSE,L4
      COMMON/SUM/A,S1,S2,N7,N,L4
      V=0.0d0
      IF(mod(S1_Nexc-S2_Nexc,2).eq.0)then
       IF(LSPARSE)THEN
        CALL SUMSQGHOST
       else
        CALL SUMSQ
       endif
       V=V+A
       if(lnm2)V=V+SUM6(N,N7,c6,
     1 S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      else
       if(LSPARSE)then
        CALL SUMSGHOST
       else
        CALL SUMS
       endif
       V=V+A
       if(lnm2)V=V+SUM5(N,N7,c5,
     1 S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1 nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
      endif
      if(V.ne.0.0d0)then
       erat=AAf(e1,e2,V)/V
      else
       erat=0.0d0
      endif
      return
      end
c     ============================================================
      subroutine rrtt(N,u,ak,bkl,clj,usj,uo,uu,ww,p5,p6)
      implicit none
      integer*4 N,i,j
      real*8 u(*),ak(*),bkl(*),clj(*),CM,usj(*),
     1uo(*),uu(*),ww(*),p5(*),p6(*)
      CM=219474.0d0
      call vz(u,0.0d0,N*N)
      call vz(usj,0.0d0,N)
      call vz(ak ,0.0d0,N  )
      call vz(bkl,0.0d0,N*N)
      call vz(clj,0.0d0,N*N)
      call vz(uo,0.0d0,N*N)
      call vz(uu,0.0d0,N*N)
      call vz(ww,0.0d0,N*N)
      call vz(p5,0.0d0,N)
      call vz(p6,0.0d0,N)

      open(10,file='UIJ.SCR.TXT')
1     read(10,*,end=11,err=11)i,j,u(j+N*(i-1))
      goto 1
11    close(10)

      open(10,file='AL.SCR.TXT')
2     read(10,*,end=22,err=22)i,i,ak(i)
      goto 2
22    close(10)
      call mv(ak,N,1.0d0/CM)

      open(10,file='BKL.SCR.TXT')
3     read(10,*,end=33,err=33)i,j,bkl(j+N*(i-1))
      goto 3
33    close(10)
      call mv(bkl,N*N,1.0d0/CM)

      open(10,file='CJL.SCR.TXT')
4     read(10,*,end=44,err=44)i,j,clj(j+N*(i-1))
      goto 4
44    close(10)
      call mv(clj,N*N,1.0d0/CM)

      open(10,file='USJ.SCR.TXT')
6     read(10,*,end=66,err=66)i,i,usj(i)
      goto 6
66    close(10)

      open(10,file='UO.SCR.TXT')
7     read(10,*,end=77,err=77)i,j,uo(j+N*(i-1))
      goto 7
77    close(10)

      open(10,file='UU.SCR.TXT')
9     read(10,*,end=99,err=99)i,j,uu(j+N*(i-1))
      goto 9
99    close(10)

      open(10,file='WW.SCR.TXT')
10    read(10,*,end=100,err=100)i,j,ww(j+N*(i-1))
      goto 10
100   close(10)
      call mv(ww,N*N,1.0d0/CM)

      open(10,file='P5.SCR.TXT')
13    read(10,*,end=101,err=101)i,i,p5(i)
      goto 13
101   close(10)
      call mv(p5,N,1.0d0/CM)

      open(10,file='P6.SCR.TXT')
12    read(10,*,end=102,err=102)i,i,p6(i)
      goto 12
102   close(10)
      call mv(p6,N,1.0d0/CM)

      call w36('T-constants loaded')
      return
      end

      subroutine mv(u,n,c)
      real*8 u(*),c
      integer*4 i,n
      do 1 i=1,n
1     u(i)=u(i)*c
      return
      end

      subroutine load56(c5,c6,N7,N)
      implicit none
      integer*4 N7,N,it,I,J,K,ic
      real*8 c5(N,N,N),c6(N,N,N),AC
      do 8 I=N7,N
      do 8 J=N7,N
      do 8 K=N7,N
      c5(I,J,K)=0.0d0
8     c6(I,J,K)=0.0d0
      do 1 ic=5,6
      if(ic.eq.5)open(23,file='5QQ.SCR.TXT')
      if(ic.eq.6)open(23,file='6QQ.SCR.TXT')
      it=0
7     read(23,*,err=7000,end=7000)I,J,K,AC
      IT=IT+1
      if(ic.eq.5)then
       c5(I,J,K)=AC
       c5(I,K,J)=AC
      endif
      if(ic.eq.6)then
       c6(I,J,K)=AC
       c6(I,K,J)=AC
      endif
      goto 7
7000  close(23)
1     write(6,7006)ic,it
7006  format(' c',i1,': ',i10,' constants')
      return
      end

      subroutine addscomb(E,LSPARSE,lnm2,c5,c6,NN,ECC,
     1S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,ndee_S1,ndeo_S1,
     1S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent,ndee_S2,ndeo_S2,
     1nse_S1,nse_c,ndee_c,ndeo_c,Emono,
     1Eground,ilqct,lqc,EE,lcomb,QUARTIC,LH40,NZF,
     1ak,bkl,clj,u,uo,usj,uu,ww)
c     add STATE2 (in COMMON) to combination modes
c     S1 variables are supplied and must be set to ground
      implicit none
      include 'dimensions.h'
      logical LSPARSE,lnm2,L4,same,lcomb,lqc,QUARTIC,LH40
      integer*4 ic,IQ,JQ,I1,I2,NN,ilqct,NZF,
     1S1_Nexc,S1_Ncent,S1_Lexc(*),S1_Lcent(*),
     1S2_Nexc,S2_Ncent,S2_Lexc(*),S2_Lcent(*),
     1nse_c(*),nse_S1(*),ndeo_S1(*),ndeo_S2(*),
     1ndee_c(*),ndeo_c(*),ndee_S1(*),ndee_S2(*)
      real*8 E(*),ECC(*),AAf,A,c6(NN,NN,NN),c5(NN,NN,NN),
     1SUM6,SUM5,EE,Emono(*),Eground,Voff,sumt,
     1ak(*),bkl(*),clj(*),u(*),uo(*),usj(*),uu(*),ww(*)
      INTEGER*4 STATE1(NT3),STATE2(NT3),N7,N,IFINDSYM1,
     1ISY1,ISY2
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      call zs(STATE1,N7,N)
      S1_Nexc=0
      S1_Ncent=0
      S1_Lexc(1)=0
      S1_Lcent(1)=0
      ISY1=IFINDSYM1(N,STATE1,N7)
      ISY2=IFINDSYM1(N,STATE2,N7)
c
c     Corrections to ground state:
c     1)diagonal  <ground|ground>:
      if(S2_Nexc.eq.0)then
c      <ground|Tk-curved|ground>:
       if(ilqct.ne.0.and.lqc)then
        Eground=Eground+sumt(N,N7,U,ak,bkl,clj,usj,uo,uu,ww,
     1  S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     2  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
       endif
C      <ground|V4|ground>:
       IF(QUARTIC)THEN
        IF(LSPARSE)THEN
         CALL SUMSQGHOST
        ELSE
         CALL SUMSQ
        ENDIF
        Eground=Eground+A
       ENDIF
C      <ground|V6|ground>:
       if(lnm2)then
        Eground=Eground+SUM6(N,N7,c6,
     1  S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
       endif
C      <ground|Kinetic|ground>:
       IF(LH40)THEN
        CALL SUM4
        Eground=Eground+A
       ENDIF
C      <ground|VE|ground>:
       IF(NZF.NE.0)THEN
        CALL SUMSE
        Eground=Eground+A
       ENDIF
c     2) off-diagonal to ground
      else
       voff=0.0d0
       if(ISY1.EQ.ISY2)then
c       <ground|Tk-curved|double>, odd and even:
        if(ilqct.ne.0.and.lqc)then
         voff=voff+sumt(N,N7,U,ak,bkl,clj,usj,uo,uu,ww,
     1   S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     2   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        endif
        if(mod(S1_Nexc-S2_Nexc,2).eq.0)then
c        even:
C        Kinetic
         IF(LH40)THEN
          CALL SUM4
          voff=voff+A
         ENDIF
C        V4:
         IF(QUARTIC)THEN
          IF(LSPARSE)THEN
           CALL SUMSQGHOST
          ELSE
           CALL SUMSQ
          ENDIF
          voff=voff+A
         ENDIF
C        V6:
         if(lnm2)then
          Voff=Voff+SUM6(N,N7,c6,
     1    S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1    nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         endif
C        VE:
         IF(NZF.NE.0)THEN
          CALL SUMSE
          Voff=Voff+A
         ENDIF
        else
c        odd:
C        V3:
         IF(LSPARSE)THEN
          CALL SUMSGHOST
         ELSE
          CALL SUMS
         ENDIF
         Voff=Voff+A
C        V5:
         if(lnm2)then
          Voff=Voff+SUM5(N,N7,c5,
     1    S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1    nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         endif
        endif
c                          <n|V|*>^2
c       En' = En + sum(*) -----------
c                           En - E*
        Eground=Eground+AAf(0.0d0,EE,Voff)
       endif
      endif
c
c     Corrections to monoexcited states:
      do 1 IQ=N7,N
      STATE1(IQ)=STATE1(IQ)+1
      call addexcitation(IQ,S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,ME0)
      ISY1=IFINDSYM1(N,STATE1,N7)
      if(ISY1.eq.ISY2)then
c      check that state1 <> state2:
       same=S2_Nexc.eq.1.and.S2_Lcent(1).eq.IQ
c      diagonal:
       if(same)then
        if(ilqct.ne.0.and.lqc)then
         Emono(IQ)=Emono(IQ)+sumt(N,N7,U,ak,bkl,clj,usj,uo,uu,ww,
     1   S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     2   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        endif
c       V4 and V6
        if(QUARTIC)then
         IF(LSPARSE)THEN
          CALL SUMSQGHOST
         ELSE
          CALL SUMSQ
         ENDIF
         Emono(IQ)=Emono(IQ)+A
        ENDIF
        if(lnm2)Emono(IQ)=Emono(IQ)+SUM6(N,N7,c6,
     1  S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1  nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
       else
        Voff=0.0d0
        if(ilqct.ne.0.and.lqc)then
         Voff=Voff+sumt(N,N7,U,ak,bkl,clj,usj,uo,uu,ww,
     1   S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     2   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        endif
        if(mod(S1_Nexc-S2_Nexc,2).eq.0)then
c        V4,V6
         if(QUARTIC)then
          IF(LSPARSE)THEN
           CALL SUMSQGHOST
          ELSE
           CALL SUMSQ
          ENDIF
          Voff=Voff+A
         endif
         if(lnm2)Voff=Voff+SUM6(N,N7,c6,
     1   S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        else
c        V3,V5
         IF(LSPARSE)THEN
          CALL SUMSGHOST
         ELSE
          CALL SUMS
         ENDIF
         Voff=Voff+A
         if(lnm2)Voff=Voff+SUM5(N,N7,c5,
     1   S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        endif
        Emono(IQ)=Emono(IQ)+AAf(E(IQ),EE,Voff)
       endif
      endif
      call removeexcitation(IQ,S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent)
1     STATE1(IQ)=STATE1(IQ)-1

c     Corrections to double-excited states:
      if(lcomb)then
       ic=0
       do 101 IQ=N7,N
       STATE1(IQ)=STATE1(IQ)+1
       call addexcitation(IQ,S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,ME0)
       do 102 JQ=IQ,N
       ic=ic+1
       STATE1(JQ)=STATE1(JQ)+1
       call addexcitation(JQ,S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,ME0)
       ISY1=IFINDSYM1(N,STATE1,N7)
       if(ISY1.EQ.ISY2)then
c       check that state1 <> state2:
        same=.false.
        if(S2_Nexc.eq.2)then
         i1=S2_Lcent(1)
         if(S2_Ncent.gt.1)then
          i2=S2_Lcent(2)
         else
          i2=i1
         endif
         same=(i1.eq.IQ.and.i2.eq.JQ).or.(i1.eq.JQ.and.i2.eq.IQ)
        endif
        if(same)then
c        diagonal Et, V4 and V6:
         if(ilqct.ne.0.and.lqc)ECC(ic)=ECC(ic)+sumt(N,N7,U,ak,bkl,clj,
     1   usj,uo,uu,ww,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,
     1   S2_Lcent,nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,
     1   ndee_S2)
         IF(QUARTIC)THEN
          IF(LSPARSE)THEN
           CALL SUMSQGHOST
          ELSE
           CALL SUMSQ
          ENDIF
          ECC(ic)=ECC(ic)+A
         ENDIF
         if(lnm2)ECC(ic)=ECC(ic)+SUM6(N,N7,c6,
     1   S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
        else
         Voff=0.0d0
         if(ilqct.ne.0.and.lqc)Voff=Voff+sumt(N,N7,U,ak,bkl,clj,usj,uo,
     1   uu,ww,S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     2   nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         if(mod(S1_Nexc-S2_Nexc,2).eq.0)then
c         even ,V4,V6
          IF(QUARTIC)THEN
           IF(LSPARSE)THEN
            CALL SUMSQGHOST
           ELSE
            CALL SUMSQ
           ENDIF
           Voff=Voff+A
          endif
          if(lnm2)Voff=Voff+SUM6(N,N7,c6,
     1    S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1    nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         else
c         oddV3,V5
          IF(LSPARSE)THEN
           CALL SUMSGHOST
          ELSE
           CALL SUMS
          ENDIF
          Voff=Voff+A
          if(lnm2)Voff=Voff+SUM5(N,N7,c5,
     1    S1_Ncent,S1_Lexc,S1_Lcent,S2_Ncent,S2_Lexc,S2_Lcent,
     1    nse_c,nse_S1,ndeo_S1,ndeo_S2,ndee_c,ndeo_c,ndee_S1,ndee_S2)
         endif
         ECC(ic)=ECC(ic)+AAf(E(IQ)+E(JQ),EE,Voff)
        endif
       endif
       call removeexcitation(JQ,S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent)
102    STATE1(JQ)=STATE1(JQ)-1
       call removeexcitation(IQ,S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent)
101    STATE1(IQ)=STATE1(IQ)-1
      endif

      return
      end

      subroutine za(S1,S2,N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent)
      integer*4 S1(*),S2(*),
     1N7,N,S1_Nexc,S2_Nexc,S1_Ncent,S2_Ncent
      call zs(S1,N7,N)
      call zs(S2,N7,N)
      S1_Nexc=0
      S1_Ncent=0
      S2_Nexc=0
      S2_Ncent=0
      return
      end
