      SUBROUTINE PHASE(EPHA,ASL)
C     DIAGONAL CORRECTION VIA PHASE INTEGRAL
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      parameter (NQQ=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6,
     3NX4=NT3*((NT3*(NT3+1))/2))
      INTEGER*4 STATE1(NT3),STATE2(NT3)
      DIMENSION EIT(2),EPHA(NT3),O(2)
      COMMON/CEM/E(NT3)
      LOGICAL L4
      COMMON/SUM/AS,STATE1,STATE2,N7,N,L4
      COMMON/DIA2A/CIJK(NT3,NT3,NT3)
      COMMON/DIA2B/CS(NQQ),ICS(3,NQQ),NCSP
      real*8 ropt,OH,DOH
      COMMON/opt/ropt(100)
      equivalence (OH,ropt(15)),(DOH,ropt(16))
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      COMMON/VQA/CQ4(NT3,NT3,NT3)
      COMMON/VQB/DS(NX4),IDS(3,NX4),NDSP
      COMMON/INTEGRAL/A,B,C,D,IT1
      COMMON/V4/CH(NX4),K4(NX4),L44(NX4),KP4(NX4),LPP4(NX4),
     1AH4L,NCO
      call w36(' ')
      call w36('Phase')
      call w36('^^^^^')
      CM=219470.0d0
      B=0.0d0
C     PI=3.142592653589
      PI=DBLE(4)*dATAN(dble(1))
      DLIMIT=0.01d0/CM
      AITGLIM=10000000.0d0-1.0d0
C     1 a.u.= 2.1947E5 cm^-1
      WRITE(3,*)' Phase integrals'
      WRITE(6,*)' Phase integrals'
      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
      WRITE(3,3002)
      WRITE(6,3002)
3002  FORMAT(' Mode   A         C         D      2*E0     E1-E0',/,
     1       '-------------------------------------------------')
      DO 5 I=N7,N
      A=E(I)
      D=0.0d0
      IF(A.LT.0.0d0)THEN
       WRITE(3,*)' Absolute value of frequency used for definition of q'
      ENDIF
      if(LSPARSE)then
       do 1 II=1,NCSP
1      if(ICS(1,II).eq.I.and.ICS(2,II).eq.I.and.ICS(3,II).eq.I)goto 2
       C=0.0d0
2      C=CS(II)
       do 3 II=1,NDSP
3      if(IDS(1,II).eq.I.and.IDS(2,II).eq.I.and.IDS(3,II).eq.I)goto 4
4      if(QUARTIC)D=DS(II)
      else
       C=CIJK(I,I,I)
       if(QUARTIC)D=CQ4(I,I,I)
      endif
      ALFAC=DSQRT(ABS(A)*0.5d0)*PI
C     V(q)=(a/2)q^2 + c/6)q^3 + (d/24)q^4, q=Q*DSQRT(ABS(Wharm))
      DO 6 NI=0,1
      ALIMIT=(DBLE(NI)+0.5d0)*ALFAC
C     int (O1..O2)DSQRT(E-V(q))dq = SQRT(Hbar*Wharm/2)*(ni+1/2)*pi
      DE=1.0d0/CM
      IT1=0
      EN1=ABS(A)*(DBLE(NI)+0.45d0)
      EN2=EN1+DE
7     CALL AITGS(AI1,EN1,O,IT2,IT3)
      CALL AITGS(AI2,EN2,O,IT2,IT3)
      IF(AI1.GT.AITGLIM.OR.AI2.GT.AITGLIM)THEN
       WRITE(3,*)' The harmonic frequency retained'
       WRITE(6,*)' The harmonic frequency retained'
       EIT(2)=A
       EIT(1)=A
       EPHA(I)=A
       GOTO 8
      ENDIF
      IF(ABS(AI2-AI1).LT.0.0000001d0)THEN
       WRITE(3,*)'Division by zero'
       GOTO 6
      ENDIF
      EN3=EN2+(EN2-EN1)*(ALIMIT-AI2)/(AI2-AI1)
      IT1=IT1+1
      IF(IT1.GT.100)THEN
       WRITE(6,*)' Stable state has not been found after 100 iterations'
       WRITE(3,*)' Stable state has not been found after 100 iterations'
       WRITE(3,*)' The harmonic frequency retained'
       WRITE(6,*)' The harmonic frequency retained'
       EIT(2)=A
       EIT(1)=A
       EPHA(I)=A
       GOTO 8
      ENDIF
      IF(ABS(EN3-EN2).LT.DLIMIT)GOTO 6
      EN1=EN2
      EN2=EN3
      GOTO 7
6     EIT(NI+1)=EN3
      EIT(2)=EIT(2)-EIT(1)
      EIT(1)=EIT(1)*2.0d0
      EPHA(I)=EIT(2)
8     CONTINUE
      WRITE(6,3001)I,A*CM,C*CM,D*CM,EIT(1)*CM,EIT(2)*CM,IT1,IT2,IT3
5     WRITE(3,3001)I,A*CM,C*CM,D*CM,EIT(1)*CM,EIT(2)*CM,IT1,IT2,IT3
3001  FORMAT(I3,5F10.2,3I4)
      RETURN
      END
c     ====================================================================
      SUBROUTINE PHASEEF(EPHA,ASL)
C     DIAGONAL CORRECTION VIA PHASE INTEGRAL, effective potential of ground
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      PARAMETER (NQQ=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6,
     3NX4=NT3*((NT3*(NT3+1))/2))
      INTEGER*4 STATE1(NT3),STATE2(NT3)
      DIMENSION EIT(2),EPHA(NT3),O(2)
      COMMON/CEM/E(NT3)
      LOGICAL L4
      COMMON/SUM/AS,STATE1,STATE2,N7,N,L4
      COMMON/DIA2A/CIJK(NT3,NT3,NT3)
      COMMON/DIA2B/CS(NQQ),ICS(3,NQQ),NCSP
      real*8 ropt,OH,DOH
      COMMON/opt/ropt(100)
      equivalence (OH,ropt(15)),(DOH,ropt(16))
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      COMMON/VQA/CQ4(NT3,NT3,NT3)
      COMMON/VQB/DS(NX4),IDS(3,NX4),NDSP
      COMMON/INTEGRAL/A,B,C,D,IT1
      COMMON/V4/CH(NX4),K4(NX4),L44(NX4),KP4(NX4),LPP4(NX4),
     1AH4L,NCO
      CM=219470.0d0
      PI=DBLE(4)*DATAN(DBLE(1))
      DLIMIT=0.01d0/CM
      AITGLIM=10000000.0d0-1.0d0
      WRITE(3,*)' Phase integrals-effective potentials'
      WRITE(6,*)' Phase integrals-effective potentials'
      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
      WRITE(3,3002)
      WRITE(6,3002)
3002  FORMAT('Hi(eff)=w0/2 pi^2 +(A/2)q^2+Bq+(C/6)q^3+(D/24)q^4',/,
     1'Mode     w0       A       B       C       D    2*E0   E1-E0',/,
     1'-----------------------------------------------------------')
      DO 5 I=N7,N
      IF(E(I).LT.0.0d0)THEN
       WRITE(3,*)' Absolute value of frequency used for definition of q'
      ENDIF
      w0=abs(E(I))
      ALFAC=DSQRT(w0/2.0d0)*PI
      A=w0
      B=0.0d0
      D=0.0d0
      if(LSPARSE)then
       do 1 II=1,NCSP
1      if(ICS(1,II).eq.I.and.ICS(2,II).eq.I.and.ICS(3,II).eq.I)goto 2
       C=0.0d0
2      C=CS(II)
       do 3 II=1,NDSP
3      if(IDS(1,II).eq.I.and.IDS(2,II).eq.I.and.IDS(3,II).eq.I)goto 4
       D=0.0d0
4      if(QUARTIC)D=DS(II)
      else
       C=CIJK(I,I,I)
       if(QUARTIC)D=CQ4(I,I,I)
      endif
      DO 50 J=N7,N
      IF(J.NE.I)THEN
       if(LSPARSE)then
        do 51 II=1,NCSP
        if(ICS(1,II).eq.J.and.ICS(2,II).eq.J.and.ICS(3,II).eq.I)goto 61
        if(ICS(1,II).eq.J.and.ICS(2,II).eq.I.and.ICS(3,II).eq.J)goto 61
51      if(ICS(1,II).eq.I.and.ICS(2,II).eq.J.and.ICS(3,II).eq.J)goto 61
        goto 9
61      B=B+0.25d0*CS(II)
9       do 71 II=1,NDSP
        if(IDS(1,II).eq.J.and.IDS(2,II).eq.I.and.IDS(3,II).eq.I)goto 81
71      if(IDS(1,II).eq.I.and.IDS(2,II).eq.J.and.IDS(3,II).eq.J)goto 81
        goto 10
81      A=A+0.25d0*DS(II)
10      continue
       else
        A=A+0.25d0*CQ4(I,J,J)
        B=B+0.25d0*CIJK(I,J,J)
       endif
      ENDIF
50    CONTINUE
      DO 6 NI=0,1
      ALIMIT=(DBLE(NI)+0.5d0)*ALFAC
C     int (O1..O2)DSQRT(E-V(q))dq = SQRT(Hbar*Wharm/2)*(ni+1/2)*pi
      DE=1.0d0/CM
      IT1=0
      EN1=dABS(A)*(DBLE(NI)+0.45d0)
      EN2=EN1+DE
7     CALL AITGS(AI1,EN1,O,IT2,IT3)
      CALL AITGS(AI2,EN2,O,IT2,IT3)
      IF(AI1.GT.AITGLIM.OR.AI2.GT.AITGLIM)THEN
       WRITE(3,*)' The harmonic frequency retained'
       WRITE(6,*)' The harmonic frequency retained'
       EIT(2)=w0
       EIT(1)=w0
       EPHA(I)=w0
       GOTO 8
      ENDIF
      IF(ABS(AI2-AI1).LT.0.0000001d0)THEN
       WRITE(3,*)'Division by zero'
       GOTO 6
      ENDIF
      EN3=EN2+(EN2-EN1)*(ALIMIT-AI2)/(AI2-AI1)
      IT1=IT1+1
      IF(IT1.GT.100)THEN
       WRITE(6,*)' Stable state has not been found after 100 iterations'
       WRITE(3,*)' Stable state has not been found after 100 iterations'
       WRITE(3,*)' The harmonic frequency retained'
       WRITE(6,*)' The harmonic frequency retained'
       EIT(2)=w0
       EIT(1)=w0
       EPHA(I)=w0
       GOTO 8
      ENDIF
      IF(ABS(EN3-EN2).LT.DLIMIT)GOTO 6
      EN1=EN2
      EN2=EN3
      GOTO 7
6     EIT(NI+1)=EN3
      EIT(2)=EIT(2)-EIT(1)
      EIT(1)=EIT(1)*2.0d0
      EPHA(I)=EIT(2)
8     CONTINUE
      WRITE(6,3001)I,E(I)*CM,A*CM,B*CM,C*CM,D*CM,EIT(1)*CM,EIT(2)*CM
5     WRITE(3,3001)I,E(I)*CM,A*CM,B*CM,C*CM,D*CM,EIT(1)*CM,EIT(2)*CM
3001  FORMAT(I3,7F8.1)
      call w36('Phase-ok')
      call w36(' ')
      RETURN
      END
