      subroutine proder(avq,avq2,N7)
      implicit none
      integer*4 N7,N,nprop,j,idumm,nprop0,ip,k,IQ,JQ,is,N71,N72
      include 'dimensions.h'
      parameter (nprop0=NT0*NT0)
      character*20 labprop(nprop0)
      logical lex,lex2,lprop
      character*80 st,st2,s80
      real*8 prop(nprop0),avq(*),avq2(NT3,NT3),xp,yp
      real*8,allocatable:: propq2(:,:),propq(:,:)
c     propq2(nprop0,NT3**2),propq(nprop0,NT3*2)

      call w36(' ')
      call w36('Proder')
      call w36('^^^^^^')

      inquire(file='PROP.TXT.SCR',exist=lex)
      inquire(file='PROP2.TXT.SCR',exist=lex2)
      if(lex)then
       open(9,file='PROP.TXT.SCR')
       if(lex2)open(91,file='PROP2.TXT.SCR')
       read(9,*)N71,N
       if(N71.gt.N7)call report('N71>N7')
       if(N.gt.NT3)call report('N exceeded in proder')
       if(lex2)then
        read(91,*)N72,N
        if(N72.gt.N7)call report('N72>N7')
       endif
24     read(9,*,end=9999,err=9999)lprop
       if(lex2)read(91,*)
       read(9,9003)st
       if(lex2)read(91,9003)st2
       if(lex2.and.st.ne.st2)call report('error in property file')
9003   format(a80)
       read(9,*)nprop
       if(lex2)read(91,*)nprop
       if(nprop.gt.nprop0)call report('too many properties')
       allocate(propq(1:nprop,1:N**2),stat=is)
       if(is.ne.0)call report('cannot allocate propq')
       allocate(propq2(1:nprop,1:N**2),stat=is)
       if(is.ne.0)call report('cannot allocate propq2')

c      equilibrium property:
       do 25 ip=1,nprop
       read(9,9003)s80
       if(lex2)read(91,*)
       labprop(ip)=s80(1:20)
25     read(s80(21:80),*)prop(ip)
c
c      property derivatives:
       do 26 ip=1,nprop
       do 261 j=N71,N
       read(9,9003)s80
261    read(s80(21:80),*)idumm,propq(ip,j),propq(ip,N+j)
       if(lex2)then
        do 262 j=N72,N
        do 262 k=j,N
        read(91,9003)s80
        read(s80(21:80),*)idumm,idumm,xp,yp
c       symmetrize d^2/dij and d^2/dji:
        propq2(ip,k+N*(j-1))=(xp+yp)/2.0d0
262     propq2(ip,j+N*(k-1))=(xp+yp)/2.0d0
       endif
26     continue
c
       if(lprop)then
        call w36(st)
        call w36('Equilibrium:')
        do 29 ip=1,nprop
        write(3,3009)labprop(ip),prop(ip)
29      write(6,3009)labprop(ip),prop(ip)
        call w36('Average <Q>:')
        do 27 ip=1,nprop
        do 28 IQ=N7,N
28      prop(ip)=prop(ip)+propq(ip,IQ)*avq(IQ)
        write(6,3009)labprop(ip),prop(ip)
27      write(3,3009)labprop(ip),prop(ip)
        call w36('Average <Qii>:')
        do 30 ip=1,nprop
        do 31 IQ=N7,N
31      prop(ip)=prop(ip)+propq(ip,N+IQ)*avq2(IQ,IQ)
        write(6,3009)labprop(ip),prop(ip)
30      write(3,3009)labprop(ip),prop(ip)
3009    format(a20,' ',g15.5)
        if(lex2)then
         call w36('Average <Qij>:')
         do 35 ip=1,nprop
         do 34 IQ=N7,N
c        subtract the incomplete second derivatives first:
         prop(ip)=prop(ip)-propq(ip,N+IQ)*avq2(IQ,IQ)
         do 34 JQ=N7,N
c        add all of them:
34       prop(ip)=prop(ip)+propq2(ip,IQ+N*(JQ-1))*avq2(IQ,JQ)
         write(6,3009)labprop(ip),prop(ip)
35       write(3,3009)labprop(ip),prop(ip)
        endif
       endif

       goto 24
9999   if(lex)close(9)
       if(lex2)close(91)
       deallocate(propq)
       deallocate(propq2)
      endif
      return
      end
