      SUBROUTINE READARCP2K(IC,N0,N,F,P,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,optrot,ajm,sigma,loptrot,
     2lnmr,ljj,lff,lpolar,ldip,x,iz)
c
c     read force field and other properties from CP2K output
c
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      include 'dimensions.h'
      DIMENSION F(N0,N),P(NT0,3,3),ALPHA(3,3,NT3),
     1AAT(NT0,3,3),dip(3),polar(3,3),GG(3,3,NT3),AA(3,3,3,NT3),
     1gten(3,3),aten(3,3,3),sigma(*),ajm(NT0,NT0),zmass(NT0),
     1x(NT0,3),iz(NT0),kind(NT0)
      CHARACTER*80 st
      CHARACTER*10 s10
      LOGICAL lapt,laat,lttt,lfc,lx,lten,lfcd,
     1lpolar,ljj,lnmr,loptrot,lff,ldip,
     1l,lmass
c
      ldip=.false.
      ljj=.false.
      lff=.false.
      lnmr=.false.
      loptrot=.false.
      lpolar=.false.
      lmass=.false.
      NAT=N/3
C
      write(s10,10)IC
10    format(I10)
      do 1 istart=1,len(s10)
1     if(s10(istart:istart).ne.' ')goto 2
2     continue

      istart=8
      if(s10(8:8).eq.' ')s10(8:8)='0'
      if(s10(9:9).eq.' ')s10(9:9)='0'

      inquire( file='CP2K/'//s10(istart:len(s10))//'/c.out',exist=l)

      if(l)then
       open(88,file='CP2K/'//s10(istart:len(s10))//'/c.out')
3      read(88,400,end=499,err=499)st
c      write(6,400)st
400    format(a80)

       if(st(1:38).eq.' VIB| Hessian in cartesian coordinates')then
        if(.not.lmass)call report('Masses not found')
        n1=1
102     n2=min(n1+4,n)
        read(88,*)
        read(88,*)
        do 7 i=1,n
7       read(88,2222)(F(i,j),j=n1,n2)
2222    format(12x,5f13.6)
        if(n2.lt.n)then
         n1=min(n1+5,n)
         goto 102
        endif
        do 8 i=1,n
        do 8 j=1,n
8       F(i,j)=F(i,j)*dsqrt(zmass((i+2)/3)*zmass((j+2)/3))/548.58d0
        open(21,file='CP2K/'//s10(istart:len(s10))//'/FILE.FC')
        CALL WRITEFF(NT3,N,F)
        close(21)

        lff=.true.
        if(.not.lfc)then
         lfc=.true.
         if(.not.lfcd)then
          open(21,file='FILE.FC')
          CALL WRITEFF(NT3,N,F)
          close(21)
          call w36(' Force field written into FILE.FC')
         else
          call w36(' FILE.FC left on disk unchanged')
         endif
        endif

        close(88)
        return

       endif

       if(st(1:21).eq.'  Atom  Kind  Element')then
        read(88,400)st

        do 9 i=1,nat
        read(88,400)st
        read(st(19:21),*)kind(i)
        read(st(22:33),*)x(i,1)
        read(st(34:45),*)x(i,2)
        read(st(46:57),*)x(i,3)
9       read(st(68:80),*)zmass(i)

        lmass=.true.
        open(89,file='CP2K/'//s10(istart:len(s10))//'/FILE.X')
        write(89,*)'CP2K'
        write(89,*)nat
        do 90 i=1,nat
90      write(89,890)kind(i),(x(i,k),k=1,3)
890     format(i3,3f12.6,' 0 0 0 0 0 0 0 0.0')
        close(89)
        lmass=.true.
       endif

       goto 3

      else
       call report('CP2K/'//s10(istart:len(s10))//'/c.out not found')
      endif

499   write(6,*)'CP2K/'//s10(istart:len(s10))//'/c.out'
      call report('Incomplete CP2K')
      end
