      SUBROUTINE READG9836(NAT,LINEAR,N,FCAR0,AM,N7,R,XLIM,YLIM,step)
c     as readg98, but reads all two-atomic quartic constants from FILE.36.OUT
      IMPLICIT none
      integer*4 i,j,k,N,nat,N7,l,ia,n33,n33t,ka,is
      include 'dimensions.h'
      integer*4 iz(NT0),ig98,ia98dumm,nstep,ltot,II,ic,ix,
     1n44,n44t
      CHARACTER*50 S50
      CHARACTER*2 atsym
c
c     N^3 strings:
      real*8,allocatable:: CX3(:,:,:),CX4(:),ajmq(:,:,:),C36(:)
c     real*8 CX3(NT3,NT3,NT3),CX4(max(NT0*81*NT0*NT0,162*NT0**2)),
c    1ajmq(2*NT3,NT0,NT0)
      real*8,allocatable:: G(:)

c     rest:
      real*8 FCAR0(NT3,NT3),FCAR(NT3,NT3),
     2AM(NT3),R(NT0,3),APT(NT0,3,3),
     1AAT(NT0,3,3),ALPHA(3,3,NT3),APT0(NT0,3,3),aptn(NT0,3,3),
     1AAT0(NT0,3,3),ALPHA0(3,3,NT3),dip(3),dip0(3),polar(3,3),
     1polar0(3,3),alphan(NT0,3,3,3),GG(3,3,NT3),GG0(3,3,NT3),
     1AATA(NT3,NT0,3,3),ALPHAA(NT3,3,3,NT3),APTA(NT3,NT0,3,3),
     1gten(3,3),aten(3,3,3),gten0(3,3),aten0(3,3,3),amave,
     1sigma(2*NT0),sigma0(NT0),ajm(NT0,NT0),ajm0(NT0,NT0),
     1sigmaq(2*NT3,NT0),optrot,optrotq(NT3*2),
     1AA(3,3,3,NT3),AA0(3,3,3,NT3),bohr,ass,step,optrot0,ff,f1,f2,
     1ylim,xlim
      integer*4 i1,i2,i3,i4,i5,i6,i7,i8,ist,jst,ja,jx,jy,kx,ky,iy,
     1id,jd,lx,la
      LOGICAL lex,lttt,lfc,lx0,lff,lcmx,lxf,
     1LINEAR,OPT,lapt,laat,lten,lfcd,lnmr,ljj,loptrot,lgr
      logical lzmat,lharm,lopt,lpolar,l411
      common/lop/lopt(300)
      equivalence (lharm,lopt(9)),(lzmat,lopt(10)),(lcmx,lopt(33)),
     1(l411,lopt(35))
      character*7 round(2)
      character*1 xyz(3)
      data round/'forward','   back'/
      data xyz/'x','y','z'/
C
      call w36(' ')
      call w36('readg9836')
      call w36('^^^^^^')

      bohr=0.529177d0
C
      inquire(file='FILE.TEN',exist=lten)
      inquire(file='FILE.FC',exist=lfcd)
      inquire(file='FILE.X',exist=lxf)
      INQUIRE(FILE='FILE.36.OUT',EXIST=OPT)
      IF(.NOT.OPT)then
       CALL w36('FILE.36.OUT not found, trying disk only')
       if(.not.lxf)call report('FILE.X not found')
       if(.not.lfcd)call report('FILE.FC not found')
       call readdisk(NAT,FCAR0,AM,R,iz,LINEAR,N,N7)
       return
      endif
C
      OPEN(2,FILE='FILE.36.OUT')
C
c     find geometry
      write(6,*)' Looking for geometry'
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    (lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       write(6,1111)S50
       write(3,1111)S50
c      rescue mode, read z-matrix geometry after charge:
       if(lcmx.and.s50(2:7).eq.'Charge'.and.s50(14:18).eq.'Multi')then
        l=0
1555    l=l+1
        read(2,*,end=1556,err=1556)iz(l),(r(l,i),i=1,3)
        if(l.gt.NT0)call report('Too many atoms')
        goto 1555
1556    nat=l-1
        goto 1557
       endif

       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       DO 41 I=1,4
41     READ(2,*)
       l=0
5      READ(2,1111)s50
       IF(s50(2:4).NE.'---')THEN
        l=l+1
        BACKSPACE 2
        if(ig98.eq.0)then
         READ(2,*)IA,iz(l),(r(l,i),i=1,3)
        else
         READ(2,*)IA,iz(l),IA98DUMM,(r(l,i),i=1,3)
        endif
        GOTO 5
       ENDIF
       nat=l
1557   write(3,*)nat
       open(20,file='FILE.X')
       write(20,*)nat
       write(20,*)nat
       do 34 l=1,nat
       write(20,4100)iz(l),(r(l,i),i=1,3)
34     write(3,4100)iz(l),(r(l,i),i=1,3)
4100   format(I3,3F15.10)
       close(20)
       goto 203
      ENDIF
      goto 201
202   call report('Geometry not found')
203   do 55 ia=1,nat
      atsym='??'
      ASS=amave(iz(IA),atsym)
c
c     assign default mass, if not defined previously:
      if(am(3*(IA-1)+1).lt.0.0d0)then
       DO 551 I=1,3
551    AM(3*IA-3+I)=ASS
      endif
55    continue
      write(6,*)nat,' atoms'
      write(3,*)nat,' atoms'
c
      WRITE(3,1113)(AM(i),i=1,3*nat)
1113  FORMAT(4F15.8)
      IF(NAT.EQ.2.OR.LINEAR)THEN
       WRITE(3,*)'Linear molecule'
       N7=6
       LINEAR=.TRUE.
      ENDIF
      N=3*NAT
      allocate(G(N))
C
      IF(step.gt.1.0d-9)then
       write(3,3000)step,step/bohr
       write(6,3000)step,step/bohr
       step=step/bohr
3000   format('Step defined as ',F10.5,'A (',F10.5,'au)')
      endif
C
      NSTEP=1+N+N
      write(3,*)nstep,' harmonic force fields expected'
      write(6,*)nstep,' harmonic force fields expected'
c
c     read-in zero point:
      lapt=.false.
      laat=.false.
      lttt=.false.
      lx0=.false.
      lfc=.false.
      ltot=0
      call readar0(NT3,N,FCAR0,APT0,AAT0,ALPHA0,dip0,polar0,GG0,AA0,
     1gten0,aten0,optrot0,ajm0,sigma0)
      call readar(NT3,N,FCAR0,APT0,AAT0,ALPHA0,lapt,laat,lttt,lfc,lx0,
     1lten,lfcd,dip0,ltot,polar0,GG0,AA0,gten0,aten0,
     1optrot0,ajm0,sigma0,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      write(6,*)'zero point finished'
      write(3,*)'zero point finished'
      write(3,3700)(dip0(i),i=1,3)
      write(6,3700)(dip0(i),i=1,3)
3700  format(' Dipole         ',3F10.4)
      open(22,file='DIPOLE.TXT.SCR')
      write(22,3699)(dip0(i),i=1,3)
3699  format(3F15.7,' dipole (au)')
      write(22,3698)optrot0
3698  format(F15.7,' optrot')
      write(22,3697)
3697  format('Chemical shifts (ppm):')
      do 558 i=1,nat
558   write(22,3696)i,sigma0(i)
3696  format(i5,F15.7)
      write(22,3695)
3695  format('Spin spin coupling:')
      do 559 i=1,nat
      do 559 j=1,nat
559   write(22,3694)i,j,ajm0(i,j)
3694  format(2i5,F15.7)
      close(22)
      write(3,3701)((polar0(i,j),i=1,3),j=1,3)
      write(6,3701)((polar0(i,j),i=1,3),j=1,3)
3701  format(' Polarizability ',3F10.4,/,
     1       '                ',3F10.4,/,
     1       '                ',3F10.4)
c
c     load only harmonic ff if requested:
      if(lharm)then
       close(2)
       write(6,*)'lharm option called'
       write(3,*)'lharm option called'
       return
      endif
c
      inquire(file='SCR.33',exist=lex)
      if(lex)then
       call w36('SCR.33 found, G.OUT will not be read further')
       close(2)
       return
      endif
c
      is=0
      allocate(CX3(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX3 in readg98s6')
      allocate(CX4(1:81*NAT**3),stat=is)
      if(is.ne.0)call report('cannot allocate CX4 in readg98s6')
      allocate(C36(1:162*NAT**2),stat=is)
      if(is.ne.0)call report('cannot allocate C36 in readg98s6')
      allocate(ajmq(2*N,NAT,NAT),stat=is)
      if(is.ne.0)call report('cannot allocate ajmq in readg98s6')

      DO 54 I=1,N
      DO 54 J=1,N
      DO 54 K=1,N
54    CX3(I,J,K)=0.0d0
      DO 56 I=1,NAT*NAT*NAT*81
56    CX4(I)=0.0d0
      DO 58 I=1,162*NAT**2
58    C36(I)=0.0d0
c
      if(ljj.or.lnmr.or.loptrot)then
c      first derivatives 1..N as well as diagonal second derivatives 1..N:
       DO 560 II=1,N
       optrotq(II)=0.0d0
       optrotq(N+II)=-2.0d0*optrot0
       DO 560 I=1,NAT
       sigmaq(II,I)=0.0d0
       sigmaq(N+II,I)=-2.0d0*sigma0(I)
       DO 560 J=1,NAT
       ajmq(N+II,I,J)=-2.0d0*ajm0(I,J)
560    ajmq(II,I,J)=0.0d0
      endif
c
      if(lapt.or.laat)then
       DO 541 II=1,N
       DO 541 I=1,NAT
       DO 541 J=1,3
       DO 541 K=1,3
       AATA(II,I,J,K)=0.0d0
541    APTA(II,I,J,K)=0.0d0
      endif
c
      if(lttt)then
       DO 542 II=1,N
       DO 542 I=1,N
       DO 542 J=1,3
       DO 542 K=1,3
542    alphaa(II,J,K,I)=0.0d0
      endif
      do 547 i=1,nat
      do 547 j=1,3
      do 547 k=1,3
547   aptn(i,j,k)=0.0d0
      do 552 i=1,nat
      do 552 j=1,3
      do 552 k=1,3
      do 552 l=1,3
552   alphan(i,j,k,l)=0.0d0
c
      ia=1
      ix=1
      jx=1
      ist=0
      jst=1
c     loop over displaced geometries:
      do 3333 IC=1,36*nat
      ist=ist+1
      if(ist.gt.2)then
       ist=1
       jst=jst+1
       if(jst.gt.2)then
        jst=1
        ix=ix+1
        if(ix.gt.3)then
         ix=1
         jx=jx+1
         if(jx.gt.3)then
          jx=1
          ia=ia+1
         endif
        endif
       endif
      endif
      write(6,3016)IC,ia,xyz(ix),round(ist),xyz(jx),round(jst)
      write(3,3016)IC,ia,xyz(ix),round(ist),xyz(jx),round(jst)
3016  format(' expected: ',i5,1h:,' atom',i5,2(', ',a1,' ',a7))

      I=3*(ia-1)+ix
c
c     read geometry and check the diff. step:
      call chkgeo2(r,NT0,nat,lzmat,step,id,jd,ff)
      write(6,*)
c     initialize archive reading:
      call readar0(NT3,N,FCAR,APT,AAT,ALPHA,dip,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma)
c     read gaussian archive:
      call readar(NT3,N,FCAR,APT,AAT,ALPHA,lapt,laat,lttt,lfc,lx0,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      write(3,3700)(dip(j),j=1,3)
      write(3,3701)((polar(k,j),k=1,3),j=1,3)
      if(lnmr)call w36('NMR shifts found')
c
      if(jx.eq.ix.and.jst.eq.ist)then
       ff=1.0d0-dble(2*(ist-1))
       DO 3 J=1,N
       DO 3 K=1,N
3      CX3(I,J,K)=CX3(I,J,K)+FCAR(J,K)*ff
       do 548 j=1,3
548    aptn(ia,ix,j)=aptn(ia,ix,j)+ff*dip(j)
       do 553 j=1,3
       do 553 k=1,3
553    alphan(ia,ix,j,k)=alphan(ia,ix,j,k)+ff*polar(j,k)
       if(lapt.or.laat)then
        DO 543 II=1,NAT
        DO 543 J=1,3
        DO 543 K=1,3
        AATA(I,II,J,K)=AATA(I,II,J,K)+AAT(II,J,K)*ff
543     APTA(I,II,J,K)=APTA(I,II,J,K)+APT(II,J,K)*ff
       endif
       if(ljj.or.lnmr.or.loptrot)then
        optrotq(I)=optrotq(I)+optrot*ff
        optrotq(N+I)=optrotq(N+I)+optrot
        DO 556 II=1,NAT
        sigmaq(I,II)=sigmaq(I,II)+sigma(II)*ff
        sigmaq(N+I,II)=sigmaq(N+I,II)+sigma(II)
        DO 556 J=1,NAT
        ajmq(I+N,II,J)=ajmq(I+N,II,J)+ajm(II,J)
556     ajmq(I,II,J)=ajmq(I,II,J)+ajm(II,J)*ff
       endif
       if(lttt)then
        DO 544 II=1,N
        DO 544 J=1,3
        DO 544 K=1,3
544     alphaa(I,J,K,II)=alphaa(I,J,K,II)+alpha(J,K,II)*ff
       endif
      endif

      if(ist.ne.jst)then
       ff=-1.0d0
      else
       ff=1.0d0
      endif
c          1xx1xx 1xx1xy ... 1zz1zz  2xxxx     ...... NatzzNatzz
c indices:   1      2          9                      Nat*Nat*81
c
c     tree-atom constants
      DO 4 J=1,3*nat
      DO 4 K=1,3*nat
      i1=nat*((9*ia+3*ix+jx-13)*nat*9+3*(J-1))+K
4     CX4(i1)=CX4(i1)+FCAR(J,K)*ff
c
c     two-atom constants
      II=((ia-1)*9+(ix-1)*3+jx-1)*nat*9
      DO 42 ja=1,nat
      DO 42 kx=1,3
      DO 42 ky=1,3
c     IIJJ:
      i1=II+(ja-1)*9+(kx-1)*3+ky
      C36(i1)=C36(i1)+FCAR(3*(ja-1)+kx,3*(ja-1)+ky)*ff
c     IIIJ:
      i1=81*nat**2+i1
42    C36(i1)=C36(i1)+FCAR(3*(ia-1)+kx,3*(ja-1)+ky)*ff

3333  continue
c
      close(2)
C
      if(step.lt.1.0d-9)call report('Diff. step too small!')
c
      f1=1.0d0/(2.0d0*STEP)**2
      DO 57 I=1,81*nat**3
57    CX4(I)=CX4(I)*f1
      DO 59 I=1,2*81*nat**2
59    C36(I)=C36(I)*f1

      f2=0.5d0/(2.0d0*STEP)
      DO 15 I=1,N
      DO 15 J=1,N
      DO 15 K=1,N
15    CX3(I,J,K)=CX3(I,J,K)*f2
c
      do 549 ia=1,nat
      do 549 ix=1,3
      do 549 j=1,3
549   aptn(ia,ix,j)=aptn(ia,ix,j)*f2

      do 554 ia=1,nat
      do 554 ix=1,3
      do 554 j=1,3
      do 554 k=1,3
554   alphan(ia,ix,j,k)=alphan(ia,ix,j,k)*f2
c
      write(3,*)' numeric apt         analytic apt'
      do 550 ia=1,nat
      do 550 ix=1,3
      do 550 j=1,3
550   write(3,3009)aptn(ia,ix,j),APT0(ia,ix,j)
3009  format(2F10.5)
c
      write(3,*)' numeric PolDer         analytic PolDer'
      do 555 ia=1,nat
      do 555 ix=1,3
      do 555 j=1,3
      do 555 k=1,3
555   write(3,3010)ia,ix,j,k,alphan(ia,ix,j,k),
     1ALPHA0(j,k,3*(ia-1)+ix)
3010  format(i4,3i2,2F10.5)
c
      if(lttt)then
       DO 545 II=1,N
       DO 545 I=1,N
       DO 545 J=1,3
       DO 545 K=1,3
545    alphaa(I,J,K,II)=alphaa(I,J,K,II)*f2
       open(15,file='TTT.SCR',form='unformatted')
       write(15)((((alphaa(i,j,k,l),i=1,N),j=1,3),k=1,3),l=1,N)
       close(15)
      endif
c
      if(lapt.or.laat)then
       DO 546 II=1,NAT
       DO 546 I=1,N
       DO 546 J=1,3
       DO 546 K=1,3
       AATA(I,II,J,K)=AATA(I,II,J,K)*f2
546    APTA(I,II,J,K)=APTA(I,II,J,K)*f2
       open(15,file='TEN.SCR',form='unformatted')
       write(15)((((APTA(i,j,k,l),i=1,N),j=1,nat),k=1,3),l=1,3)
       write(15)((((AATA(i,j,k,l),i=1,N),j=1,nat),k=1,3),l=1,3)
       close(15)
      endif
c
      if(ljj.or.lnmr.or.loptrot)then
       DO 557 I=1,N
       optrotq(N+I)=optrotq(N+I)*f1
       optrotq(I)=optrotq(I)*f2
       DO 557 II=1,NAT
       sigmaq(N+I,II)=sigmaq(N+I,II)*f1
       sigmaq(I,II)=sigmaq(I,II)*f2
       DO 557 J=1,NAT
       ajmq(N+I,II,J)=ajmq(N+I,II,J)*f1
557    ajmq(I,II,J)=ajmq(I,II,J)*f2
       inquire(file='NMR.SCR.TXT',exist=lex)
       if(lex)then
        call w36('NMR.SCR.TXT found on disk, not overwritten')
       else
        write(6,7009)N,NAT
        write(3,7009)N,NAT
7009    format('N=',i4,', NAT=',i4)
        call wrnmr(optrot0,optrotq,sigma0,sigmaq,ajm0,ajmq,
     1NT3,NT0,N,nat,loptrot,lnmr,ljj)
       endif
      endif
c
      if(.not.lfc)then
       call report('Force fields not present, program finished.')
      endif
C
      N33=0
      N33T=0
      OPEN(4,FILE='SCR.33')
      DO 82 I=1,N
      DO 82 J=1,N
      DO 82 K=1,N
      N33T=N33T+1
      IF(ABS(CX3(I,J,K)).GE.YLIM)THEN
       N33=N33+1
       WRITE(4,4000)I,J,K,CX3(I,J,K)
4000   format(3i6,G16.8)
      ENDIF
82    CONTINUE
      CLOSE(4)
c
      WRITE(6,5961)YLIM,N33,100*N33/N33T,N33T
      WRITE(3,5961)YLIM,N33,100*N33/N33T,N33T
5961  FORMAT(/,' Selected Cartesian cubic constants in SCR.33',/,
     3' YLIM   :',F10.6,/,
     5' Number :',I10,'(',I3,'%), total ',I10)
c
c     i i j k
      do 841 ia=1,nat
      do 841 ix=1,3
      do 841 iy=1,3
      do 841 ja=1,nat
      do 841 jx=1,3
      do 841 ka=1,nat
      do 841 kx=1,3
      i1 =nat*((9*ia+3*ix+iy-13)*nat*9+3*(3*(ja-1)+jx-1))+3*(ka-1)+kx
      i2 =nat*((9*ia+3*ix+iy-13)*nat*9+3*(3*(ka-1)+kx-1))+3*(ja-1)+jx
      i3 =nat*((9*ia+3*iy+ix-13)*nat*9+3*(3*(ja-1)+jx-1))+3*(ka-1)+kx
      i4 =nat*((9*ia+3*iy+ix-13)*nat*9+3*(3*(ka-1)+kx-1))+3*(ja-1)+jx
      CX4(i1)=(CX4(i1)+CX4(i2)+CX4(i3)+CX4(i4))/4.0d0
      CX4(i2)=CX4(i1)
      CX4(i3)=CX4(i1)
841   CX4(i4)=CX4(i1)
c     i i j j
      do 842 ia=1,nat
      do 842 ix=1,3
      do 842 iy=1,3
      do 842 ja=1,nat
      do 842 jx=1,3
      do 842 kx=1,3
      i1 =nat*((9*ia+3*ix+iy-13)*nat*9+3*(3*(ja-1)+jx-1))+3*(ja-1)+kx
      i2 =nat*((9*ja+3*jx+kx-13)*nat*9+3*(3*(ia-1)+ix-1))+3*(ia-1)+iy
      CX4(i1)=(CX4(i1)+CX4(i2))/2.0d0
842   CX4(i2)=CX4(i1)
c     i i i k
      do 843 ia=1,nat
      do 843 ix=1,3
      do 843 iy=1,3
      do 843 jx=1,3
      do 843 ka=1,nat
      do 843 kx=1,3
      i1 =nat*((9*ia+3*ix+iy-13)*nat*9+3*(3*(ia-1)+jx-1))+3*(ka-1)+kx
      i2 =nat*((9*ia+3*ix+jx-13)*nat*9+3*(3*(ia-1)+iy-1))+3*(ka-1)+kx
      i3 =nat*((9*ia+3*iy+jx-13)*nat*9+3*(3*(ia-1)+ix-1))+3*(ka-1)+kx
      CX4(i1)=(CX4(i1)+CX4(i2)+CX4(i3))/3.0d0
      CX4(i2)=CX4(i1)
843   CX4(i3)=CX4(i1)
c     i i j i
      do 844 ia=1,nat
      do 844 ix=1,3
      do 844 iy=1,3
      do 844 jx=1,3
      do 844 ja=1,nat
      do 844 kx=1,3
      i1 =nat*((9*ia+3*ix+iy-13)*nat*9+3*(3*(ja-1)+jx-1))+3*(ia-1)+kx
      i2 =nat*((9*ia+3*ix+kx-13)*nat*9+3*(3*(ja-1)+jx-1))+3*(ia-1)+iy
      i3 =nat*((9*ia+3*iy+kx-13)*nat*9+3*(3*(ja-1)+jx-1))+3*(ia-1)+ix
      CX4(i1)=(CX4(i1)+CX4(i2)+CX4(i3))/3.0d0
      CX4(i2)=CX4(i1)
844   CX4(i3)=CX4(i1)
      call w36(' ')
      call w36('CX4 (3-atom) were symmetrized')

      do 84 ia=1,nat
      do 84 ja=1,nat
      do 84 ix=1,3
      do 84 iy=1,3
      do 84 jx=1,3
      do 84 jy=1,3
      i1=((ia-1)*9+(ix-1)*3+iy-1)*nat*9+(ja-1)*9+(jx-1)*3+jy
      i2=((ia-1)*9+(iy-1)*3+ix-1)*nat*9+(ja-1)*9+(jx-1)*3+jy
      i3=((ia-1)*9+(ix-1)*3+iy-1)*nat*9+(ja-1)*9+(jy-1)*3+jx
      i4=((ia-1)*9+(iy-1)*3+ix-1)*nat*9+(ja-1)*9+(jy-1)*3+jx

      i5=((ja-1)*9+(jx-1)*3+jy-1)*nat*9+(ia-1)*9+(ix-1)*3+iy
      i6=((ja-1)*9+(jy-1)*3+jx-1)*nat*9+(ia-1)*9+(ix-1)*3+iy
      i7=((ja-1)*9+(jx-1)*3+jy-1)*nat*9+(ia-1)*9+(iy-1)*3+ix
      i8=((ja-1)*9+(jy-1)*3+jx-1)*nat*9+(ia-1)*9+(iy-1)*3+ix
      C36(i1 )=(C36(i1)+C36(i2)+C36(i3)+C36(i4)+
     1          C36(i5)+C36(i6)+C36(i7)+C36(i8))/8.0d0
      C36(i2)=C36(i1)
      C36(i3)=C36(i1)
      C36(i4)=C36(i1)
      C36(i5)=C36(i1)
      C36(i6)=C36(i1)
      C36(i7)=C36(i1)
84    C36(i8)=C36(i1)
      call w36('C36 (2-atom) were symmetrized')
c     IIIJ not symmetried to save space

      N44=0
      N44T=0
      OPEN(4,FILE='SCR.37')
      do 851 i=1,N
      ia=(i+2)/3
      ix=i-3*(ia-1)
      do 851 j=i,N
      ja=(j+2)/3
      jx=j-3*(ja-1)
      do 851 k=j,N
      ka=(k+2)/3
      kx=k-3*(ka-1)
      do 851 l=k,N
      la=(l+2)/3
      lx=l-3*(la-1)
      if(ia.eq.ja)then
       i1=nat*((9*ia+3*ix+jx-13)*nat*9+3*(k-1))+l
      else
       if(ia.eq.ka)then
        i1=nat*((9*ia+3*ix+kx-13)*nat*9+3*(j-1))+l
       else
        if(ia.eq.la)then
         i1=nat*((9*ia+3*ix+lx-13)*nat*9+3*(k-1))+j
        else
         if(ja.eq.ka)then
          i1=nat*((9*ja+3*jx+kx-13)*nat*9+3*(i-1))+l
          if(ia.eq.1.and.ix.eq.1.and.ja.eq.34.and.jx.eq.2.
     1    and.kx.eq.3.and.la.eq.34.and.lx.eq.3)then
          write(6,*)CX4(nat*((9*ja+3*jx+kx-13)*nat*9+3*(i-1))+l)
          write(6,*)CX4(nat*((9*ja+3*jx+kx-13)*nat*9+3*(l-1))+i)
          write(6,*)CX4(nat*((9*ja+3*kx+jx-13)*nat*9+3*(l-1))+i)
          write(6,*)CX4(nat*((9*ja+3*kx+jx-13)*nat*9+3*(i-1))+l)
          endif
         else
          if(ja.eq.la)then
           i1=nat*((9*ja+3*jx+lx-13)*nat*9+3*(i-1))+k
          else
           if(ka.eq.la)then
            i1=nat*((9*ka+3*kx+lx-13)*nat*9+3*(i-1))+j
           else
            goto 851
           endif
          endif
         endif
        endif
       endif
      endif
      N44T=N44T+1
      IF(DABS(CX4(i1)).GE.XLIM)THEN
       N44=N44+1
       WRITE(4,4142)i,j,k,l,CX4(i1)
4142   format(4i6,G16.8)
      ENDIF
851   CONTINUE
      close(4)

      WRITE(6,5962)XLIM,N44,100*N44/N44T,N44T
      WRITE(3,5962)XLIM,N44,100*N44/N44T,N44T
5962  FORMAT(/,' Selected Cartesian three-atom quartics in SCR.37',/,
     3' XLIM   :',F10.6,/,
     5' Number :',I10,'(',I3,'%), total ',I10)
c
      N44T=0
      N44=0
      OPEN(4,FILE='SCR.36')
      do 85 i=1,N
      ia=(i+2)/3
      ix=i-3*(ia-1)
      do 85 j=i,N
      ja=(j+2)/3
      jx=j-3*(ja-1)
      do 85 k=j,N
      ka=(k+2)/3
      kx=k-3*(ka-1)
      do 85 l=k,N
      la=(l+2)/3
      lx=l-3*(la-1)
      if(ia.eq.ja)then
c      =============================================================
c      II
       if(ka.eq.ia)then
c       III
        if(la.eq.ia)then
c        IIII
         i1=(9*ia+3*ix-13+jx)*nat*9+(ia-1)*9+(kx-1)*3+lx
        else
c        IIIL
         i1=81*nat**2+(9*ia+3*ix-13+jx)*nat*9+(la-1)*9+(kx-1)*3+lx
        endif
       else
c       IIK
        if(la.eq.ia)then
c        IIKI
         i1=81*nat**2+(9*ia+3*ix-13+jx)*nat*9+(ka-1)*9+(lx-1)*3+kx
        else
         if(la.eq.ka)then
c         IIKK
          i1=(9*ia+3*ix-13+jx)*nat*9+(ka-1)*9+(kx-1)*3+lx
         else
c         IIKL skip
          goto 85
         endif
        endif
       endif
      else
c      =============================================================
c      IJ
       if(ka.eq.ia)then
c       IJI
        if(la.eq.ia)then
c        IJII
         i1=81*nat**2+(9*ka+3*kx-13+lx)*nat*9+(ja-1)*9+(ix-1)*3+jx
        else
         if(la.eq.ja)then
c         IJIJ
          i1=(9*ia+3*ix-13+kx)*nat*9+(ja-1)*9+(jx-1)*3+lx
         else
c         IJIL skip
          goto 85
         endif
        endif
       else
        if(ka.eq.ja)then
c        IJJ
         if(la.eq.ia)then
c         IJJI
          i1=(9*ja+3*jx-13+kx)*nat*9+(ia-1)*9+(ix-1)*3+lx
         else
          if(la.eq.ja)then
c          IJJJ
           i1=81*nat**2+(9*ja+3*kx-13+lx)*nat*9+(ia-1)*9+(jx-1)*3+ix
          else
c          IJJL skip
           goto 85
          endif
         endif
        else
c        IJK - skip for all L
         goto 85
        endif
       endif
c      =============================================================
      endif
      N44T=N44T+1
      IF(DABS(C36(i1)).GE.XLIM)THEN
       N44=N44+1
       WRITE(4,4141)i,j,k,l,C36(i1)
4141   format(4i6,G16.8)
      ENDIF
85    CONTINUE
      close(4)

      WRITE(6,5963)XLIM,N44,100*N44/N44T,N44T
      WRITE(3,5963)XLIM,N44,100*N44/N44T,N44T
5963  FORMAT(/,' Selected Cartesian two-atom quartics in SCR.36',/,
     3' XLIM   :',F10.6,/,
     5' Number :',I10,'(',I3,'%), total ',I10)

      deallocate(CX3,CX4,ajmq,C36)
      RETURN
      END
