      SUBROUTINE setstate(ASL,SSP)
c
c     define vibrational states
c     iset= 0   based on LEXC and NQ1
c         = 1   estimate interaction with ground + fundamentals
c         = 2   DCT,cartesian
c         = 3   read only HAND.OPT
c
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      PARAMETER (
     1NQQ=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6,NGE0=24,
     1NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6 ,
     3NX4=NT3*((NT3*(NT3+1))/2))
      DIMENSION IYX(2,NGE0)
      CHARACTER*3 SSP(NGE0)
      INTEGER*4 STATE1(NT3),STATE2(NT3)
      LOGICAL L4,moreatoms
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      COMMON/CEM/E(NT3)
      common/iop/iopt(300)
      equivalence (NQ1,iopt(1)),(ic,iopt(2)),(ngh,iopt(3)),(ic,iset)
      COMMON/DIA1/NHBIG,IT(NM0),IS(NM0),IBIGSYM(NM0),
     1ICC(NM0,ME0),IN(NM0,ME0)
      COMMON/DIA2A/CiIJK(NT3,NT3,NT3)
      COMMON/DIA2B/CS(NXX),ICS(3,NXX),NCSP
      real*8 ropt,OH,DOH
      COMMON/opt/ropt(100)
      equivalence (OH,ropt(15)),(DOH,ropt(16)),(HLIM,ropt(22))
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40,lex
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      COMMON/RUNCON/LEXCL
      COMMON/VQA/CQ4(NT3,NT3,NT3)
      COMMON/VQB/DS(NX4),IDS(3,NX4),NDSP
      COMMON/MMM/VMM,NMM,NHAND
      CHARACTER*3 SSTR
      CHARACTER*80 SNH
      INTEGER*4 CHT(NGE0,NGE0)
      COMMON/SYMCOM/IY(NT3),CHT,IG,IGG,KG,ID(NGE0),SSTR
      INTEGER*4 GAMA(NGE0),GI(NGE0)
      COMMON/V4/CH(NX4),K4(NX4),L44(NX4),KP4(NX4),LPP4(NX4),
     1AH4L,NCO
      COMMON/ALLstate/istall(NT3,NM0)
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent
c
      call w36(' ')
      call w36('Setstate')
      call w36('^^^^^^^^')

      call statereport(N-N7+1)
c
      do 2 I=1,2
      do 2 II=1,NGE0
2     IYX(I,II)=0
22221 DO 337 I=1,N
      STATE1(I)=0
      istall(I,2)=0
      istall(I,1)=0
337   STATE2(I)=0
      DO 338 I=N7,N
      DO 339 II=N7,N
339   istall(II,I)=0
338   istall(I,I)=1
      S1_Ncent=0
      S1_Nexc=0
      S2_Ncent=0
      S2_Nexc=0
      NHBIG=0
c
      if(ic.eq.0)THEN
c     ***************
      write(3,6767)NQ1,LEXCL
      write(6,6767)NQ1,LEXCL
6767  format(' Constructing basis functions',/,
     1       ' Maximum number of excited centers ',I4,/,
     1       ' Maximum degree of excitations     ',I4)
C
C     Ground state defined:
      call rep2(STATE2)
c
c     place first excitation on some mode:
      DO 66 I1=N7,N
      STATE2(I1)=STATE2(I1)+1
      CALL REP2(STATE2)
C     HERE MONEXCITED ARE DEFINED
      IF(LEXCL.LT.2)GOTO 72
c
c     place second exc on some mode:
      DO 67 I2=I1,N
      STATE2(I2)=STATE2(I2)+1
c
c     how many modes are excited, don't take if >NQ1
      nme=0
      do 1002 i=n7,n
1002  if(STATE2(i).gt.0)nme=nme+1
      if(nme.gt.NQ1)goto 74
C     HERE DOUBLE EXCITED STATES ARE GENERATED
      CALL REP2(STATE2)
      IF(LEXCL.LT.3)GOTO 74
c
c     place third excitation on some mode:
      DO 68 I3=I2,N
      STATE2(I3)=STATE2(I3)+1
      nme=0
      do 1003 i=n7,n
1003  if(STATE2(i).gt.0)nme=nme+1
      if(nme.gt.NQ1)goto 76
C     HERE TRIPLE EXCITED STATES ARE GENERATED
      CALL REP2(STATE2)
      IF(LEXCL.LT.4)GOTO 76
c
      DO 69 I4=I3,N
      STATE2(I4)=STATE2(I4)+1
      nme=0
      do 1004 i=n7,n
1004  if(STATE2(i).gt.0)nme=nme+1
      if(nme.gt.NQ1)goto 78
C     HERE QUADRUPLE EXCITED STATES ARE GENERATED
      CALL REP2(STATE2)
      IF(LEXCL.LT.5)GOTO 78
c
c     place fifth excitation somewhere
      DO 70 I5=I4,N
      STATE2(I5)=STATE2(I5)+1
      nme=0
      do 1005 i=n7,n
1005  if(STATE2(i).gt.0)nme=nme+1
      if(nme.gt.NQ1)goto 70
C     HERE FIVE-TIMES EXCITED STATES ARE GENERATED
      CALL REP2(STATE2)
70    STATE2(I5)=STATE2(I5)-1
78    CONTINUE
69    STATE2(I4)=STATE2(I4)-1
76    CONTINUE
68    STATE2(I3)=STATE2(I3)-1
74    CONTINUE
67    STATE2(I2)=STATE2(I2)-1
72    CONTINUE
66    STATE2(I1)=STATE2(I1)-1
C
C     estimate interaction to ground state and fundamental vibrations
      ENDIF
c     ****
c
      IF(ic.eq.1)THEN
c     ***************
c
      write(3,6768)OH,HLIM,NQ1,LEXCL
      write(6,6768)OH,HLIM,NQ1,LEXCL
      HHLIM=HLIM/219470.0d0
6768  format(' Constructing basis functions',/,
     1       ' V-limit ',F10.6,/,
     1       ' H-limit ',F10.2,' cm-1',/,
     1       ' Maximum number of excited centers ',I4,/,
     1       ' Maximum degree of excitations     ',I4)
      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
      call vqqvcc
C
      IER=0
      NHBIG=0
      NHTOT=0
c
C     Ground state defined:
      NHBIG=NHBIG+1
      NHTOT=NHTOT+1
      IS(NHBIG)=0
      IT(NHBIG)=0
      DO 5011 J=1,LEXCL
      ICC(NHBIG,J)=0
5011  IN(NHBIG,J)=0
c
C     Monoexcited states defined:
      DO 51 IQ=N7,N
      NHBIG=NHBIG+1
      NHTOT=NHTOT+1
      IT(NHBIG)=1
      IS(NHBIG)=1
      ICC(NHBIG,1)=IQ
      IN(NHBIG,1)=1
51    CONTINUE
c
      DO 661 I1=N7,N
      istall(I1,2)=istall(I1,2)+1
      call addexcitation(I1,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent,ME0)
      E1=E(I1)
      write(6,6000)I1,N,NHBIG
6000  format(' Excitation ',I4,' of ',I4,';',I10,' states')
      IF(LEXCL.LT.2)GOTO 721
      DO 671 I2=I1,N
      if(HW)then
       write(SNH,*)I2
       call strim(SNH,ne1,ne2)
       do i=ne1,ne2
       write(6,6001,advance='no')SNH(i:i)
6001   format(1A1,$)
       enddo
       write(6,6001)':'
       write(SNH,*)NHBIG
       call strim(SNH,ne1,ne2)
       write(6,6001)(SNH(i:i),i=ne1,ne2)
       write(6,6001)' '
      endif
      istall(I2,2)=istall(I2,2)+1
      call addexcitation(I2,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent,ME0)
      nme=0
      do 1006 i=n7,n
1006  if(istall(i,2).gt.0)nme=nme+1
      if(nme.gt.NQ1)goto 7411
      if(HLIM.ne.0.0d0.and.E1+E(I2).gt.HHLIM)goto 7411
      E2=E1+E(I2)
      NHTOT=NHTOT+1
c     double excited state here
c     interaction to ground
c     quartic
      IF(LQD)THEN
       B=ABS(ssqh2(1,2)/E2)
c      write(6,*)I2,B,OH
       IVIB=0
       IF(B.GT.OH)THEN
        CALL REP3(istall,IVIB,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 741
       ENDIF
      ENDIF
c     kinetic
      IF(LH40)THEN
c      to ground
       B=ABS(sum42()/E2)
       IVIB=0
       IF(B.GT.OH)THEN
        CALL REP3(istall,IVIB,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 741
       ENDIF
      ENDIF
c     phase subst
      IF(NZF.NE.0)THEN
       IVIB=0
       B=ABS(sumse2(1,2)/E2)
       IF(B.GT.OH)THEN
        CALL REP3(istall,IVIB,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 741
       ENDIF
      ENDIF
c
c     interaction double to single excited
      DO 811 IQ=N7,N
c     cubic
      B=ABS(ssh2(IQ,2)/(E(IQ)-E2))
      IF(B.GT.OH)THEN
       CALL REP3(istall,IQ,IER)
       IF(IER.EQ.1)GOTO 22221
       GOTO 741
      ENDIF
811   continue
c
741   IF(LEXCL.LT.3)GOTO 7411
c
      DO 681 I3=I2,N
      istall(I3,2)=istall(I3,2)+1
      call addexcitation(I3,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent,ME0)
      nme=0
      do 1007 i=n7,n
1007  if(istall(i,2).gt.0)nme=nme+1
      if(nme.gt.NQ1)goto 7611
      if(HLIM.ne.0.0d0.and.E2+E(I3).gt.HHLIM)goto 7611
      NHTOT=NHTOT+1
      E3=E2+E(I3)
C     If off-diagonal quartics, then they interact with monoexcited
      IF(LQD)THEN
       DO 821 IQ=N7,N
       B=ABS(ssqh2(IQ,2)/(E(IQ)-E3))
       IF(B.GT.OH)THEN
        CALL REP3(istall,IQ,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 761
       ENDIF
821    continue
      ENDIF
C
C     If kinetic quartics, then they interact with monoexcited
      IF(LH40)THEN
       DO 103 IQ=N7,N
c      ?        (IQ,2)
       B=ABS(sum42()/(E(IQ)-E3))
       IF(B.GT.OH)THEN
        CALL REP3(istall,IQ,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 761
       ENDIF
103    continue
      ENDIF
c
C     If substituted frequencies, then they interact with monoexcited
      IF(NZF.NE.0)THEN
       DO 829 IQ=N7,N
       B=ABS(sumse2(IQ,2)/(E(IQ)-E3))
       IF(B.GT.OH)THEN
        CALL REP3(istall,IQ,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 761
       ENDIF
829    continue
      ENDIF
c
C     They interact with ground through cubics:
      B=ABS(ssh2(1,2)/E3)
      IF(B.GT.OH)THEN
       CALL REP3(istall,IVIB,IER)
       IF(IER.EQ.1)GOTO 22221
       GOTO 761
      ENDIF
C
761   IF(LEXCL.LT.4)GOTO 7611
c
      DO 691 I4=I3,N
      istall(I4,2)=istall(I4,2)+1
      call addexcitation(I4,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent,ME0)
      nme=0
      do 1008 i=n7,n
1008  if(istall(i,2).gt.0)nme=nme+1
      if(nme.gt.NQ1)goto 7811
      if(HLIM.ne.0.0d0.and.E3+E(I4).gt.HHLIM)goto 7811
      NHTOT=NHTOT+1
      E4=E3+E(I4)
C     HERE QUADRUPLE EXCITED STATES ARE GENERATED
C
C     If off-diagonal quartics, then they interact with ground:
      IF(LQD)THEN
       IVIB=0
       B=ABS(ssqh2(1,2)/E4)
       IF(B.GT.OH)THEN
        CALL REP3(istall,IVIB,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 781
       ENDIF
      ENDIF
C
C     If kinetic quartics, then they interact with ground:
      IF(LH40)THEN
       IVIB=0
c                  (1,2)
       B=ABS(sum42()/E4)
       IF(B.GT.OH)THEN
        CALL REP3(istall,IVIB,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 781
       ENDIF
      ENDIF
C
C     They interact with monoexcited through cubics:
      DO 831 IQ=N7,N
      B=ABS(ssh2(IQ,2)/(E(IQ)-E4))
      IF(B.GT.OH)THEN
       CALL REP3(istall,IQ,IER)
       IF(IER.EQ.1)GOTO 22221
       GOTO 781
      ENDIF
831   continue
C
781   IF(LEXCL.LT.5)GOTO 7811
c
      DO 701 I5=I4,N
      istall(I5,2)=istall(I5,2)+1
      call addexcitation(I5,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent,ME0)
      nme=0
      do 1009 i=n7,n
1009  if(istall(i,2).gt.0)nme=nme+1
      if(nme.gt.NQ1)goto 801
      if(HLIM.ne.0.0d0.and.E4+E(I5).gt.HHLIM)goto 801
      NHTOT=NHTOT+1
      E5=E4+E(I5)
C     If off-diagonal quartics, then they interact with monoexcited
      IF(LQD)THEN
       DO 841 IQ=N7,N
       B=ABS(ssqh2(IQ,2)/(E(IQ)-E5))
       IF(B.GT.OH)THEN
        CALL REP3(istall,IQ,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 801
       ENDIF
841    continue
      ENDIF
C
C     If kinetic quartics, then they interact with monoexcited
      IF(LH40)THEN
       DO 1041 IQ=N7,N
c      B=ABS(sum42(IQ,2)/(E(IQ)-E5))
       B=ABS(sum42()/(E(IQ)-E5))
       IF(B.GT.OH)THEN
        CALL REP3(istall,IQ,IER)
        IF(IER.EQ.1)GOTO 22221
        GOTO 801
       ENDIF
1041   continue
      ENDIF
C
801   CONTINUE
      call removeexcitation(I5,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent)
701   istall(I5,2)=istall(I5,2)-1
7811  CONTINUE
      call removeexcitation(I4,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent)
691   istall(I4,2)=istall(I4,2)-1
7611  CONTINUE
      call removeexcitation(I3,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent)
681   istall(I3,2)=istall(I3,2)-1
7411  CONTINUE
      call removeexcitation(I2,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent)
671   istall(I2,2)=istall(I2,2)-1
721   CONTINUE
      call removeexcitation(I1,S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent)
661   istall(I1,2)=istall(I1,2)-1

      write(6,6004)NHTOT
      write(3,6004)NHTOT
6004  format(I12,' of states investigated')
C
      ENDIF
c     *****
c
      if(ic.eq.2)THEN
c     ***************
      write(3,*)'Plane wave basis'
      write(6,*)'Plane wave basis'
      write(3,6767)NQ1,LEXCL
      write(6,6767)NQ1,LEXCL
      write(3,*)'natoms ',ngh
      write(6,*)'natoms ',ngh
      N7=1
C
C     Ground state defined:
c
      if(LEXCL.gt.20)call report('LEXCL>20 not implemented')
c
      call rep4(STATE2)
c
      DO 9066 I1=1,N
      STATE2(I1)=STATE2(I1)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9066
      CALL rep4(STATE2)
      IF(LEXCL.LT.2)GOTO 9066
      DO 9067 I2=I1,N
      STATE2(I2)=STATE2(I2)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9067
      CALL rep4(STATE2)
      IF(LEXCL.LT.3)GOTO 9067
      DO 9068 I3=I2,N
      STATE2(I3)=STATE2(I3)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9068
      CALL rep4(STATE2)
      IF(LEXCL.LT.4)GOTO 9068
      DO 9069 I4=I3,N
      STATE2(I4)=STATE2(I4)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9069
      CALL rep4(STATE2)
      IF(LEXCL.LT.5)GOTO 9069
      DO 9071 I5=I4,N
      STATE2(I5)=STATE2(I5)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9071
      CALL rep4(STATE2)
      IF(LEXCL.LT.6)GOTO 9071
      DO 9072 I6=I5,N
      STATE2(I6)=STATE2(I6)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9072
      CALL rep4(STATE2)
      IF(LEXCL.LT.7)GOTO 9072
      DO 9073 I7=I6,N
      STATE2(I7)=STATE2(I7)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9073
      CALL rep4(STATE2)
      IF(LEXCL.LT.8)GOTO 9073
      DO 9074 I8=I7,N
      STATE2(I8)=STATE2(I8)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9074
      CALL rep4(STATE2)
      IF(LEXCL.LT.9)GOTO 9074
      DO 9075 I9=I8,N
      STATE2(I9)=STATE2(I9)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9075
      CALL rep4(STATE2)
      IF(LEXCL.LT.10)GOTO 9075
      DO 9076 I10=I9,N
      STATE2(I10)=STATE2(I10)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9076
      CALL rep4(STATE2)
      IF(LEXCL.LT.11)GOTO 9076
      DO 9077 I11=I10,N
      STATE2(I11)=STATE2(I11)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9077
      CALL rep4(STATE2)
      IF(LEXCL.LT.12)GOTO 9077
      DO 9078 I12=I11,N
      STATE2(I12)=STATE2(I12)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9078
      CALL rep4(STATE2)
      IF(LEXCL.LT.13)GOTO 9078
      DO 9079 I13=I12,N
      STATE2(I13)=STATE2(I13)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9079
      CALL rep4(STATE2)
      IF(LEXCL.LT.14)GOTO 9079
      DO 9080 I14=I13,N
      STATE2(I14)=STATE2(I14)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9080
      CALL rep4(STATE2)
      IF(LEXCL.LT.15)GOTO 9080
      DO 9081 I15=I14,N
      STATE2(I15)=STATE2(I15)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9081
      CALL rep4(STATE2)
      IF(LEXCL.LT.16)GOTO 9081
      DO 9082 I16=I15,N
      STATE2(I16)=STATE2(I16)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9082
      CALL rep4(STATE2)
      IF(LEXCL.LT.17)GOTO 9082
      DO 9083 I17=I16,N
      STATE2(I17)=STATE2(I17)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9083
      CALL rep4(STATE2)
      IF(LEXCL.LT.18)GOTO 9083
      DO 9084 I18=I17,N
      STATE2(I18)=STATE2(I18)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9084
      CALL rep4(STATE2)
      IF(LEXCL.LT.19)GOTO 9084
      DO 9085 I19=I18,N
      STATE2(I19)=STATE2(I19)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9085
      CALL rep4(STATE2)
      IF(LEXCL.LT.20)GOTO 9085
      DO 9086 I20=I19,N
      STATE2(I20)=STATE2(I20)+1
      IF(moreatoms(NQ1,ngh,STATE2,N))GOTO 9086
      CALL rep4(STATE2)
9086  STATE2(I20)=STATE2(I20)-1
9085  STATE2(I19)=STATE2(I19)-1
9084  STATE2(I18)=STATE2(I18)-1
9083  STATE2(I17)=STATE2(I17)-1
9082  STATE2(I16)=STATE2(I16)-1
9081  STATE2(I15)=STATE2(I15)-1
9080  STATE2(I14)=STATE2(I14)-1
9079  STATE2(I13)=STATE2(I13)-1
9078  STATE2(I12)=STATE2(I12)-1
9077  STATE2(I11)=STATE2(I11)-1
9076  STATE2(I10)=STATE2(I10)-1
9075  STATE2(I9 )=STATE2(I9 )-1
9074  STATE2(I8 )=STATE2(I8 )-1
9073  STATE2(I7 )=STATE2(I7 )-1
9072  STATE2(I6 )=STATE2(I6 )-1
9071  STATE2(I5 )=STATE2(I5 )-1
9069  STATE2(I4 )=STATE2(I4 )-1
9068  STATE2(I3 )=STATE2(I3 )-1
9067  STATE2(I2 )=STATE2(I2 )-1
9066  STATE2(I1 )=STATE2(I1 )-1
      ENDIF
c     ****
c
      if(ic.eq.3)THEN
c     ***************
      call vqqvcc
      WRITE(3,*)NHAND,' user defined states:'
      WRITE(6,*)NHAND,' user defined states:'
      OPEN(2,FILE='HAND.OPT')
      DO 891 I=1,NHAND
      READ(2,*)(STATE2(J),J=N7,N)
891   CALL REPHAND(STATE2)
      CLOSE(2)
      DO 901 J=N7,N
901   STATE2(J)=0
      ENDIF
c     ****
c
      WRITE(6,3013)NHBIG
      WRITE(3,3013)NHBIG
3013  FORMAT(I6,' states selected into the Hamiltonian')
c
      IF(NHAND.GT.0.and.ic.ne.3)THEN
       IQ=999
       WRITE(3,*)NHAND,' user defined states:'
       WRITE(6,*)NHAND,' user defined states:'
       OPEN(2,FILE='HAND.OPT')
       DO 89 I=1,NHAND
       READ(2,*)(STATE2(J),J=N7,N)
       B=99.9999d0
       CALL REP(STATE2,IQ,B,IER)
       IF(IER.EQ.1)CALL REPORT(' Error - state allready defined')
89     CONTINUE
       DO 90 J=N7,N
90     STATE2(J)=0
       WRITE(3,*)' Total of ',NHBIG,' states '
       WRITE(6,*)' Total of ',NHBIG,' states '
      ENDIF
C
      if(Iset.lt.2)then
      CALL  FINDSYM(NHBIG,IS,ICC,IN,IBIGSYM,IY,N,KG,
     1CHT,N7,NGE0,NT3,GAMA,GI,NM0,LEXCL)
      WRITE(3,*)' States to be ordered according to the symmetry'
      WRITE(6,*)' States to be ordered according to the symmetry'
      CALL SYMORDER(IYX,ISB,KG,SSP,LEXCL)
      else
      ISB=1
      IYX(1,1)=1
      IYX(2,1)=NHBIG
      endif
c
      WRITE(3,*)ISB,' symmetry blocks found'
      WRITE(6,*)ISB,' symmetry blocks found'
      DO 93 J=1,ISB
93    WRITE(3,*)J,' : ',IYX(1,J),' - ',IYX(2,J)
C
      WRITE(3,3005)N-N7+1,NHBIG
      WRITE(6,3005)N-N7+1,NHBIG
3005  FORMAT(I20,' FUNDAMENTALS',/,
     1       I20,' STATES IN THE HAMILTONIAN')
      CALL WS(ISB,IYX)
C
      call w36('Setstate-ok')
      RETURN
      END
c
      function moreatoms(NQ1,ngh,s,N)
      logical moreatoms
      integer*4 ngh,N,i,ia,s(N),nme,NQ1
      nme=0
      ia=0
      do 1 i=1,N/3
      i1=(i-1)*3+1
      i2=(i-1)*3+2
      i3=(i-1)*3+3
      if(s(i1).gt.0.or.s(i2).gt.0.or.s(i3).gt.0)ia=ia+1
      if(s(i1).gt.0)nme=nme+1
      if(s(i2).gt.0)nme=nme+1
      if(s(i3).gt.0)nme=nme+1
1     continue
      moreatoms=(ia.gt.ngh).or.(nme.gt.NQ1)
      return
      end

      subroutine statereport(N)
      implicit none
      integer*4 N,i
      include 'dimensions.h'
      real*8 NS(ME0+1),sum
      NS(1)=1.0d0
      do 1 i=1,ME0
1     NS(i+1)=NS(i)*dble(N+i-1)/dble(i)
      WRITE(3,4012)0,NS(1),NS(1)
4012  FORMAT(' Number of states excited',i3,'-times: ',2f20.0)
      sum=1.0d0
      do 2 i=1,ME0
      sum=sum+NS(i+1)
2     WRITE(3,3012)i,NS(i+1),sum
3012  FORMAT('                         ',i3,'-times: ',2g20.10)
      WRITE(3,5012)sum
5012  FORMAT('                           -------- ',/,
     1       '                             total: ',g20.10)
      return
      end

      subroutine strim(SNH,ne1,ne2)
      implicit none
      character*(*) SNH
      integer*4 ne1,ne2,len
      do 1 ne1=1,len(SNH)
1     if(SNH(ne1:ne1).ne.' ')goto 2
2     do 3 ne2=len(SNH),1,-1
3     if(SNH(ne2:ne2).ne.' ')return
      return
      end
