      SUBROUTINE setstatex2
c
c     define vibrational states in Cartesian basis
c     algorithm for unlimited excitation number
c
      implicit none
      integer*4 I,NHBIG,iex,Nexc,
     1iopt,icem2,ic,nh0
      include 'dimensions.h'
      INTEGER*4 STATE(6*NT0**2),NACT,ice2,LE2C
      real*8 cut1,ropt,eii2,bu2
      integer*4 IT(NM0),IS(NM0),ICC(NM0,ME0),
     1IBIGSYM(NM0),IN(NM0,ME0),si(ME0),ibe
      COMMON/DIA1/NHBIG,IT,IS,IBIGSYM,ICC,IN
      COMMON/opt/ropt(100)
      COMMON/iop/iopt(300)
      equivalence (cut1,ropt(4)),(icem2,iopt(10)),(LE2C,iopt(9))
      COMMON/lcbe2/eii2(6*NT0**2),bu2(6*NT0**2,2,2),NACT,
     1ibe(3,6*NT0**2)
      common/excc2/ice2(ME0),nh0
c
c     LE2C - maximal number of excitations
c     icem2 - maximal number of excited centers
      if(LE2C.gt.ME0)call report('Max number of excitation exceeded')
      write(6,6009)LE2C,cut1,icem2
      write(3,6009)LE2C,cut1,icem2
6009  format(' LE2C =',i3,', cut1 = ',f10.2,'A, icem2 =',i3)
      do 2 I=1,LE2C
2     write(3,6099)I,ice2(I)
6099  format(i3,'x exc. state resides up to',i4,' centers')
c
      call statereport(NACT)
c
      nh0=NHBIG

C     Ground state:
      DO  1965 I=1,NACT
1965  STATE(I)=0
      call repx2(STATE,NACT,icem2)
c
c     states Nexc excited
      do 3 Nexc=1,LE2C

c     distribute Nexc excitations upon N centers:
c     initial indices - all to the first center:
      do 41 iex=1,Nexc
41    si(iex)=1
5     DO  1966 I=1,NACT
1966  STATE(I)=0
      write(6,6000)(si(i),i=1,Nexc)
6000  format(20i3)
      do 4 iex=1,Nexc
4     state(si(iex))=state(si(iex))+1
      call repx2(STATE,NACT,icem2)
c
c     find index to be changed
      do 8 ic=Nexc,1,-1
8     if(si(ic).lt.NACT)goto 9
      goto 3
9     do 10 i=ic+1,Nexc
10    si(i)=si(ic)+1
      si(ic)=si(ic)+1
c
      goto 5
c
3     continue
C
      WRITE(6,3013)NHBIG-nh0
      WRITE(3,3013)NHBIG-nh0
3013  FORMAT(I6,' additional states selected')
      RETURN
      END
