      SUBROUTINE SETSYM(SSTR,IG,IGG,KG,ID,CHT,M0,N,N7,IY,SSP)                   
      IMPLICIT INTEGER*4 (I-N)                                                  
      IMPLICIT REAL*8 (A-H,O-Z)                                                 
      CHARACTER*3 SSTR,SSP(M0)                                                  
      CHARACTER*1 PRIME                                                         
      INTEGER*4 CHT                                                             
      LOGICAL OPT                                                               
      DIMENSION CHT(M0,M0),IY(N),ID(M0)                                         
      PRIME=CHAR(39)                                                            
      DO 1 I=1,M0                                                               
      ID(I)=1                                                                   
      SSP(I)='XXX'                                                              
      DO 1 J=1,M0                                                               
1     CHT(J,I)=1                                                                
      IG=0                                                                      
      IF(SSTR.EQ.'C1 ')THEN                                                     
       IG=1                                                                     
       IGG=1                                                                    
C      # of symmetry elements                                                   
       KG=1                                                                     
C      # of symmetries                                                          
C       1 A                                                                     
       SSP(1)='A  '                                                             
      ENDIF                                                                     
      IF(SSTR.EQ.'C2V')THEN                                                     
       IG=1                                                                     
       IGG=4                                                                    
C      # of symmetry elements                                                   
       KG=4                                                                     
C      # of symmetries                                                          
       CHT(2,3)=-1                                                              
       CHT(2,4)=-1                                                              
       CHT(3,2)=-1                                                              
       CHT(3,4)=-1                                                              
       CHT(4,2)=-1                                                              
       CHT(4,3)=-1                                                              
C       1 1 1 1 A1                                                              
C       1 1-1-1 A2                                                              
C       1-1 1-1 B1                                                              
C       1-1-1 1 B2                                                              
       SSP(1)='A1 '                                                             
       SSP(2)='A2 '                                                             
       SSP(3)='B1 '                                                             
       SSP(4)='B2 '                                                             
      ENDIF                                                                     
      IF(SSTR.EQ.'C2H')THEN                                                     
       IG=1                                                                     
       IGG=4                                                                    
C      # of symmetry elements                                                   
       KG=4                                                                     
C      # of symmetries                                                          
       CHT(2,2)=-1                                                              
       CHT(2,4)=-1                                                              
       CHT(3,3)=-1                                                              
       CHT(3,4)=-1                                                              
       CHT(4,2)=-1                                                              
       CHT(4,3)=-1                                                              
C       1 1 1 1 Ag                                                              
C       1-1 1-1 Bg                                                              
C       1 1-1-1 Au                                                              
C       1-1-1 1 Bu                                                              
       SSP(1)='Ag '                                                             
       SSP(2)='Bg '                                                             
       SSP(3)='Au '                                                             
       SSP(4)='Bu '                                                             
      ENDIF                                                                     
      IF(SSTR.EQ.'C2 ')THEN                                                     
       IG=1                                                                     
       IGG=2                                                                    
       KG=2                                                                     
       CHT(2,2)=-1                                                              
C       1 1 A                                                                   
C       1-1 B                                                                   
       SSP(1)='A  '                                                             
       SSP(2)='B  '                                                             
      ENDIF                                                                     
      IF(SSTR.EQ.'CS ')THEN                                                     
       IG=1                                                                     
       IGG=2                                                                    
C      # of symmetry elements                                                   
       KG=2                                                                     
C      # of symmetries                                                          
       CHT(2,2)=-1                                                              
C       1 1 A'                                                                  
C       1-1 A''                                                                 
       SSP(1)='AP '                                                             
       SSP(1)(2:2)=PRIME                                                        
       SSP(2)='APP'                                                             
       SSP(2)(2:2)=PRIME                                                        
       SSP(2)(3:3)=PRIME                                                        
      ENDIF                                                                     
      IF(SSTR.EQ.'D2H ')THEN                                                    
       IG=1                                                                     
       IGG=8                                                                    
       KG=8                                                                     
       CHT(2,3)=-1                                                              
       CHT(2,4)=-1                                                              
       CHT(2,7)=-1                                                              
       CHT(2,8)=-1                                                              
       CHT(3,2)=-1                                                              
       CHT(3,4)=-1                                                              
       CHT(3,6)=-1                                                              
       CHT(3,8)=-1                                                              
       CHT(4,2)=-1                                                              
       CHT(4,3)=-1                                                              
       CHT(4,6)=-1                                                              
       CHT(4,7)=-1                                                              
       CHT(5,5)=-1                                                              
       CHT(5,6)=-1                                                              
       CHT(5,7)=-1                                                              
       CHT(5,8)=-1                                                              
       CHT(6,3)=-1                                                              
       CHT(6,4)=-1                                                              
       CHT(6,5)=-1                                                              
       CHT(6,6)=-1                                                              
       CHT(7,2)=-1                                                              
       CHT(7,4)=-1                                                              
       CHT(7,5)=-1                                                              
       CHT(7,7)=-1                                                              
       CHT(8,2)=-1                                                              
       CHT(8,3)=-1                                                              
       CHT(8,5)=-1                                                              
       CHT(8,8)=-1                                                              
C      1 1 1 1 1 1 1 1 Ag   1                                                   
C      1 1-1-1 1 1-1-1 B1g  2                                                   
C      1-1 1-1 1-1 1-1 B2g  3                                                   
C      1-1-1 1 1-1-1 1 B3g  4                                                   
C      1 1 1 1-1-1-1-1 Au   5                                                   
C      1 1-1-1-1-1 1 1 B1u  6                                                   
C      1-1 1-1-1 1-1 1 B2u  7                                                   
C      1-1-1 1-1 1 1-1 B3u  8                                                   
       SSP(1)='Ag '                                                             
       SSP(2)='B1g'                                                             
       SSP(3)='B2g'                                                             
       SSP(4)='B3g'                                                             
       SSP(5)='Au '                                                             
       SSP(6)='B1u'                                                             
       SSP(7)='B2u'                                                             
       SSP(8)='B3u'                                                             
      ENDIF                                                                     
      IF(SSTR.EQ.'D6H ')THEN                                                    
       IG=1                                                                     
       IGG=24
       KG=12
       CHT( 2, 5)=-1
       CHT( 2, 6)=-1
       CHT( 2,11)=-1
       CHT( 2,12)=-1
       CHT( 3, 2)=-1
       CHT( 3, 4)=-1
       CHT( 3, 6)=-1
       CHT( 3, 8)=-1
       CHT( 3,10)=-1
       CHT( 3,12)=-1
       CHT( 4, 2)=-1
       CHT( 4, 4)=-1
       CHT( 4, 5)=-1
       CHT( 4, 8)=-1
       CHT( 4,10)=-1
       CHT( 4,11)=-1
       CHT( 5, 7)=-1
       CHT( 5, 8)=-1
       CHT( 5, 9)=-1
       CHT( 5,10)=-1
       CHT( 5,11)=-1
       CHT( 5,12)=-1
       CHT( 6, 5)=-1
       CHT( 6, 6)=-1
       CHT( 6, 7)=-1
       CHT( 6, 8)=-1
       CHT( 6, 9)=-1
       CHT( 6,10)=-1
       CHT( 7, 2)=-1
       CHT( 7, 4)=-1
       CHT( 7, 6)=-1
       CHT( 7, 7)=-1
       CHT( 7, 9)=-1
       CHT( 7,11)=-1
       CHT( 8, 2)=-1
       CHT( 8, 4)=-1
       CHT( 8, 5)=-1
       CHT( 8, 7)=-1
       CHT( 8, 9)=-1
       CHT( 8,12)=-1
       CHT( 9, 1)= 2
       CHT( 9, 3)=-1
       CHT( 9, 4)=-2
       CHT( 9, 5)= 0
       CHT( 9, 6)= 0
       CHT( 9, 7)= 2
       CHT( 9, 9)=-1
       CHT( 9,10)=-2
       CHT( 9,11)= 0
       CHT( 9,12)= 0
       CHT(10, 1)= 2
       CHT(10, 2)=-1
       CHT(10, 3)=-1
       CHT(10, 4)= 2
       CHT(10, 5)= 0
       CHT(10, 6)= 0
       CHT(10, 7)= 2
       CHT(10, 8)=-1
       CHT(10, 9)=-1
       CHT(10,10)= 2
       CHT(10,11)= 0
       CHT(10,12)= 0
       CHT(11, 1)= 2
       CHT(11, 3)=-1
       CHT(11, 4)=-2
       CHT(11, 5)= 0
       CHT(11, 6)= 0
       CHT(11, 7)=-2
       CHT(11, 8)=-1
       CHT(11,10)= 2
       CHT(11,11)= 0
       CHT(11,12)= 0
       CHT(12, 1)= 2
       CHT(12, 2)=-1
       CHT(12, 3)=-1
       CHT(12, 4)= 2
       CHT(12, 5)= 0
       CHT(12, 6)= 0
       CHT(12, 7)=-2
       CHT(12,10)=-2
       CHT(12,11)= 0
       CHT(12,12)= 0
C 1 A1g   1  1  1  1  1  1   1  1  1  1  1  1  
C 2 A2g   1  1  1  1 -1 -1   1  1  1  1 -1 -1  
C 3 B1g   1 -1  1 -1  1 -1   1 -1  1 -1  1 -1  
C 4 B2g   1 -1  1 -1 -1  1   1 -1  1 -1 -1  1  
C 5 A1u   1  1  1  1  1  1  -1 -1 -1 -1 -1 -1  
C 6 A2u   1  1  1  1 -1 -1  -1 -1 -1 -1  1  1  
C 7 B1u   1 -1  1 -1  1 -1  -1  1 -1  1 -1  1  
C 8 B2u   1 -1  1 -1 -1  1  -1  1 -1  1  1 -1  
C 9 E1g   2  1 -1 -2  0  0   2  1 -1 -2  0  0  
C10 E2g   2 -1 -1  2  0  0   2 -1 -1  2  0  0  
C11 E1u   2  1 -1 -2  0  0  -2 -1  1  2  0  0  
C12 E2u   2 -1 -1  2  0  0  -2  1  1 -2  0  0  
       SSP(1)='A1g'                                                             
       SSP(2)='A2g'                                                             
       SSP(3)='B1g'                                                             
       SSP(4)='B2g'                                                             
       SSP(5)='A1u'                                                             
       SSP(6)='A2u'                                                             
       SSP(7)='B1u'                                                             
       SSP(8)='B2u'                                                             
       SSP(9)='E1g'                                                             
       SSP(10)='E2g'
       SSP(11)='E1u'
       SSP(12)='E2u'
      ENDIF                                                                     
      IF(IG.EQ.0)CALL REPORT('Unknown point group selected')                    
      IF(SSTR.NE.'C1 ')THEN                                                     
       INQUIRE(FILE='SYM.OPT',EXIST=OPT)                                        
       IF(.NOT.OPT)CALL REPORT('File SYM.OPT not found.')                       
       OPEN(7,FILE='SYM.OPT')                                                   
       DO 2 I=N7,N                                                              
2      READ(7,*)IY(I)                                                           
       WRITE(3,*)' Normal mode symmetry defined from SYM.OPT'                   
       CLOSE(7)                                                                 
      ELSE                                                                      
       DO 3 I=N7,N                                                              
3      IY(I)=1                                                                  
      ENDIF                                                                     
      RETURN                                                                    
      END                                                                       
