      function ssqh2(is1,is2)
c
C       = (1/24) < state1 | SUMij  Diijk QiQiQjQk | state2>
c
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      INTEGER*4 icenter(NT3),state1(NT3),state2(NT3),S1,S2,PR,PRJK
      logical lorto
      LOGICAL L4
      COMMON/SUM/SUM,IDSTATE1(NT3),IDSTATE2(NT3),N7,N,L4
      common/vqq/diijk(NT3**3),diiij(NT3**2),diijj(NT3**2),diiii(NT3),
     1          aiijj,aiiii,siijj(NT3),siijk(NT3**2)
      COMMON/ALLstate/istall(NT3,NM0)
c
c     rewrite states into local variables,non-zero:
      nst=0
      lorto=.false.
      do 1 i=N7,N
      if(istall(i,is1).ne.0.or.istall(i,is2).ne.0)then
       nst=nst+1
       icenter(nst)=i
       state1(nst)=istall(i,is1)
       state2(nst)=istall(i,is2)
       if(state1(nst).ne.state2(nst))lorto=.true.
      endif
1     continue
      n2=n*n
c
c     ii,j,k, j<k, j<>i, k<>i
      S44=0.0d0
      do 21 j0=1,nst
c
c     set <J>
      IF(state1(j0).EQ.state2(j0)+1)THEN
       PR=state1(j0)
      ELSE
       IF(state1(j0).EQ.state2(j0)-1)THEN
        PR=state2(j0)
       ELSE
        GOTO 21
       ENDIF
      ENDIF
c
      j=icenter(j0)
c
      do 22 k0=j0+1,nst
c
c     set <K>
      IF(state1(k0).EQ.state2(k0)+1)THEN
       PRJK=PR*state1(k0)
      ELSE
       IF(state1(k0).EQ.state2(k0)-1)THEN
        PRJK=PR*state2(k0)
       ELSE
        GOTO 22
       ENDIF
      ENDIF
c
      k=icenter(k0)
      ijk=(j-1)*n+(k-1)*n2
c
c     first, i inside
      s44in=0.0d0
      do 2 i0=1,nst
      if(i0.eq.j0.or.i0.eq.k0)goto 2
      i=icenter(i0)
      tiijk=diijk(i+ijk)
      if(abs(tiijk).lt.1.0d-12)goto 2
      s44in=s44in+tiijk
c
c     set <II>
      S1=state1(i0)
      S2=state2(i0)
      IF(S1.EQ.S2)THEN
       PR=PRJK*(2*S1+1)*(2*S1+1)
      ELSE
       IF(S1.EQ.S2-2)THEN
        PR=PRJK*S2*(S2-1)
       ELSE
        IF(S1.EQ.S2+2)THEN
         PR=PRJK*S1*(S1-1)
        ELSE
         GOTO 2
        ENDIF
       ENDIF
      ENDIF
c
c
c     check the rest
      DO 7 i2=1,nst
7     IF(i2.NE.i0.and.i2.NE.j0.and.i2.NE.k0.
     1and.state1(i2).ne.state2(i2))GOTO 2
c
      S44=S44+dsqrt(dble(PR))*tiijk
2     CONTINUE
c
c     now, the i outside- use precalculated siijk
c     skip, if ortogonal
      DO 73 i2=1,nst
73    IF(i2.NE.j0.and.i2.NE.k0.and.state1(i2).ne.state2(i2))GOTO 401
c
      S44=S44+dsqrt(dble(PRJK))*(siijk(j+(k-1)*n)-s44in)
c
401   continue
c
22    CONTINUE
c     k0
c
21    CONTINUE
c     k0
c
      S33=0.0d0
c     iiij, j<>i
      do 3 i0=1,nst
      ii=icenter(i0)
      do 3 j0=1,nst
      jj=icenter(j0)
      if(ii.eq.jj)goto 3
      tiiij=diiij(ii+(jj-1)*n)
      if(abs(tiiij).lt.1.0d-9)goto 3
      PR=1
      icon=0
C     TERM <S1|Qii^3Qj|S2>
      DO 6 i2=1,nst
      IQ=icenter(i2)
      S1=state1(I2)
      S2=state2(I2)
      IF(IQ.NE.II.AND.IQ.NE.JJ)THEN
       IF(S1.EQ.S2)GOTO 6
       GOTO 3
      ENDIF
      IF(IQ.EQ.II)THEN
       IF(S1.EQ.S2+3)THEN
        PR=PR*S1*(S1-1)*(S1-2)
        icon=icon+1
        GOTO 6
       ENDIF
       IF(S1.EQ.S2-3)THEN
        PR=PR*S2*(S2-1)*(S2-2)
        icon=icon+1
        GOTO 6
       ENDIF
       IF(S1.EQ.S2+1)THEN
        PR=PR*9*S1*S1*S1
        icon=icon+1
        GOTO 6
       ENDIF
       IF(S1.EQ.S2-1)THEN
        PR=PR*9*S2*S2*S2
        icon=icon+1
        GOTO 6
       ENDIF
       GOTO 3
      ENDIF
C     <S1|Q|S2>(IQ),IQ=JJ
      IF(S1.EQ.S2+1)THEN
       PR=PR*S1
       icon=icon+1
       GOTO 6
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=PR*S2
       icon=icon+1
       GOTO 6
      ENDIF
      GOTO 3
6     CONTINUE
      if(icon.eq.2)S33=S33+DSQRT(DBLE(PR))*tiiij
3     continue
c
c     qi^2 qj^2 diijj, i<j
      S22=0.0d0
c
c     pre-select non-zero components
      do 41 i2=1,nst
      if(state1(I2).ne.state2(I2).and.state1(I2).ne.state2(I2)+2.
     1and.state1(I2).ne.state2(I2)-2)goto 400
41    continue
c
c     i,j, both excited, i<j
      s22a=0.0d0
      s22ag=0.0d0
      do 42 i0=1,nst
      i=icenter(i0)
      do 42 j0=i0+1,nst
      j=icenter(j0)
      tiijj=diijj(i+(j-1)*n)
      if(abs(tiijj).lt.1.0d-9)goto 42
      s22ag=s22ag+tiijj
      PR=1
      DO 311 i2=1,nst
      S1=state1(I2)
      S2=state2(I2)
      IF(icenter(i2).NE.I.AND.icenter(i2).NE.J)THEN
C     <S1|S2>(IQ)
       IF(S1.EQ.S2)GOTO 311
       GOTO 42
      ENDIF
C     <S1|Q^2|S2>(IQ),IQ is either I or J; <0|q^2|0> implicitely
      IF(S1.EQ.S2+2)THEN
       PR=PR*S1*(S1-1)
       GOTO 311
      ENDIF
      IF(S1.EQ.S2-2)THEN
       PR=PR*S2*(S2-1)
       GOTO 311
      ENDIF
      IF(S1.EQ.S2)THEN
       PR=PR*(2*S1+1)*(2*S1+1)
       GOTO 311
      ENDIF
      GOTO 42
311   CONTINUE
      s22a=s22a+DSQRT(DBLE(PR))*tiijj
42    continue
c
c     i,j, i excited, j outside
      s22b=0.0d0
      s22bg=0.0d0
c
      do 44 i0=1,nst
      i=icenter(i0)
c
      sumt=siijj(i)
      do 45 j0=1,nst
      j=icenter(j0)
45    sumt=sumt-diijj(i+(j-1)*n)
c
      s22bg=s22bg+sumt
c
c     set <II>
      S1=state1(i0)
      S2=state2(i0)
      IF(S1.EQ.S2)THEN
       PR=(2*S1+1)*(2*S1+1)
      ELSE
       IF(S1.EQ.S2+2)THEN
        PR=S1*(S1-1)
       ELSE
        IF(S1.EQ.S2-2)THEN
         PR=S2*(S2-1)
        ELSE
         GOTO 44
        ENDIF
       ENDIF
      ENDIF
c
c     check ortogonality of rest of states
      DO 312 i2=1,nst
312   IF(icenter(i2).NE.I.AND.state1(I2).NE.state2(I2))GOTO 44
c
      s22b=s22b+sumt*dsqrt(dble(PR))
c
44    continue
c     i0(i)
c
c     i,j, both outside i<j
c     if excited part orthogonal, this is zero
c     we have <0|sum(i<j)diijjqi^2qj^2|0>=aiijj already precalculated
      if(lorto)then
       s22c=0.0d0
      else
       s22c=aiijj-s22bg-s22ag
      endif
c
      S22=s22a+s22b+s22c
c
400   continue
c
c     iiii, i is among excited - direct sum
      s11a=0.0d0
      s11ag=0.0d0
      do 8 i0=1,nst
      i=icenter(i0)
      tiiii=diiii(i)
      if(abs(tiiii).lt.1.0d-9)goto 8
      s11ag=s11ag+tiiii
c     <0|q^4|0>=9
      DO 5 i2=1,nst
      S1=state1(I2)
      S2=state2(I2)
      IF(icenter(i2).NE.i)THEN
       IF(S1.EQ.S2) GOTO 5
       GOTO 8
      ENDIF
      IF(S1.EQ.S2-4)THEN
       PR=S2*(S2-1)*(S2-2)*(S2-3)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2+4)THEN
       PR=S1*(S1-1)*(S1-2)*(S1-3)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2-2)THEN
       PR=(4*S2-2)*(4*S2-2)*S2*(S2-1)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2+2)THEN
       PR=(4*S1-2)*(4*S1-2)*S1*(S1-1)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2)THEN
       PR=(6*S1*S1+6*S1+3)*(6*S1*S1+6*S1+3)
       GOTO 5
      ENDIF
      GOTO 8
5     CONTINUE
C     <S1|Diiii|S2>
      S11a=S11a+DSQRT(DBLE(PR))*tiiii
8     CONTINUE
c
c     iiii, i is not among excited - from pre-defined sum aiiii
      if(lorto)then
       s11b=0.0d0
      else
       s11b=aiiii-s11ag-s11ag-s11ag
      endif
c
      S11=s11a+s11b
C
      ssqh2=0.01041666666d0*(S11+6.0d0*S22+4.0d0*S33+12.0d0*S44)
C     0.0104167=(1/4)*(1/24)
      RETURN
      END
