      SUBROUTINE SUMSGHOST
C     A = (1/6) < STATE1 | SUMijk Cijk QiQjQk | STATE2> = <1|V|2>
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      PARAMETER (NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6 )
      INTEGER*4 STATE1(NT3),STATE2(NT3),S1,S2,PR
      LOGICAL L4,lopt,lcda
      COMMON/SUM/SUM,STATE1,STATE2,N7,N,L4
      COMMON/DIA2B/CS(NXX),ICS(3,NXX),NCSP
      common/tem/s11,s22,s33
      COMMON/iop/iopt(300)
      COMMON/lop/lopt(300)
      equivalence (iopt(14),nproc),(lcda,lopt(25))

      if(lcda)then
       call sumsghostd
       return
      endif

      if(nproc.gt.1)then
       call sumsghostp
       return
      endif

      S11=0.0d0
      S22=0.0d0
      S33=0.0d0
      DO 1000 IC=1,NCSP
      I=ICS(1,IC)
      J=ICS(2,IC)
      K=ICS(3,IC)
C     i=<j=<k
C
C     Term ijk, i<j<k
      IF(I.LT.J.AND.J.LT.K)THEN
      PR=1
      DO 1 IQ=N7,N
      IF(IQ.NE.K.AND.IQ.NE.J.AND.IQ.NE.I)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 1
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(S1.EQ.S2+1)THEN
       PR=PR*S1
       GOTO 1
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=PR*S2
       GOTO 1
      ENDIF
      GOTO 1000
1     CONTINUE
      S33=S33+DSQRT(DBLE(PR))*CS(IC)
      GOTO 1000
      ENDIF
C
C     TERM   ijk, i=j<k
      IF(I.EQ.J.AND.J.LT.K)THEN
       II=I
       JJ=K
       GOTO 1001
      ENDIF
C
C     TERM   ijk, i<j=k
      IF(I.LT.J.AND.J.EQ.K)THEN
       II=J
       JJ=I
       GOTO 1001
      ENDIF
C
C     TERM   iii
      DO 5 IQ=N7,N
      IF(IQ.NE.I)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 5
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(S1.EQ.S2-3)THEN
       PR=S2*(S2-1)*(S2-2)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2+3)THEN
       PR=S1*(S1-1)*(S1-2)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=9*S2*S2*S2
       GOTO 5
      ENDIF
      IF(S1.EQ.S2+1)THEN
       PR=9*S1*S1*S1
       GOTO 5
      ENDIF
      GOTO 1000
5     CONTINUE
      S11=S11+DSQRT(DBLE(PR))*CS(IC)
      GOTO 1000
C
C     Calculate <S1|Qii^2 Qjj|+S2>:
1001  PR=1
      DO 3 IQ=N7,N
      IF(IQ.NE.II.AND.IQ.NE.JJ)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 3
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(IQ.EQ.JJ)THEN
       IF(S1.EQ.S2+1)THEN
	PR=PR*S1
	GOTO 3
       ENDIF
       IF(S1.EQ.S2-1)THEN
	PR=PR*S2
	GOTO 3
       ENDIF
       GOTO 1000
      ENDIF
      IF(S1.EQ.S2)THEN
       PR=PR*(2*S1+1)*(2*S1+1)
       GOTO 3
      ENDIF
      IF(S1.EQ.S2+2)THEN
       PR=PR*S1*(S1-1)
       GOTO 3
      ENDIF
      IF(S1.EQ.S2-2)THEN
       PR=PR*S2*(S2-1)
       GOTO 3
      ENDIF
      GOTO 1000
3     CONTINUE
      S22=S22+DSQRT(DBLE(PR))*CS(IC)
1000  CONTINUE
C
      SUM=(S11+3.0*S22+6.0*S33)*0.058925565101
C     0.0589=1/(6*sqrt(8))
      RETURN
      END
