      SUBROUTINE SUMSGHOSTD
C     A = (1/6) < STATE1 | SUMijk Cijk QiQjQk | STATE2> = <1|V|2>
c     using damped coordinates by dafac
      IMPLICIT none
      INTEGER*4 NXX
      include 'dimensions.h'
      PARAMETER (NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6 )
      INTEGER*4 STATE1(NT3),STATE2(NT3),S1,S2,N,N7,ICS,NCSP,
     1IC,I,J,K,IQ,II,JJ
      real*8 PR,S11,S22,S33,ropt,dafac,daint,CS,SUM,st
      LOGICAL L4
      COMMON/SUM/SUM,STATE1,STATE2,N7,N,L4
      COMMON/DIA2B/CS(NXX),ICS(3,NXX),NCSP
      common/tem/s11,s22,s33
      COMMON/opt/ropt(100)
      equivalence (dafac,ropt(6))

      st=dsqrt(2.0d0)
      S11=0.0d0
      S22=0.0d0
      S33=0.0d0
      DO 1000 IC=1,NCSP
      I=ICS(1,IC)
      J=ICS(2,IC)
      K=ICS(3,IC)
C     i=<j=<k
C
C     Term ijk, i<j<k
      IF(I.LT.J.AND.J.LT.K)THEN
      PR=1.0d0
      DO 8 IQ=1,N
      IF(IQ.NE.K.AND.IQ.NE.J.AND.IQ.NE.I)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 8
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(S1.EQ.S2+1)THEN
       PR=PR*daint(S1,1,S2,dafac)*st
       GOTO 8
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=PR*daint(S1,1,S2,dafac)*st
       GOTO 8
      ENDIF
      GOTO 1000
8     CONTINUE
      S33=S33+PR*CS(IC)
      GOTO 1000
      ENDIF
C
C     TERM   ijk, i=j<k
      IF(I.EQ.J.AND.J.LT.K)THEN
       II=I
       JJ=K
       GOTO 1001
      ENDIF
C
C     TERM   ijk, i<j=k
      IF(I.LT.J.AND.J.EQ.K)THEN
       II=J
       JJ=I
       GOTO 1001
      ENDIF
C
C     TERM   iii
      DO 52 IQ=1,N
      IF(IQ.NE.I)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 52
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(S1.EQ.S2-3)THEN
       PR=daint(S1,3,S2,dafac)*2.0d0*st
       GOTO 52
      ENDIF
      IF(S1.EQ.S2+3)THEN
       PR=daint(S1,3,S2,dafac)*2.0d0*st
       GOTO 52
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=daint(S1,3,S2,dafac)*2.0d0*st
       GOTO 52
      ENDIF
      IF(S1.EQ.S2+1)THEN
       PR=daint(S1,3,S2,dafac)*2.0d0*st
       GOTO 52
      ENDIF
      GOTO 1000
52    CONTINUE
      S11=S11+PR*CS(IC)
      GOTO 1000
C
C     Calculate <S1|Qii^2 Qjj|+S2>:
1001  PR=1.0d0
      DO 31 IQ=1,N
      IF(IQ.NE.II.AND.IQ.NE.JJ)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 31
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(IQ.EQ.JJ)THEN
       IF(S1.EQ.S2+1)THEN
       PR=PR*daint(S1,1,S2,dafac)*st
       GOTO 31
       ENDIF
       IF(S1.EQ.S2-1)THEN
       PR=PR*daint(S1,1,S2,dafac)*st
       GOTO 31
       ENDIF
       GOTO 1000
      ENDIF
      IF(S1.EQ.S2)THEN
       PR=PR*daint(S1,2,S2,dafac)*2.0d0
       GOTO 31
      ENDIF
      IF(S1.EQ.S2+2)THEN
       PR=PR*daint(S1,2,S2,dafac)*2.0d0
       GOTO 31
      ENDIF
      IF(S1.EQ.S2-2)THEN
       PR=PR*daint(S1,2,S2,dafac)*2.0d0
       GOTO 31
      ENDIF
      GOTO 1000
31    CONTINUE
      S22=S22+PR*CS(IC)
1000  CONTINUE
      SUM=(S11+3.0d0*S22+6.0d0*S33)*0.058925565101d0
C     0.0589=1/(6*sqrt(8))
      RETURN
      END
