      SUBROUTINE SUMSQF
C     A = (1/24) < STATE1 | SUMij  Diijj QiQiQjQj | STATE2>
C       + (1/24) < STATE1 | SUMijk "Diijk" type   | STATE2>
      IMPLICIT none
      include 'dimensions.h'
      INTEGER*4 STATE1(NT3),STATE2(NT3),S1,S2,PR,i,j,nse,ndee,ndeo,ii,
     1ndee_c(ME0),ndeo_c(ME0),ndee_S1(ME0),ndee_S2(ME0),K,
     1nse_c(ME0),nse_S1(ME0),ndeo_S1(ME0),ndeo_S2(ME0),N7,N,iq,jj,
     1S1i,S1j,S2i,S2j
      real*8 S11,S22,S33,S44,SUM,D
      logical L4
      COMMON/SUM/SUM,STATE1,STATE2,N7,N,L4
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent
      COMMON/VQA/D(NT3,NT3,NT3)
c
c     ndee .. number of different excitations, even difference
c     ndeo .. number of different excitations, odd difference
c     nse  .. number of same excitations
      call detndee(ndee,ndeo,nse,S1_Ncent,S2_Ncent,S1_Lcent,
     1S2_Lcent,nse_c,nse_S1,ndee_c,ndee_S1,ndee_S2, ndeo_c, ndeo_S1,
     2ndeo_S2,S1_Lexc,S2_Lexc)
      S11=0.0d0
      S22=0.0d0
      S33=0.0d0
      S44=0.0d0

      if(ndeo.ne.0)goto 62
c
c     term iiii
      if(ndee.eq.1)then
       S1=ndee_S1(1)
       S2=ndee_S2(1)
       I=ndee_c(1)
       IF(S1.EQ.S2-4)THEN
        PR=S2*(S2-1)*(S2-2)*(S2-3)
       ELSE
        if(S1.EQ.S2+4)then
         PR=S1*(S1-1)*(S1-2)*(S1-3)
        else
         IF(S1.EQ.S2-2)THEN
          PR=(4*S2-2)*(4*S2-2)*S2*(S2-1)
         ELSE
          if(S1.EQ.S2+2)then
           PR=(4*S1-2)*(4*S1-2)*S1*(S1-1)
          else
           IF(S1.EQ.S2)THEN
            call report('should not happen')
           ELSE
            goto 5
           ENDIF
          endif
         ENDIF
        endif
       ENDIF
       S11=S11+DSQRT(DBLE(PR))*D(I,I,I)
5      CONTINUE
      else
       if(ndee.eq.0)then
        do 61 I=N7,N
        do 51 iq=1,nse
        if(nse_c(iq).eq.I)then
        S1=nse_S1(iq)
         S11=S11+DSQRT(DBLE((6*S1*S1+6*S1+3)*(6*S1*S1+6*S1+3)))*D(I,I,I)
         goto 61
        endif
51      continue
        S11=S11+3.0d0*D(I,I,I)
61      continue
       endif
      endif
c
c     term iijj i>j
      if(ndee.eq.2)then
       S1i=ndee_S1(1)
       S2i=ndee_S2(1)
       S1j=ndee_S1(2)
       S2j=ndee_S2(2)
       I=ndee_c(1)
       J=ndee_c(2)
       IF(S1i.EQ.S2i+2)THEN
        PR=S1i*(S1i-1)
       ELSE
        if(S1i.EQ.S2i-2)then
         PR=S2i*(S2i-1)
        else
         goto 62
        endif
       ENDIF
       IF(S1j.EQ.S2j+2)THEN
        S22=S22+DSQRT(DBLE(PR*S1j*(S1j-1)))*D(I,J,J)
       ELSE
        if(S1j.EQ.S2j-2)then
         S22=S22+DSQRT(DBLE(PR*S2j*(S2j-1)))*D(I,J,J)
        else
         goto 62
        endif
       ENDIF
      else
       if(ndee.eq.1)then
        S1i=ndee_S1(1)
        S2i=ndee_S2(1)
        I=ndee_c(1)
        IF(S1i.EQ.S2i+2)THEN
         PR=S1i*(S1i-1)
        ELSE
         IF(S1i.EQ.S2i-2)THEN
          PR=S2i*(S2i-1)
         ELSE
          goto 62
         ENDIF
        ENDIF
        do 71 II=N7,N
        IF(II.ne.I)THEN
         do 81 iq=1,nse
         if(nse_c(iq).eq.II)then
          S1=nse_S1(iq)
          S22=S22+DSQRT(DBLE(PR*(2*S1+1)*(2*S1+1)))*D(II,I,I)
          goto 71
         endif
81       continue
         S22=S22+DSQRT(DBLE(PR))*D(II,I,I)
        ENDIF
71      continue
       else
        IF(ndee.eq.0)THEN
         do 91 II=N7,N
         do 91 JJ=II+1,N
         PR=1
         do 41 iq=1,nse
         if(nse_c(iq).eq.II)then
          PR=PR*(2*nse_S1(iq)+1)*(2*nse_S1(iq)+1)
         endif
         if(nse_c(iq).eq.JJ)then
          PR=PR*(2*nse_S1(iq)+1)*(2*nse_S1(iq)+1)
         endif
41       continue
91       S22=S22+DSQRT(DBLE(PR))*D(II,JJ,JJ)
        ENDIF
       endif
      endif
62    continue

c     iiij and ijjj
      if(ndeo.eq.2.and.ndee.eq.0)then
       S1i=ndeo_S1(1)
       S2i=ndeo_S2(1)
       S1j=ndeo_S1(2)
       S2j=ndeo_S2(2)
       I=ndeo_c(1)
       J=ndeo_c(2)
c      iiij:
       IF(S1i.EQ.S2i+3)THEN
        PR=S1i*(S1i-1)*(S1i-2)
       ELSE
        IF(S1i.EQ.S2i-3)THEN
         PR=S2i*(S2i-1)*(S2i-2)
        ELSE
         IF(S1i.EQ.S2i+1)THEN
          PR=9*S1i*S1i*S1i
         ELSE
          IF(S1i.EQ.S2i-1)THEN
           PR=9*S2i*S2i*S2i
          ELSE
           goto 612
          ENDIF
         ENDIF
        ENDIF
       ENDIF
       IF(S1j.EQ.S2j+1)THEN
        S33=S33+DSQRT(DBLE(PR*S1j))*D(I,I,J)
       ELSE
        IF(S1j.EQ.S2j-1)THEN
         S33=S33+DSQRT(DBLE(PR*S2j))*D(I,I,J)
        ELSE
         goto 612
        ENDIF
       ENDIF
612    CONTINUE
c      ijjj:
       IF(S1j.EQ.S2j+3)THEN
        PR=S1j*(S1j-1)*(S1j-2)
       ELSE
        IF(S1j.EQ.S2j-3)THEN
         PR=S2j*(S2j-1)*(S2j-2)
        ELSE
         IF(S1j.EQ.S2j+1)THEN
          PR=9*S1j*S1j*S1j
         ELSE
          IF(S1j.EQ.S2j-1)THEN
           PR=9*S2j*S2j*S2j
          ELSE
           goto 613
          ENDIF
         ENDIF
        ENDIF
       ENDIF
       IF(S1i.EQ.S2i+1)THEN
        S33=S33+DSQRT(DBLE(PR*S1i))*D(J,J,I)
       ELSE
        IF(S1i.EQ.S2i-1)THEN
         S33=S33+DSQRT(DBLE(PR*S2i))*D(J,J,I)
        ELSE
         goto 613
        ENDIF
       ENDIF
613    CONTINUE
      endif
c
c     ijkk
      if(ndeo.eq.2)then
       S1i=ndeo_S1(1)
       S2i=ndeo_S2(1)
       S1j=ndeo_S1(2)
       S2j=ndeo_S2(2)
       I=ndeo_c(1)
       J=ndeo_c(2)
       IF(S1i.EQ.S2i+1)THEN
        PR=S1i
       ELSE
        IF(S1i.EQ.S2i-1)THEN
         PR=S2i
        ELSE
         goto 712
        ENDIF
       ENDIF
       IF(S1j.EQ.S2j+1)THEN
        PR=PR*S1j
       ELSE
        IF(S1j.EQ.S2j-1)THEN
         PR=PR*S2j
        ELSE
         goto 712
        ENDIF
       ENDIF
       if(ndee.eq.1)then
        S1=ndee_S1(1)
        S2=ndee_S2(1)
        K=ndee_c(1)
        IF(S1.EQ.S2+2)THEN
         S44=S44+DSQRT(DBLE(PR*S1*(S1-1)))*D(K,I,J)
        ELSE
         IF(S1.EQ.S2-2)THEN
          S44=S44+DSQRT(DBLE(PR*S2*(S2-1)))*D(K,I,J)
         ELSE
          IF(S1.EQ.S2)THEN
           call report('should not happen -ndee')
          ELSE
           goto 712
          ENDIF
         ENDIF
        ENDIF
       else
        if(ndee.eq.0)then
         do 7 II=N7,N
         if(II.ne.I.and.II.ne.J)then
          do 701 iq=1,nse
          if(nse_c(iq).eq.II)then
           S1=nse_S1(iq)
           S44=S44+DSQRT(DBLE(PR*(2*S1+1)*(2*S1+1)))*D(II,I,J)
           goto 7
          endif
701       continue
          S44=S44+DSQRT(DBLE(PR))*D(II,I,J)
         endif
7        continue
        endif
       endif
      endif
712   continue
      SUM=0.01041666666d0*(S11+6.0d0*S22+4.0d0*S33+12.0d0*S44)
      RETURN
      END
